import { __decorate, __awaiter, __param } from 'tslib';
import { ɵɵdefineInjectable, Injectable, EventEmitter, Input, Output, Component, ViewChild, ChangeDetectorRef, Renderer2, ElementRef, ChangeDetectionStrategy, ɵɵinject, SecurityContext, Directive, NgModule, ViewChildren, Inject } from '@angular/core';
import { CommonModule, DOCUMENT } from '@angular/common';
import { FormBuilder, FormControl, FormArray, FormsModule, ReactiveFormsModule } from '@angular/forms';
import { BsModalService, ModalModule } from 'ngx-bootstrap/modal';
import { BehaviorSubject, of } from 'rxjs';
import { GoogleChartsModule } from 'angular-google-charts';
import { PaginationModule } from 'ngx-bootstrap/pagination';
import { DomSanitizer } from '@angular/platform-browser';
import { moveItemInArray, transferArrayItem, DragDropModule } from '@angular/cdk/drag-drop';
import { SortableModule } from 'ngx-bootstrap/sortable';
import { CarouselModule } from 'ngx-bootstrap/carousel';
import { NgMultiSelectDropDownModule } from 'ng-multiselect-dropdown';
import { TabsModule } from 'ngx-bootstrap';
import { HttpClient } from '@angular/common/http';
import * as ClassicEditor from '@ckeditor/ckeditor5-build-classic';
import { CKEditorModule } from '@ckeditor/ckeditor5-angular';
import { MatSelectModule } from '@angular/material/select';
import { TooltipModule } from 'ngx-bootstrap/tooltip';
import { ActivatedRoute } from '@angular/router';

class SubmitAnswerPayload {
}

class Timer {
}

var LapValues;
(function (LapValues) {
    LapValues["blood"] = "Blood";
    LapValues["sub"] = "Sub";
    LapValues["hematologic"] = "Hematologic";
    LapValues["cerebrospinal"] = "Rerebrospinal";
})(LapValues || (LapValues = {}));

var Navigation;
(function (Navigation) {
    Navigation["next"] = "NEXT";
    Navigation["previous"] = "PREVIOUS";
    Navigation["submit"] = "SUBMIT";
    Navigation["Default"] = "NIL";
})(Navigation || (Navigation = {}));

var ErrorCodes;
(function (ErrorCodes) {
    ErrorCodes[ErrorCodes["Unauthorized"] = 401] = "Unauthorized";
    ErrorCodes[ErrorCodes["Forbidden"] = 403] = "Forbidden";
    ErrorCodes[ErrorCodes["NotFound"] = 404] = "NotFound";
})(ErrorCodes || (ErrorCodes = {}));

var Engine;
(function (Engine) {
    Engine["qp"] = "QP";
    Engine["usmle"] = "USMLE";
    Engine["nclex"] = "NCLEX";
})(Engine || (Engine = {}));

class EmailDetails {
}

class SystemConfig {
}

var RemediaionType;
(function (RemediaionType) {
    RemediaionType[RemediaionType["textType"] = 3] = "textType";
    RemediaionType[RemediaionType["linkType"] = 1] = "linkType";
    RemediaionType[RemediaionType["PhoenixVideoAsset"] = 4] = "PhoenixVideoAsset";
})(RemediaionType || (RemediaionType = {}));
var AssetPosition;
(function (AssetPosition) {
    AssetPosition["left"] = "Left";
    AssetPosition["bottom"] = "Bottom";
    AssetPosition["withInText"] = "WithinText";
    AssetPosition["top"] = "Top";
    AssetPosition["right"] = "Right";
})(AssetPosition || (AssetPosition = {}));
var RationaleType;
(function (RationaleType) {
    RationaleType[RationaleType["correctRationale"] = 1] = "correctRationale";
    RationaleType[RationaleType["inCorrectRationale"] = 2] = "inCorrectRationale";
})(RationaleType || (RationaleType = {}));
var ExternalClientCode;
(function (ExternalClientCode) {
    ExternalClientCode["Phoenix"] = "PHOENIX";
})(ExternalClientCode || (ExternalClientCode = {}));
var UserAnswerTypes;
(function (UserAnswerTypes) {
    UserAnswerTypes[UserAnswerTypes["UnAttempted"] = 0] = "UnAttempted";
    UserAnswerTypes[UserAnswerTypes["Correct"] = 1] = "Correct";
    UserAnswerTypes[UserAnswerTypes["Incorrect"] = 2] = "Incorrect";
})(UserAnswerTypes || (UserAnswerTypes = {}));
var SummaryDisplayTypes;
(function (SummaryDisplayTypes) {
    SummaryDisplayTypes[SummaryDisplayTypes["SummaryHeader"] = 2] = "SummaryHeader";
    SummaryDisplayTypes[SummaryDisplayTypes["SummaryPredefined"] = 3] = "SummaryPredefined";
    SummaryDisplayTypes[SummaryDisplayTypes["SummaryDefault"] = 1] = "SummaryDefault";
})(SummaryDisplayTypes || (SummaryDisplayTypes = {}));

var NavigationType;
(function (NavigationType) {
    NavigationType[NavigationType["ForwardOnly"] = 1] = "ForwardOnly";
    NavigationType[NavigationType["Both"] = 2] = "Both";
})(NavigationType || (NavigationType = {}));

var ThemesEnum;
(function (ThemesEnum) {
    ThemesEnum[ThemesEnum["BlueTheme"] = 1] = "BlueTheme";
    ThemesEnum[ThemesEnum["GreenTheme"] = 2] = "GreenTheme";
})(ThemesEnum || (ThemesEnum = {}));
var FontSizeEnum;
(function (FontSizeEnum) {
    FontSizeEnum["SmallFont"] = "16px";
    FontSizeEnum["MediumFont"] = "18px";
    FontSizeEnum["LargeFont"] = "20px";
})(FontSizeEnum || (FontSizeEnum = {}));
const appThemesData = [
    {
        id: 1,
        name: 'blueTheme',
        properties: {
            '--primary-color': '#005b92',
            '--secondary-color': '#EDEDED',
            '--tertiary-color': '#80bde1',
            '--text-color': '#000'
        }
    },
    {
        id: 2,
        name: 'greenTheme',
        properties: {
            '--primary-color': '#2e822f',
            '--secondary-color': '#CEE59F',
            '--tertiary-color': '#9ecb3b',
            '--text-color': '#000'
        }
    }
];
const invertThemeProperties = {
    '--primary-color': '#929292',
    '--secondary-color': '#303030',
    '--tertiary-color': '#f1f0f0',
    '--text-color': '#fff'
};

let QuizService = class QuizService {
    constructor() {
    }
    set engineType(engineType) {
        this.engineName = engineType;
    }
    set isOnline(isOnline) {
        this.isOnlineEngine = isOnline;
    }
    get engineType() {
        return this.engineName;
    }
    get isOnline() {
        return this.isOnlineEngine;
    }
    set testDetails(value) {
        this.testData = value;
    }
    get testDetails() {
        return this.testData;
    }
    get instanceDetails() {
        return this.testData.instanceData;
    }
    get testModeSettings() {
        return this.testData.additionalTestModeSettings;
    }
    get testEngineFeatures() {
        return this.testData.testEngineFeatures;
    }
    get testSettings() {
        return this.testData.testSettings;
    }
    set systemConfigs(systemConfig) {
        this.systemConfig = systemConfig;
    }
    get systemConfigs() {
        return this.systemConfigs;
    }
};
QuizService.ɵprov = ɵɵdefineInjectable({ factory: function QuizService_Factory() { return new QuizService(); }, token: QuizService, providedIn: "root" });
QuizService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], QuizService);

let FooterComponent = class FooterComponent {
    constructor(modalService, quizService) {
        this.modalService = modalService;
        this.quizService = quizService;
        this.showAnswer = false;
        this.navigation = Navigation;
        this.navigationTypes = NavigationType;
        /* Outputs */
        this.questionChanged = new EventEmitter();
        this.showAnswerStatus = new EventEmitter();
        this.clearResponseEmitter = new EventEmitter();
    }
    ngOnChanges(changes) {
        if (changes.itemData && changes.itemData.currentValue) {
            this.setItemDetails();
        }
    }
    ngOnInit() {
        this.testData = this.quizService.testDetails;
        this.testEngineFeatures = this.quizService.testEngineFeatures;
        this.instanceData = this.quizService.instanceDetails;
        this.testModeSettings = this.quizService.testModeSettings;
        if (this.testData && this.testData.testSettings) {
            this.navigationType = this.testData.testSettings.navigationType;
        }
    }
    setItemDetails() {
        if (this.itemData) {
            this.showAnswer = false;
            this.showAnswerStatus.emit(false);
            this.currentQuestionIndex = this.itemData.sequence
                ? this.itemData.sequence
                : 0;
        }
    }
    nextOrPreviousItem(navigation) {
        this.questionChanged.emit(navigation);
    }
    showHideStatus(status) {
        this.showAnswer = status;
        this.showAnswerStatus.emit(status);
    }
    clearResponse() {
        this.clearResponseEmitter.emit(true);
    }
    submitQuiz() {
        this.questionChanged.emit(this.navigation.submit);
    }
    openSubmitModel(template) {
        this.quizSubmitMessage = '';
        let totalUnAttempted = 0;
        const isLastQuestion = this.instanceData.numberOfQuestions === this.itemData.sequence;
        let totalUnAttemptedRef = this.testProgress.totalUnAttempted;
        try {
            let userAnswerBeforeSubmitQuiz = this.itemData.userAttemptDetails
                .userAnswer;
            let userAnswer = this.userAnswer.userAnswer;
            if (totalUnAttemptedRef > 0 || userAnswer.length == 0) {
                if (userAnswerBeforeSubmitQuiz.length > 0 && userAnswer.length == 0) {
                    totalUnAttempted = totalUnAttemptedRef + 1;
                }
                else if (userAnswerBeforeSubmitQuiz.length == 0 &&
                    userAnswer.length > 0) {
                    totalUnAttempted = totalUnAttemptedRef - 1;
                }
                else {
                    totalUnAttempted = totalUnAttemptedRef;
                }
                let totalAttempted = this.instanceData.numberOfQuestions - totalUnAttempted;
                if (totalAttempted !== this.instanceData.numberOfQuestions) {
                    if (this.navigationType === this.navigationTypes.Both) {
                        this.quizSubmitMessage = `You have answered only  ${totalAttempted} out of ${this.instanceData.numberOfQuestions} questions. You CANNOT go back and change your answers after submitting the Quiz.`;
                    }
                    else {
                        if (isLastQuestion) {
                            this.quizSubmitMessage = `You have answered only  ${totalAttempted} out of ${this.instanceData.numberOfQuestions} questions.`;
                        }
                        else {
                            this.quizSubmitMessage = `You have answered only  ${totalAttempted} out of ${this.instanceData.numberOfQuestions} questions. You CANNOT answer the remaining question(s) after submitting the Quiz.`;
                        }
                    }
                }
            }
        }
        catch (e) {
            this.quizSubmitMessage = '';
        }
        if (this.userAnswer)
            this.modalRef = this.modalService.show(template);
    }
    isFeatureDisabed(feature) {
        if (!this.itemData) {
            return true;
        }
        else if (feature === this.disableNav) {
            return true;
        }
    }
};
FooterComponent.ctorParameters = () => [
    { type: BsModalService },
    { type: QuizService }
];
__decorate([
    Input('userAnswer')
], FooterComponent.prototype, "userAnswer", void 0);
__decorate([
    Input('itemData')
], FooterComponent.prototype, "itemData", void 0);
__decorate([
    Input('testProgress')
], FooterComponent.prototype, "testProgress", void 0);
__decorate([
    Input('disableNav')
], FooterComponent.prototype, "disableNav", void 0);
__decorate([
    Output()
], FooterComponent.prototype, "questionChanged", void 0);
__decorate([
    Output()
], FooterComponent.prototype, "showAnswerStatus", void 0);
__decorate([
    Output()
], FooterComponent.prototype, "clearResponseEmitter", void 0);
FooterComponent = __decorate([
    Component({
        selector: 'qp-footer',
        template: "<div class=\"wk-row footer-pagination-wrap\">\n  <ng-container *ngIf=\"testData && instanceData\">\n    <div\n      class=\"wk-layout-33-33-33 gray-bg wk-layout-responsive wk-layout-full-width mb20\"\n    >\n      <div class=\"wk-layout-item\">\n        <div class=\"wk-button-bar mb0\">\n          <div class=\"wk-button-group-left\">\n            <button\n              type=\"button\"\n              class=\"wkqp-button wk-button-primary\"\n              (click)=\"clearResponse()\"\n            >\n              Clear Response\n            </button>\n            <button\n              type=\"button\"\n              class=\"wkqp-button wk-button-primary\"\n              (click)=\"showHideStatus(true)\"\n              *ngIf=\"testModeSettings.showAnswer && !showAnswer\"\n            >\n              Show Answer\n            </button>\n            <button\n              type=\"button\"\n              class=\"wkqp-button wk-button-primary\"\n              (click)=\"showHideStatus(false)\"\n              *ngIf=\"testModeSettings.showAnswer && showAnswer\"\n            >\n              Hide Answer\n            </button>\n          </div>\n        </div>\n      </div>\n      <div class=\"wk-layout-item text-center prev-next-btn-wrapper\">\n        <button\n          [class.custom-icon-disabled]=\"\n            isFeatureDisabed(navigation.previous) ||\n            currentQuestionIndex === 1 ||\n            navigationType === navigationTypes.ForwardOnly\n          \"\n          class=\"wkqp-button wk-button-primary nav-btn mr5\"\n          (click)=\"nextOrPreviousItem(navigation.previous)\"\n        >\n          <span class=\"wk-icon-arrow-left\"></span>\n        </button>\n        <button\n          [class.custom-icon-disabled]=\"\n            isFeatureDisabed(navigation.next) ||\n            currentQuestionIndex === instanceData.numberOfQuestions\n          \"\n          class=\"wkqp-button wk-button-primary nav-btn ml5\"\n          (click)=\"nextOrPreviousItem(navigation.next)\"\n        >\n          <span class=\"wk-icon-arrow-right\"></span>\n        </button>\n      </div>\n      <div class=\"wk-layout-item text-right\">\n        <button\n          *ngIf=\"!instanceData.isPreview\"\n          class=\"wkqp-button wk-button-primary\"\n          (click)=\"openSubmitModel(template)\"\n        >\n          Submit Quiz\n        </button>\n      </div>\n    </div>\n  </ng-container>\n</div>\n<ng-template #template>\n  <div class=\"modal-dialog\">\n    <div class=\"modal-content\">\n      <div class=\"modal-header submitModal\">\n        <h5 class=\"modal-title pull-left\">\n          <strong>\n            <h4 class=\"submit-modal-line\" *ngIf=\"quizSubmitMessage\">\n              {{ quizSubmitMessage }}\n            </h4>\n            <div\n              class=\"submit-unattempted-modal\"\n              [ngClass]=\"{ 'all-question-submited': !quizSubmitMessage }\"\n            >\n              Are you sure you want to submit the Quiz?\n            </div></strong\n          >\n        </h5>\n      </div>\n      <div class=\"modal-footer\">\n        <button\n          type=\"button\"\n          class=\"wkqp-button wkqp-button-warning\"\n          (click)=\"submitQuiz(); modalRef.hide()\"\n        >\n          Yes\n        </button>\n        <button\n          type=\"button\"\n          class=\"wkqp-button wkqp-button-warning\"\n          (click)=\"modalRef.hide()\"\n        >\n          No\n        </button>\n      </div>\n    </div>\n  </div>\n</ng-template>\n",
        styles: [".wkqp-button-group-left a.wkqp-button.wkqp-button-primary{background-color:var(--primary-color);color:#fff}.nav-btn:disabled{cursor:not-allowed!important}.submitModal{background-color:#fff!important;border:0;height:auto!important;padding-right:10px}.errorModal{background-color:red!important}.submit-modal-content{margin-top:30vh;width:55vw;margin-left:-12vw}.modal-content{margin-top:0!important}.modal-title{line-height:1.6}.mr5{margin-right:5px}.ml5{margin-left:5px}.wk-layout-full-width{max-width:100%}.disabled-feature{opacity:.2;pointer-events:none}.wk-icon-arrow-left,.wk-icon-arrow-right{font-size:20px}.custom-icon-disabled{cursor:not-allowed;pointer-events:none;opacity:.3;background-color:#fff!important;color:#666!important;border:1px solid #bcbcbc}.all-question-submited{margin-top:15px;margin-left:15px;font-size:1.728rem;font-weight:700;color:#000;font-family:'Helvetica Neue',Helvetica,Roboto,Arial,sans-serif!important}.modal-dialog{margin-top:25%!important;width:650px!important;min-width:650px!important}"]
    })
], FooterComponent);

let UtilTimeService = class UtilTimeService {
    constructor() {
    }
    /* convert seconds to minute */
    secondsToMinute(sec) {
        var minutes = Math.floor(sec / 60);
        return minutes;
    }
    /* convert seconds to hh:mm:ss format */
    convertSecondsToTimerFormat(totalSeconds) {
        let hours = Math.floor(totalSeconds / 3600);
        totalSeconds %= 3600;
        hours = hours < 10 ? '0' + hours : hours;
        let minutes = Math.floor(totalSeconds / 60);
        minutes = minutes < 10 ? '0' + minutes : minutes;
        let seconds = totalSeconds % 60;
        seconds = seconds < 10 ? '0' + seconds : seconds;
        return `${hours}:${minutes}:${seconds}`;
    }
};
UtilTimeService.ɵprov = ɵɵdefineInjectable({ factory: function UtilTimeService_Factory() { return new UtilTimeService(); }, token: UtilTimeService, providedIn: "root" });
UtilTimeService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], UtilTimeService);

let HeaderComponent = class HeaderComponent {
    constructor(utilService, quizService) {
        this.utilService = utilService;
        this.quizService = quizService;
        this.isTotalTimeExceeded = false;
        this.isItemTimeExceeded = false;
    }
    ngOnChanges(changes) {
        if (changes.itemData && changes.itemData.currentValue) {
            this.setItemDetails();
        }
    }
    ngOnInit() {
        this.testData = this.quizService.testData;
        this.instanceData = this.quizService.instanceDetails;
        this.testEngineFeatures = this.quizService.testEngineFeatures;
        this.testModeSettings = this.quizService.testModeSettings;
        this.setQuizTimer();
    }
    /* setting quiz timer  for the header*/
    setQuizTimer() {
        this.quizTimerConfig = new Timer();
        this.quizTimerConfig.isIncrement = true;
        const instanceData = this.quizService.instanceDetails;
        this.quizTimerConfig.timer = instanceData.totalTimeSpent;
        this.quizTimerConfig.limit = instanceData.quizTime;
        this.timePerQuestion = instanceData.questionTime;
        this.quizTime = this.utilService.convertSecondsToTimerFormat(instanceData.quizTime);
    }
    /* Seting iterm details for the latest item recieved from qp base */
    setItemDetails() {
        if (this.itemData) {
            this.timeSpentForItem =
                this.itemData &&
                    this.itemData.userAttemptDetails &&
                    this.itemData.userAttemptDetails.timeSpent
                    ? this.itemData.userAttemptDetails.timeSpent
                    : 0;
            this.isItemTimeExceeded = false;
            this.itemTimerConfig = new Timer();
            this.itemTimerConfig.timer = this.timeSpentForItem;
            this.itemTimerConfig.isIncrement = true;
            this.itemTimerConfig.limit = this.quizService.instanceDetails.questionTime;
        }
    }
    getTotalTimeSpent() {
        return this.quizTimer.getTimer();
    }
    getItemTimeSpent() {
        return this.itemTimer.getTimer();
    }
    itemTimeExceeded() {
        this.isItemTimeExceeded = true;
    }
    totalTimeExceeded() {
        this.isTotalTimeExceeded = true;
    }
    getTimer(time) {
        return this.utilService.convertSecondsToTimerFormat(time);
    }
};
HeaderComponent.ctorParameters = () => [
    { type: UtilTimeService },
    { type: QuizService }
];
__decorate([
    Input('itemData')
], HeaderComponent.prototype, "itemData", void 0);
__decorate([
    Input('testProgress')
], HeaderComponent.prototype, "testProgress", void 0);
__decorate([
    ViewChild('itemTimer')
], HeaderComponent.prototype, "itemTimer", void 0);
__decorate([
    ViewChild('quizTimer')
], HeaderComponent.prototype, "quizTimer", void 0);
HeaderComponent = __decorate([
    Component({
        selector: 'qp-header',
        template: "<div class=\"quiz-header-badges\">\n  <ng-container *ngIf=\"testData && testModeSettings\">\n    <div\n      class=\"quiz-badges-child\"\n      [ngClass]=\"{\n        'badges-exceeded':\n          instanceData.questionTime == 0 ||\n          timeSpentForItem > instanceData.questionTime ||\n          isItemTimeExceeded ||\n          instanceData.quizTime == 0 ||\n          instanceData.totalTimeSpent > instanceData.quizTime ||\n          isTotalTimeExceeded\n      }\"\n      *ngIf=\"\n        testModeSettings.showItemTimeLimit && instanceData.questionTime > 0\n      \"\n    >\n      <span class=\"quiz-bades-label\">Time Allotted Per Question</span>\n      <span class=\"wkqp-badge\">{{ timePerQuestion }} Seconds </span>\n    </div>\n    <div\n      class=\"quiz-badges-child\"\n      *ngIf=\"testModeSettings.showItemTimeSpent; else hiddenItemTimer\"\n      [ngClass]=\"{\n        'badges-exceeded':\n          instanceData.questionTime == 0 ||\n          timeSpentForItem > instanceData.questionTime ||\n          isItemTimeExceeded ||\n          instanceData.quizTime == 0 ||\n          instanceData.totalTimeSpent > instanceData.quizTime ||\n          isTotalTimeExceeded\n      }\"\n    >\n      <span\n        class=\"quiz-bades-label\"\n        *ngIf=\"\n          timeSpentForItem < instanceData.questionTime && !isItemTimeExceeded\n        \"\n        >Time Spent on Question</span\n      >\n      <span\n        class=\"quiz-bades-label\"\n        *ngIf=\"\n          instanceData.questionTime == 0 ||\n          timeSpentForItem > instanceData.questionTime ||\n          isItemTimeExceeded\n        \"\n        >Time on Question Exceeded</span\n      >\n\n      <span\n        class=\"wkqp-badge\"\n        [ngClass]=\"\n          instanceData.questionTime == 0 ||\n          timeSpentForItem > instanceData.questionTime ||\n          isItemTimeExceeded\n            ? 'wkqp-badge-danger'\n            : 'wkqp-badge-success'\n        \"\n      >\n        <lib-timer\n          #itemTimer\n          [timerConfig]=\"itemTimerConfig\"\n          (timeExceeded)=\"itemTimeExceeded()\"\n        ></lib-timer>\n      </span>\n    </div>\n    <ng-template #hiddenItemTimer>\n      <div class=\"hidden-conatiner\">\n        <lib-timer\n          #itemTimer\n          [timerConfig]=\"itemTimerConfig\"\n          (timeExceeded)=\"itemTimeExceeded()\"\n        ></lib-timer>\n      </div>\n    </ng-template>\n    <div\n      class=\"quiz-badges-child\"\n      *ngIf=\"testModeSettings.showCorrect && testProgress\"\n      [ngClass]=\"{\n        'badges-exceeded':\n          instanceData.questionTime == 0 ||\n          timeSpentForItem > instanceData.questionTime ||\n          isItemTimeExceeded ||\n          instanceData.quizTime == 0 ||\n          instanceData.totalTimeSpent > instanceData.quizTime ||\n          isTotalTimeExceeded\n      }\"\n    >\n      <span class=\"quiz-bades-label\">Correct</span>\n\n      <span class=\"wkqp-badge\">{{ testProgress.totalCorrectAnswers }}</span>\n    </div>\n    <div\n      class=\"quiz-badges-child\"\n      [ngClass]=\"{\n        'badges-exceeded':\n          instanceData.questionTime == 0 ||\n          timeSpentForItem > instanceData.questionTime ||\n          isItemTimeExceeded ||\n          instanceData.quizTime == 0 ||\n          instanceData.totalTimeSpent > instanceData.quizTime ||\n          isTotalTimeExceeded\n      }\"\n      *ngIf=\"testModeSettings.showIncorrect && testProgress\"\n    >\n      <span class=\"quiz-bades-label\">Incorrect</span>\n\n      <span class=\"wkqp-badge\">{{ testProgress.totalWrongAnswers }}</span>\n    </div>\n    <div\n      class=\"quiz-badges-child\"\n      [ngClass]=\"{\n        'badges-exceeded':\n          instanceData.questionTime == 0 ||\n          timeSpentForItem > instanceData.questionTime ||\n          isItemTimeExceeded ||\n          instanceData.quizTime == 0 ||\n          instanceData.totalTimeSpent > instanceData.quizTime ||\n          isTotalTimeExceeded\n      }\"\n      *ngIf=\"testModeSettings.showUnanswered && testProgress\"\n    >\n      <span class=\"quiz-bades-label\">Unanswered</span>\n\n      <span class=\"wkqp-badge\">{{ testProgress.totalUnAttempted }}</span>\n    </div>\n    <div\n      class=\"quiz-badges-child\"\n      [ngClass]=\"{\n        'badges-exceeded':\n          instanceData.questionTime == 0 ||\n          timeSpentForItem > instanceData.questionTime ||\n          isItemTimeExceeded ||\n          instanceData.quizTime == 0 ||\n          instanceData.totalTimeSpent > instanceData.quizTime ||\n          isTotalTimeExceeded\n      }\"\n      *ngIf=\"testModeSettings.showTestTimeLimit && instanceData.quizTime > 0\"\n    >\n      <span class=\"quiz-bades-label\">Time Allotted for Quiz</span>\n\n      <span class=\"wkqp-badge\">{{ quizTime }}</span>\n    </div>\n    <div\n      class=\"quiz-badges-child\"\n      [ngClass]=\"{\n        'badges-exceeded':\n          instanceData.questionTime == 0 ||\n          timeSpentForItem > instanceData.questionTime ||\n          isItemTimeExceeded ||\n          instanceData.quizTime == 0 ||\n          instanceData.totalTimeSpent > instanceData.quizTime ||\n          isTotalTimeExceeded\n      }\"\n      *ngIf=\"testModeSettings.showTestTimeSpent; else hiddenQuizTimer\"\n    >\n      <span\n        class=\"quiz-bades-label\"\n        *ngIf=\"\n          instanceData.totalTimeSpent < instanceData.quizTime &&\n          !isTotalTimeExceeded\n        \"\n        >Time Spent on Quiz</span\n      >\n      <span\n        class=\"quiz-bades-label\"\n        *ngIf=\"\n          instanceData.quizTime == 0 ||\n          instanceData.totalTimeSpent > instanceData.quizTime ||\n          isTotalTimeExceeded\n        \"\n        >Time on Quiz Exceeded</span\n      >\n\n      <span\n        class=\"wkqp-badge\"\n        [ngClass]=\"\n          instanceData.quizTime == 0 ||\n          instanceData.totalTimeSpent > instanceData.quizTime ||\n          isTotalTimeExceeded\n            ? 'wkqp-badge-danger'\n            : 'wkqp-badge-success'\n        \"\n      >\n        <lib-timer\n          #quizTimer\n          [timerConfig]=\"quizTimerConfig\"\n          (timeExceeded)=\"totalTimeExceeded()\"\n        ></lib-timer>\n      </span>\n    </div>\n    <ng-template #hiddenQuizTimer>\n      <div class=\"hidden-conatiner\">\n        <lib-timer\n          #quizTimer\n          [timerConfig]=\"quizTimerConfig\"\n          (timeExceeded)=\"totalTimeExceeded()\"\n        ></lib-timer>\n      </div>\n    </ng-template>\n    <div\n      class=\"quiz-badges-child\"\n      [ngClass]=\"{\n        'badges-exceeded':\n          instanceData.questionTime == 0 ||\n          timeSpentForItem > instanceData.questionTime ||\n          isItemTimeExceeded ||\n          instanceData.quizTime == 0 ||\n          instanceData.totalTimeSpent > instanceData.quizTime ||\n          isTotalTimeExceeded\n      }\"\n      *ngIf=\"testModeSettings.showItems\"\n    >\n      <span class=\"quiz-bades-label\">Question</span>\n\n      <span class=\"wkqp-badge\"\n        >{{ itemData && itemData.sequence ? itemData.sequence : '' }} of\n        {{ instanceData.numberOfQuestions }}</span\n      >\n    </div>\n  </ng-container>\n</div>\n",
        styles: [".quiz-header-badges{display:flex;padding:10px;background:var(--secondary-color)}.quiz-badges-child:last-child{padding-right:0}.quiz-bades-label{padding-bottom:5px;line-height:18px;display:block;min-height:40px}table.correct-inline-text span.wkqp-badge{white-space:normal}.hidden-conatiner{display:none}"]
    })
], HeaderComponent);

let TestIndexComponent = class TestIndexComponent {
    constructor() {
        this.indexChanged = new EventEmitter();
    }
    ngOnChanges(changes) { }
    ngOnInit() { }
    questionChanged(index) {
        this.currentIndex = this.indexOfItems[index].sequence;
        this.indexChanged.emit(this.indexOfItems[index]);
    }
    updateBookMarkStatus(bookmarkDetails) {
        if (!bookmarkDetails ||
            (this.indexOfItems && this.indexOfItems.length === 0)) {
            return false;
        }
        this.indexOfItems.map(object => {
            if (object.itemId === bookmarkDetails.itemId) {
                object.itemBookmark = bookmarkDetails.bookmarkstatus;
            }
        });
    }
};
__decorate([
    Input()
], TestIndexComponent.prototype, "indexOfItems", void 0);
__decorate([
    Input()
], TestIndexComponent.prototype, "selectedTheme", void 0);
__decorate([
    Input()
], TestIndexComponent.prototype, "currentIndex", void 0);
__decorate([
    Output()
], TestIndexComponent.prototype, "indexChanged", void 0);
TestIndexComponent = __decorate([
    Component({
        selector: 'lib-test-index',
        template: "<ng-container *ngIf=\"indexOfItems && indexOfItems.length > 0\">\n  <ul class=\"list-item\">\n    <ng-container *ngFor=\"let item of indexOfItems; let i = index\">\n      <li\n        (click)=\"questionChanged(i)\"\n        [attr.data-index]=\"i\"\n        [class.list-item-selected]=\"item.sequence == currentIndex\"\n      >\n        {{ i + 1 }}\n        <ng-container *ngIf=\"item.itemBookmark == true\">\n          <img\n            class=\"examTaker-marked-icon\"\n            src=\"assets/engine-icons/mark-icon.png\"\n          />\n        </ng-container>\n      </li>\n    </ng-container>\n  </ul>\n</ng-container>\n",
        styles: [".list-item{margin:0;padding:0}.list-item li{list-style:none;margin:0;padding:3px 5px 3px 18px;width:100%;text-align:left;font-size:13px;position:relative;color:var(--text-color)}.list-item li:before{content:'';font-size:40px;color:var(--text-color);position:absolute;left:8px;top:10px;line-height:normal;width:5px;height:5px;background-color:var(--secondary-color);border-radius:50%}.list-item li:hover:before{color:#fff;background-color:#fff}.list-item li:nth-child(2n-2){background-color:var(--secondary-color)}.list-item-selected{background-color:var(--primary-color)!important;pointer-events:none;color:#fff}.list-item li:hover{background-color:var(--primary-color)!important;cursor:pointer;color:#fff}.list-item-selected:before{color:#fff;background-color:#fff!important}.examTaker-marked-icon{width:8px}"]
    })
], TestIndexComponent);

let ThemeService = class ThemeService {
    constructor() {
        this.activeTheme = new BehaviorSubject(ThemesEnum.BlueTheme);
        this.invertColor = new BehaviorSubject(false);
        this.fontSize = new BehaviorSubject(FontSizeEnum.SmallFont);
    }
    setActiveTheme(themeId) {
        this.activeTheme.next(themeId);
    }
    setFontSize(fontSizeInPx) {
        this.fontSize.next(fontSizeInPx);
    }
    toggleInverseColor() {
        this.invertColor.next(!this.invertColor.value);
    }
};
ThemeService.ɵprov = ɵɵdefineInjectable({ factory: function ThemeService_Factory() { return new ThemeService(); }, token: ThemeService, providedIn: "root" });
ThemeService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], ThemeService);

let QpFeaturesComponent = class QpFeaturesComponent {
    constructor(quizService, themeService) {
        this.quizService = quizService;
        this.themeService = themeService;
        this.nclex = true;
        this.updatedBookMark = new EventEmitter();
        this.updatedNotesData = new EventEmitter();
        this.changedTextSize = new EventEmitter();
        this.changedTheme = new EventEmitter();
        this.updateBookMarkStatus = new EventEmitter();
    }
    ngOnInit() {
        this.testData = this.quizService.testDetails;
        this.testEngineFeatures = this.quizService.testEngineFeatures;
    }
    ngOnChanges(changes) {
        if (this.userAttemptDetails) {
            this.resetFeatures(true);
            this.bookmark = this.userAttemptDetails.itemBookmark;
            this.itemNotes = this.userAttemptDetails.itemNotes;
        }
    }
    updatedBookMarkStatus(bookmark) {
        this.bookmark = bookmark;
        this.updateBookMarkStatus.emit(bookmark);
    }
    updatedNotes(notesData) {
        this.itemNotes = notesData;
    }
    updatedTextSize(size) {
        this.changedTextSize.emit(size);
    }
    resetFeatures(value) {
        this.resetQPFeatures = value;
    }
};
QpFeaturesComponent.ctorParameters = () => [
    { type: QuizService },
    { type: ThemeService }
];
__decorate([
    Input('userAttemptDetails')
], QpFeaturesComponent.prototype, "userAttemptDetails", void 0);
__decorate([
    Output()
], QpFeaturesComponent.prototype, "updatedBookMark", void 0);
__decorate([
    Output()
], QpFeaturesComponent.prototype, "updatedNotesData", void 0);
__decorate([
    Output()
], QpFeaturesComponent.prototype, "changedTextSize", void 0);
__decorate([
    Output()
], QpFeaturesComponent.prototype, "changedTheme", void 0);
__decorate([
    Output()
], QpFeaturesComponent.prototype, "updateBookMarkStatus", void 0);
QpFeaturesComponent = __decorate([
    Component({
        selector: 'lib-qp-features',
        template: "<div class=\"qp-feature-wrapper\" *ngIf=\"testEngineFeatures\">\n  <wkqp-item-bookmark\n    *ngIf=\"testEngineFeatures.showFlagQuestion\"\n    [isBookMarked]=\"bookmark\"\n    (updatedBookMarkStatus)=\"updatedBookMarkStatus($event)\"\n  ></wkqp-item-bookmark>\n\n  <wkqp-item-notes\n    *ngIf=\"testEngineFeatures.showQuestionNote\"\n    [resetFeature]=\"resetQPFeatures\"\n    [currentNotes]=\"itemNotes\"\n    (updatedNotes)=\"updatedNotes($event)\"\n    (updateResetValue)=\"resetFeatures(false)\"\n  ></wkqp-item-notes>\n\n  <wkqp-lab-values\n    *ngIf=\"testEngineFeatures.showStaticLabValues\"\n    [resetFeature]=\"resetQPFeatures\"\n    (updateResetValue)=\"resetFeatures(false)\"\n  ></wkqp-lab-values>\n\n  <wkqp-nclex-exam-calculator\n    *ngIf=\"testEngineFeatures.showCalculator && nclex\"\n    [resetFeature]=\"resetQPFeatures\"\n    (updateResetValue)=\"resetFeatures(false)\"\n  ></wkqp-nclex-exam-calculator>\n\n  <wkqp-usmle-exam-calculator\n    *ngIf=\"testEngineFeatures.showCalculator && !nclex\"\n    [resetFeature]=\"resetQPFeatures\"\n    (updateResetValue)=\"resetFeatures(false)\"\n  ></wkqp-usmle-exam-calculator>\n\n  <wkqp-inverse-theme\n    *ngIf=\"testEngineFeatures.showReverseEngineColor\"\n    [inverseColor]=\"themeService.invertColor | async\"\n  ></wkqp-inverse-theme>\n\n  <wkqp-text-zoom\n    *ngIf=\"testEngineFeatures.showTextZoom\"\n    [fontSize]=\"themeService.fontSize | async\"\n  ></wkqp-text-zoom>\n</div>\n",
        styles: [".qp-feature-wrapper{display:flex;align-items:center;justify-content:flex-end}"]
    })
], QpFeaturesComponent);

let ItemService = class ItemService {
    constructor() {
        this.hideShow = new BehaviorSubject(false);
        this.currentState = this.hideShow.asObservable();
        this.clearAnswer = new BehaviorSubject(false);
        this.currentAnswerState = this.clearAnswer.asObservable();
        this.userAnswer = new BehaviorSubject([]);
        this.userAnswerState = this.userAnswer.asObservable();
        this.duplicateValue = new BehaviorSubject(false);
        this.duplicateValueState = this.duplicateValue.asObservable();
        this.validateAnswerValue = new BehaviorSubject(false);
        this.validateAnswerValueState = this.validateAnswerValue.asObservable();
        this.validateCompleteEntry = new BehaviorSubject(false);
        this.validateCompleteEntryState = this.validateCompleteEntry.asObservable();
        this.fontSelected = new BehaviorSubject(1);
        this.currentFont = this.fontSelected.asObservable();
        this.themeSelected = new BehaviorSubject(false);
        this.currentTheme = this.themeSelected.asObservable();
        this.assetImagePath = './assets/media/';
        this.assetVideoPath = './assets/media/';
        this.assetAudioPath = './assets/media/';
    }
    // Function to show answer event
    showAnswer(state) {
        this.hideShow.next(true);
    }
    // Function to hide answer event
    hideAnswer(state) {
        this.hideShow.next(false);
    }
    // Function to clear answer event
    clearAnswerMethod(state) {
        this.clearAnswer.next(true);
    }
    clearAnswerMethodFalse(state) {
        this.clearAnswer.next(false);
    }
    userAnswerMethod(data) {
        this.userAnswer.next(data);
    }
    duplicateValueMethod(data) {
        this.duplicateValue.next(data);
    }
    validateAnswerValueMethod(data) {
        this.validateAnswerValue.next(data);
    }
    validateCompleteEntryMethod(data) {
        this.validateCompleteEntry.next(data);
    }
    userSelectedFont(data) {
        this.fontSelected.next(data);
    }
    userSelectedTheme(data) {
        this.themeSelected.next(data);
    }
    setUserAnswer(answer) {
        this.userSelectedAnswer = answer;
    }
    getUserAnswer() {
        return this.userSelectedAnswer;
    }
    set userAnswers(userAnswer) {
        this.currentUserAnswer = userAnswer;
    }
    get userAnswers() {
        return this.currentUserAnswer;
    }
};
ItemService.ɵprov = ɵɵdefineInjectable({ factory: function ItemService_Factory() { return new ItemService(); }, token: ItemService, providedIn: "root" });
ItemService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], ItemService);

let QPBaseComponent = class QPBaseComponent {
    constructor(quizService, itemService, themeService) {
        this.quizService = quizService;
        this.itemService = itemService;
        this.themeService = themeService;
        this.isSummary = false;
        this.currentIndex = 1;
        this.selectedTheme = false;
        /* Outputs */
        this.questionChanged = new EventEmitter();
        this.pageChanged = new EventEmitter();
        this.itemChangedByIndex = new EventEmitter();
        this.reportContentErrorData = new EventEmitter();
        this.sendReportContentErrorDetails = new EventEmitter();
    }
    ngOnChanges(changes) {
        if (changes.itemData && changes.itemData.currentValue) {
            this.setItemDetails();
        }
        else if (changes.summaryData && changes.summaryData.currentValue) {
            this.isSummary = true;
        }
    }
    ngOnInit() {
        if (this.testData) {
            this.quizService.testDetails = this.testData;
            this.preferredTextFormat = this.testData.preferredTextFormat;
            if (this.testData.additionalTestModeSettings) {
                this.canShowTitle = this.testData.additionalTestModeSettings.showTestTitle;
            }
            this.themeService.setActiveTheme(this.testData['testEngineTheme']);
        }
        this.quizService.isOnline = this.isOnline;
        if (this.summaryData) {
            this.isSummary = true;
        }
        if (this.examEngineType) {
            this.quizService.engineType = this.examEngineType;
        }
        if (this.systemConfig) {
            this.quizService.systemConfig = this.systemConfig;
        }
    }
    setItemDetails() {
        this.currentItem = this.itemData;
        this.resetItemData();
        if (this.currentItem &&
            this.currentItem.modelFeedback &&
            this.currentItem.modelFeedback.length > 0) {
            this.currentItem.modelFeedback[0].preferredTextFormat = this.preferredTextFormat;
        }
        if (this.currentItem && this.currentItem.itemTypeName === 'Hotspot') {
            this.imagePath = this.currentItem.assets[0]
                ? this.currentItem.assets[0].assetPath
                : '';
        }
        if (this.currentItem && this.currentItem.userAttemptDetails) {
            this.userAttemptDetails = this.currentItem.userAttemptDetails;
        }
        this.currentIndex = this.currentItem.sequence
            ? this.currentItem.sequence
            : 1;
    }
    /* Function which will set the user answer from the item types */
    getUserAnswer(event) {
        this.userAnswer = event;
    }
    /* When user trigger next or previous event */
    nextorPreviousItem(event) {
        this.featureContainer.resetFeatures(true);
        let userAnswerData = this.formatSubmitAnswerPayload(event);
        this.questionChanged.emit(userAnswerData);
    }
    /* show answer */
    showAnswerStatus(event) {
        this.showHide = event;
    }
    /* Clear response */
    clearResponse(event) {
        this.clearAnswer = true;
        setTimeout(() => {
            this.clearAnswer = false;
        }, 100);
    }
    /*reset default for features */
    resetItemData() {
        this.emptyAnswer = false;
        this.clearAnswer = false;
        this.showHide = false;
        this.itemData = null;
    }
    paginationChanged(event) {
        this.pageChanged.emit(event);
    }
    canShowIndex() {
        const testEngineFeatures = this.quizService.testEngineFeatures;
        if (testEngineFeatures && testEngineFeatures.showQuizIndex) {
            return true;
        }
        return false;
    }
    indexChanged(indexValue) {
        this.featureContainer.resetFeatures(true);
        let userAnswerData = this.formatSubmitAnswerPayload();
        userAnswerData['indexData'] = indexValue;
        this.itemChangedByIndex.emit(userAnswerData);
        this.currentItem = null;
    }
    /* Update bookmark status into index */
    updateBookMarkStatus(bookmarkstatus) {
        const bookmasrkStatusObject = {
            bookmarkstatus: bookmarkstatus,
            itemId: this.currentItem.id
        };
        this.testIndexComponent.updateBookMarkStatus(bookmasrkStatusObject);
    }
    /* Format payload as per the function which needs to be called next */
    formatSubmitAnswerPayload(event = '') {
        if (this.currentItem.itemType === 24) {
            this.userAnswer = this.itemService.userAnswers;
        }
        let userAnswerData = new SubmitAnswerPayload();
        userAnswerData.userAnswer = this.userAnswer['userAnswer'];
        userAnswerData.correct = this.userAnswer['correct'];
        userAnswerData.timeSpentForItem = this.header.getItemTimeSpent();
        userAnswerData.itemBookmark = this.featureContainer.bookmark;
        userAnswerData.itemNotes = this.featureContainer.itemNotes;
        userAnswerData.submit = event === 'SUBMIT' ? true : false;
        userAnswerData.navigation = event;
        return userAnswerData;
    }
    reportContentError(clientDetails) {
        this.reportContentErrorData.emit(clientDetails);
    }
    sendReportContentError(mailContent) {
        this.sendReportContentErrorDetails.emit(mailContent);
    }
};
QPBaseComponent.ctorParameters = () => [
    { type: QuizService },
    { type: ItemService },
    { type: ThemeService }
];
__decorate([
    Input('systemConfig')
], QPBaseComponent.prototype, "systemConfig", void 0);
__decorate([
    Input('testData')
], QPBaseComponent.prototype, "testData", void 0);
__decorate([
    Input('testProgress')
], QPBaseComponent.prototype, "testProgress", void 0);
__decorate([
    Input('itemData')
], QPBaseComponent.prototype, "itemData", void 0);
__decorate([
    Input('summaryData')
], QPBaseComponent.prototype, "summaryData", void 0);
__decorate([
    Input('isOnline')
], QPBaseComponent.prototype, "isOnline", void 0);
__decorate([
    Input('indexData')
], QPBaseComponent.prototype, "indexOfItems", void 0);
__decorate([
    Input('examEngineType')
], QPBaseComponent.prototype, "examEngineType", void 0);
__decorate([
    Input()
], QPBaseComponent.prototype, "templateData", void 0);
__decorate([
    Input()
], QPBaseComponent.prototype, "mailSuccessData", void 0);
__decorate([
    Input('disableNav')
], QPBaseComponent.prototype, "disableNav", void 0);
__decorate([
    Output()
], QPBaseComponent.prototype, "questionChanged", void 0);
__decorate([
    Output()
], QPBaseComponent.prototype, "pageChanged", void 0);
__decorate([
    Output()
], QPBaseComponent.prototype, "itemChangedByIndex", void 0);
__decorate([
    Output()
], QPBaseComponent.prototype, "reportContentErrorData", void 0);
__decorate([
    Output()
], QPBaseComponent.prototype, "sendReportContentErrorDetails", void 0);
__decorate([
    ViewChild(HeaderComponent, { static: false })
], QPBaseComponent.prototype, "header", void 0);
__decorate([
    ViewChild(QpFeaturesComponent, { static: false })
], QPBaseComponent.prototype, "featureContainer", void 0);
__decorate([
    ViewChild(TestIndexComponent, { static: false })
], QPBaseComponent.prototype, "testIndexComponent", void 0);
QPBaseComponent = __decorate([
    Component({
        selector: 'qp-base',
        template: "<!-- <lib-app-theme-selector [testData]=\"testData\" (emitSelectedAppTheme)=\"recieveSelectedTheme($event)\"></lib-app-theme-selector> -->\n<div\n  class=\"qp-base-container\"\n  appTheme\n  [activeTheme]=\"themeService.activeTheme | async\"\n>\n  <ng-container *ngIf=\"!isSummary; else summaryPage\">\n    <div\n      class=\"sidbar-index-item\"\n      *ngIf=\"canShowIndex()\"\n      inverseColor\n      [activeTheme]=\"themeService.activeTheme | async\"\n      [isInvert]=\"themeService.invertColor | async\"\n    >\n      <lib-test-index\n        [selectedTheme]=\"selectedTheme\"\n        [currentIndex]=\"currentIndex\"\n        [indexOfItems]=\"indexOfItems\"\n        (indexChanged)=\"indexChanged($event)\"\n      ></lib-test-index>\n    </div>\n    <div\n      class=\"qp-items-wrapper\"\n      [ngClass]=\"{ 'no-side-bar': !canShowIndex() }\"\n    >\n      <div class=\"qp-header\">\n        <div class=\"qp-header-row-one\">\n          <div class=\"qp-header-row-one-left\" *ngIf=\"canShowTitle\">\n            <h1>{{ testData.title }}</h1>\n          </div>\n          <div class=\"qp-header-row-one-right\">\n            <lib-qp-features\n              #featureContainer\n              [userAttemptDetails]=\"userAttemptDetails\"\n              (updateBookMarkStatus)=\"updateBookMarkStatus($event)\"\n            ></lib-qp-features>\n          </div>\n        </div>\n        <div class=\"qp-header-row-two\">\n          <qp-header\n            class=\"qp-header-innerwrapper\"\n            #h\n            [itemData]=\"currentItem\"\n            [testProgress]=\"testProgress\"\n          >\n          </qp-header>\n        </div>\n      </div>\n\n      <div\n        class=\"qp-article\"\n        inverseColor\n        [activeTheme]=\"themeService.activeTheme | async\"\n        [isInvert]=\"themeService.invertColor | async\"\n        fontSize\n        [fontSize]=\"themeService.fontSize | async\"\n      >\n        <ng-container *ngIf=\"currentItem; else loader\">\n          <item-type-wrapper\n            [imagePath]=\"imagePath\"\n            [testData]=\"testData\"\n            [isClearAnswer]=\"clearAnswer\"\n            [isShowHide]=\"showHide\"\n            [questionCurrentData]=\"currentItem\"\n            [examEngineType]=\"examEngineType\"\n            (userAnswerValue)=\"getUserAnswer($event)\"\n          >\n          </item-type-wrapper>\n        </ng-container>\n        <ng-template #loader>\n          <div class=\"loader-container\">\n            <span class=\"wk-icon-spin wk-spin wkqp-spin-center\"></span>\n          </div>\n        </ng-template>\n      </div>\n      <div class=\"qp-footer\">\n        <qp-footer\n          #f\n          [itemData]=\"currentItem\"\n          [userAnswer]=\"userAnswer\"\n          [testProgress]=\"testProgress\"\n          [disableNav]=\"disableNav\"\n          (questionChanged)=\"nextorPreviousItem($event)\"\n          (showAnswerStatus)=\"showAnswerStatus($event)\"\n          (clearResponseEmitter)=\"clearResponse($event)\"\n        >\n        </qp-footer>\n      </div>\n    </div>\n  </ng-container>\n  <ng-template #summaryPage>\n    <div class=\"qp-items-wrapper\">\n      <qp-summary\n        [summaryData]=\"summaryData\"\n        [testData]=\"testData\"\n        (pageChanged)=\"paginationChanged($event)\"\n        [templateData]=\"templateData\"\n        [mailSuccessData]=\"mailSuccessData\"\n        (reportContentError)=\"reportContentError($event)\"\n        (sendReportContentError)=\"sendReportContentError($event)\"\n      ></qp-summary>\n    </div>\n  </ng-template>\n</div>\n",
        styles: [".qp-base-container{display:flex;width:100%;max-width:75rem;margin-left:auto;margin-right:auto}.qp-items-wrapper{flex:1;flex-direction:column;height:100%}.qp-header{padding-bottom:0}.qp-article{padding-top:20px;padding-left:3px;padding-right:3px;min-height:300px;float:left;width:100%}.qp-inverse-color{background-color:#000;color:var(--text-color)}.qp-footer{padding:0 0 20px}.qp-header-row-one{display:flex;align-items:start;padding:16px 0 0}.qp-header-row-one-left{width:50%}.qp-header-row-one-left h1{margin:0}.qp-header-row-one-right{display:flex;justify-content:flex-end;flex:1}.qp-header-row-two{display:flex;align-items:center}.sidbar-index-item{width:80px;border:1px solid #a3a3a3;overflow-y:auto;min-height:100%;margin-top:15px;margin-right:15px;max-height:540px}.qp-header-innerwrapper{flex-grow:1;padding-top:5px}.loader-container{position:absolute;top:300px;left:50%;transform:translate(-50%,0);text-align:center}.loader-container span{font-size:50px;color:var(--primary-color)}.loader-container h2{font-size:24px;text-align:center;width:100%;margin:0;padding:0}"]
    })
], QPBaseComponent);

let MediaControlsComponent = class MediaControlsComponent {
    constructor() {
        this.timer = [];
        this.updateTimer = function () {
            let eTime;
            let tTime, eSeconds, eMinutes, tMinutes, tSeconds;
            // calculate elapsed time
            eSeconds = Math.round(this.video.currentTime);
            eMinutes = Math.floor(eSeconds / 60);
            eMinutes = eMinutes >= 10 ? eMinutes : eMinutes;
            eSeconds = Math.floor(eSeconds % 60);
            eSeconds = eSeconds >= 10 ? eSeconds : '0' + eSeconds;
            // calculate total time
            tSeconds = Math.round(this.video.duration);
            tMinutes = Math.floor(tSeconds / 60);
            tMinutes = tMinutes >= 10 ? tMinutes : tMinutes;
            tSeconds = Math.floor(tSeconds % 60);
            tSeconds = tSeconds >= 10 ? tSeconds : '0' + tSeconds;
            // assign these values to our variables
            eTime =
                '' +
                    (isNaN(eMinutes) ? '0' : eMinutes) +
                    ':' +
                    (isNaN(eSeconds) ? '00' : eSeconds);
            tTime =
                '' +
                    (isNaN(tMinutes) ? '0' : tMinutes) +
                    ':' +
                    (isNaN(tSeconds) ? '00' : tSeconds);
            if (this.type === 'video') {
                this.timer = '' + eTime + '/' + tTime;
            }
            else {
                this.timer = '' + eTime + '/' + tTime;
            }
        };
    }
    ngOnInit() {
        setTimeout(() => {
            this.video = this.element.nativeElement.parentElement.previousElementSibling;
            this.playPauseButton = this.element.nativeElement['children'][0];
            this.seekBar = this.element.nativeElement['children'][1];
            this.mute = this.element.nativeElement['children'][2];
            this.volumeBar = this.element.nativeElement['children'][3];
            if (this.video !== undefined) {
                this.getControls();
            }
        }, 300);
    }
    getControls() {
        this.seekBar.addEventListener('change', () => {
            const time = this.video.duration * (this.seekBar.value / 100);
            this.video.currentTime = time;
            this.updateTimer();
        });
        this.video.addEventListener('timeupdate', () => {
            const value = (100 / this.video.duration) * this.video.currentTime;
            this.seekBar.value = value;
            this.updateTimer();
        });
        this.seekBar.addEventListener('mousedown', () => {
            this.playPause();
        });
        this.seekBar.addEventListener('mouseup', () => {
            this.playPause();
        });
        this.volumeBar.addEventListener('change', () => {
            this.video.volume = this.volumeBar.value;
        });
        this.video.addEventListener('ended', () => {
            this.video.currentTime = 0.1;
        });
    }
    playPause() {
        if (this.video.paused !== undefined) {
            if (this.video.paused === true) {
                this.video.play();
                this.updateTimer();
                this.playPauseButton.innerHTML = `<i class='fa fa-pause' aria-hidden='true'></i>`;
                this.playPauseButton.setAttribute('aria-label', 'Play');
            }
            else {
                this.video.pause();
                this.updateTimer();
                this.playPauseButton.innerHTML = `<i class='fa fa-play' aria-hidden='true'></i>`;
                this.playPauseButton.setAttribute('aria-label', 'Pause');
            }
        }
    }
    fullScreen() {
        if (this.video.requestFullscreen) {
            this.video.requestFullscreen();
        }
        else if (this.video.mozRequestFullScreen) {
            this.video.mozRequestFullScreen(); // Firefox
        }
        else if (this.video.webkitRequestFullscreen) {
            this.video.webkitRequestFullscreen(); // Chrome and Safari
        }
        else if (this.video.webkitSupportsFullscreen) {
            this.video.webkitEnterFullscreen();
        }
    }
    muted() {
        if (this.video.muted === false) {
            this.video.muted = true;
        }
        else {
            this.video.muted = false;
        }
    }
};
__decorate([
    ViewChild('element', { static: true })
], MediaControlsComponent.prototype, "element", void 0);
__decorate([
    Input()
], MediaControlsComponent.prototype, "assetId", void 0);
__decorate([
    Input()
], MediaControlsComponent.prototype, "assetType", void 0);
__decorate([
    Input()
], MediaControlsComponent.prototype, "controlsPosition", void 0);
MediaControlsComponent = __decorate([
    Component({
        selector: 'app-media-controls',
        template: "<div\n  class=\"video-controls media-controls\"\n  [ngClass]=\"{ 'media-asset-control': controlsPosition == 'graphic' }\"\n  #element\n  id=\"mediaControls\"\n>\n  <button\n    type=\"button\"\n    aria-label=\"Play\"\n    class=\"play-pause\"\n    (click)=\"playPause()\"\n  >\n    <i class=\"fa fa-play\" aria-hidden=\"true\"></i>\n  </button>\n  <input\n    type=\"range\"\n    aria-label=\"seek bar\"\n    class=\"seek-bar\"\n    value=\"0\"\n    aria-valuemin=\"0\"\n    aria-valuemax=\"100\"\n    aria-valuenow=\"\"\n  />\n  <span\n    *ngIf=\"assetType == 'video' && timer.length == 0\"\n    id=\"videotimer{{ assetId }}\"\n    aria-label=\"seek Timer\"\n    class=\"seek-timer\"\n    >0.00.00</span\n  >\n  <span\n    *ngIf=\"assetType == 'video' && timer.length !== 0\"\n    id=\"videotimer{{ assetId }}\"\n    aria-label=\"seek Timer\"\n    class=\"seek-timer\"\n    >{{ timer }}</span\n  >\n  <span\n    *ngIf=\"assetType == 'audio' && timer.length == 0\"\n    id=\"videotimer{{ assetId }}\"\n    aria-label=\"seek Timer\"\n    class=\"seek-timer\"\n    >0.00.00</span\n  >\n  <span\n    *ngIf=\"assetType == 'audio' && timer.length !== 0\"\n    id=\"audiotimer{{ assetId }}\"\n    aria-label=\"seek Timer\"\n    class=\"seek-timer\"\n    >{{ timer }}</span\n  >\n  <button\n    type=\"button\"\n    aria-label=\"mute\"\n    class=\"mute\"\n    (click)=\"muted()\"\n    *ngIf=\"video?.muted == true\"\n  >\n    <i class=\"fa fa-volume-off\" aria-hidden=\"true\"></i\n    ><i class=\"fa fa-times volume-mute\" aria-hidden=\"true\"></i>\n  </button>\n  <button\n    type=\"button\"\n    aria-label=\"mute\"\n    class=\"mute\"\n    (click)=\"muted()\"\n    *ngIf=\"video?.muted !== true\"\n  >\n    <i class=\"fa fa-volume-up\" aria-hidden=\"true\"></i>\n  </button>\n  <input\n    type=\"range\"\n    style=\"display:none;\"\n    class=\"volume-bar\"\n    min=\"0\"\n    max=\"1\"\n    step=\"0.1\"\n    value=\"1\"\n  />\n  <button\n    *ngIf=\"assetType == 'video'\"\n    aria-label=\"full screen\"\n    type=\"button\"\n    class=\"full-screen\"\n    (click)=\"fullScreen()\"\n  >\n    <i class=\"fa fa-arrows-alt\" aria-hidden=\"true\"></i>\n  </button>\n</div>\n",
        styles: [".media-asset-control{float:left;width:400px;clear:both}.volume-mute{font-size:12px;position:relative;top:-3px;left:0}"]
    })
], MediaControlsComponent);

let MultipleChoiceComponent = class MultipleChoiceComponent {
    constructor(itemService, formBuilder) {
        this.itemService = itemService;
        this.formBuilder = formBuilder;
        this.userAnswer = [];
        this.userSelectedLabel = [];
        this.assetData = [];
        this.radioValue = {};
        this.questionDetails1 = [];
        this.assetPosition = [];
        // tslint:disable-next-line:max-line-length
        this.alphabetsIndex = [
            "A",
            "B",
            "C",
            "D",
            "E",
            "F",
            "G",
            "H",
            "I",
            "J",
            "K",
            "L",
            "M",
            "N",
            "O",
            "P",
            "Q",
            "R",
            "S",
            "T",
            "U",
            "V",
            "W",
            "X",
            "Y",
            "Z"
        ];
        this.incorrectRationale = [];
        this.imagePath = [];
    }
    get questionDetails() {
        return this.questionDetails;
    }
    set questionCurrentData(value) {
        if (value) {
            this.questionDetails1 = value;
            this.createQuestion();
        }
        else {
            this.questionDetails1 = [];
            this.createQuestion();
        }
    }
    /* Init */
    ngOnInit() { }
    /* Do check */
    ngDoCheck() {
        if (this.isClearAnswer === true) {
            this.clearUserInputs();
            this.itemService.userAnswerMethod([]);
            this.itemService.clearAnswerMethodFalse(false);
            this.itemService.hideAnswer(false);
        }
        if (this.isShowHide === true) {
            this.message = true;
        }
        else if (this.isShowHide === false) {
            this.message = false;
        }
    }
    ngOnChanges(changes) { }
    /* function to get selected answer */
    selectAnswer(option) {
        this.radioValue = option;
        this.userAnswer = this.radioValue["choiceId"];
        if (this.userAnswer !== undefined && this.userAnswer !== null) {
            const answerObj = [this.userAnswer];
            this.itemService.userAnswerMethod(answerObj);
            this.itemService.validateAnswerValueMethod(this.isUserAnswersCorrect());
        }
        else {
            this.itemService.userAnswerMethod([]);
            this.itemService.validateAnswerValueMethod(false);
        }
    }
    /* function to get correct answer*/
    correctAnswer() {
        for (const i of this.questionDetails1.choiceInteraction.simpleChoices) {
            if (i.correct === true) {
                this.correctAns = i;
            }
        }
        this.incorrectRationale = this.questionDetails1.choiceInteraction.simpleChoices.filter(item => item.rationale !== null && item.correct !== true);
    }
    /*Check whether user selected Answer is correct or not */
    isUserAnswersCorrect() {
        if (this.userAnswer === this.correctAns.choiceId) {
            return true;
        }
        else {
            return false;
        }
    }
    /* function to clear user inputs */
    clearUserInputs() {
        this.userAnswer = [];
        this.form.reset();
    }
    /* Get Choice css class */
    getChoiceClassName(choiceDetails) {
        if (choiceDetails.correct) {
            return "wk-icon-checkmark green-checkmark";
        }
        else if (!choiceDetails.correct &&
            this.userAnswer === choiceDetails.choiceId) {
            return "wk-icon-close wrong-checkmark";
        }
        else {
            return "wk-icon-checkmark disabled-checkmark";
        }
    }
    /* Check everytime when value change */
    valueChanged() {
        if (this.userAnswer !== undefined && this.userAnswer !== null) {
            const answerObj = this.userAnswer.length !== 0 ? [this.userAnswer] : this.userAnswer;
            this.itemService.userAnswerMethod(answerObj);
            this.itemService.validateAnswerValueMethod(this.isUserAnswersCorrect());
        }
        else {
            this.itemService.userAnswerMethod([]);
            this.itemService.validateAnswerValueMethod(false);
        }
    }
    createQuestion() {
        this.radioValue = {};
        this.userAnswer = [];
        this.correctAns = [];
        this.itemService.userAnswerMethod([]);
        this.itemService.validateAnswerValueMethod(false);
        // Get user Answer value
        this.itemService.userAnswerState.subscribe(answer => (this.userAnswerService = answer));
        this.assetData = this.questionDetails1.assets;
        if (this.assetData.length !== 0) {
            this.assetPosition = this.questionDetails1.assets[0]["assetsPosition"];
        }
        this.correctAnswer();
        if (this.questionDetails1.userAttemptDetails.userAnswer !== undefined &&
            Object.keys(this.questionDetails1.userAttemptDetails.userAnswer)
                .length !== 0) {
            for (const j of this.questionDetails1.choiceInteraction.simpleChoices) {
                if (this.questionDetails1.userAttemptDetails.userAnswer[0] ===
                    j["choiceId"]) {
                    this.radioValue = j;
                    this.userAnswer = this.radioValue["choiceId"];
                }
            }
        }
        this.form = this.formBuilder.group({
            choices: [this.radioValue["choiceId"]]
        });
        this.valueChanged();
    }
};
MultipleChoiceComponent.ctorParameters = () => [
    { type: ItemService },
    { type: FormBuilder }
];
__decorate([
    Input("questionDetails")
], MultipleChoiceComponent.prototype, "questionCurrentData", null);
__decorate([
    Input()
], MultipleChoiceComponent.prototype, "examEngineType", void 0);
__decorate([
    Input()
], MultipleChoiceComponent.prototype, "isClearAnswer", void 0);
__decorate([
    Input()
], MultipleChoiceComponent.prototype, "isShowHide", void 0);
__decorate([
    Input()
], MultipleChoiceComponent.prototype, "checkQuizSubmission", void 0);
__decorate([
    Input()
], MultipleChoiceComponent.prototype, "imagePath", void 0);
__decorate([
    Input()
], MultipleChoiceComponent.prototype, "canShowMetadata", void 0);
__decorate([
    Input()
], MultipleChoiceComponent.prototype, "preferredTextFormat", void 0);
MultipleChoiceComponent = __decorate([
    Component({
        selector: "multiple-choice",
        template: "<!-- #####################QP Multiple choice question template############### -->\n<ng-container *ngIf=\"examEngineType == 'QP' || examEngineType == 'NCLEX'\">\n  <!-- Question and Answer  Block-->\n  <div class=\"wk-row\">\n    <div class=\"fullwidth-box\">\n      <media-carousel\n        *ngIf=\"\n          questionDetails1.assets &&\n          questionDetails1.assets.length != 0 &&\n          assetPosition != 'Bottom' &&\n          assetPosition != 'WithinText'\n        \"\n        [imagePath]=\"imagePath\"\n        [assetData]=\"assetData\"\n        [assetsPosition]=\"assetPosition\"\n      ></media-carousel>\n\n      <div\n        [ngClass]=\"{\n          'wk-col-8':\n            questionDetails1.assets != undefined &&\n            questionDetails1.assets.length != 0 &&\n            assetPosition != 'WithinText',\n          'wk-col-12':\n            questionDetails1.assets == undefined ||\n            questionDetails1.assets.length == 0 ||\n            assetPosition == 'WithinText',\n          'right-assets-position-question': assetPosition == 'Right',\n          'left-assets-position-question': assetPosition == 'Left',\n          'top-assets-position-question': assetPosition == 'Top',\n          'bottom-assets-position-question': assetPosition == 'Bottom'\n        }\"\n      >\n        <div\n          class=\"wkqp-layout-item item-questions-des-wrapper multiple-choice-pt0\"\n        >\n          <div class=\"normal-font mb0 item-que-mb0\">\n            <div\n              class=\"wkqp-field-header\"\n              *ngIf=\"assetPosition != 'WithinText'\"\n            >\n              <div\n                class=\"normal-font wkqp-prewrap mb15 white-space-normal\"\n                libGetFormatText\n                [preferredTextFormat]=\"preferredTextFormat\"\n                [plainText]=\"questionDetails1.promptText\"\n                [richText]=\"questionDetails1.richPromptText\"\n              ></div>\n            </div>\n            <div\n              class=\"wkqp-field-header\"\n              *ngIf=\"assetPosition == 'WithinText'\"\n            >\n              <item-text-assets\n                [promptText]=\"questionDetails1.promptText\"\n                [imagePath]=\"imagePath\"\n                [assetData]=\"assetData\"\n                [assetsPosition]=\"assetPosition\"\n              ></item-text-assets>\n            </div>\n          </div>\n        </div>\n        <media-carousel\n          *ngIf=\"\n            questionDetails1.assets &&\n            questionDetails1.assets.length != 0 &&\n            assetPosition == 'Bottom' &&\n            assetPosition != 'WithinText'\n          \"\n          [imagePath]=\"imagePath\"\n          [assetData]=\"assetData\"\n          [assetsPosition]=\"assetPosition\"\n        ></media-carousel>\n        <div class=\"common-full-width\">\n          <fieldset class=\"common-full-width mb20\">\n            <form [formGroup]=\"form\">\n              <ng-container\n                *ngFor=\"\n                  let item of questionDetails1.choiceInteraction.simpleChoices\n                \"\n              >\n                <div class=\"choice-que-des-wrapper choice-mb0\">\n                  <span\n                    *ngIf=\"message\"\n                    [ngClass]=\"getChoiceClassName(item)\"\n                  ></span>\n                  <input\n                    type=\"radio\"\n                    class=\"choice-radio\"\n                    [hidden]=\"message\"\n                    [value]=\"item.choiceId\"\n                    (change)=\"selectAnswer(item)\"\n                    formControlName=\"choices\"\n                  />\n                  <span\n                    class=\"choice-que-cont-des wkqp-prewrap white-space-normal\"\n                    libGetFormatText\n                    [preferredTextFormat]=\"preferredTextFormat\"\n                    [plainText]=\"item.label\"\n                    [richText]=\"item.richLabel\"\n                  ></span>\n                </div>\n                <div\n                  class=\"wkqp-alert-info wkqp-prewrap correct-rationale-section wkqp-prewrap rational-inline\"\n                  *ngIf=\"message && item.rationale\"\n                >\n                  <strong class=\"white-space-normal\">Rationale: </strong>\n                  <span\n                    class=\"white-space-normal\"\n                    libGetFormatText\n                    [preferredTextFormat]=\"preferredTextFormat\"\n                    [plainText]=\"item.rationale\"\n                    [richText]=\"item.richRationale\"\n                  ></span>\n                </div>\n              </ng-container>\n            </form>\n          </fieldset>\n        </div>\n\n        <div *ngIf=\"canShowMetadata && message != true\">\n          <lib-metadata [itemData]=\"questionDetails1\"></lib-metadata>\n        </div>\n\n        <!--User answer and correct answer block-->\n        <ng-container *ngIf=\"message\">\n          <p\n            class=\"wkqp-prewrap   white-space-normal mb20\"\n            [ngClass]=\"\n              isUserAnswersCorrect()\n                ? 'wkqp-alert-success wkqp-success'\n                : 'wkqp-alert-danger wkqp-danger'\n            \"\n            *ngIf=\"userAnswer.length != 0\"\n          >\n            <strong>Your Response:</strong>\n            <span\n              class=\"optionlevel\"\n              libGetFormatText\n              [preferredTextFormat]=\"preferredTextFormat\"\n              [plainText]=\"radioValue['label']\"\n              [richText]=\"radioValue['richLabel']\"\n            ></span>\n          </p>\n          <p\n            class=\" wkqp-prewrap wkqp-alert-success wkqp-success  white-space-normal mb20\"\n            *ngIf=\"!isUserAnswersCorrect()\"\n          >\n            <strong>Correct Response:</strong>\n            <span\n              class=\"optionlevel\"\n              libGetFormatText\n              [preferredTextFormat]=\"preferredTextFormat\"\n              [plainText]=\"correctAns.label\"\n              [richText]=\"correctAns.richLabel\"\n            ></span>\n          </p>\n          <div *ngIf=\"canShowMetadata\">\n            <lib-metadata [itemData]=\"questionDetails1\"></lib-metadata>\n          </div>\n        </ng-container>\n      </div>\n      <div class=\"rationale-remedation-block mb20\" *ngIf=\"message\">\n        <lib-rationale\n          [itemData]=\"questionDetails1.modelFeedback\"\n          [preferredTextFormat]=\"preferredTextFormat\"\n        ></lib-rationale>\n\n        <lib-remediation\n          [itemData]=\"questionDetails1.remediationLinks\"\n          [preferredTextFormat]=\"preferredTextFormat\"\n        ></lib-remediation>\n      </div>\n    </div>\n  </div>\n</ng-container>\n\n<!--####################  USMLE Multiple choice question template #########################-->\n<ng-container *ngIf=\"examEngineType == 'USMLE'\">\n  <div class=\"wk-row\">\n    <!--Media Carousel-->\n    <media-carousel\n      *ngIf=\"\n        questionDetails1.assets &&\n        questionDetails1.assets.length != 0 &&\n        assetPosition != 'Bottom' &&\n        assetPosition != 'WithinText'\n      \"\n      [imagePath]=\"imagePath\"\n      [assetData]=\"assetData\"\n      [assetsPosition]=\"assetPosition\"\n    ></media-carousel>\n\n    <!--Question Prompt text-->\n    <div\n      [ngClass]=\"{\n        'wk-col-8':\n          questionDetails1.assets != undefined &&\n          questionDetails1.assets.length != 0 &&\n          assetPosition != 'WithinText',\n        'wk-col-12':\n          questionDetails1.assets == undefined ||\n          questionDetails1.assets.length == 0 ||\n          assetPosition == 'WithinText',\n        'right-assets-position-question': assetPosition == 'Right',\n        'left-assets-position-question': assetPosition == 'Left',\n        'top-assets-position-question': assetPosition == 'Top',\n        'bottom-assets-position-question': assetPosition == 'Bottom'\n      }\"\n    >\n      <div class=\"wkqp-layout-item\">\n        <div class=\"wkqp-field-item normal-font mb0 \">\n          <div class=\"wkqp-field-header\" *ngIf=\"assetPosition != 'WithinText'\">\n            <div class=\"mb20 normal-font wkqp-prewrap white-space-normal\">\n              {{ questionDetails1.promptText }}\n            </div>\n          </div>\n          <div class=\"wkqp-field-header\" *ngIf=\"assetPosition == 'WithinText'\">\n            <item-text-assets\n              [promptText]=\"questionDetails1.promptText\"\n              [imagePath]=\"imagePath\"\n              [assetData]=\"assetData\"\n              [assetsPosition]=\"assetPosition\"\n            ></item-text-assets>\n          </div>\n        </div>\n      </div>\n      <div class=\"common-full-width\">\n        <div class=\"answer-box\">\n          <fieldset class=\"common-full-width\">\n            <legend class=\"offscreen\">{{ questionDetails1.promptText }}</legend>\n\n            <div class=\"option-wrapper\">\n              <form [formGroup]=\"form\">\n                <ng-container\n                  *ngFor=\"\n                    let item of questionDetails1.choiceInteraction\n                      .simpleChoices;\n                    let i = index\n                  \"\n                >\n                  <div\n                    class=\"answer-wrapper\"\n                    [ngClass]=\"{\n                      'correct-answer':\n                        item.correct == true && checkQuizSubmission == true\n                    }\"\n                  >\n                    <span\n                      *ngIf=\"checkQuizSubmission == true\"\n                      [ngClass]=\"getChoiceClassName(item)\"\n                    ></span>\n                    <input\n                      type=\"radio\"\n                      [hidden]=\"checkQuizSubmission == true\"\n                      [value]=\"item.choiceId\"\n                      (change)=\"selectAnswer(item)\"\n                      formControlName=\"choices\"\n                    />\n                    <span>{{ alphabetsIndex[i] }}.</span>\n                    <span style=\"padding-left: 6px;\">{{ item.label }}</span>\n                  </div>\n                </ng-container>\n              </form>\n            </div>\n            <div\n              class=\"examTaker-explanations ember-view raph-examTakerExplanations\"\n              *ngIf=\"checkQuizSubmission == true\"\n            >\n              <div class=\"raph-examTakerExplanations-correctExplanation-title\">\n                Answer Explanation\n              </div>\n              <ng-container\n                *ngFor=\"\n                  let item of questionDetails1.choiceInteraction.simpleChoices;\n                  let i = index\n                \"\n              >\n                <div\n                  class=\"raph-examTakerExplanations-correctExplanation-content\"\n                  *ngIf=\"item.correct == true\"\n                >\n                  <div\n                    class=\"raph-examTakerExplanations-correctExplanation-content-label\"\n                  >\n                    The correct answer is\n                    <div\n                      class=\"raph-examTakerExplanations-correctExplanation-letter\"\n                    >\n                      {{ alphabetsIndex[i] }}\n                    </div>\n                  </div>\n\n                  <div\n                    id=\"ember13569\"\n                    class=\"raph-examTakerExplanations-correctExplanation-content-content ember-view katexHtml\"\n                    *ngIf=\"item.correct == true\"\n                  >\n                    <div>\n                      <p>\n                        {{ questionDetails1.modelFeedback[0].feedbackText }}\n                      </p>\n                      <p></p>\n                    </div>\n                  </div>\n                </div>\n              </ng-container>\n            </div>\n            <div\n              class=\"raph-examTakerExplanations-incorrectExplanations\"\n              *ngIf=\"\n                checkQuizSubmission == true && incorrectRationale.length !== 0\n              \"\n            >\n              <div\n                class=\"raph-examTakerExplanations-incorrectExplanations-title\"\n              >\n                Incorrect answer explanations\n              </div>\n              <ng-container\n                *ngFor=\"\n                  let item of questionDetails1.choiceInteraction.simpleChoices;\n                  let i = index\n                \"\n              >\n                <div\n                  class=\"raph-examTakerExplanations-incorrectExplanations-content\"\n                >\n                  <div\n                    class=\"raph-examTakerExplanations-incorrectExplanations-explanation\"\n                    *ngIf=\"item.correct !== true && item.rationale !== null\"\n                  >\n                    <div\n                      class=\"raph-examTakerExplanations-incorrectExplanations-explanation-letter\"\n                    >\n                      {{ alphabetsIndex[i] }}.\n                    </div>\n                    <div\n                      id=\"ember13628\"\n                      class=\"raph-examTakerExplanations-incorrectExplanations-explanation-body ember-view katexHtml\"\n                    >\n                      <div>\n                        <p>\n                          {{ item.rationale == null ? 'NA' : item.rationale }}\n                        </p>\n                      </div>\n                    </div>\n                  </div>\n                </div>\n              </ng-container>\n            </div>\n          </fieldset>\n        </div>\n      </div>\n      <media-carousel\n        *ngIf=\"\n          questionDetails1.assets &&\n          questionDetails1.assets.length != 0 &&\n          assetPosition == 'Bottom' &&\n          assetPosition != 'WithinText'\n        \"\n        [imagePath]=\"imagePath\"\n        [assetData]=\"assetData\"\n        [assetsPosition]=\"assetPosition\"\n      ></media-carousel>\n    </div>\n  </div>\n</ng-container>\n",
        styles: [".option-wrapper{display:table;padding:7px;border:1px solid #3852a4;border-bottom-width:5px;max-width:400px}.answer-wrapper{padding:4px;display:table;width:100%;border-radius:3px}.correct-answer{border:1px solid #090;background-color:#9f9}.answer-explanation{padding:7.5px 15px;background-color:orange;font-size:15px;line-height:16px;font-weight:700}.raph-examTakerExplanations-correctExplanation-title{padding:7.5px 15px;background-color:orange;font-size:15px;line-height:16px;font-weight:700}.examTaker-content .examTaker-explanations{max-width:400px;margin-top:21px}.raph-examTakerExplanations{display:table;border:1px solid #3852a4;border-bottom-width:5px}.raph-examTakerExplanations-correctExplanation-content{padding:15px}.raph-examTakerExplanations-correctExplanation-content-label{line-height:1.5}.raph-examTakerExplanations-correctExplanation-letter{display:inline;text-transform:uppercase;font-weight:700}.raph-examTakerExplanations-correctExplanation-content .raph-examTakerExplanations-correctExplanation-content-content{margin-top:15px}.raph-examTakerExplanations-correctExplanation-content-content{line-height:1.5}.raph-examTakerExplanations-incorrectExplanations{display:table;border:1px solid #3852a4;border-bottom-width:5px;width:400px}.raph-examTakerExplanations-incorrectExplanations-title{font-size:80%;line-height:150%;background-color:#d7dced;border-bottom:1px solid #aab;text-align:center;font-weight:700}.raph-examTakerExplanations-incorrectExplanations-content{padding:6px}.raph-examTakerExplanations-incorrectExplanations-content .raph-examTakerExplanations-incorrectExplanations-explanation:not(:last-child){margin-bottom:6px}.raph-examTakerExplanations-incorrectExplanations-explanation{display:flex}.raph-examTakerExplanations-incorrectExplanations-explanation .raph-examTakerExplanations-incorrectExplanations-explanation-letter{width:24px;min-width:24px}.raph-examTakerExplanations-incorrectExplanations-explanation-letter{text-transform:uppercase;line-height:1.5}.layout-default .layout-default-content,.raph-examTakerExplanations-incorrectExplanations-explanation .raph-examTakerExplanations-incorrectExplanations-explanation-body{flex-grow:1}.raph-examTakerExplanations-incorrectExplanations-explanation-body{line-height:1.5}.choice-que-des-wrapper{float:left;width:100%;margin-bottom:.1875rem;padding-bottom:5px}.choice-que-des-wrapper .choice-checkbox,.choice-que-des-wrapper .choice-radio{float:left;width:20px}.choice-que-des-wrapper.choice-mb0{margin-bottom:0;padding-bottom:0}.item-questions-des-wrapper.multiple-choice-pt0 p{padding-top:0}"]
    })
], MultipleChoiceComponent);

let MultipleResponseComponent = class MultipleResponseComponent {
    constructor(itemService, formBuilder) {
        this.itemService = itemService;
        this.formBuilder = formBuilder;
        // Declare the variables
        this.userAnswer = [];
        this.correctAns = [];
        this.assetData = [];
        this.selectedOrderIds = [];
        this.questionDetails1 = [];
        this.assetPosition = [];
        // tslint:disable-next-line:max-line-length
        this.alphabetsIndex = [
            "A",
            "B",
            "C",
            "D",
            "E",
            "F",
            "G",
            "H",
            "I",
            "J",
            "K",
            "L",
            "M",
            "N",
            "O",
            "P",
            "Q",
            "R",
            "S",
            "T",
            "U",
            "V",
            "W",
            "X",
            "Y",
            "Z"
        ];
        this.incorrectRationale = [];
        this.imagePath = [];
    }
    get questionDetails() {
        return this.questionDetails;
    }
    set questionCurrentData(value) {
        if (value) {
            this.questionDetails1 = value;
            this.createQuestion();
        }
        else {
            this.questionDetails1 = [];
            this.createQuestion();
        }
    }
    /* Init */
    ngOnInit() { }
    ngOnChanges(changes) { }
    /* Do check */
    ngDoCheck() {
        if (this.isClearAnswer === true) {
            this.clearUserInputs();
            this.itemService.userAnswerMethod([]);
            this.itemService.clearAnswerMethodFalse(false);
            this.itemService.hideAnswer(false);
        }
        if (this.isShowHide === true) {
            this.message = true;
        }
        else if (this.isShowHide === false) {
            this.message = false;
        }
    }
    /* function to get correct answer */
    correctAnswer() {
        for (const i of this.questionDetails1.choiceInteraction.simpleChoices) {
            if (i.correct === true) {
                this.correctAns.push(i);
                if (i.richLabel) {
                    this.correctAnsRichLabel = (this.correctAnsRichLabel) ? this.correctAnsRichLabel + ', ' + i.richLabel : i.richLabel;
                }
                this.correctAnsLabel = (this.correctAnsLabel) ? this.correctAnsLabel + ', ' + i.label : i.label;
            }
        }
        this.incorrectRationale = this.questionDetails1.choiceInteraction.simpleChoices.filter(item => item.rationale !== null && item.correct !== true);
    }
    /* function to get selected answer */
    selectAnswer(option, i) {
        this.selectedOrderIds = this.form.value.orders
            .map((v, i) => v
            ? this.questionDetails1.choiceInteraction.simpleChoices[i].choiceId
            : null)
            .filter(v => v !== null);
        this.commaSeperatedUserResponseLabel();
        this.userAnswer = this.selectedOrderIds;
        if (this.userAnswer.length !== 0) {
            const answerObj = this.userAnswer;
            this.itemService.userAnswerMethod(answerObj);
            this.itemService.validateAnswerValueMethod(this.isUserAnswersCorrect());
        }
        else {
            this.itemService.userAnswerMethod([]);
            this.itemService.validateAnswerValueMethod(false);
        }
    }
    /* Check wheather user selected answr is correct */
    isUserAnswersCorrect() {
        this.selectedOrderIds = this.form.value.orders
            .map((v, i) => v
            ? this.questionDetails1.choiceInteraction.simpleChoices[i].choiceId
            : null)
            .filter(v => v !== null);
        if (this.selectedOrderIds.length !== this.correctAns.length) {
            return false;
        }
        else {
            for (const answer of this.correctAns) {
                if (!this.selectedOrderIds.find(item => item === answer.choiceId)) {
                    return false;
                }
            }
        }
        return true;
    }
    /* function to clear user inputs */
    clearUserInputs() {
        this.userAnswer = [];
        this.form.reset();
    }
    /* Get choice css class */
    getChoiceClassName(choiceDetails) {
        let checked = false;
        for (const item of this.selectedOrderIds) {
            if (choiceDetails["choiceId"] === item) {
                checked = true;
            }
        }
        if (choiceDetails.correct) {
            return "wk-icon-checkmark green-checkmark";
        }
        else if (!choiceDetails.correct && checked === true) {
            return "wk-icon-close wrong-checkmark";
        }
        else {
            return "wk-icon-checkmark disabled-checkmark";
        }
    }
    /* Check the value is changed or not */
    valueChanged() {
        this.selectedOrderIds = this.form.value.orders
            .map((v, i) => v
            ? this.questionDetails1.choiceInteraction.simpleChoices[i].choiceId
            : null)
            .filter(v => v !== null);
        this.commaSeperatedUserResponseLabel();
        this.userAnswer = this.selectedOrderIds;
        if (this.userAnswer.length !== 0) {
            const answerObj = this.userAnswer;
            this.itemService.userAnswerMethod(answerObj);
            this.itemService.validateAnswerValueMethod(this.isUserAnswersCorrect());
        }
        else {
            this.itemService.userAnswerMethod([]);
            this.itemService.validateAnswerValueMethod(false);
        }
    }
    getFormArray() {
        return this.form.get("orders");
    }
    createQuestion() {
        this.userAnswer = [];
        this.correctAns = [];
        this.incorrectRationale = [];
        this.itemService.userAnswerMethod([]);
        this.itemService.validateAnswerValueMethod(false);
        this.correctAnswer();
        // Get user answer value from service
        this.itemService.userAnswerState.subscribe(answer => (this.userAnswerService = answer));
        this.assetData = this.questionDetails1.assets;
        if (this.assetData.length !== 0) {
            this.assetPosition = this.questionDetails1.assets[0]["assetsPosition"];
        }
        const controls = this.questionDetails1.choiceInteraction.simpleChoices.map(c => new FormControl(false));
        // controls[0].setValue(true);
        this.form = this.formBuilder.group({
            orders: new FormArray(controls)
        });
        // this.getFormArray();
        if (this.questionDetails1.userAttemptDetails.userAnswer.length !== 0) {
            for (let i = 0; i < this.questionDetails1.choiceInteraction.simpleChoices.length; i++) {
                for (const j of this.questionDetails1.userAttemptDetails.userAnswer) {
                    if (this.questionDetails1.choiceInteraction.simpleChoices[i]["choiceId"] === j) {
                        controls[i].setValue(true);
                    }
                }
            }
            this.valueChanged();
        }
    }
    commaSeperatedUserResponseLabel() {
        this.userResponseLabel = '';
        this.userResponseRichLabel = '';
        this.selectedOrderIds.forEach(selected => {
            const selectedChoice = this.questionDetails1.choiceInteraction.simpleChoices.find(choice => choice.choiceId == selected);
            if (selectedChoice) {
                if (selectedChoice.richLabel) {
                    this.userResponseRichLabel = (this.userResponseRichLabel) ? this.userResponseRichLabel + ', ' + selectedChoice.richLabel : selectedChoice.richLabel;
                }
                this.userResponseLabel = (this.userResponseLabel) ? this.userResponseLabel + ', ' + selectedChoice.label : selectedChoice.label;
            }
        });
    }
};
MultipleResponseComponent.ctorParameters = () => [
    { type: ItemService },
    { type: FormBuilder }
];
__decorate([
    Input("questionDetails")
], MultipleResponseComponent.prototype, "questionCurrentData", null);
__decorate([
    Input()
], MultipleResponseComponent.prototype, "examEngineType", void 0);
__decorate([
    Input()
], MultipleResponseComponent.prototype, "canShowMetadata", void 0);
__decorate([
    Input()
], MultipleResponseComponent.prototype, "isClearAnswer", void 0);
__decorate([
    Input()
], MultipleResponseComponent.prototype, "isShowHide", void 0);
__decorate([
    Input()
], MultipleResponseComponent.prototype, "imagePath", void 0);
__decorate([
    Input()
], MultipleResponseComponent.prototype, "checkQuizSubmission", void 0);
__decorate([
    Input()
], MultipleResponseComponent.prototype, "preferredTextFormat", void 0);
MultipleResponseComponent = __decorate([
    Component({
        selector: "multiple-response",
        template: "<!-- ############################## QP Exam engine Type ############################-->\n<ng-container *ngIf=\"examEngineType == 'QP' || examEngineType == 'NCLEX'\">\n  <!--Question and Answer Block-->\n  <div class=\"wk-row\">\n    <media-carousel\n      *ngIf=\"\n        questionDetails1.assets &&\n        questionDetails1.assets.length != 0 &&\n        assetPosition != 'Bottom' &&\n        assetPosition != 'WithinText'\n      \"\n      [imagePath]=\"imagePath\"\n      [assetData]=\"assetData\"\n      [assetsPosition]=\"assetPosition\"\n    ></media-carousel>\n\n    <div\n      [ngClass]=\"{\n        'wk-col-8':\n          questionDetails1.assets != undefined &&\n          questionDetails1.assets.length != 0 &&\n          assetPosition != 'WithinText',\n        'wk-col-12':\n          questionDetails1.assets == undefined ||\n          questionDetails1.assets.length == 0 ||\n          assetPosition == 'WithinText',\n        'right-assets-position-question': assetPosition == 'Right',\n        'left-assets-position-question': assetPosition == 'Left',\n        'top-assets-position-question': assetPosition == 'Top',\n        'bottom-assets-position-question': assetPosition == 'Bottom'\n      }\"\n    >\n      <div class=\"wkqp-layout-item item-questions-des-wrapper\">\n        <div class=\"wkqp-field-item normal-font mb0 item-que-mb0\">\n          <div class=\"wkqp-field-header\" *ngIf=\"assetPosition != 'WithinText'\">\n            <div\n              class=\"normal-font wkqp-prewrap white-space-normal mb20\"\n              libGetFormatText\n              [preferredTextFormat]=\"preferredTextFormat\"\n              [plainText]=\"questionDetails1.promptText\"\n              [richText]=\"questionDetails1.richPromptText\"\n            ></div>\n          </div>\n          <div class=\"wkqp-field-header\" *ngIf=\"assetPosition == 'WithinText'\">\n            <item-text-assets\n              [promptText]=\"questionDetails1.promptText\"\n              [imagePath]=\"imagePath\"\n              [assetData]=\"assetData\"\n              [assetsPosition]=\"assetPosition\"\n            ></item-text-assets>\n          </div>\n        </div>\n      </div>\n      <div class=\"common-full-width mb20\">\n        <form [formGroup]=\"form\">\n          <ng-container\n            formArrayName=\"orders\"\n            *ngFor=\"\n              let order of form['controls'].orders['controls'];\n              let i = index\n            \"\n          >\n            <div class=\"choice-que-des-wrapper\">\n              <span\n                *ngIf=\"message\"\n                [ngClass]=\"\n                  getChoiceClassName(\n                    questionDetails1.choiceInteraction.simpleChoices[i]\n                  )\n                \"\n              ></span>\n              <input\n                type=\"checkbox\"\n                class=\"choice-checkbox\"\n                [formControlName]=\"i\"\n                [hidden]=\"message\"\n                (change)=\"\n                  selectAnswer(\n                    questionDetails1.choiceInteraction.simpleChoices[i],\n                    i\n                  )\n                \"\n              />\n              <span\n                class=\"choice-que-cont-des wkqp-prewrap\"\n                libGetFormatText\n                [preferredTextFormat]=\"preferredTextFormat\"\n                [plainText]=\"\n                  questionDetails1.choiceInteraction.simpleChoices[i].label\n                \"\n                [richText]=\"\n                  questionDetails1.choiceInteraction.simpleChoices[i].richLabel\n                \"\n              ></span>\n              <div\n                class=\"wkqp-alert-info wkqp-prewrap correct-rationale-section wkqp-prewrap rational-inline correct-rationale-section\"\n                *ngIf=\"\n                  message &&\n                  questionDetails1.choiceInteraction.simpleChoices[i].rationale\n                \"\n              >\n                <strong class=\"correct-answer-rationale\">Rationale: </strong>\n                <span\n                  class=\"pl5\"\n                  libGetFormatText\n                  [preferredTextFormat]=\"preferredTextFormat\"\n                  [plainText]=\"\n                    questionDetails1.choiceInteraction.simpleChoices[i]\n                      .rationale\n                  \"\n                  [richText]=\"\n                    questionDetails1.choiceInteraction.simpleChoices[i]\n                      .richRationale\n                  \"\n                ></span>\n              </div>\n            </div>\n          </ng-container>\n        </form>\n      </div>\n      <media-carousel\n        *ngIf=\"\n          questionDetails1.assets &&\n          questionDetails1.assets.length != 0 &&\n          assetPosition == 'Bottom' &&\n          assetPosition != 'WithinText'\n        \"\n        [imagePath]=\"imagePath\"\n        [assetData]=\"assetData\"\n        [assetsPosition]=\"assetPosition\"\n      ></media-carousel>\n      <ng-container *ngIf=\"message\">\n        <div\n          [ngClass]=\"\n            isUserAnswersCorrect()\n              ? 'wkqp-alert-success wkqp-success'\n              : 'wkqp-alert-danger wkqp-danger'\n          \"\n          class=\"wkqp-prewrap white-space-normal mb20\"\n          *ngIf=\"userAnswer.length != 0\"\n        >\n          <strong class=\"your-response-left\">Your Response:</strong>\n          <span class=\"optionlevel\">\n            <span\n              libGetFormatText\n              [preferredTextFormat]=\"preferredTextFormat\"\n              [plainText]=\"userResponseLabel\"\n              [richText]=\"userResponseRichLabel\"\n            ></span>\n          </span>\n        </div>\n        <div\n          class=\" wkqp-prewrap wkqp-alert-success wkqp-success  white-space-normal mb20\"\n          *ngIf=\"!isUserAnswersCorrect()\"\n        >\n          <strong>Correct Response:</strong>\n          <span class=\"optionlevel\">\n            <span\n              libGetFormatText\n              [preferredTextFormat]=\"preferredTextFormat\"\n              [plainText]=\"correctAnsLabel\"\n              [richText]=\"correctAnsRichLabel\"\n            ></span>\n          </span>\n        </div>\n\n        <div *ngIf=\"canShowMetadata\">\n          <lib-metadata [itemData]=\"questionDetails1\"></lib-metadata>\n        </div>\n      </ng-container>\n    </div>\n    <div class=\"rationale-remedation-block mb20\" *ngIf=\"message\">\n      <lib-rationale\n        [itemData]=\"questionDetails1.modelFeedback\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></lib-rationale>\n      <lib-remediation\n        [itemData]=\"questionDetails1.remediationLinks\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></lib-remediation>\n    </div>\n  </div>\n</ng-container>\n\n<!-- ############################## USMLE Exam engine Type ############################-->\n<ng-container *ngIf=\"examEngineType == 'USMLE'\">\n  <div class=\"wk-row\">\n    <media-carousel\n      *ngIf=\"\n        questionDetails1.assets &&\n        questionDetails1.assets.length != 0 &&\n        assetPosition != 'Bottom' &&\n        assetPosition != 'WithinText'\n      \"\n      [imagePath]=\"imagePath\"\n      [assetData]=\"assetData\"\n      [assetsPosition]=\"assetPosition\"\n    ></media-carousel>\n\n    <div class=\"wkqp-field-item\">\n      <!--Question prompt text-->\n      <div\n        [ngClass]=\"{\n          'wk-col-8':\n            questionDetails1.assets != undefined &&\n            questionDetails1.assets.length != 0 &&\n            assetPosition != 'WithinText',\n          'wk-col-12':\n            questionDetails1.assets == undefined ||\n            questionDetails1.assets.length == 0 ||\n            assetPosition == 'WithinText',\n          'right-assets-position-question': assetPosition == 'Right',\n          'left-assets-position-question': assetPosition == 'Left',\n          'top-assets-position-question': assetPosition == 'Top',\n          'bottom-assets-position-question': assetPosition == 'Bottom'\n        }\"\n      >\n        <div class=\"wkqp-layout-item\">\n          <div class=\"wkqp-field-item normal-font mb0 \">\n            <div\n              class=\"wkqp-field-header\"\n              *ngIf=\"assetPosition != 'WithinText'\"\n            >\n              <div class=\"mb20 normal-font wkqp-prewrap\">\n                {{ questionDetails1.promptText }}\n              </div>\n            </div>\n            <div\n              class=\"wkqp-field-header\"\n              *ngIf=\"assetPosition == 'WithinText'\"\n            >\n              <item-text-assets\n                [promptText]=\"questionDetails1.promptText\"\n                [imagePath]=\"imagePath\"\n                [assetData]=\"assetData\"\n                [assetsPosition]=\"assetPosition\"\n              ></item-text-assets>\n            </div>\n          </div>\n        </div>\n        <!--Question Answer Choice-->\n        <div class=\"common-full-width answer-box\">\n          <div>\n            <fieldset class=\"common-full-width\">\n              <legend class=\"offscreen\">\n                {{ questionDetails1.promptText }}\n              </legend>\n\n              <div class=\"option-wrapper\">\n                <form [formGroup]=\"form\">\n                  <ng-container\n                    formArrayName=\"orders\"\n                    *ngFor=\"\n                      let order of form['controls'].orders['controls'];\n                      let i = index\n                    \"\n                  >\n                    <div\n                      class=\"answer-wrapper\"\n                      [ngClass]=\"{\n                        'correct-answer':\n                          questionDetails1.choiceInteraction.simpleChoices[i]\n                            .correct == true && checkQuizSubmission == true\n                      }\"\n                    >\n                      <span\n                        *ngIf=\"checkQuizSubmission == true\"\n                        [ngClass]=\"\n                          getChoiceClassName(\n                            questionDetails1.choiceInteraction.simpleChoices[i]\n                          )\n                        \"\n                      ></span>\n                      <input\n                        type=\"checkbox\"\n                        [formControlName]=\"i\"\n                        [hidden]=\"checkQuizSubmission == true\"\n                        (change)=\"\n                          selectAnswer(\n                            questionDetails1.choiceInteraction.simpleChoices[i],\n                            i\n                          )\n                        \"\n                      />\n                      {{\n                        questionDetails1.choiceInteraction.simpleChoices[i]\n                          .label\n                      }}\n                    </div>\n                    <div\n                      class=\"wkqp-alert-info wkqp-prewrap correct-rationale-section wkqp-prewrap\"\n                      *ngIf=\"\n                        checkQuizSubmission == true &&\n                        questionDetails1.choiceInteraction.simpleChoices[i]\n                          .rationale\n                      \"\n                    >\n                      <strong>Rationale: </strong\n                      >{{\n                        questionDetails1.choiceInteraction.simpleChoices[i]\n                          .rationale\n                      }}\n                    </div>\n                  </ng-container>\n                </form>\n              </div>\n              <div\n                class=\"examTaker-explanations ember-view raph-examTakerExplanations\"\n                *ngIf=\"checkQuizSubmission == true\"\n              >\n                <div\n                  class=\"raph-examTakerExplanations-correctExplanation-title\"\n                >\n                  Answer Explanation\n                </div>\n                <div\n                  class=\"raph-examTakerExplanations-correctExplanation-content\"\n                >\n                  <div\n                    class=\"raph-examTakerExplanations-correctExplanation-content-label\"\n                  >\n                    The correct answer is\n                    <div\n                      class=\"raph-examTakerExplanations-correctExplanation-letter\"\n                    >\n                      <div class=\" wkqp-prewrap\">\n                        <ng-container\n                          *ngFor=\"\n                            let item of questionDetails1.choiceInteraction\n                              .simpleChoices;\n                            let i = index\n                          \"\n                        >\n                          <span\n                            class=\"optionlevel\"\n                            *ngIf=\"item.correct == true\"\n                          >\n                            {{ alphabetsIndex[i] }}\n                          </span>\n                        </ng-container>\n                      </div>\n                    </div>\n                  </div>\n\n                  <div\n                    id=\"ember13569\"\n                    class=\"raph-examTakerExplanations-correctExplanation-content-content ember-view katexHtml\"\n                  >\n                    <div>\n                      <p>\n                        {{ questionDetails1.modelFeedback[0].feedbackText }}\n                      </p>\n                      <p></p>\n                    </div>\n                  </div>\n                </div>\n                <!-- <div class=\"wkqp-alert-info wkqp-prewrap correct-rationale-section wkqp-prewrap\" *ngIf=\" checkQuizSubmission == true && item.rationale\">{{item.rationale}}</div> -->\n                <!-- </ng-container> -->\n              </div>\n              <div\n                class=\"raph-examTakerExplanations-incorrectExplanations\"\n                *ngIf=\"\n                  checkQuizSubmission == true && incorrectRationale.length !== 0\n                \"\n              >\n                <div\n                  class=\"raph-examTakerExplanations-incorrectExplanations-title\"\n                >\n                  Incorrect answer explanations\n                </div>\n                <ng-container\n                  *ngFor=\"\n                    let item of questionDetails1.choiceInteraction\n                      .simpleChoices;\n                    let i = index\n                  \"\n                >\n                  <div\n                    class=\"raph-examTakerExplanations-incorrectExplanations-content\"\n                  >\n                    <div\n                      class=\"raph-examTakerExplanations-incorrectExplanations-explanation\"\n                      *ngIf=\"item.correct !== true && item.rationale !== null\"\n                    >\n                      <div\n                        class=\"raph-examTakerExplanations-incorrectExplanations-explanation-letter\"\n                      >\n                        {{ alphabetsIndex[i] }}.\n                      </div>\n                      <div\n                        id=\"ember13628\"\n                        class=\"raph-examTakerExplanations-incorrectExplanations-explanation-body ember-view katexHtml\"\n                      >\n                        <div>\n                          <p>\n                            <strong>Rationale: </strong>\n                            {{ item.rationale == null ? 'NA' : item.rationale }}\n                          </p>\n                        </div>\n                      </div>\n                    </div>\n                  </div>\n                </ng-container>\n              </div>\n            </fieldset>\n          </div>\n        </div>\n        <media-carousel\n          *ngIf=\"\n            questionDetails1.assets &&\n            questionDetails1.assets.length != 0 &&\n            assetPosition == 'Bottom' &&\n            assetPosition != 'WithinText'\n          \"\n          [imagePath]=\"imagePath\"\n          [assetData]=\"assetData\"\n          [assetsPosition]=\"assetPosition\"\n        ></media-carousel>\n      </div>\n    </div>\n  </div>\n</ng-container>\n",
        styles: [".option-wrapper{display:table;padding:7px;border:1px solid #3852a4;border-bottom-width:5px;max-width:400px}.answer-wrapper{padding:4px;display:table;width:100%;border-radius:3px}.correct-answer{border:1px solid #090;background-color:#9f9}.answer-explanation{padding:7.5px 15px;background-color:orange;font-size:15px;line-height:16px;font-weight:700}.raph-examTakerExplanations-correctExplanation-title{padding:7.5px 15px;background-color:orange;font-size:15px;line-height:16px;font-weight:700}.examTaker-content .examTaker-explanations{max-width:400px;margin-top:21px}.raph-examTakerExplanations{display:table;border:1px solid #3852a4;border-bottom-width:5px}.raph-examTakerExplanations-correctExplanation-content{padding:15px}.raph-examTakerExplanations-correctExplanation-content-label{line-height:1.5}.raph-examTakerExplanations-correctExplanation-letter{display:inline;text-transform:uppercase;font-weight:700}.raph-examTakerExplanations-correctExplanation-content .raph-examTakerExplanations-correctExplanation-content-content{margin-top:15px}.raph-examTakerExplanations-correctExplanation-content-content{line-height:1.5}.raph-examTakerExplanations-incorrectExplanations{display:table;border:1px solid #3852a4;border-bottom-width:5px;width:400px}.raph-examTakerExplanations-incorrectExplanations-title{font-size:80%;line-height:150%;background-color:#d7dced;border-bottom:1px solid #aab;text-align:center;font-weight:700}.raph-examTakerExplanations-incorrectExplanations-content{padding:6px}.raph-examTakerExplanations-incorrectExplanations-content .raph-examTakerExplanations-incorrectExplanations-explanation:not(:last-child){margin-bottom:6px}.raph-examTakerExplanations-incorrectExplanations-explanation{display:flex}.raph-examTakerExplanations-incorrectExplanations-explanation .raph-examTakerExplanations-incorrectExplanations-explanation-letter{width:24px;min-width:24px}.raph-examTakerExplanations-incorrectExplanations-explanation-letter{text-transform:uppercase;line-height:1.5}.layout-default .layout-default-content,.raph-examTakerExplanations-incorrectExplanations-explanation .raph-examTakerExplanations-incorrectExplanations-explanation-body{flex-grow:1}.raph-examTakerExplanations-incorrectExplanations-explanation-body{line-height:1.5}.your-response-left{float:left}.choice-que-des-wrapper{float:left;width:100%;margin-bottom:.1875rem;padding-bottom:5px;padding-top:0}.choice-que-des-wrapper .choice-checkbox,.choice-que-des-wrapper .choice-radio{float:left;width:20px}.choice-que-des-wrapper.choice-mb0{margin-bottom:0;padding-bottom:0}.correct-answer-rationale{float:left}"]
    })
], MultipleResponseComponent);

let ItemTypeWrapperComponent = class ItemTypeWrapperComponent {
    constructor(itemService, quizService) {
        this.itemService = itemService;
        this.quizService = quizService;
        this.userAnswerObj = [];
        this.imagePath = [];
        this.userAnswerValue = new EventEmitter();
        this.figureLabelEntry = new EventEmitter();
    }
    set testData(value) {
        this.preferredTextFormat = value.preferredTextFormat;
    }
    ngOnInit() {
        this.userAnswerObj = [];
        this.itemService.currentState.subscribe(message => (this.message = message));
        this.itemService.currentAnswerState.subscribe(clear => (this.clearAnswer = clear));
        this.itemService.userAnswerState.subscribe(answer => (this.userAnswerService = answer));
        this.itemService.validateAnswerValueState.subscribe(correct => (this.isCorrect = correct));
        this.itemService.duplicateValueState.subscribe(duplicate => (this.duplicalteValue = duplicate));
        this.itemService.validateCompleteEntryState.subscribe(entry => (this.completeEntry = entry));
        this.instanceData = this.quizService.instanceDetails;
        this.testSettings = this.quizService.testSettings;
    }
    ngDoCheck() {
        if (this.emptyAnswer === true) {
            this.itemService.userAnswerMethod([]);
        }
        if (this.isClearAnswer === true) {
            this.itemService.userAnswerMethod([]);
            this.itemService.clearAnswerMethodFalse(false);
        }
        this.userAnswerObj = [];
        this.userAnswerObj['userAnswer'] = this.userAnswerService;
        this.userAnswerObj['correct'] = this.isCorrect;
        this.userAnswerValue.emit(this.userAnswerObj);
        this.figureLabelEntry.emit({
            duplicate: this.duplicalteValue,
            entry: this.completeEntry
        });
    }
    metadataDisplayValidation() {
        if (this.instanceData && this.questionCurrentData && this.testSettings) {
            if (this.testSettings.showMetadata &&
                this.instanceData.isPreview &&
                this.questionCurrentData.selectedMetaDetails) {
                return true;
            }
            return false;
        }
        return false;
    }
};
ItemTypeWrapperComponent.ctorParameters = () => [
    { type: ItemService },
    { type: QuizService }
];
__decorate([
    Input()
], ItemTypeWrapperComponent.prototype, "questionCurrentData", void 0);
__decorate([
    Input()
], ItemTypeWrapperComponent.prototype, "examEngineType", void 0);
__decorate([
    Input()
], ItemTypeWrapperComponent.prototype, "isClearAnswer", void 0);
__decorate([
    Input()
], ItemTypeWrapperComponent.prototype, "isShowHide", void 0);
__decorate([
    Input()
], ItemTypeWrapperComponent.prototype, "imagePath", void 0);
__decorate([
    Input()
], ItemTypeWrapperComponent.prototype, "checkQuizSubmission", void 0);
__decorate([
    Input()
], ItemTypeWrapperComponent.prototype, "emptyAnswer", void 0);
__decorate([
    Input()
], ItemTypeWrapperComponent.prototype, "selectedTheme", void 0);
__decorate([
    Input()
], ItemTypeWrapperComponent.prototype, "fontSize", void 0);
__decorate([
    Input('testData')
], ItemTypeWrapperComponent.prototype, "testData", null);
__decorate([
    Output()
], ItemTypeWrapperComponent.prototype, "userAnswerValue", void 0);
__decorate([
    Output()
], ItemTypeWrapperComponent.prototype, "figureLabelEntry", void 0);
ItemTypeWrapperComponent = __decorate([
    Component({
        selector: 'item-type-wrapper',
        template: "<ng-container *ngIf=\"questionCurrentData\">\n  <div class=\"item-wrapper-container\">\n    <!--Exhibit modal -->\n    <app-exhibit-modal\n      [fontSize]=\"fontSize\"\n      [selectedTheme]=\"selectedTheme\"\n      [questionDetails]=\"questionCurrentData\"\n      [examEngineType]=\"examEngineType\"\n    ></app-exhibit-modal>\n\n    <!--Multiple choice Question -->\n    <ng-container\n      *ngIf=\"\n        questionCurrentData &&\n        questionCurrentData.labelText == 'MULTIPLE_CHOICE' &&\n        !questionCurrentData.parentDetails\n      \"\n    >\n      <multiple-choice\n        [imagePath]=\"imagePath\"\n        [checkQuizSubmission]=\"checkQuizSubmission\"\n        [isClearAnswer]=\"isClearAnswer\"\n        [isShowHide]=\"isShowHide\"\n        [questionDetails]=\"questionCurrentData\"\n        [examEngineType]=\"examEngineType\"\n        [canShowMetadata]=\"metadataDisplayValidation()\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></multiple-choice>\n    </ng-container>\n\n    <!--Mulitple Response-->\n    <ng-container\n      *ngIf=\"\n        questionCurrentData.labelText == 'CHOICE_MULTIPLE' &&\n        !questionCurrentData.parentDetails\n      \"\n    >\n      <multiple-response\n        [checkQuizSubmission]=\"checkQuizSubmission\"\n        [imagePath]=\"imagePath\"\n        [isClearAnswer]=\"isClearAnswer\"\n        [isShowHide]=\"isShowHide\"\n        [questionDetails]=\"questionCurrentData\"\n        [examEngineType]=\"examEngineType\"\n        [canShowMetadata]=\"metadataDisplayValidation()\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></multiple-response>\n    </ng-container>\n\n    <!--Clinical Sympotoms-->\n    <ng-container\n      *ngIf=\"\n        questionCurrentData.parentDetails &&\n        questionCurrentData.parentLabelText == 'CLINICAL_SYMPTOMS'\n      \"\n    >\n      <!--Clinical-multiple-choice-->\n      <ng-container *ngIf=\"questionCurrentData.labelText == 'MULTIPLE_CHOICE'\">\n        <clinical-multiple-choice\n          [checkQuizSubmission]=\"checkQuizSubmission\"\n          [isClearAnswer]=\"isClearAnswer\"\n          [isShowHide]=\"isShowHide\"\n          [questionDetails]=\"questionCurrentData\"\n          [examEngineType]=\"examEngineType\"\n          [imagePath]=\"imagePath\"\n          [canShowMetadata]=\"metadataDisplayValidation()\"\n          [preferredTextFormat]=\"preferredTextFormat\"\n        >\n        </clinical-multiple-choice>\n      </ng-container>\n\n      <!--Clinical-multiple-response-->\n      <ng-container *ngIf=\"questionCurrentData.labelText == 'CHOICE_MULTIPLE'\">\n        <clinical-multiple-response\n          [checkQuizSubmission]=\"checkQuizSubmission\"\n          [isClearAnswer]=\"isClearAnswer\"\n          [isShowHide]=\"isShowHide\"\n          [questionDetails]=\"questionCurrentData\"\n          [examEngineType]=\"examEngineType\"\n          [imagePath]=\"imagePath\"\n          [canShowMetadata]=\"metadataDisplayValidation()\"\n          [preferredTextFormat]=\"preferredTextFormat\"\n        >\n        </clinical-multiple-response>\n      </ng-container>\n    </ng-container>\n\n    <!--Medical case-->\n    <ng-container\n      *ngIf=\"\n        questionCurrentData.parentDetails &&\n        questionCurrentData.parentLabelText == 'MEDICAL_CASE'\n      \"\n    >\n      <!--Medical Multiple choice-->\n      <ng-container *ngIf=\"questionCurrentData.labelText == 'MULTIPLE_CHOICE'\">\n        <medical-multiple-choice\n          [checkQuizSubmission]=\"checkQuizSubmission\"\n          [isClearAnswer]=\"isClearAnswer\"\n          [isShowHide]=\"isShowHide\"\n          [questionDetails]=\"questionCurrentData\"\n          [examEngineType]=\"examEngineType\"\n          [imagePath]=\"imagePath\"\n          [canShowMetadata]=\"metadataDisplayValidation()\"\n          [preferredTextFormat]=\"preferredTextFormat\"\n        >\n        </medical-multiple-choice>\n      </ng-container>\n\n      <!--Medical multiple response-->\n      <ng-container *ngIf=\"questionCurrentData.labelText == 'CHOICE_MULTIPLE'\">\n        <medical-multiple-response\n          [checkQuizSubmission]=\"checkQuizSubmission\"\n          [isClearAnswer]=\"isClearAnswer\"\n          [isShowHide]=\"isShowHide\"\n          [questionDetails]=\"questionCurrentData\"\n          [examEngineType]=\"examEngineType\"\n          [imagePath]=\"imagePath\"\n          [canShowMetadata]=\"metadataDisplayValidation()\"\n          [preferredTextFormat]=\"preferredTextFormat\"\n        >\n        </medical-multiple-response>\n      </ng-container>\n    </ng-container>\n\n    <!--True / False -->\n    <ng-container *ngIf=\"questionCurrentData.labelText == 'TRUE_FALSE'\">\n      <true-false\n        [imagePath]=\"imagePath\"\n        [checkQuizSubmission]=\"checkQuizSubmission\"\n        [isClearAnswer]=\"isClearAnswer\"\n        [isShowHide]=\"isShowHide\"\n        [questionDetails]=\"questionCurrentData\"\n        [examEngineType]=\"examEngineType\"\n        [canShowMetadata]=\"metadataDisplayValidation()\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></true-false>\n    </ng-container>\n\n    <!--Fill in the blanks-->\n    <ng-container *ngIf=\"questionCurrentData.labelText == 'FILL_IN_THE_BLANK'\">\n      <fill-in-the-blanks\n        [fontSize]=\"fontSize\"\n        [selectedTheme]=\"selectedTheme\"\n        [checkQuizSubmission]=\"checkQuizSubmission\"\n        [imagePath]=\"imagePath\"\n        [isClearAnswer]=\"isClearAnswer\"\n        [isShowHide]=\"isShowHide\"\n        [questionDetails]=\"questionCurrentData\"\n        [examEngineType]=\"examEngineType\"\n        [canShowMetadata]=\"metadataDisplayValidation()\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></fill-in-the-blanks>\n    </ng-container>\n\n    <!--Graphic option-->\n    <ng-container *ngIf=\"questionCurrentData.labelText == 'GRAPHIC_OPTION'\">\n      <graphic-option\n        [checkQuizSubmission]=\"checkQuizSubmission\"\n        [imagePath]=\"imagePath\"\n        [isClearAnswer]=\"isClearAnswer\"\n        [isShowHide]=\"isShowHide\"\n        [questionDetails]=\"questionCurrentData\"\n        [examEngineType]=\"examEngineType\"\n        [canShowMetadata]=\"metadataDisplayValidation()\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></graphic-option>\n    </ng-container>\n\n    <!--Drag and Drop-->\n\n    <ng-container *ngIf=\"questionCurrentData.labelText == 'DRAG_AND_DROP'\">\n      <drag-and-drop\n        [fontSize]=\"fontSize\"\n        [selectedTheme]=\"selectedTheme\"\n        [checkQuizSubmission]=\"checkQuizSubmission\"\n        [imagePath]=\"imagePath\"\n        [isClearAnswer]=\"isClearAnswer\"\n        [isShowHide]=\"isShowHide\"\n        [questionDetails]=\"questionCurrentData\"\n        [examEngineType]=\"examEngineType\"\n        [canShowMetadata]=\"metadataDisplayValidation()\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></drag-and-drop>\n    </ng-container>\n\n    <!--Hotspot-->\n\n    <ng-container *ngIf=\"questionCurrentData.labelText == 'HOT_SPOT'\">\n      <hot-spot\n        class=\"hotspot-focus\"\n        [fontSize]=\"fontSize\"\n        [selectedTheme]=\"selectedTheme\"\n        [checkQuizSubmission]=\"checkQuizSubmission\"\n        [imagePath]=\"imagePath\"\n        [isClearAnswer]=\"isClearAnswer\"\n        [isShowHide]=\"isShowHide\"\n        [questionDetails]=\"questionCurrentData\"\n        [examEngineType]=\"examEngineType\"\n        [canShowMetadata]=\"metadataDisplayValidation()\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></hot-spot>\n    </ng-container>\n\n    <!--Figure Labelling-->\n\n    <ng-container *ngIf=\"questionCurrentData.labelText == 'FIGURE_LABELING'\">\n      <figure-labeling\n        [fontSize]=\"fontSize\"\n        [selectedTheme]=\"selectedTheme\"\n        [checkQuizSubmission]=\"checkQuizSubmission\"\n        [imagePath]=\"imagePath\"\n        [isClearAnswer]=\"isClearAnswer\"\n        [isShowHide]=\"isShowHide\"\n        [questionDetails]=\"questionCurrentData\"\n        [examEngineType]=\"examEngineType\"\n        [canShowMetadata]=\"metadataDisplayValidation()\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></figure-labeling>\n    </ng-container>\n\n    <!--Inline choice-->\n\n    <ng-container *ngIf=\"questionCurrentData.labelText == 'INLINE_CHOICE'\">\n      <inline-choice\n        [checkQuizSubmission]=\"checkQuizSubmission\"\n        [imagePath]=\"imagePath\"\n        [isClearAnswer]=\"isClearAnswer\"\n        [isShowHide]=\"isShowHide\"\n        [questionDetails]=\"questionCurrentData\"\n        [examEngineType]=\"examEngineType\"\n        [canShowMetadata]=\"metadataDisplayValidation()\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></inline-choice>\n    </ng-container>\n  </div>\n</ng-container>\n",
        styles: [".item-wrapper-container{font-size:var(--font-size)!important}"]
    })
], ItemTypeWrapperComponent);

let ClinicalMultipleChoiceComponent = class ClinicalMultipleChoiceComponent {
    constructor(itemService, formBuilder) {
        this.itemService = itemService;
        this.formBuilder = formBuilder;
        // Declare the variables
        this.userAnswer = [];
        this.correctAns = [];
        this.className = "";
        this.userResponse = false;
        this.assetData = [];
        this.userSelectedLabel = [];
        this.radioValue = {};
        this.questionDetails1 = [];
        this.assetPosition = [];
        this.incorrectRationale = [];
        this.imagePath = [];
    }
    get questionDetails() {
        return this.questionDetails;
    }
    set questionCurrentData(value) {
        if (value) {
            this.questionDetails1 = value;
            this.createQuestion();
        }
        else {
            this.questionDetails1 = [];
            this.createQuestion();
        }
    }
    /* Init */
    ngOnInit() { }
    ngOnChanges(changes) { }
    /*Do check */
    ngDoCheck() {
        // Clear response
        if (this.isClearAnswer === true) {
            this.clearUserInputs();
            this.itemService.userAnswerMethod([]);
            this.itemService.clearAnswerMethodFalse(false);
            this.itemService.hideAnswer(false);
        }
        // Show or hide response
        if (this.isShowHide === true) {
            this.message = true;
        }
        else if (this.isShowHide === false) {
            this.message = false;
        }
    }
    /* function to get correct answer */
    correctAnswer() {
        for (const i of this.questionDetails1.choiceInteraction.simpleChoices) {
            if (i.correct === true) {
                this.correctAns = i;
            }
        }
        this.incorrectRationale = this.questionDetails1.choiceInteraction.simpleChoices.filter(item => item.rationale !== null && item.correct !== true);
    }
    /* function to get selected answer */
    selectAnswer(option) {
        //conosole.log('radioValue', this.form.controls['choices'].value);
        this.radioValue = option;
        this.userAnswer = this.radioValue["choiceId"];
        if (this.userAnswer !== undefined && this.userAnswer !== null) {
            const answerObj = [this.userAnswer];
            this.itemService.userAnswerMethod(answerObj);
            this.itemService.validateAnswerValueMethod(this.isUserAnswersCorrect());
        }
        else {
            this.itemService.userAnswerMethod([]);
            this.itemService.validateAnswerValueMethod(false);
        }
    }
    /* Check user answer is correct */
    isUserAnswersCorrect() {
        if (this.userAnswer === this.correctAns.choiceId) {
            return true;
        }
        else {
            return false;
        }
    }
    /* function to clear user inputs */
    clearUserInputs() {
        this.userAnswer = [];
        this.form.reset();
    }
    /* Get answer css class based on the user answer */
    getChoiceClassName(choiceDetails) {
        if (choiceDetails.correct) {
            return "wk-icon-checkmark green-checkmark";
        }
        else if (!choiceDetails.correct &&
            this.userAnswer === choiceDetails.choiceId) {
            return "wk-icon-close wrong-checkmark";
        }
        else {
            return "wk-icon-checkmark disabled-checkmark";
        }
    }
    /* Check the value changes */
    valueChanged() {
        if (this.userAnswer !== undefined && this.userAnswer !== null) {
            const answerObj = this.userAnswer.length !== 0 ? [this.userAnswer] : this.userAnswer;
            this.itemService.userAnswerMethod(answerObj);
            this.itemService.validateAnswerValueMethod(this.isUserAnswersCorrect());
        }
        else {
            this.itemService.userAnswerMethod([]);
            this.itemService.validateAnswerValueMethod(false);
        }
    }
    createQuestion() {
        this.radioValue = {};
        this.userAnswer = [];
        this.correctAns = [];
        this.incorrectRationale = [];
        this.itemService.userAnswerMethod([]);
        this.itemService.validateAnswerValueMethod(false);
        this.assetData = this.questionDetails1.parentDetails.assets;
        if (this.assetData.length !== 0) {
            this.assetPosition = this.questionDetails1.parentDetails.assets[0]["assetsPosition"];
        }
        this.correctAnswer();
        if (this.questionDetails1.userAttemptDetails.userAnswer !== undefined &&
            Object.keys(this.questionDetails1.userAttemptDetails.userAnswer)
                .length !== 0) {
            for (const j of this.questionDetails1.choiceInteraction.simpleChoices) {
                if (this.questionDetails1.userAttemptDetails.userAnswer[0] ===
                    j["choiceId"]) {
                    this.radioValue = j;
                    this.userAnswer = this.radioValue["choiceId"];
                }
            }
        }
        this.form = this.formBuilder.group({
            choices: [this.radioValue["choiceId"]]
        });
        this.valueChanged();
    }
};
ClinicalMultipleChoiceComponent.ctorParameters = () => [
    { type: ItemService },
    { type: FormBuilder }
];
__decorate([
    Input("questionDetails")
], ClinicalMultipleChoiceComponent.prototype, "questionCurrentData", null);
__decorate([
    Input()
], ClinicalMultipleChoiceComponent.prototype, "examEngineType", void 0);
__decorate([
    Input()
], ClinicalMultipleChoiceComponent.prototype, "canShowMetadata", void 0);
__decorate([
    Input()
], ClinicalMultipleChoiceComponent.prototype, "isClearAnswer", void 0);
__decorate([
    Input()
], ClinicalMultipleChoiceComponent.prototype, "isShowHide", void 0);
__decorate([
    Input()
], ClinicalMultipleChoiceComponent.prototype, "imagePath", void 0);
__decorate([
    Input()
], ClinicalMultipleChoiceComponent.prototype, "checkQuizSubmission", void 0);
__decorate([
    Input()
], ClinicalMultipleChoiceComponent.prototype, "preferredTextFormat", void 0);
ClinicalMultipleChoiceComponent = __decorate([
    Component({
        selector: "clinical-multiple-choice",
        template: "<!--############################ QP Exam Engine Type ####################################-->\n<ng-container *ngIf=\"examEngineType == 'QP' || examEngineType == 'NCLEX'\">\n  <!--Question and Answer Choice-->\n  <div class=\"wkqp-row clinical-res-mb0 clinical-minhight fullwidth-box\">\n    <!--Answer Choice-->\n    <div class=\"wkqp-row clinical-res fullwidth-box\">\n      <div class=\"wkqp-layout-item\">\n        <div class=\"normal-font mb0 fullwidth-box\">\n          <fieldset class=\"common-full-width\">\n            <legend class=\"offscreen\">\n              <span\n                libGetFormatText\n                [preferredTextFormat]=\"preferredTextFormat\"\n                [plainText]=\"questionDetails1.promptText\"\n                [richText]=\"questionDetails1.richPromptText\"\n              ></span>\n            </legend>\n\n            <form [formGroup]=\"form\">\n              <ng-container\n                *ngFor=\"\n                  let item of questionDetails1.choiceInteraction.simpleChoices\n                \"\n              >\n                <div class=\"common-full-width choice-mb\">\n                  <span\n                    *ngIf=\"message\"\n                    [ngClass]=\"getChoiceClassName(item)\"\n                  ></span>\n                  <input\n                    type=\"radio\"\n                    [hidden]=\"message\"\n                    [value]=\"item.choiceId\"\n                    (change)=\"selectAnswer(item)\"\n                    formControlName=\"choices\"\n                  />\n                  <span\n                    libGetFormatText\n                    [preferredTextFormat]=\"preferredTextFormat\"\n                    [plainText]=\"item.label\"\n                    [richText]=\"item.richLabel\"\n                  ></span>\n                </div>\n                <div\n                  class=\"wkqp-alert-info mt10 wkqp-prewrap correct-rationale-section wkqp-prewrap rational-inline\"\n                  *ngIf=\"message && item.rationale\"\n                >\n                  <strong class=\"white-space-normal\">Rationale: </strong>\n                  <span\n                    class=\"white-space-normal\"\n                    libGetFormatText\n                    [preferredTextFormat]=\"preferredTextFormat\"\n                    [plainText]=\"item.rationale\"\n                    [richText]=\"item.richRationale\"\n                  ></span>\n                </div>\n              </ng-container>\n            </form>\n          </fieldset>\n        </div>\n      </div>\n    </div>\n\n    <!--Question Text-->\n    <div class=\"wkqp-field-item\">\n      <div class=\"wkqp-field-header custom-field-header\">\n        <p\n          class=\"mb20 normal-font wkqp-prewrap heading-h2 heading-h2-pb0 question-prompt-text ng-binding\"\n        >\n          <span\n            libGetFormatText\n            [preferredTextFormat]=\"preferredTextFormat\"\n            [plainText]=\"questionDetails1.promptText\"\n            [richText]=\"questionDetails1.richPromptText\"\n          ></span>\n        </p>\n      </div>\n    </div>\n\n    <div class=\"wkqp-row mb20 clinical-res\">\n      <div class=\"wkqp-field-header label-heading clinical-heading \">\n        <span>Clinical Presenting Symptoms</span>\n      </div>\n\n      <!--Carousel-->\n      <media-carousel\n        *ngIf=\"\n          questionDetails1.parentDetails.assets &&\n          questionDetails1.parentDetails.assets.length != 0 &&\n          assetPosition != 'Bottom' &&\n          assetPosition != 'WithinText'\n        \"\n        [imagePath]=\"imagePath\"\n        [assetData]=\"assetData\"\n        [assetsPosition]=\"assetPosition\"\n      ></media-carousel>\n\n      <div\n        [ngClass]=\"{\n          'wk-col-8':\n            questionDetails1.parentDetails.assets != undefined &&\n            questionDetails1.parentDetails.assets.length != 0 &&\n            assetPosition != 'WithinText',\n          'wk-col-12':\n            questionDetails1.parentDetails.assets == undefined ||\n            questionDetails1.parentDetails.assets.length == 0 ||\n            assetPosition == 'WithinText',\n          'right-assets-position-question clinical-multiple-choice-right-wk-col-8':\n            assetPosition == 'Right',\n          'left-assets-position-question': assetPosition == 'Left',\n          'top-assets-position-question': assetPosition == 'Top',\n          'bottom-assets-position-question': assetPosition == 'Bottom'\n        }\"\n      >\n        <div class=\"wkqp-layout-item\">\n          <div class=\"wkqp-field-item normal-font mb0 \">\n            <div\n              class=\"wkqp-field-header\"\n              *ngIf=\"assetPosition != 'WithinText'\"\n            >\n              <p\n                class=\"mb20 normal-font wkqp-prewrap heading-h3 headingh3-res question-parent-text\"\n              >\n                {{ questionDetails1.parentDetails.promptText }}\n              </p>\n            </div>\n            <div\n              class=\"wkqp-field-header\"\n              *ngIf=\"assetPosition == 'WithinText'\"\n            >\n              <item-text-assets\n                [promptText]=\"questionDetails1.parentDetails.promptText\"\n                [imagePath]=\"imagePath\"\n                [assetData]=\"assetData\"\n                [assetsPosition]=\"assetPosition\"\n              ></item-text-assets>\n            </div>\n          </div>\n        </div>\n\n        <media-carousel\n          *ngIf=\"\n            questionDetails1.parentDetails.assets &&\n            questionDetails1.parentDetails.assets.length != 0 &&\n            assetPosition == 'Bottom' &&\n            assetPosition != 'WithinText'\n          \"\n          [imagePath]=\"imagePath\"\n          [assetData]=\"assetData\"\n          [assetsPosition]=\"assetPosition\"\n        ></media-carousel>\n      </div>\n    </div>\n  </div>\n  <div *ngIf=\"canShowMetadata && message != true\">\n    <lib-metadata [itemData]=\"questionDetails1\"></lib-metadata>\n  </div>\n\n  <!--User answer and show answer -->\n  <ng-container *ngIf=\"message\">\n    <!--your answer-->\n    <p\n      class=\"wkqp-prewrap  mb20\"\n      [ngClass]=\"\n        isUserAnswersCorrect()\n          ? 'wkqp-alert-success wkqp-success'\n          : 'wkqp-alert-danger wkqp-danger'\n      \"\n      *ngIf=\"userAnswer.length != 0\"\n    >\n      <strong>Your Response:</strong>\n      <span\n        class=\"optionlevel\"\n        libGetFormatText\n        [preferredTextFormat]=\"preferredTextFormat\"\n        [plainText]=\"radioValue['label']\"\n        [richText]=\"radioValue['richLabel']\"\n      ></span>\n    </p>\n    <!--Correct response-->\n    <p\n      class=\"wkqp-prewrap wkqp-alert-success wkqp-success mb20\"\n      *ngIf=\"!isUserAnswersCorrect()\"\n    >\n      <strong>Correct Response:</strong>\n      <span\n        class=\"optionlevel\"\n        libGetFormatText\n        [preferredTextFormat]=\"preferredTextFormat\"\n        [plainText]=\"correctAns.label\"\n        [richText]=\"correctAns.richLabel\"\n      ></span>\n    </p>\n    <div *ngIf=\"canShowMetadata\">\n      <lib-metadata [itemData]=\"questionDetails1\"></lib-metadata>\n    </div>\n    <div class=\"common-full-width mb20\">\n      <lib-rationale\n        [itemData]=\"questionDetails1.modelFeedback\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></lib-rationale>\n      <!--Remediation-->\n      <lib-remediation\n        [itemData]=\"questionDetails1.remediationLinks\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></lib-remediation>\n    </div>\n  </ng-container>\n</ng-container>\n\n<!--############################ USMLE Exam Engine Type ####################################-->\n<ng-container *ngIf=\"examEngineType == 'USMLE'\">\n  <!--Question and answer choice-->\n  <div class=\"wkqp-row mb20 clinical-res-mb0 clinical-minhight\">\n    <!--Answer Choice-->\n    <div class=\"wkqp-row mb20 clinical-res\">\n      <div class=\"wkqp-layout-item\">\n        <div class=\"wkqp-field-item normal-font mb0\">\n          <fieldset class=\"common-full-width\">\n            <legend class=\"offscreen\">{{ questionDetails1.promptText }}</legend>\n\n            <form [formGroup]=\"form\">\n              <ng-container\n                *ngFor=\"\n                  let item of questionDetails1.choiceInteraction.simpleChoices\n                \"\n              >\n                <div>\n                  <span\n                    *ngIf=\"checkQuizSubmission == true\"\n                    [ngClass]=\"getChoiceClassName(item)\"\n                  ></span>\n                  <input\n                    type=\"radio\"\n                    [hidden]=\"checkQuizSubmission == true\"\n                    [value]=\"item.choiceId\"\n                    (change)=\"selectAnswer(item)\"\n                    formControlName=\"choices\"\n                  />\n                  <span>{{ item.label }}</span>\n                </div>\n                <div\n                  class=\"wkqp-alert-info wkqp-prewrap correct-rationale-section wkqp-prewrap\"\n                  *ngIf=\"checkQuizSubmission == true && item.rationale\"\n                >\n                  <strong>Rationale: </strong>{{ item.rationale }}\n                </div>\n              </ng-container>\n            </form>\n          </fieldset>\n        </div>\n      </div>\n    </div>\n\n    <!--Question text-->\n    <div class=\"wkqp-field-item\">\n      <div class=\"wkqp-field-header custom-field-header\">\n        <div class=\"mb20 normal-font wkqp-prewrap heading-h2 heading-h2-pb0\">\n          {{ questionDetails1.promptText }}\n        </div>\n      </div>\n    </div>\n    <div class=\"wkqp-row mb20 clinical-res\">\n      <div class=\"wkqp-field-header label-heading clinical-heading\">\n        <span>Clinical Presenting Symptoms</span>\n      </div>\n\n      <!--Carousel-->\n      <media-carousel\n        *ngIf=\"\n          questionDetails1.parentDetails.assets &&\n          questionDetails1.parentDetails.assets.length != 0 &&\n          assetPosition != 'Bottom' &&\n          assetPosition != 'WithinText'\n        \"\n        [imagePath]=\"imagePath\"\n        [assetData]=\"assetData\"\n        [assetsPosition]=\"assetPosition\"\n      ></media-carousel>\n\n      <div\n        [ngClass]=\"{\n          'wk-col-8':\n            questionDetails1.parentDetails.assets != undefined &&\n            questionDetails1.parentDetails.assets.length != 0 &&\n            assetPosition != 'WithinText',\n          'wk-col-12':\n            questionDetails1.parentDetails.assets == undefined ||\n            questionDetails1.parentDetails.assets.length == 0 ||\n            assetPosition == 'WithinText',\n          'right-assets-position-question': assetPosition == 'Right',\n          'left-assets-position-question': assetPosition == 'Left',\n          'top-assets-position-question': assetPosition == 'Top',\n          'bottom-assets-position-question': assetPosition == 'Bottom'\n        }\"\n      >\n        <div class=\"wkqp-layout-item\">\n          <div class=\"wkqp-field-item normal-font mb0 \">\n            <div\n              class=\"wkqp-field-header\"\n              *ngIf=\"assetPosition != 'WithinText'\"\n            >\n              <div class=\"mb20 normal-font wkqp-prewrap\">\n                {{ questionDetails1.parentDetails.promptText }}\n              </div>\n            </div>\n            <div\n              class=\"wkqp-field-header\"\n              *ngIf=\"assetPosition == 'WithinText'\"\n            >\n              <item-text-assets\n                [promptText]=\"questionDetails1.parentDetails.promptText\"\n                [imagePath]=\"imagePath\"\n                [assetData]=\"assetData\"\n                [assetsPosition]=\"assetPosition\"\n              ></item-text-assets>\n            </div>\n          </div>\n        </div>\n\n        <media-carousel\n          *ngIf=\"\n            questionDetails1.parentDetails.assets &&\n            questionDetails1.parentDetails.assets.length != 0 &&\n            assetPosition == 'Bottom' &&\n            assetPosition != 'WithinText'\n          \"\n          [imagePath]=\"imagePath\"\n          [assetData]=\"assetData\"\n          [assetsPosition]=\"assetPosition\"\n        ></media-carousel>\n      </div>\n    </div>\n  </div>\n\n  <!--User answer and correct answer-->\n  <ng-container *ngIf=\"checkQuizSubmission == true\">\n    <!-- User answer -->\n    <p\n      class=\"wkqp-prewrap  mb20\"\n      [ngClass]=\"\n        isUserAnswersCorrect()\n          ? 'wkqp-alert-success wkqp-success'\n          : 'wkqp-alert-danger wkqp-danger'\n      \"\n      *ngIf=\"userAnswer.length != 0\"\n    >\n      <strong>Your Response:</strong>\n      <span class=\"optionlevel\">{{ radioValue['label'] }}</span>\n    </p>\n\n    <!--Correct answer-->\n    <p\n      class=\"wkqp-prewrap wkqp-alert-success wkqp-success \"\n      *ngIf=\"!isUserAnswersCorrect()\"\n    >\n      <strong>Correct Response:</strong>\n      <span class=\"optionlevel\">{{ correctAns.label }}</span>\n    </p>\n\n    <!--Rationale-->\n    <p\n      class=\"wk-row common-full-width\"\n      *ngIf=\"questionDetails1.modelFeedback[0].length !== 0\"\n    >\n      <strong>Rationale:</strong>\n      <span>{{ questionDetails1.modelFeedback[0].feedbackText }}</span>\n    </p>\n\n    <!--Remediation-->\n    <div\n      class=\"wk-row common-full-width\"\n      *ngIf=\"questionDetails1.remediationLinks.length !== 0\"\n    >\n      <strong>Remediation:</strong>\n      <div\n        *ngFor=\"\n          let Remediation of questionDetails1.remediationLinks;\n          let k = index\n        \"\n      >\n        <span *ngIf=\"Remediation.linkTypeId == 1\">{{\n          Remediation.linkText1\n        }}</span>\n        <span *ngIf=\"Remediation.linkTypeId != 1\">\n          {{ Remediation.linkText1 }}</span\n        >\n      </div>\n    </div>\n  </ng-container>\n</ng-container>\n",
        styles: [".clinical-multiple-choice-right-wk-col-8{width:64%!important;padding:0}.choice-mb{margin-bottom:.1875rem}"]
    })
], ClinicalMultipleChoiceComponent);

let ClinicalMultipleResponseComponent = class ClinicalMultipleResponseComponent {
    constructor(itemService, formBuilder) {
        this.itemService = itemService;
        this.formBuilder = formBuilder;
        // Declare the variables
        this.userAnswer = [];
        this.correctAns = [];
        this.assetData = [];
        this.selectedOrderIds = [];
        this.questionDetails1 = [];
        this.assetPosition = [];
        this.incorrectRationale = [];
        this.imagePath = [];
    }
    get questionDetails() {
        return this.questionDetails;
    }
    set questionCurrentData(value) {
        if (value) {
            this.questionDetails1 = value;
            this.createQuestion();
        }
        else {
            this.questionDetails1 = [];
            this.createQuestion();
        }
    }
    /* Init */
    ngOnInit() { }
    ngOnChanges(changes) {
        console.log("clinical multiple response changes", changes);
    }
    /* Do check */
    ngDoCheck() {
        if (this.isClearAnswer === true) {
            this.clearUserInputs();
            this.itemService.userAnswerMethod([]);
            this.itemService.clearAnswerMethodFalse(false);
            this.itemService.hideAnswer(false);
        }
        if (this.isShowHide === true) {
            this.message = true;
        }
        else if (this.isShowHide === false) {
            this.message = false;
        }
    }
    /* function to get correct answer */
    correctAnswer() {
        for (const i of this.questionDetails1.choiceInteraction.simpleChoices) {
            if (i.correct === true) {
                this.correctAns.push(i);
                this.correctAnsString = (this.correctAnsString) ? this.correctAnsString + ', ' + i.label : i.label;
            }
        }
        this.incorrectRationale = this.questionDetails1.choiceInteraction.simpleChoices.filter(item => item.rationale !== null && item.correct !== true);
    }
    /* function to get selected answer */
    selectAnswer(option, i) {
        this.selectedOrderIds = this.form.value.orders
            .map((v, i) => v
            ? this.questionDetails1.choiceInteraction.simpleChoices[i].choiceId
            : null)
            .filter(v => v !== null);
        this.commaSeperatedUserResponseLabel();
        this.userAnswer = this.selectedOrderIds;
        if (this.userAnswer.length !== 0) {
            const answerObj = this.userAnswer;
            this.itemService.userAnswerMethod(answerObj);
            this.itemService.validateAnswerValueMethod(this.isUserAnswersCorrect());
        }
        else {
            this.itemService.userAnswerMethod([]);
            this.itemService.validateAnswerValueMethod(false);
        }
    }
    /* Check wheather the user answer value is correct or not */
    isUserAnswersCorrect() {
        this.selectedOrderIds = this.form.value.orders
            .map((v, i) => v
            ? this.questionDetails1.choiceInteraction.simpleChoices[i].choiceId
            : null)
            .filter(v => v !== null);
        if (this.selectedOrderIds.length !== this.correctAns.length) {
            return false;
        }
        else {
            for (const answer of this.correctAns) {
                if (!this.selectedOrderIds.find(item => item === answer.choiceId)) {
                    return false;
                }
            }
        }
        return true;
    }
    /* function to clear user inputs */
    clearUserInputs() {
        this.userAnswer = [];
        this.form.reset();
    }
    /* Get choice css class */
    getChoiceClassName(choiceDetails) {
        let checked = false;
        for (const item of this.selectedOrderIds) {
            if (choiceDetails["choiceId"] === item) {
                checked = true;
            }
        }
        if (choiceDetails.correct) {
            return "wk-icon-checkmark green-checkmark";
        }
        else if (!choiceDetails.correct && checked === true) {
            return "wk-icon-close wrong-checkmark";
        }
        else {
            return "wk-icon-checkmark disabled-checkmark";
        }
    }
    /* Check the value is changed or not */
    valueChanged() {
        this.selectedOrderIds = this.form.value.orders
            .map((v, i) => v
            ? this.questionDetails1.choiceInteraction.simpleChoices[i].choiceId
            : null)
            .filter(v => v !== null);
        this.commaSeperatedUserResponseLabel();
        this.userAnswer = this.selectedOrderIds;
        if (this.userAnswer.length !== 0) {
            const answerObj = this.userAnswer;
            this.itemService.userAnswerMethod(answerObj);
            this.itemService.validateAnswerValueMethod(this.isUserAnswersCorrect());
        }
        else {
            this.itemService.userAnswerMethod([]);
            this.itemService.validateAnswerValueMethod(false);
        }
    }
    getFormArray() {
        return this.form.get("orders");
    }
    createQuestion() {
        this.assetData = this.questionDetails1.parentDetails.assets;
        this.userAnswer = [];
        this.correctAns = [];
        this.incorrectRationale = [];
        this.itemService.userAnswerMethod([]);
        this.itemService.validateAnswerValueMethod(false);
        if (this.assetData.length !== 0) {
            this.assetPosition = this.questionDetails1.parentDetails.assets[0]["assetsPosition"];
        }
        const controls = this.questionDetails1.choiceInteraction.simpleChoices.map(c => new FormControl(false));
        this.form = this.formBuilder.group({
            orders: new FormArray(controls)
        });
        this.getFormArray();
        if (this.questionDetails1.userAttemptDetails.userAnswer.length !== 0) {
            for (let i = 0; i < this.questionDetails1.choiceInteraction.simpleChoices.length; i++) {
                for (const j of this.questionDetails1.userAttemptDetails.userAnswer) {
                    if (this.questionDetails1.choiceInteraction.simpleChoices[i]["choiceId"] === j) {
                        controls[i].setValue(true);
                    }
                }
            }
            this.valueChanged();
        }
        this.correctAnswer();
    }
    commaSeperatedUserResponseLabel() {
        this.userResponseLabel = '';
        this.selectedOrderIds.forEach(selected => {
            const selectedChoice = this.questionDetails1.choiceInteraction.simpleChoices.find(choice => choice.choiceId == selected);
            if (selectedChoice) {
                this.userResponseLabel = (this.userResponseLabel) ? this.userResponseLabel + ', ' + selectedChoice.label : selectedChoice.label;
            }
        });
    }
};
ClinicalMultipleResponseComponent.ctorParameters = () => [
    { type: ItemService },
    { type: FormBuilder }
];
__decorate([
    Input("questionDetails")
], ClinicalMultipleResponseComponent.prototype, "questionCurrentData", null);
__decorate([
    Input()
], ClinicalMultipleResponseComponent.prototype, "examEngineType", void 0);
__decorate([
    Input()
], ClinicalMultipleResponseComponent.prototype, "isClearAnswer", void 0);
__decorate([
    Input()
], ClinicalMultipleResponseComponent.prototype, "isShowHide", void 0);
__decorate([
    Input()
], ClinicalMultipleResponseComponent.prototype, "imagePath", void 0);
__decorate([
    Input()
], ClinicalMultipleResponseComponent.prototype, "checkQuizSubmission", void 0);
__decorate([
    Input()
], ClinicalMultipleResponseComponent.prototype, "canShowMetadata", void 0);
__decorate([
    Input()
], ClinicalMultipleResponseComponent.prototype, "preferredTextFormat", void 0);
ClinicalMultipleResponseComponent = __decorate([
    Component({
        selector: "clinical-multiple-response",
        template: "<!-- ########################## QP exam Engine Type ##########################-->\n<ng-container *ngIf=\"examEngineType == 'QP' || examEngineType == 'NCLEX'\">\n  <!--Question & answer choice Block-->\n  <div class=\"wkqp-row mb20 clinical-res-mb0 clinical-minhight fullwidth-box\">\n    <!--Question Answer Choice-->\n    <div class=\"wkqp-row mb20 clinical-res fullwidth-box\">\n      <div class=\"wkqp-layout-item\">\n        <div class=\"wkqp-field-item normal-font mb0 fullwidth-box\">\n          <fieldset class=\"common-full-width\">\n            <legend\n              class=\"offscreen\"\n              libGetFormatText\n              [preferredTextFormat]=\"preferredTextFormat\"\n              [plainText]=\"questionDetails1.promptText\"\n              [richText]=\"questionDetails1.richPromptText\"\n            ></legend>\n\n            <form [formGroup]=\"form\">\n              <ng-container\n                formArrayName=\"orders\"\n                *ngFor=\"let order of getFormArray().controls; let i = index\"\n              >\n                <div>\n                  <span\n                    *ngIf=\"message\"\n                    [ngClass]=\"\n                      getChoiceClassName(\n                        questionDetails1.choiceInteraction.simpleChoices[i]\n                      )\n                    \"\n                  ></span>\n                  <input\n                    type=\"checkbox\"\n                    [formControlName]=\"i\"\n                    [hidden]=\"message\"\n                    (change)=\"\n                      selectAnswer(\n                        questionDetails1.choiceInteraction.simpleChoices[i],\n                        i\n                      )\n                    \"\n                  />\n                  <span\n                    libGetFormatText\n                    [preferredTextFormat]=\"preferredTextFormat\"\n                    [plainText]=\"\n                      questionDetails1.choiceInteraction.simpleChoices[i].label\n                    \"\n                    [richText]=\"\n                      questionDetails1.choiceInteraction.simpleChoices[i]\n                        .richLabel\n                    \"\n                  ></span>\n                </div>\n                <div\n                  class=\"wkqp-alert-info wkqp-prewrap correct-rationale-section wkqp-prewrap rational-inline\"\n                  *ngIf=\"\n                    message &&\n                    questionDetails1.choiceInteraction.simpleChoices[i]\n                      .rationale\n                  \"\n                >\n                  <strong class=\"rationale-\">Rationale: </strong>\n                  <span\n                    libGetFormatText\n                    [preferredTextFormat]=\"preferredTextFormat\"\n                    [plainText]=\"\n                      questionDetails1.choiceInteraction.simpleChoices[i]\n                        .rationale\n                    \"\n                    [richText]=\"\n                      questionDetails1.choiceInteraction.simpleChoices[i]\n                        .richRationale\n                    \"\n                  ></span>\n                </div>\n              </ng-container>\n            </form>\n          </fieldset>\n        </div>\n      </div>\n    </div>\n\n    <!--Question prompt text-->\n    <div class=\"wkqp-field-item\">\n      <div class=\"wkqp-field-header custom-field-header\">\n        <p\n          class=\"mb20 normal-font wkqp-prewrap heading-h2 heading-h2-pb0 question-prompt-text ng-binding\"\n          libGetFormatText\n          [preferredTextFormat]=\"preferredTextFormat\"\n          [plainText]=\"questionDetails1.promptText\"\n          [richText]=\"questionDetails1.richPromptText\"\n        ></p>\n      </div>\n    </div>\n    <div class=\"wkqp-row mb20 clinical-res\">\n      <div class=\"wkqp-field-header label-heading clinical-heading\">\n        <span>Clinical Presenting Symptoms</span>\n      </div>\n      <!--Carousel-->\n      <media-carousel\n        *ngIf=\"\n          questionDetails1.parentDetails.assets &&\n          questionDetails1.parentDetails.assets.length != 0 &&\n          assetPosition != 'Bottom' &&\n          assetPosition != 'WithinText'\n        \"\n        [imagePath]=\"imagePath\"\n        [assetData]=\"assetData\"\n        [assetsPosition]=\"assetPosition\"\n      ></media-carousel>\n\n      <div\n        [ngClass]=\"{\n          'wk-col-8':\n            questionDetails1.parentDetails.assets != undefined &&\n            questionDetails1.parentDetails.assets.length != 0 &&\n            assetPosition != 'WithinText',\n          'wk-col-12':\n            questionDetails1.parentDetails.assets == undefined ||\n            questionDetails1.parentDetails.assets.length == 0 ||\n            assetPosition == 'WithinText',\n          'right-assets-position-question': assetPosition == 'Right',\n          'left-assets-position-question': assetPosition == 'Left',\n          'top-assets-position-question': assetPosition == 'Top',\n          'bottom-assets-position-question': assetPosition == 'Bottom'\n        }\"\n      >\n        <div class=\"wkqp-layout-item\">\n          <div class=\"wkqp-field-item normal-font mb0 \">\n            <div\n              class=\"wkqp-field-header\"\n              *ngIf=\"assetPosition != 'WithinText'\"\n            >\n              <p\n                class=\"mb20 normal-font wkqp-prewrap heading-h3 headingh3-res question-parent-text\"\n              >\n                {{ questionDetails1.parentDetails.promptText }}\n              </p>\n            </div>\n            <div\n              class=\"wkqp-field-header\"\n              *ngIf=\"assetPosition == 'WithinText'\"\n            >\n              <item-text-assets\n                [promptText]=\"questionDetails1.parentDetails.promptText\"\n                [imagePath]=\"imagePath\"\n                [assetData]=\"assetData\"\n                [assetsPosition]=\"assetPosition\"\n              ></item-text-assets>\n            </div>\n          </div>\n        </div>\n\n        <media-carousel\n          *ngIf=\"\n            questionDetails1.parentDetails.assets &&\n            questionDetails1.parentDetails.assets.length != 0 &&\n            assetPosition == 'Bottom' &&\n            assetPosition != 'WithinText'\n          \"\n          [imagePath]=\"imagePath\"\n          [assetData]=\"assetData\"\n          [assetsPosition]=\"assetPosition\"\n        ></media-carousel>\n      </div>\n    </div>\n  </div>\n  <div *ngIf=\"canShowMetadata && message != true\">\n    <lib-metadata [itemData]=\"questionDetails1\"></lib-metadata>\n  </div>\n\n  <!-- User answer and correct answer block-->\n  <ng-container *ngIf=\"message\">\n    <!--your response-->\n    <span\n      class=\"wkqp-prewrap mt10-al-in  mb20\"\n      [ngClass]=\"\n        isUserAnswersCorrect()\n          ? 'wkqp-alert-success wkqp-success'\n          : 'wkqp-alert-danger wkqp-danger'\n      \"\n      *ngIf=\"userAnswer.length != 0\"\n    >\n      <strong>Your Response:</strong>\n      <span class=\"optionlevel\">{{ userResponseLabel }}</span>\n    </span>\n\n    <!--Correct response-->\n    <span\n      class=\"wkqp-prewrap wkqp-alert-success wkqp-success  mb20\"\n      *ngIf=\"!isUserAnswersCorrect()\"\n    >\n      <strong>Correct Response:</strong>\n      <span class=\"optionlevel\">{{ correctAnsString }}</span>\n    </span>\n    <div *ngIf=\"canShowMetadata\">\n      <lib-metadata [itemData]=\"questionDetails1\"></lib-metadata>\n    </div>\n\n    <div class=\"common-full-width mb20\">\n      <lib-rationale\n        [itemData]=\"questionDetails1.modelFeedback\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></lib-rationale>\n\n      <!--Remediation-->\n      <lib-remediation\n        [itemData]=\"questionDetails1.remediationLinks\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></lib-remediation>\n    </div>\n  </ng-container>\n</ng-container>\n\n<!-- ########################## USMLE exam Engine Type ##########################-->\n<ng-container *ngIf=\"examEngineType == 'USMLE'\">\n  <!--Question and answer block starts-->\n  <div class=\"wkqp-row mb20 clinical-res-mb0 clinical-minhight\">\n    <!--Question answer choice-->\n    <div class=\"wkqp-row mb20 clinical-res\">\n      <div class=\"wkqp-layout-item\">\n        <div class=\"wkqp-field-item normal-font mb0\">\n          <fieldset class=\"common-full-width\">\n            <legend class=\"offscreen\">{{ questionDetails1.promptText }}</legend>\n\n            <form [formGroup]=\"form\">\n              <ng-container\n                formArrayName=\"orders\"\n                *ngFor=\"let order of getFormArray().controls; let i = index\"\n              >\n                <div>\n                  <span\n                    *ngIf=\"checkQuizSubmission == true\"\n                    [ngClass]=\"\n                      getChoiceClassName(\n                        questionDetails1.choiceInteraction.simpleChoices[i]\n                      )\n                    \"\n                  ></span>\n                  <input\n                    type=\"checkbox\"\n                    [formControlName]=\"i\"\n                    [hidden]=\"checkQuizSubmission == true\"\n                    (change)=\"\n                      selectAnswer(\n                        questionDetails1.choiceInteraction.simpleChoices[i],\n                        i\n                      )\n                    \"\n                  />\n                  {{\n                    questionDetails1.choiceInteraction.simpleChoices[i].label\n                  }}\n                </div>\n                <div\n                  class=\"wkqp-alert-info wkqp-prewrap correct-rationale-section wkqp-prewrap\"\n                  *ngIf=\"\n                    checkQuizSubmission == true &&\n                    questionDetails1.choiceInteraction.simpleChoices[i]\n                      .rationale\n                  \"\n                >\n                  <strong>Rationale: </strong>\n                  {{\n                    questionDetails1.choiceInteraction.simpleChoices[i]\n                      .rationale\n                  }}\n                </div>\n              </ng-container>\n            </form>\n          </fieldset>\n        </div>\n      </div>\n    </div>\n\n    <!--Question prompt text-->\n    <div class=\"wkqp-field-item\">\n      <div class=\"wkqp-field-header custom-field-header\">\n        <div class=\"mb20 normal-font wkqp-prewrap\">\n          {{ questionDetails1.promptText }}\n        </div>\n      </div>\n    </div>\n    <div class=\"wkqp-row mb20 clinical-res\">\n      <div class=\"wkqp-field-header label-heading clinical-heading\">\n        <span>Clinical Presenting Symptoms</span>\n      </div>\n      <!--Carousel-->\n      <media-carousel\n        *ngIf=\"\n          questionDetails1.parentDetails.assets &&\n          questionDetails1.parentDetails.assets.length != 0 &&\n          assetPosition != 'Bottom' &&\n          assetPosition != 'WithinText'\n        \"\n        [imagePath]=\"imagePath\"\n        [assetData]=\"assetData\"\n        [assetsPosition]=\"assetPosition\"\n      ></media-carousel>\n\n      <div\n        [ngClass]=\"{\n          'wk-col-8':\n            questionDetails1.parentDetails.assets != undefined &&\n            questionDetails1.parentDetails.assets.length != 0 &&\n            assetPosition != 'WithinText',\n          'wk-col-12':\n            questionDetails1.parentDetails.assets == undefined ||\n            questionDetails1.parentDetails.assets.length == 0 ||\n            assetPosition == 'WithinText',\n          'right-assets-position-question': assetPosition == 'Right',\n          'left-assets-position-question': assetPosition == 'Left',\n          'top-assets-position-question': assetPosition == 'Top',\n          'bottom-assets-position-question': assetPosition == 'Bottom'\n        }\"\n      >\n        <div class=\"wkqp-layout-item\">\n          <div class=\"wkqp-field-item normal-font mb0 \">\n            <div\n              class=\"wkqp-field-header\"\n              *ngIf=\"assetPosition != 'WithinText'\"\n            >\n              <div class=\"mb20 normal-font wkqp-prewrap\">\n                {{ questionDetails1.parentDetails.promptText }}\n              </div>\n            </div>\n            <div\n              class=\"wkqp-field-header\"\n              *ngIf=\"assetPosition == 'WithinText'\"\n            >\n              <item-text-assets\n                [promptText]=\"questionDetails1.parentDetails.promptText\"\n                [imagePath]=\"imagePath\"\n                [assetData]=\"assetData\"\n                [assetsPosition]=\"assetPosition\"\n              ></item-text-assets>\n            </div>\n          </div>\n        </div>\n\n        <media-carousel\n          *ngIf=\"\n            questionDetails1.parentDetails.assets &&\n            questionDetails1.parentDetails.assets.length != 0 &&\n            assetPosition == 'Bottom' &&\n            assetPosition != 'WithinText'\n          \"\n          [imagePath]=\"imagePath\"\n          [assetData]=\"assetData\"\n          [assetsPosition]=\"assetPosition\"\n        ></media-carousel>\n      </div>\n    </div>\n  </div>\n\n  <!--User answer and correct answer-->\n  <ng-container *ngIf=\"checkQuizSubmission == true\">\n    <!--Your response-->\n    <span\n      class=\"wkqp-prewrap mt10-al-in  mb20\"\n      [ngClass]=\"\n        isUserAnswersCorrect()\n          ? 'wkqp-alert-success wkqp-success'\n          : 'wkqp-alert-danger wkqp-danger'\n      \"\n      *ngIf=\"userAnswer.length != 0\"\n    >\n      <strong>Your Response:</strong>\n\n      <form [formGroup]=\"form\" class=\"your-response-form\">\n        <ng-container\n          formArrayName=\"orders\"\n          *ngFor=\"let order of getFormArray().controls; let i = index\"\n        >\n          <span *ngIf=\"order.value === true\" class=\"optionlevel\">\n            {{ questionDetails1.choiceInteraction.simpleChoices[i].label }},\n          </span>\n        </ng-container>\n      </form>\n    </span>\n\n    <!--Correct response-->\n    <span\n      class=\"wkqp-prewrap wkqp-alert-success wkqp-success \"\n      *ngIf=\"!isUserAnswersCorrect()\"\n    >\n      <strong>Correct Response:</strong>\n      <ng-container *ngFor=\"let item of correctAns\">\n        <span class=\"optionlevel\"> {{ item.label }}, </span>\n      </ng-container>\n    </span>\n\n    <!--Rationale-->\n    <p\n      class=\"wk-row common-full-width\"\n      *ngIf=\"questionDetails1.modelFeedback[0].length !== 0\"\n    >\n      <strong>Rationale:</strong>\n      <span>{{ questionDetails1.modelFeedback[0].feedbackText }}</span>\n    </p>\n\n    <!--Remediation-->\n    <div\n      class=\"wk-row common-full-width\"\n      *ngIf=\"questionDetails1.remediationLinks.length !== 0\"\n    >\n      <strong>Remediation:</strong>\n      <div\n        *ngFor=\"\n          let Remediation of questionDetails1.remediationLinks;\n          let k = index\n        \"\n      >\n        <span *ngIf=\"Remediation.linkTypeId == 1\">{{\n          Remediation.linkText1\n        }}</span>\n        <span *ngIf=\"Remediation.linkTypeId != 1\">\n          {{ Remediation.linkText1 }}</span\n        >\n      </div>\n    </div>\n  </ng-container>\n</ng-container>\n",
        styles: [".bottom-assets-position-question{float:left!important;width:100%!important}"]
    })
], ClinicalMultipleResponseComponent);

let TrueFalseComponent = class TrueFalseComponent {
    constructor(itemService, formBuilder) {
        this.itemService = itemService;
        this.formBuilder = formBuilder;
        // Declare the variables
        this.userAnswer = [];
        this.correctAns = [];
        this.assetData = [];
        this.radioValue = {};
        this.questionDetails1 = [];
        this.assetPosition = [];
        // tslint:disable-next-line:max-line-length
        this.alphabetsIndex = [
            "A",
            "B",
            "C",
            "D",
            "E",
            "F",
            "G",
            "H",
            "I",
            "J",
            "K",
            "L",
            "M",
            "N",
            "O",
            "P",
            "Q",
            "R",
            "S",
            "T",
            "U",
            "V",
            "W",
            "X",
            "Y",
            "Z"
        ];
        this.incorrectRationale = [];
        this.imagePath = [];
    }
    get questionDetails() {
        return this.questionDetails;
    }
    set questionCurrentData(value) {
        if (value) {
            this.questionDetails1 = value;
            this.createQuestion();
        }
        else {
            this.questionDetails1 = [];
            this.createQuestion();
        }
    }
    /* Init */
    ngOnInit() { }
    /* Do Check */
    ngDoCheck() {
        if (this.isClearAnswer === true) {
            this.clearUserInputs();
            this.itemService.userAnswerMethod([]);
            this.itemService.clearAnswerMethodFalse(false);
            this.itemService.hideAnswer(false);
        }
        if (this.isShowHide === true) {
            this.message = true;
        }
        else if (this.isShowHide === false) {
            this.message = false;
        }
    }
    ngOnChanges(changes) { }
    /*function to get correct answer */
    correctAnswer() {
        for (const i of this.questionDetails1.choiceInteraction.simpleChoices) {
            if (i.correct === true) {
                this.correctAns = i;
            }
        }
        this.incorrectRationale = this.questionDetails1.choiceInteraction.simpleChoices.filter(item => item.rationale !== null && item.correct !== true);
    }
    /* function to get selected answer */
    selectAnswer(option) {
        this.radioValue = option;
        this.userAnswer = this.radioValue["choiceId"];
        // Call the service to store the user answer
        if (this.userAnswer !== undefined && this.userAnswer !== null) {
            const answerObj = [this.userAnswer];
            this.itemService.userAnswerMethod(answerObj);
            this.itemService.validateAnswerValueMethod(this.isUserAnswersCorrect());
        }
        else {
            this.itemService.userAnswerMethod([]);
            this.itemService.validateAnswerValueMethod(false);
        }
    }
    /* Check wheather the user selected answer is correct */
    isUserAnswersCorrect() {
        if (this.userAnswer === this.correctAns.choiceId) {
            return true;
        }
        else {
            return false;
        }
    }
    /* function to clear user inputs */
    clearUserInputs() {
        this.userAnswer = [];
        this.form.reset();
    }
    /* Get Choice class name */
    getChoiceClassName(choiceDetails) {
        if (choiceDetails.correct) {
            return "wk-icon-checkmark green-checkmark";
        }
        else if (!choiceDetails.correct &&
            this.userAnswer === choiceDetails.choiceId) {
            return "wk-icon-close wrong-checkmark";
        }
        else {
            return "wk-icon-checkmark disabled-checkmark";
        }
    }
    /* Check the value has been changed */
    valueChanged() {
        if (this.userAnswer !== undefined && this.userAnswer !== null) {
            const answerObj = this.userAnswer.length !== 0 ? [this.userAnswer] : this.userAnswer;
            this.itemService.userAnswerMethod(answerObj);
            this.itemService.validateAnswerValueMethod(this.isUserAnswersCorrect());
        }
        else {
            this.itemService.userAnswerMethod([]);
            this.itemService.validateAnswerValueMethod(false);
        }
    }
    /* Check the asset empty */
    checkEmptyAsset() {
        return Object.keys(this.assetData).length === 0;
    }
    createQuestion() {
        this.radioValue = {};
        this.userAnswer = [];
        this.correctAns = [];
        this.incorrectRationale = [];
        this.itemService.userAnswerMethod([]);
        this.itemService.validateAnswerValueMethod(false);
        this.itemService.userAnswerState.subscribe(answer => (this.userAnswerService = answer));
        this.assetData = this.questionDetails1.assets;
        if (this.assetData.length !== 0) {
            this.assetPosition = this.questionDetails1.assets[0]["assetsPosition"];
        }
        this.correctAnswer();
        if (this.questionDetails1.userAttemptDetails.userAnswer !== undefined &&
            Object.keys(this.questionDetails1.userAttemptDetails.userAnswer)
                .length !== 0) {
            for (const j of this.questionDetails1.choiceInteraction.simpleChoices) {
                if (this.questionDetails1.userAttemptDetails.userAnswer[0] ===
                    j["choiceId"]) {
                    this.radioValue = j;
                    this.userAnswer = this.radioValue["choiceId"];
                }
            }
        }
        this.form = this.formBuilder.group({
            choices: [this.radioValue["choiceId"]]
        });
        this.valueChanged();
    }
};
TrueFalseComponent.ctorParameters = () => [
    { type: ItemService },
    { type: FormBuilder }
];
__decorate([
    Input("questionDetails")
], TrueFalseComponent.prototype, "questionCurrentData", null);
__decorate([
    Input()
], TrueFalseComponent.prototype, "examEngineType", void 0);
__decorate([
    Input()
], TrueFalseComponent.prototype, "canShowMetadata", void 0);
__decorate([
    Input()
], TrueFalseComponent.prototype, "isClearAnswer", void 0);
__decorate([
    Input()
], TrueFalseComponent.prototype, "isShowHide", void 0);
__decorate([
    Input()
], TrueFalseComponent.prototype, "imagePath", void 0);
__decorate([
    Input()
], TrueFalseComponent.prototype, "checkQuizSubmission", void 0);
__decorate([
    Input()
], TrueFalseComponent.prototype, "preferredTextFormat", void 0);
TrueFalseComponent = __decorate([
    Component({
        selector: "true-false",
        template: "<!-- ##################### QP Exam Engine type #######################-->\n<ng-container *ngIf=\"examEngineType == 'QP' || examEngineType == 'NCLEX'\">\n  <!-- Question and Answer  Block-->\n  <div class=\"wk-row\">\n    <media-carousel\n      *ngIf=\"\n        questionDetails1.assets &&\n        questionDetails1.assets.length != 0 &&\n        assetPosition != 'Bottom' &&\n        assetPosition != 'WithinText'\n      \"\n      [imagePath]=\"imagePath\"\n      [assetData]=\"assetData\"\n      [assetsPosition]=\"assetPosition\"\n    ></media-carousel>\n\n    <div\n      [ngClass]=\"{\n        'wk-col-8':\n          questionDetails1.assets != undefined &&\n          questionDetails1.assets.length != 0 &&\n          assetPosition != 'WithinText',\n        'wk-col-12':\n          questionDetails1.assets == undefined ||\n          questionDetails1.assets.length == 0 ||\n          assetPosition == 'WithinText',\n        'right-assets-position-question': assetPosition == 'Right',\n        'left-assets-position-question': assetPosition == 'Left',\n        'top-assets-position-question': assetPosition == 'Top',\n        'bottom-assets-position-question': assetPosition == 'Bottom'\n      }\"\n    >\n      <div class=\"wkqp-layout-item\">\n        <div class=\"wkqp-field-item normal-font mb0 \">\n          <div class=\"wkqp-field-header\" *ngIf=\"assetPosition != 'WithinText'\">\n            <div\n              class=\"mb20 normal-font wkqp-prewrap\"\n              libGetFormatText\n              [preferredTextFormat]=\"preferredTextFormat\"\n              [plainText]=\"questionDetails1.promptText\"\n              [richText]=\"questionDetails1.richPromptText\"\n            ></div>\n          </div>\n          <div class=\"wkqp-field-header\" *ngIf=\"assetPosition == 'WithinText'\">\n            <item-text-assets\n              [promptText]=\"questionDetails1.promptText\"\n              [imagePath]=\"imagePath\"\n              [assetData]=\"assetData\"\n              [assetsPosition]=\"assetPosition\"\n            ></item-text-assets>\n          </div>\n        </div>\n      </div>\n      <media-carousel\n        *ngIf=\"\n          questionDetails1.assets &&\n          questionDetails1.assets.length != 0 &&\n          assetPosition == 'Bottom' &&\n          assetPosition != 'WithinText'\n        \"\n        [imagePath]=\"imagePath\"\n        [assetData]=\"assetData\"\n        [assetsPosition]=\"assetPosition\"\n      ></media-carousel>\n      <div class=\"common-full-width\">\n        <fieldset class=\"common-full-width mb20\">\n          <legend\n            class=\"offscreen\"\n            libGetFormatText\n            [preferredTextFormat]=\"preferredTextFormat\"\n            [plainText]=\"questionDetails1.promptText\"\n            [richText]=\"questionDetails1.richPromptText\"\n          ></legend>\n\n          <form [formGroup]=\"form\">\n            <ng-container\n              *ngFor=\"\n                let item of questionDetails1.choiceInteraction.simpleChoices\n              \"\n            >\n              <div class=\"wkqp-radio-field common-full-width pt0mb0\">\n                <span\n                  *ngIf=\"message\"\n                  [ngClass]=\"getChoiceClassName(item)\"\n                ></span>\n                <input\n                  type=\"radio\"\n                  [hidden]=\"message\"\n                  [value]=\"item.choiceId\"\n                  (change)=\"selectAnswer(item)\"\n                  formControlName=\"choices\"\n                />\n                <span\n                  libGetFormatText\n                  [preferredTextFormat]=\"preferredTextFormat\"\n                  [plainText]=\"item.label\"\n                  [richText]=\"item.richLabel\"\n                ></span>\n              </div>\n              <div\n                class=\"wkqp-alert-info wkqp-prewrap correct-rationale-section wkqp-prewrap\"\n                *ngIf=\"message && item.rationale\"\n              >\n                <strong>Rationale: </strong>\n                <span\n                  libGetFormatText\n                  [preferredTextFormat]=\"preferredTextFormat\"\n                  [plainText]=\"item.rationale\"\n                  [richText]=\"item.richRationale\"\n                ></span>\n              </div>\n            </ng-container>\n          </form>\n        </fieldset>\n      </div>\n\n      <div *ngIf=\"canShowMetadata && message != true\">\n        <lib-metadata [itemData]=\"questionDetails1\"></lib-metadata>\n      </div>\n      <!--User answer and correct answer-->\n      <ng-container *ngIf=\"message\">\n        <p\n          class=\"wkqp-prewrap  mb20\"\n          [ngClass]=\"\n            isUserAnswersCorrect()\n              ? 'wkqp-alert-success wkqp-success'\n              : 'wkqp-alert-danger wkqp-danger'\n          \"\n          *ngIf=\"userAnswer.length !== 0\"\n        >\n          <strong>Your Response:</strong>\n          <span\n            class=\"optionlevel\"\n            libGetFormatText\n            [preferredTextFormat]=\"preferredTextFormat\"\n            [plainText]=\"radioValue['label']\"\n            [richText]=\"radioValue['richLabel']\"\n          ></span>\n        </p>\n        <p\n          class=\"wkqp-prewrap wkqp-alert-success wkqp-success  mb20\"\n          *ngIf=\"!isUserAnswersCorrect()\"\n        >\n          <strong>Correct Response:</strong>\n          <span\n            class=\"optionlevel\"\n            libGetFormatText\n            [preferredTextFormat]=\"preferredTextFormat\"\n            [plainText]=\"correctAns.label\"\n            [richText]=\"correctAns.richLabel\"\n          ></span>\n        </p>\n        <div *ngIf=\"canShowMetadata\">\n          <lib-metadata [itemData]=\"questionDetails1\"></lib-metadata>\n        </div>\n      </ng-container>\n    </div>\n    <div class=\"rationale-remedation-block mb20\" *ngIf=\"message\">\n      <lib-rationale\n        [itemData]=\"questionDetails1.modelFeedback\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></lib-rationale>\n      <lib-remediation\n        [itemData]=\"questionDetails1.remediationLinks\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></lib-remediation>\n    </div>\n  </div>\n</ng-container>\n\n<!-- ##################### USMLE Exam Engine type #######################-->\n<ng-container *ngIf=\"examEngineType == 'USMLE'\">\n  <!-- Question and Answer  Block-->\n  <div class=\"wk-row\">\n    <media-carousel\n      [imagePath]=\"imagePath\"\n      *ngIf=\"\n        questionDetails1.assets &&\n        questionDetails1.assets.length != 0 &&\n        assetPosition != 'Bottom' &&\n        assetPosition != 'WithinText'\n      \"\n      [assetData]=\"assetData\"\n      [assetsPosition]=\"assetPosition\"\n    ></media-carousel>\n\n    <div\n      [ngClass]=\"{\n        'wk-col-8':\n          questionDetails1.assets != undefined &&\n          questionDetails1.assets.length != 0 &&\n          assetPosition != 'WithinText',\n        'wk-col-12':\n          questionDetails1.assets == undefined ||\n          questionDetails1.assets.length == 0 ||\n          assetPosition == 'WithinText',\n        'right-assets-position-question': assetPosition == 'Right',\n        'left-assets-position-question': assetPosition == 'Left',\n        'top-assets-position-question': assetPosition == 'Top',\n        'bottom-assets-position-question': assetPosition == 'Bottom'\n      }\"\n    >\n      <div class=\"wkqp-layout-item\">\n        <div class=\"wkqp-field-item normal-font mb0 \">\n          <div class=\"wkqp-field-header\" *ngIf=\"assetPosition != 'WithinText'\">\n            <div class=\"normal-font wkqp-prewrap\">\n              {{ questionDetails1.promptText }}\n            </div>\n          </div>\n          <div class=\"wkqp-field-header\" *ngIf=\"assetPosition == 'WithinText'\">\n            <item-text-assets\n              [promptText]=\"questionDetails1.promptText\"\n              [imagePath]=\"imagePath\"\n              [assetData]=\"assetData\"\n              [assetsPosition]=\"assetPosition\"\n            ></item-text-assets>\n          </div>\n        </div>\n      </div>\n      <div class=\"common-full-width\">\n        <fieldset class=\"common-full-width\">\n          <legend class=\"offscreen\">{{ questionDetails1.promptText }}</legend>\n\n          <div class=\"option-wrapper\">\n            <form [formGroup]=\"form\">\n              <ng-container\n                *ngFor=\"\n                  let item of questionDetails1.choiceInteraction.simpleChoices;\n                  let i = index\n                \"\n              >\n                <div\n                  class=\"answer-wrapper\"\n                  [ngClass]=\"{\n                    'correct-answer':\n                      item.correct == true && checkQuizSubmission == true\n                  }\"\n                >\n                  <span\n                    *ngIf=\"checkQuizSubmission == true\"\n                    [ngClass]=\"getChoiceClassName(item)\"\n                  ></span>\n                  <input\n                    type=\"radio\"\n                    [hidden]=\"checkQuizSubmission == true\"\n                    [value]=\"item.choiceId\"\n                    (change)=\"selectAnswer(item)\"\n                    formControlName=\"choices\"\n                  />\n                  <span>{{ alphabetsIndex[i] }}.</span>\n                  <span style=\"padding-left: 6px;\">{{ item.label }}</span>\n                </div>\n                <!-- <div class=\"wkqp-alert-info wkqp-prewrap correct-rationale-section wkqp-prewrap\" *ngIf=\" checkQuizSubmission == true && item.rationale\">{{item.rationale}}</div> -->\n              </ng-container>\n            </form>\n          </div>\n          <div\n            class=\"examTaker-explanations ember-view raph-examTakerExplanations\"\n            *ngIf=\"checkQuizSubmission == true\"\n          >\n            <div class=\"raph-examTakerExplanations-correctExplanation-title\">\n              Answer Explanation\n            </div>\n            <ng-container\n              *ngFor=\"\n                let item of questionDetails1.choiceInteraction.simpleChoices;\n                let i = index\n              \"\n            >\n              <div\n                class=\"raph-examTakerExplanations-correctExplanation-content\"\n                *ngIf=\"item.correct == true\"\n              >\n                <div\n                  class=\"raph-examTakerExplanations-correctExplanation-content-label\"\n                >\n                  The correct answer is\n                  <div\n                    class=\"raph-examTakerExplanations-correctExplanation-letter\"\n                  >\n                    {{ alphabetsIndex[i] }}\n                  </div>\n                </div>\n\n                <div\n                  id=\"ember13569\"\n                  class=\"raph-examTakerExplanations-correctExplanation-content-content ember-view katexHtml\"\n                  *ngIf=\"item.correct == true\"\n                >\n                  <div>\n                    <p>\n                      {{ questionDetails1.modelFeedback[0].feedbackText }}\n                    </p>\n                    <p></p>\n                  </div>\n                </div>\n              </div>\n              <!-- <div class=\"wkqp-alert-info wkqp-prewrap correct-rationale-section wkqp-prewrap\" *ngIf=\" checkQuizSubmission == true && item.rationale\">{{item.rationale}}</div> -->\n            </ng-container>\n          </div>\n          <div\n            class=\"raph-examTakerExplanations-incorrectExplanations\"\n            *ngIf=\"\n              checkQuizSubmission == true && incorrectRationale.length !== 0\n            \"\n          >\n            <div class=\"raph-examTakerExplanations-incorrectExplanations-title\">\n              Incorrect answer explanations\n            </div>\n            <ng-container\n              *ngFor=\"\n                let item of questionDetails1.choiceInteraction.simpleChoices;\n                let i = index\n              \"\n            >\n              <div\n                class=\"raph-examTakerExplanations-incorrectExplanations-content\"\n              >\n                <div\n                  class=\"raph-examTakerExplanations-incorrectExplanations-explanation\"\n                  *ngIf=\"item.correct !== true && item.rationale !== null\"\n                >\n                  <div\n                    class=\"raph-examTakerExplanations-incorrectExplanations-explanation-letter\"\n                  >\n                    {{ alphabetsIndex[i] }}.\n                  </div>\n                  <div\n                    id=\"ember13628\"\n                    class=\"raph-examTakerExplanations-incorrectExplanations-explanation-body ember-view katexHtml\"\n                  >\n                    <div>\n                      <p>\n                        <!-- <strong>Rationale: </strong>  -->\n                        {{ item.rationale == null ? 'NA' : item.rationale }}\n                      </p>\n                    </div>\n                  </div>\n                </div>\n              </div>\n            </ng-container>\n          </div>\n        </fieldset>\n      </div>\n      <media-carousel\n        *ngIf=\"\n          questionDetails1.assets &&\n          questionDetails1.assets.length != 0 &&\n          assetPosition == 'Bottom' &&\n          assetPosition != 'WithinText'\n        \"\n        [imagePath]=\"imagePath\"\n        [assetData]=\"assetData\"\n        [assetsPosition]=\"assetPosition\"\n      ></media-carousel>\n    </div>\n  </div>\n</ng-container>\n",
        styles: [".option-wrapper{display:table;padding:7px;border:1px solid #3852a4;border-bottom-width:5px;max-width:400px}.answer-wrapper{padding:4px;display:table;width:100%;border-radius:3px}.correct-answer{border:1px solid #090;background-color:#9f9}.answer-explanation{padding:7.5px 15px;background-color:orange;font-size:15px;line-height:16px;font-weight:700}.raph-examTakerExplanations-correctExplanation-title{padding:7.5px 15px;background-color:orange;font-size:15px;line-height:16px;font-weight:700}.examTaker-content .examTaker-explanations{max-width:400px;margin-top:21px}.raph-examTakerExplanations{display:table;border:1px solid #3852a4;border-bottom-width:5px}.raph-examTakerExplanations-correctExplanation-content{padding:15px}.raph-examTakerExplanations-correctExplanation-content-label{line-height:1.5}.raph-examTakerExplanations-correctExplanation-letter{display:inline;text-transform:uppercase;font-weight:700}.raph-examTakerExplanations-correctExplanation-content .raph-examTakerExplanations-correctExplanation-content-content{margin-top:15px}.raph-examTakerExplanations-correctExplanation-content-content{line-height:1.5}.raph-examTakerExplanations-incorrectExplanations{display:table;border:1px solid #3852a4;border-bottom-width:5px;width:400px}.raph-examTakerExplanations-incorrectExplanations-title{font-size:80%;line-height:150%;background-color:#d7dced;border-bottom:1px solid #aab;text-align:center;font-weight:700}.raph-examTakerExplanations-incorrectExplanations-content{padding:6px}.raph-examTakerExplanations-incorrectExplanations-content .raph-examTakerExplanations-incorrectExplanations-explanation:not(:last-child){margin-bottom:6px}.raph-examTakerExplanations-incorrectExplanations-explanation{display:flex}.raph-examTakerExplanations-incorrectExplanations-explanation .raph-examTakerExplanations-incorrectExplanations-explanation-letter{width:24px;min-width:24px}.raph-examTakerExplanations-incorrectExplanations-explanation-letter{text-transform:uppercase;line-height:1.5}.layout-default .layout-default-content,.raph-examTakerExplanations-incorrectExplanations-explanation .raph-examTakerExplanations-incorrectExplanations-explanation-body{flex-grow:1}.raph-examTakerExplanations-incorrectExplanations-explanation-body{line-height:1.5}"]
    })
], TrueFalseComponent);

let MedicalMultipleChoiceComponent = class MedicalMultipleChoiceComponent {
    constructor(itemService, formBuilder) {
        this.itemService = itemService;
        this.formBuilder = formBuilder;
        // Declare the variables
        this.userAnswer = [];
        this.correctAns = [];
        this.userResponse = false;
        this.assetData = [];
        this.userSelectedLabel = [];
        this.radioValue = {};
        this.questionDetails1 = [];
        this.assetPosition = [];
        this.incorrectRationale = [];
        this.imagePath = [];
    }
    get questionDetails() {
        return this.questionDetails;
    }
    set questionCurrentData(value) {
        if (value) {
            this.questionDetails1 = value;
            this.createQuestion();
        }
        else {
            this.questionDetails1 = [];
            this.createQuestion();
        }
    }
    /* init */
    ngOnInit() { }
    ngOnChanges(changes) { }
    /* Do check */
    ngDoCheck() {
        // Clear answer req
        if (this.isClearAnswer === true) {
            this.clearUserInputs();
            this.itemService.userAnswerMethod([]);
            this.itemService.clearAnswerMethodFalse(false);
            this.itemService.hideAnswer(false);
        }
        // Show and hide answer req
        if (this.isShowHide === true) {
            this.message = true;
        }
        else if (this.isShowHide === false) {
            this.message = false;
        }
    }
    /* function to get correct answer */
    correctAnswer() {
        for (const i of this.questionDetails1.choiceInteraction.simpleChoices) {
            if (i.correct === true) {
                this.correctAns = i;
            }
        }
        this.incorrectRationale = this.questionDetails1.choiceInteraction.simpleChoices.filter(item => item.rationale !== null && item.correct !== true);
    }
    /* function to get selected answer */
    selectAnswer(option) {
        this.radioValue = option;
        this.userAnswer = this.radioValue['choiceId'];
        if (this.userAnswer !== undefined && this.userAnswer !== null) {
            const answerObj = [this.userAnswer];
            this.itemService.userAnswerMethod(answerObj);
            this.itemService.validateAnswerValueMethod(this.isUserAnswersCorrect());
        }
        else {
            this.itemService.userAnswerMethod([]);
            this.itemService.validateAnswerValueMethod(false);
        }
    }
    /* Check wheather the user answer is corect or not */
    isUserAnswersCorrect() {
        if (this.userAnswer === this.correctAns.choiceId) {
            return true;
        }
        else {
            return false;
        }
    }
    /* function to clear user inputs */
    clearUserInputs() {
        this.userAnswer = [];
        this.form.reset();
    }
    /* Get choice class name */
    getChoiceClassName(choiceDetails) {
        if (choiceDetails.correct) {
            return 'wk-icon-checkmark green-checkmark';
        }
        else if (!choiceDetails.correct &&
            this.userAnswer === choiceDetails.choiceId) {
            return 'wk-icon-close wrong-checkmark';
        }
        else {
            return 'wk-icon-checkmark disabled-checkmark';
        }
    }
    /* Check the value changeds */
    valueChanged() {
        if (this.userAnswer !== undefined && this.userAnswer !== null) {
            const answerObj = this.userAnswer.length !== 0 ? [this.userAnswer] : this.userAnswer;
            this.itemService.userAnswerMethod(answerObj);
            this.itemService.validateAnswerValueMethod(this.isUserAnswersCorrect());
        }
        else {
            this.itemService.userAnswerMethod([]);
            this.itemService.validateAnswerValueMethod(false);
        }
    }
    createQuestion() {
        this.radioValue = {};
        this.userAnswer = [];
        this.correctAns = [];
        this.incorrectRationale = [];
        this.itemService.userAnswerMethod([]);
        this.itemService.validateAnswerValueMethod(false);
        this.assetData = this.questionDetails1.parentDetails.assets;
        if (this.assetData.length !== 0) {
            this.assetPosition = this.questionDetails1.parentDetails.assets[0]['assetsPosition'];
        }
        this.correctAnswer();
        if (this.questionDetails1.userAttemptDetails.userAnswer !== undefined) {
            for (const j of this.questionDetails1.choiceInteraction.simpleChoices) {
                if (this.questionDetails1.userAttemptDetails.userAnswer[0] ===
                    j['choiceId']) {
                    this.radioValue = j;
                    this.userAnswer = this.radioValue['choiceId'];
                }
            }
        }
        this.form = this.formBuilder.group({
            choices: [this.radioValue['choiceId']]
        });
        this.valueChanged();
    }
};
MedicalMultipleChoiceComponent.ctorParameters = () => [
    { type: ItemService },
    { type: FormBuilder }
];
__decorate([
    Input('questionDetails')
], MedicalMultipleChoiceComponent.prototype, "questionCurrentData", null);
__decorate([
    Input()
], MedicalMultipleChoiceComponent.prototype, "examEngineType", void 0);
__decorate([
    Input()
], MedicalMultipleChoiceComponent.prototype, "canShowMetadata", void 0);
__decorate([
    Input()
], MedicalMultipleChoiceComponent.prototype, "isClearAnswer", void 0);
__decorate([
    Input()
], MedicalMultipleChoiceComponent.prototype, "isShowHide", void 0);
__decorate([
    Input()
], MedicalMultipleChoiceComponent.prototype, "imagePath", void 0);
__decorate([
    Input()
], MedicalMultipleChoiceComponent.prototype, "checkQuizSubmission", void 0);
__decorate([
    Input()
], MedicalMultipleChoiceComponent.prototype, "preferredTextFormat", void 0);
MedicalMultipleChoiceComponent = __decorate([
    Component({
        selector: 'medical-multiple-choice',
        template: "<!-- ######################## QP Exam Engine Type ###############################-->\n<ng-container *ngIf=\"examEngineType == 'QP' || examEngineType == 'NCLEX'\">\n  <div class=\"wk-row\">\n    <div class=\"wkqp-field-header label-heading clinical-heading\">\n      <span>Case Scenario/Description</span>\n    </div>\n    <media-carousel\n      *ngIf=\"\n        questionDetails1.parentDetails.assets &&\n        questionDetails1.parentDetails.assets.length != 0 &&\n        assetPosition != 'Bottom' &&\n        assetPosition != 'WithinText'\n      \"\n      [imagePath]=\"imagePath\"\n      [assetData]=\"assetData\"\n      [assetsPosition]=\"assetPosition\"\n    ></media-carousel>\n\n    <div\n      [ngClass]=\"{\n        'wk-col-8':\n          questionDetails1.parentDetails.assets != undefined &&\n          questionDetails1.parentDetails.assets.length != 0 &&\n          assetPosition != 'WithinText',\n        'wk-col-12':\n          questionDetails1.parentDetails.assets == undefined ||\n          questionDetails1.parentDetails.assets.length == 0 ||\n          assetPosition == 'WithinText',\n        'right-assets-position-question medical-multiple-choice-right-wk-col-8':\n          assetPosition == 'Right',\n        'left-assets-position-question': assetPosition == 'Left',\n        'top-assets-position-question': assetPosition == 'Top',\n        'bottom-assets-position-question': assetPosition == 'Bottom'\n      }\"\n    >\n      <div class=\"wkqp-layout-item\">\n        <div class=\"wkqp-field-item normal-font mb0 \">\n          <div class=\"wkqp-field-header\" *ngIf=\"assetPosition != 'WithinText'\">\n            <p\n              class=\"mb20 normal-font wkqp-prewrap heading-h3 headingh3-res question-parent-text\"\n              libGetFormatText\n              [preferredTextFormat]=\"preferredTextFormat\"\n              [plainText]=\"questionDetails1.parentDetails.promptText\"\n              [richText]=\"questionDetails1.parentDetails.richPromptText\"\n            ></p>\n          </div>\n          <div\n            class=\"wkqp-field-header custom-field-header\"\n            *ngIf=\"assetPosition == 'WithinText'\"\n          >\n            <item-text-assets\n              [promptText]=\"questionDetails1.parentDetails.promptText\"\n              [imagePath]=\"imagePath\"\n              [assetData]=\"assetData\"\n              [assetsPosition]=\"assetPosition\"\n            ></item-text-assets>\n          </div>\n        </div>\n      </div>\n\n      <media-carousel\n        *ngIf=\"\n          questionDetails1.parentDetails.assets &&\n          questionDetails1.parentDetails.assets.length != 0 &&\n          assetPosition == 'Bottom' &&\n          assetPosition != 'WithinText'\n        \"\n        [imagePath]=\"imagePath\"\n        [assetData]=\"assetData\"\n        [assetsPosition]=\"assetPosition\"\n      ></media-carousel>\n    </div>\n  </div>\n  <div class=\"wk-row mb20\">\n    <div class=\"wkqp-field-item\">\n      <div\n        class=\"wkqp-field-header custom-field-header\"\n        *ngIf=\"assetPosition != 'WithinText'\"\n      >\n        <p\n          class=\"mb20 normal-font wkqp-prewrap heading-h2 heading-h2-pb0 question-prompt-text ng-binding\"\n          libGetFormatText\n          [preferredTextFormat]=\"preferredTextFormat\"\n          [plainText]=\"questionDetails1.promptText\"\n          [richText]=\"questionDetails1.richPromptText\"\n        ></p>\n      </div>\n    </div>\n    <div class=\"wkqp-layout-item\">\n      <div class=\"wkqp-field-item normal-font mb0\">\n        <form [formGroup]=\"form\">\n          <ng-container\n            *ngFor=\"\n              let item of questionDetails1.choiceInteraction.simpleChoices\n            \"\n          >\n            <div class=\"common-full-width choice-mb\">\n              <fieldset class=\"common-full-width\">\n                <legend\n                  class=\"offscreen\"\n                  libGetFormatText\n                  [preferredTextFormat]=\"preferredTextFormat\"\n                  [plainText]=\"questionDetails1.promptText\"\n                  [richText]=\"questionDetails1.richPromptText\"\n                ></legend>\n                <span\n                  *ngIf=\"message\"\n                  [ngClass]=\"getChoiceClassName(item)\"\n                ></span>\n                <input\n                  type=\"radio\"\n                  [hidden]=\"message\"\n                  [value]=\"item.choiceId\"\n                  (change)=\"selectAnswer(item)\"\n                  formControlName=\"choices\"\n                />\n                <span\n                  libGetFormatText\n                  [preferredTextFormat]=\"preferredTextFormat\"\n                  [plainText]=\"item.label\"\n                  [richText]=\"item.richLabel\"\n                ></span>\n              </fieldset>\n            </div>\n            <div\n              class=\"wkqp-alert-info wkqp-prewrap correct-rationale-section wkqp-prewrap rational-inline\"\n              *ngIf=\"message && item.rationale\"\n            >\n              <strong>Rationale: </strong>\n              <span\n                libGetFormatText\n                [preferredTextFormat]=\"preferredTextFormat\"\n                [plainText]=\"item.rationale\"\n                [richText]=\"item.richRationale\"\n              ></span>\n            </div>\n          </ng-container>\n        </form>\n      </div>\n    </div>\n  </div>\n  <div *ngIf=\"canShowMetadata && message != true\">\n    <lib-metadata [itemData]=\"questionDetails1\"></lib-metadata>\n  </div>\n\n  <!--User answer and correct answer block-->\n  <ng-container *ngIf=\"message\">\n    <p\n      class=\"wkqp-prewrap mb20\"\n      [ngClass]=\"\n        isUserAnswersCorrect()\n          ? 'wkqp-alert-success wkqp-success'\n          : 'wkqp-alert-danger wkqp-danger'\n      \"\n      *ngIf=\"userAnswer.length != 0\"\n    >\n      <strong>Your Response:</strong>\n      <span\n        class=\"optionlevel\"\n        libGetFormatText\n        [preferredTextFormat]=\"preferredTextFormat\"\n        [plainText]=\"radioValue['label']\"\n        [richText]=\"radioValue['richLabel']\"\n      ></span>\n    </p>\n    <p\n      class=\"wkqp-prewrap wkqp-alert-success wkqp-success  mb20\"\n      *ngIf=\"!isUserAnswersCorrect()\"\n    >\n      <strong>Correct Response:</strong>\n      <span\n        class=\"optionlevel\"\n        libGetFormatText\n        [preferredTextFormat]=\"preferredTextFormat\"\n        [plainText]=\"correctAns.label\"\n        [richText]=\"correctAns.richLabel\"\n      ></span>\n    </p>\n    <div *ngIf=\"canShowMetadata\">\n      <lib-metadata [itemData]=\"questionDetails1\"></lib-metadata>\n    </div>\n    <div class=\"rationale-remedation-block mb20\" *ngIf=\"message\">\n      <lib-rationale\n        [itemData]=\"questionDetails1.modelFeedback\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></lib-rationale>\n\n      <lib-remediation\n        [itemData]=\"questionDetails1.remediationLinks\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></lib-remediation>\n    </div>\n  </ng-container>\n</ng-container>\n\n<!-- ######################## USMLE Exam Engine Type ###############################-->\n<ng-container *ngIf=\"examEngineType == 'USMLE'\">\n  <div class=\"wk-row\">\n    <media-carousel\n      *ngIf=\"\n        questionDetails1.parentDetails.assets &&\n        questionDetails1.parentDetails.assets.length != 0 &&\n        assetPosition != 'Bottom' &&\n        assetPosition != 'WithinText'\n      \"\n      [imagePath]=\"imagePath\"\n      [assetData]=\"assetData\"\n      [assetsPosition]=\"assetPosition\"\n    ></media-carousel>\n\n    <div\n      [ngClass]=\"{\n        'wk-col-8':\n          questionDetails1.parentDetails.assets != undefined &&\n          questionDetails1.parentDetails.assets.length != 0 &&\n          assetPosition != 'WithinText',\n        'wk-col-12':\n          questionDetails1.parentDetails.assets == undefined ||\n          questionDetails1.parentDetails.assets.length == 0 ||\n          assetPosition == 'WithinText',\n        'right-assets-position-question': assetPosition == 'Right',\n        'left-assets-position-question': assetPosition == 'Left',\n        'top-assets-position-question': assetPosition == 'Top',\n        'bottom-assets-position-question': assetPosition == 'Bottom'\n      }\"\n    >\n      <div class=\"wkqp-layout-item\">\n        <div class=\"wkqp-field-item normal-font mb0 \">\n          <div class=\"wkqp-field-header\" *ngIf=\"assetPosition != 'WithinText'\">\n            <div class=\"mb20 normal-font wkqp-prewrap\">\n              {{ questionDetails1.parentDetails.promptText }}\n            </div>\n          </div>\n          <div class=\"wkqp-field-header\" *ngIf=\"assetPosition == 'WithinText'\">\n            <item-text-assets\n              [promptText]=\"questionDetails1.parentDetails.promptText\"\n              [imagePath]=\"imagePath\"\n              [assetData]=\"assetData\"\n              [assetsPosition]=\"assetPosition\"\n            ></item-text-assets>\n          </div>\n        </div>\n      </div>\n\n      <media-carousel\n        *ngIf=\"\n          questionDetails1.parentDetails.assets &&\n          questionDetails1.parentDetails.assets.length != 0 &&\n          assetPosition == 'Bottom' &&\n          assetPosition != 'WithinText'\n        \"\n        [imagePath]=\"imagePath\"\n        [assetData]=\"assetData\"\n        [assetsPosition]=\"assetPosition\"\n      ></media-carousel>\n    </div>\n  </div>\n\n  <div class=\"wk-row\">\n    <div class=\"wkqp-field-item\">\n      <div class=\"wkqp-field-header custom-field-header\">\n        <div class=\"mb20 normal-font wkqp-prewrap\">\n          {{ questionDetails1.promptText }}\n        </div>\n      </div>\n    </div>\n    <div class=\"wkqp-layout-item\">\n      <div class=\"wkqp-field-item normal-font mb0\">\n        <form [formGroup]=\"form\">\n          <ng-container\n            *ngFor=\"\n              let item of questionDetails1.choiceInteraction.simpleChoices\n            \"\n          >\n            <div>\n              <fieldset class=\"common-full-width\">\n                <legend class=\"offscreen\">\n                  {{ questionDetails1.promptText }}\n                </legend>\n                <span\n                  *ngIf=\"checkQuizSubmission == true\"\n                  [ngClass]=\"getChoiceClassName(item)\"\n                ></span>\n                <input\n                  type=\"radio\"\n                  [hidden]=\"checkQuizSubmission == true\"\n                  [value]=\"item.choiceId\"\n                  (change)=\"selectAnswer(item)\"\n                  formControlName=\"choices\"\n                />\n                <span>{{ item.label }}</span>\n              </fieldset>\n            </div>\n            <div\n              class=\"wkqp-alert-info wkqp-prewrap correct-rationale-section wkqp-prewrap\"\n              *ngIf=\"checkQuizSubmission == true && item.rationale\"\n            >\n              <strong>Rationale:</strong> {{ item.rationale }}\n            </div>\n          </ng-container>\n        </form>\n      </div>\n    </div>\n  </div>\n\n  <!--USer answer and correct answer Block-->\n  <ng-container *ngIf=\"checkQuizSubmission == true\">\n    <p\n      class=\"wkqp-prewrap  \"\n      [ngClass]=\"\n        isUserAnswersCorrect()\n          ? 'wkqp-alert-success wkqp-success'\n          : 'wkqp-alert-danger wkqp-danger'\n      \"\n      *ngIf=\"userAnswer.length != 0\"\n    >\n      <strong>Your Response:</strong>\n      <span class=\"optionlevel\">{{ radioValue['label'] }}</span>\n    </p>\n    <p\n      class=\"wkqp-prewrap wkqp-alert-success wkqp-success \"\n      *ngIf=\"!isUserAnswersCorrect()\"\n    >\n      <strong>Correct Response:</strong>\n      <span class=\"optionlevel\">{{ correctAns.label }}</span>\n    </p>\n    <p *ngIf=\"questionDetails1.modelFeedback[0].length !== 0\">\n      <strong>Rationale:</strong>\n      <span>{{ questionDetails1.modelFeedback[0].feedbackText }}</span>\n    </p>\n    <div *ngIf=\"questionDetails1.remediationLinks.length !== 0\">\n      <strong>Remediation:</strong>\n      <div\n        *ngFor=\"\n          let Remediation of questionDetails1.remediationLinks;\n          let k = index\n        \"\n      >\n        <span *ngIf=\"Remediation.linkTypeId == 1\">{{\n          Remediation.linkText1\n        }}</span>\n        <span *ngIf=\"Remediation.linkTypeId != 1\">\n          {{ Remediation.linkText1 }}</span\n        >\n      </div>\n    </div>\n  </ng-container>\n</ng-container>\n",
        styles: [".medical-multiple-choice-right-wk-col-8{width:64%!important;padding:0}.choice-mb{margin-bottom:.1875rem}"]
    })
], MedicalMultipleChoiceComponent);

let MedicalMultipleResponseComponent = class MedicalMultipleResponseComponent {
    constructor(itemService, formBuilder) {
        this.itemService = itemService;
        this.formBuilder = formBuilder;
        //Declare the variables
        this.userAnswer = [];
        this.correctAns = [];
        this.assetData = [];
        this.selectedOrderIds = [];
        this.questionDetails1 = [];
        this.assetPosition = [];
        this.incorrectRationale = [];
        this.imagePath = [];
    }
    get questionDetails() {
        return this.questionDetails;
    }
    set questionCurrentData(value) {
        if (value) {
            this.questionDetails1 = value;
            this.createQuestion();
        }
        else {
            this.questionDetails1 = [];
            this.createQuestion();
        }
    }
    /*Init */
    ngOnInit() { }
    ngOnChanges(changes) {
        //  console.log('medical multiple response changes', changes);
    }
    /* Do check */
    ngDoCheck() {
        // Clear user answer
        if (this.isClearAnswer === true) {
            this.clearUserInputs();
            this.itemService.userAnswerMethod([]);
            this.itemService.clearAnswerMethodFalse(false);
            this.itemService.hideAnswer(false);
        }
        // Show and hide answer
        if (this.isShowHide === true) {
            this.message = true;
        }
        else if (this.isShowHide === false) {
            this.message = false;
        }
    }
    /* function to get correct answer */
    correctAnswer() {
        for (const i of this.questionDetails1.choiceInteraction.simpleChoices) {
            if (i.correct === true) {
                this.correctAns.push(i);
                this.correctAnsString = (this.correctAnsString) ? this.correctAnsString + ', ' + i.label : i.label;
            }
        }
        this.incorrectRationale = this.questionDetails1.choiceInteraction.simpleChoices.filter(item => item.rationale !== null && item.correct !== true);
    }
    /* function to get selected answer */
    selectAnswer(option, i) {
        this.selectedOrderIds = this.form.value.orders
            .map((v, i) => v
            ? this.questionDetails1.choiceInteraction.simpleChoices[i].choiceId
            : null)
            .filter(v => v !== null);
        this.commaSeperatedUserResponseLabel();
        this.userAnswer = this.selectedOrderIds;
        if (this.userAnswer.length !== 0) {
            const answerObj = this.userAnswer;
            this.itemService.userAnswerMethod(answerObj);
            this.itemService.validateAnswerValueMethod(this.isUserAnswersCorrect());
        }
        else {
            this.itemService.userAnswerMethod([]);
            this.itemService.validateAnswerValueMethod(false);
        }
    }
    /* Check wheather the user answer is correct or not */
    isUserAnswersCorrect() {
        this.selectedOrderIds = this.form.value.orders
            .map((v, i) => v
            ? this.questionDetails1.choiceInteraction.simpleChoices[i].choiceId
            : null)
            .filter(v => v !== null);
        if (this.selectedOrderIds.length !== this.correctAns.length) {
            return false;
        }
        else {
            for (const answer of this.correctAns) {
                if (!this.selectedOrderIds.find(item => item === answer.choiceId)) {
                    return false;
                }
            }
        }
        return true;
    }
    /* function to clear user inputs */
    clearUserInputs() {
        this.userAnswer = [];
        this.form.reset();
    }
    /* Get choice class */
    getChoiceClassName(choiceDetails) {
        let checked = false;
        for (const item of this.selectedOrderIds) {
            if (choiceDetails["choiceId"] === item) {
                checked = true;
            }
        }
        if (choiceDetails.correct) {
            return "wk-icon-checkmark green-checkmark";
        }
        else if (!choiceDetails.correct && checked === true) {
            return "wk-icon-close wrong-checkmark";
        }
        else {
            return "wk-icon-checkmark disabled-checkmark";
        }
    }
    /* Check the value is changed or not */
    valueChanged() {
        this.selectedOrderIds = this.form.value.orders
            .map((v, i) => v
            ? this.questionDetails1.choiceInteraction.simpleChoices[i].choiceId
            : null)
            .filter(v => v !== null);
        this.commaSeperatedUserResponseLabel();
        this.userAnswer = this.selectedOrderIds;
        if (this.userAnswer.length !== 0) {
            const answerObj = this.userAnswer;
            this.itemService.userAnswerMethod(answerObj);
            this.itemService.validateAnswerValueMethod(this.isUserAnswersCorrect());
        }
        else {
            this.itemService.userAnswerMethod([]);
            this.itemService.validateAnswerValueMethod(false);
        }
    }
    getFormArray() {
        return this.form.get("orders");
    }
    createQuestion() {
        this.userAnswer = [];
        this.correctAns = [];
        this.incorrectRationale = [];
        this.itemService.userAnswerMethod([]);
        this.itemService.validateAnswerValueMethod(false);
        this.assetData = this.questionDetails1.parentDetails.assets;
        if (this.assetData.length !== 0) {
            this.assetPosition = this.questionDetails1.parentDetails.assets[0]["assetsPosition"];
        }
        const controls = this.questionDetails1.choiceInteraction.simpleChoices.map(c => new FormControl(false));
        // controls[0].setValue(true);
        this.form = this.formBuilder.group({
            orders: new FormArray(controls)
        });
        this.getFormArray();
        if (this.questionDetails1.userAttemptDetails.userAnswer.length !== 0) {
            for (let i = 0; i < this.questionDetails1.choiceInteraction.simpleChoices.length; i++) {
                for (const j of this.questionDetails1.userAttemptDetails.userAnswer) {
                    if (this.questionDetails1.choiceInteraction.simpleChoices[i]["choiceId"] === j) {
                        controls[i].setValue(true);
                    }
                }
            }
            this.valueChanged();
        }
        this.correctAnswer();
    }
    commaSeperatedUserResponseLabel() {
        this.userResponseLabel = '';
        this.selectedOrderIds.forEach(selected => {
            const selectedChoice = this.questionDetails1.choiceInteraction.simpleChoices.find(choice => choice.choiceId == selected);
            if (selectedChoice) {
                this.userResponseLabel = (this.userResponseLabel) ? this.userResponseLabel + ', ' + selectedChoice.label : selectedChoice.label;
            }
        });
    }
};
MedicalMultipleResponseComponent.ctorParameters = () => [
    { type: ItemService },
    { type: FormBuilder }
];
__decorate([
    Input("questionDetails")
], MedicalMultipleResponseComponent.prototype, "questionCurrentData", null);
__decorate([
    Input()
], MedicalMultipleResponseComponent.prototype, "examEngineType", void 0);
__decorate([
    Input()
], MedicalMultipleResponseComponent.prototype, "canShowMetadata", void 0);
__decorate([
    Input()
], MedicalMultipleResponseComponent.prototype, "isClearAnswer", void 0);
__decorate([
    Input()
], MedicalMultipleResponseComponent.prototype, "isShowHide", void 0);
__decorate([
    Input()
], MedicalMultipleResponseComponent.prototype, "imagePath", void 0);
__decorate([
    Input()
], MedicalMultipleResponseComponent.prototype, "checkQuizSubmission", void 0);
__decorate([
    Input()
], MedicalMultipleResponseComponent.prototype, "preferredTextFormat", void 0);
MedicalMultipleResponseComponent = __decorate([
    Component({
        selector: "medical-multiple-response",
        template: "<!-- ############################ QP exam Engine Type ###########################-->\n<ng-container *ngIf=\"examEngineType == 'QP' || examEngineType == 'NCLEX'\">\n  <div class=\"wk-row mb20\">\n    <div class=\"wkqp-field-header label-heading clinical-heading\">\n      <span>Case Scenario/Description</span>\n    </div>\n    <media-carousel\n      *ngIf=\"\n        questionDetails1.parentDetails.assets &&\n        questionDetails1.parentDetails.assets.length != 0 &&\n        assetPosition != 'Bottom' &&\n        assetPosition != 'WithinText'\n      \"\n      [imagePath]=\"imagePath\"\n      [assetData]=\"assetData\"\n      [assetsPosition]=\"assetPosition\"\n    ></media-carousel>\n\n    <div\n      [ngClass]=\"{\n        'wk-col-8':\n          questionDetails1.parentDetails.assets != undefined &&\n          questionDetails1.parentDetails.assets.length != 0 &&\n          assetPosition != 'WithinText',\n        'wk-col-12':\n          questionDetails1.parentDetails.assets == undefined ||\n          questionDetails1.parentDetails.assets.length == 0 ||\n          assetPosition == 'WithinText',\n        'right-assets-position-question': assetPosition == 'Right',\n        'left-assets-position-question': assetPosition == 'Left',\n        'top-assets-position-question': assetPosition == 'Top',\n        'bottom-assets-position-question': assetPosition == 'Bottom'\n      }\"\n    >\n      <div class=\"wkqp-layout-item\">\n        <div class=\"normal-font mb0 \">\n          <div class=\"wkqp-field-header\" *ngIf=\"assetPosition != 'WithinText'\">\n            <p\n              class=\"mb20 normal-font wkqp-prewrap heading-h3 headingh3-res question-parent-text\"\n              libGetFormatText\n              [preferredTextFormat]=\"preferredTextFormat\"\n              [plainText]=\"questionDetails1.parentDetails.promptText\"\n              [richText]=\"questionDetails1.parentDetails.richPromptText\"\n            ></p>\n          </div>\n          <div\n            class=\"wkqp-field-header custom-field-header\"\n            *ngIf=\"assetPosition == 'WithinText'\"\n          >\n            <item-text-assets\n              [promptText]=\"questionDetails1.parentDetails.promptText\"\n              [imagePath]=\"imagePath\"\n              [assetData]=\"assetData\"\n              [assetsPosition]=\"assetPosition\"\n            ></item-text-assets>\n          </div>\n        </div>\n      </div>\n\n      <media-carousel\n        *ngIf=\"\n          questionDetails1.parentDetails.assets &&\n          questionDetails1.parentDetails.assets.length != 0 &&\n          assetPosition == 'Bottom' &&\n          assetPosition != 'WithinText'\n        \"\n        [imagePath]=\"imagePath\"\n        [assetData]=\"assetData\"\n        [assetsPosition]=\"assetPosition\"\n      ></media-carousel>\n    </div>\n  </div>\n  <div class=\"wkqp-field-item\">\n    <div class=\"wkqp-field-header custom-field-header\">\n      <p\n        class=\"mb20 normal-font wkqp-prewrap heading-h2 heading-h2-pb0 question-prompt-text ng-binding\"\n        libGetFormatText\n        [preferredTextFormat]=\"preferredTextFormat\"\n        [plainText]=\"questionDetails1.promptText\"\n        [richText]=\"questionDetails1.richPromptText\"\n      ></p>\n    </div>\n  </div>\n  <div class=\"wkqp-layout-item\">\n    <div class=\"wkqp-field-item normal-font mb0\">\n      <fieldset class=\"common-full-width mb20\">\n        <legend\n          class=\"offscreen\"\n          libGetFormatText\n          [preferredTextFormat]=\"preferredTextFormat\"\n          [plainText]=\"questionDetails1.promptText\"\n          [richText]=\"questionDetails1.richPromptText\"\n        ></legend>\n\n        <form [formGroup]=\"form\">\n          <ng-container\n            formArrayName=\"orders\"\n            *ngFor=\"let order of getFormArray().controls; let i = index\"\n          >\n            <div class=\"common-full-width mt5\">\n              <span\n                *ngIf=\"message\"\n                [ngClass]=\"\n                  getChoiceClassName(\n                    questionDetails1.choiceInteraction.simpleChoices[i]\n                  )\n                \"\n              ></span>\n              <input\n                type=\"checkbox\"\n                [formControlName]=\"i\"\n                [hidden]=\"message\"\n                (change)=\"\n                  selectAnswer(\n                    questionDetails1.choiceInteraction.simpleChoices[i],\n                    i\n                  )\n                \"\n              />\n              <span\n                libGetFormatText\n                [preferredTextFormat]=\"preferredTextFormat\"\n                [plainText]=\"\n                  questionDetails1.choiceInteraction.simpleChoices[i].label\n                \"\n                [richText]=\"\n                  questionDetails1.choiceInteraction.simpleChoices[i].richLabel\n                \"\n              ></span>\n            </div>\n\n            <div\n              class=\"wkqp-alert-info wkqp-prewrap correct-rationale-section wkqp-prewrap rational-inline\"\n              *ngIf=\"\n                message &&\n                questionDetails1.choiceInteraction.simpleChoices[i].rationale\n              \"\n            >\n              <strong>Rationale: </strong>\n              <span\n                libGetFormatText\n                [preferredTextFormat]=\"preferredTextFormat\"\n                [plainText]=\"\n                  questionDetails1.choiceInteraction.simpleChoices[i].rationale\n                \"\n                [richText]=\"\n                  questionDetails1.choiceInteraction.simpleChoices[i]\n                    .richRationale\n                \"\n              ></span>\n            </div>\n          </ng-container>\n        </form>\n      </fieldset>\n    </div>\n  </div>\n  <div *ngIf=\"canShowMetadata && message != true\">\n    <lib-metadata [itemData]=\"questionDetails1\"></lib-metadata>\n  </div>\n\n  <!--User answer and correct answer-->\n  <ng-container *ngIf=\"message\">\n    <div\n      class=\"wkqp-prewrap  medical-multiple-response-wrap  mb20\"\n      [ngClass]=\"\n        isUserAnswersCorrect()\n          ? 'wkqp-alert-success wkqp-success'\n          : 'wkqp-alert-danger wkqp-danger'\n      \"\n      *ngIf=\"userAnswer.length != 0\"\n    >\n      <strong class=\"your-response-left\">Your Response:</strong>\n      <span class=\"optionlevel\">{{ userResponseLabel }}</span>\n    </div>\n    <p\n      class=\"wkqp-prewrap wkqp-alert-success wkqp-success  mb20\"\n      *ngIf=\"!isUserAnswersCorrect()\"\n    >\n      <strong>Correct Response:</strong>\n      <span class=\"optionlevel\">{{ correctAnsString }}</span>\n    </p>\n    <div *ngIf=\"canShowMetadata\">\n      <lib-metadata [itemData]=\"questionDetails1\"></lib-metadata>\n    </div>\n    <div class=\"rationale-remedation-block mb20\">\n      <lib-rationale\n        [itemData]=\"questionDetails1.modelFeedback\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></lib-rationale>\n\n      <lib-remediation\n        [itemData]=\"questionDetails1.remediationLinks\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></lib-remediation>\n    </div>\n  </ng-container>\n</ng-container>\n\n<!-- ############################ USMLE exam Engine Type ###########################-->\n<ng-container *ngIf=\"examEngineType == 'USMLE'\">\n  <div class=\"wk-row\">\n    <media-carousel\n      *ngIf=\"\n        questionDetails1.parentDetails.assets &&\n        questionDetails1.parentDetails.assets.length != 0 &&\n        assetPosition != 'Bottom' &&\n        assetPosition != 'WithinText'\n      \"\n      [imagePath]=\"imagePath\"\n      [assetData]=\"assetData\"\n      [assetsPosition]=\"assetPosition\"\n    ></media-carousel>\n\n    <div\n      [ngClass]=\"{\n        'wk-col-8':\n          questionDetails1.parentDetails.assets != undefined &&\n          questionDetails1.parentDetails.assets.length != 0 &&\n          assetPosition != 'WithinText',\n        'wk-col-12':\n          questionDetails1.parentDetails.assets == undefined ||\n          questionDetails1.parentDetails.assets.length == 0 ||\n          assetPosition == 'WithinText',\n        'right-assets-position-question': assetPosition == 'Right',\n        'left-assets-position-question': assetPosition == 'Left',\n        'top-assets-position-question': assetPosition == 'Top',\n        'bottom-assets-position-question': assetPosition == 'Bottom'\n      }\"\n    >\n      <div class=\"wkqp-layout-item\">\n        <div class=\"wkqp-field-item normal-font mb0 \">\n          <div class=\"wkqp-field-header\" *ngIf=\"assetPosition != 'WithinText'\">\n            <div class=\"mb20 normal-font wkqp-prewrap\">\n              {{ questionDetails1.parentDetails.promptText }}\n            </div>\n          </div>\n          <div class=\"wkqp-field-header\" *ngIf=\"assetPosition == 'WithinText'\">\n            <item-text-assets\n              [promptText]=\"questionDetails1.parentDetails.promptText\"\n              [imagePath]=\"imagePath\"\n              [assetData]=\"assetData\"\n              [assetsPosition]=\"assetPosition\"\n            ></item-text-assets>\n          </div>\n        </div>\n      </div>\n\n      <media-carousel\n        *ngIf=\"\n          questionDetails1.parentDetails.assets &&\n          questionDetails1.parentDetails.assets.length != 0 &&\n          assetPosition == 'Bottom' &&\n          assetPosition != 'WithinText'\n        \"\n        [imagePath]=\"imagePath\"\n        [assetData]=\"assetData\"\n        [assetsPosition]=\"assetPosition\"\n      ></media-carousel>\n    </div>\n  </div>\n  <div class=\"wkqp-field-item\">\n    <div class=\"wkqp-field-header custom-field-header\">\n      <div class=\"mb20 normal-font wkqp-prewrap\">\n        {{ questionDetails1.promptText }}\n      </div>\n    </div>\n  </div>\n  <div class=\"wkqp-layout-item\">\n    <div class=\"wkqp-field-item normal-font mb0\">\n      <fieldset class=\"common-full-width\">\n        <legend class=\"offscreen\">{{ questionDetails1.promptText }}</legend>\n        <!-- <ng-container *ngFor=\"let option of questionDetails1.choiceInteraction.simpleChoices;let i = index\">\n          <div>\n            <span *ngIf=\"message==true\" [ngClass]=\"getChoiceClassName(option)\"></span>\n            <input id=\"{{option.choiceId}}\" name=\"Multiple Response Answers\" [attr.aria-label]=\"option.label\" type=\"checkbox\"\n              [(ngModel)]=\"option.checked\" [hidden]=\"message\" (change)=\"selectAnswer(option, i)\" [checked]=\"option.checked\">\n            {{option.label}}\n          </div>\n        </ng-container> -->\n        <form [formGroup]=\"form\">\n          <ng-container\n            formArrayName=\"orders\"\n            *ngFor=\"let order of getFormArray().controls; let i = index\"\n          >\n            <div>\n              <span\n                *ngIf=\"checkQuizSubmission == true\"\n                [ngClass]=\"\n                  getChoiceClassName(\n                    questionDetails1.choiceInteraction.simpleChoices[i]\n                  )\n                \"\n              ></span>\n              <input\n                type=\"checkbox\"\n                [formControlName]=\"i\"\n                [hidden]=\"checkQuizSubmission == true\"\n                (change)=\"\n                  selectAnswer(\n                    questionDetails1.choiceInteraction.simpleChoices[i],\n                    i\n                  )\n                \"\n              />\n              {{ questionDetails1.choiceInteraction.simpleChoices[i].label }}\n            </div>\n            <div\n              class=\"wkqp-alert-info wkqp-prewrap correct-rationale-section wkqp-prewrap\"\n              *ngIf=\"\n                checkQuizSubmission == true &&\n                questionDetails1.choiceInteraction.simpleChoices[i].rationale\n              \"\n            >\n              <strong>Rationale: </strong>\n              {{\n                questionDetails1.choiceInteraction.simpleChoices[i].rationale\n              }}\n            </div>\n          </ng-container>\n        </form>\n      </fieldset>\n    </div>\n  </div>\n\n  <!--User answer and correct answer-->\n  <ng-container *ngIf=\"checkQuizSubmission == true\">\n    <div\n      class=\"wkqp-prewrap  medical-multiple-response-wrap  mb20\"\n      [ngClass]=\"\n        isUserAnswersCorrect()\n          ? 'wkqp-alert-success wkqp-success'\n          : 'wkqp-alert-danger wkqp-danger'\n      \"\n      *ngIf=\"userAnswer.length != 0\"\n    >\n      <strong>Your Response:</strong>\n      <!-- <ng-container *ngFor=\"let item of userAnswerView;\">\n        <span>\n          {{item.label}},\n        </span>\n      </ng-container> -->\n      <form [formGroup]=\"form\" class=\"your-response-form\">\n        <ng-container\n          formArrayName=\"orders\"\n          *ngFor=\"let order of getFormArray().controls; let i = index\"\n        >\n          <span *ngIf=\"order.value === true\" class=\"optionlevel\">\n            {{ questionDetails1.choiceInteraction.simpleChoices[i].label }},\n          </span>\n        </ng-container>\n      </form>\n    </div>\n    <p\n      class=\"wkqp-prewrap wkqp-alert-success wkqp-success \"\n      *ngIf=\"!isUserAnswersCorrect()\"\n    >\n      <strong>Correct Response:</strong>\n      <ng-container *ngFor=\"let item of correctAns\">\n        <span class=\"optionlevel\"> {{ item.label }}, </span>\n      </ng-container>\n    </p>\n    <p *ngIf=\"questionDetails1.modelFeedback[0].length !== 0\">\n      <strong>Rationale:</strong>\n      <span>{{ questionDetails1.modelFeedback[0].feedbackText }}</span>\n    </p>\n    <div *ngIf=\"questionDetails1.remediationLinks.length !== 0\">\n      <strong>Remediation:</strong>\n      <div\n        *ngFor=\"\n          let Remediation of questionDetails1.remediationLinks;\n          let k = index\n        \"\n      >\n        <span *ngIf=\"Remediation.linkTypeId == 1\">{{\n          Remediation.linkText1\n        }}</span>\n        <span *ngIf=\"Remediation.linkTypeId != 1\">\n          {{ Remediation.linkText1 }}</span\n        >\n      </div>\n    </div>\n  </ng-container>\n</ng-container>\n",
        styles: [".medical-multiple-response-wrap form.your-response-form,.medical-multiple-response-wrap strong.your-response-left{float:none;display:inline}"]
    })
], MedicalMultipleResponseComponent);

let FillInTheBlanksComponent = class FillInTheBlanksComponent {
    constructor(itemService) {
        this.itemService = itemService;
        // Declare the variables
        this.userAnswer = [];
        this.correctAns = [];
        this.userAttemptDetails = [];
        this.assetData = [];
        this.questionTitleSplits = [];
        this.count = 0;
        this.correctOptions = [];
        this.options = [];
        this.selectBoxes = [];
        this.questionDetails1 = [];
        this.assetPosition = [];
        this.tempSelectedItems = [];
        this.showResponse = false;
        this.imagePath = [];
    }
    get questionDetails() {
        return this.questionDetails;
    }
    set questionCurrentData(value) {
        if (value) {
            this.questionDetails1 = value;
            this.count = 0;
            this.userAnswer = [];
            this.selectBoxes = [];
            this.createQuestion();
        }
        else {
            this.questionDetails1 = [];
            this.count = 0;
            this.createQuestion();
        }
    }
    /* Init */
    ngOnInit() {
        this.itemService.userAnswerState.subscribe(answer => (this.userAnswerService = answer));
    }
    /* Do Check */
    ngDoCheck() {
        if (this.isClearAnswer === true) {
            this.clearUserInputs();
            this.itemService.userAnswerMethod([]);
            this.itemService.clearAnswerMethodFalse(false);
            this.itemService.hideAnswer(false);
        }
        if (this.isShowHide === true) {
            this.message = true;
        }
        else if (this.isShowHide === false) {
            this.message = false;
        }
    }
    /* function to get correct answer */
    correctAnswer() {
        for (const i of this.questionDetails1.textEntryInteraction.inlineChoices) {
            this.correctAns.push(i);
        }
    }
    /* check the value changed */
    valueChanged(event) {
        if (event.length === 0) {
            this.userAnswer = [];
            this.tempSelectedItems = [];
        }
        else {
            this.userAnswer = event;
            this.tempSelectedItems = event;
        }
        if (this.userAnswer.length !== 0) {
            const checkAttempt = event.find(item => item !== '');
            if (checkAttempt === undefined) {
                this.showResponse = true;
            }
            const answerObj = checkAttempt === undefined && this.userAnswer.length !== 0
                ? []
                : this.userAnswer;
            this.itemService.userAnswerMethod(answerObj);
            this.itemService.validateAnswerValueMethod(this.isUserAnswersCorrect());
        }
        else {
            this.itemService.userAnswerMethod([]);
            this.itemService.validateAnswerValueMethod(false);
        }
    }
    /* Check Wheather the user answer is correct or not */
    isUserAnswersCorrect() {
        const userAnswers = [];
        this.questionTitleSplits.forEach(element => {
            if (element.isInputField) {
                userAnswers.push(element.ngModel);
            }
        });
        const correctAnswers = this.correctOptions.length > 0 ? this.correctOptions : [];
        let result = false;
        if (!userAnswers ||
            userAnswers.length === 0 ||
            userAnswers[0] instanceof Array ||
            userAnswers.length != correctAnswers.length) {
            return result;
        }
        else {
            for (let i = 0; i < correctAnswers.length; i++) {
                if (userAnswers[i] &&
                    correctAnswers[i] &&
                    correctAnswers[i].indexOf(userAnswers[i].toLowerCase().trim()) >= 0) {
                    result = true;
                }
                else {
                    result = false;
                    break;
                }
            }
            return result;
        }
    }
    /* function to clear user inputs */
    clearUserInputs() {
        this.userAnswer = [];
        this.selectBoxes = [];
        this.tempSelectedItems = [];
        document.getElementById('resetBtn').click();
    }
    /* Setting prevalue */
    settingPreValue() {
        if (this.userAnswer.length === 0 &&
            this.questionDetails1.userAttemptDetails.userAnswer.length !== 0) {
            this.userAnswer = this.questionDetails1.userAttemptDetails.userAnswer;
        }
        if (this.userAnswer.length !== 0) {
            const answerObj = this.userAnswer;
            this.itemService.userAnswerMethod(answerObj);
            this.itemService.validateAnswerValueMethod(this.isUserAnswersCorrect());
        }
        else {
            this.itemService.userAnswerMethod(['']);
            this.itemService.validateAnswerValueMethod(false);
        }
    }
    createQuestion() {
        this.assetData = this.questionDetails1.assets;
        this.userAnswer = [];
        this.itemService.userAnswerMethod([]);
        this.itemService.validateAnswerValueMethod(false);
        if (this.assetData.length !== 0) {
            this.assetPosition = this.questionDetails1.assets[0]['assetsPosition'];
        }
        this.correctOptions = this.questionDetails1['textEntryInteraction']['inlineChoices'];
        let preValue = [];
        this.selectBoxes = [];
        this.tempSelectedItems = [];
        if (this.questionDetails1.userAttemptDetails.userAnswer.length !== 0 &&
            this.questionDetails1.userAttemptDetails.userAnswer[0] !== 'null') {
            preValue = this.questionDetails1.userAttemptDetails.userAnswer.map(String);
            this.selectBoxes = preValue;
            this.tempSelectedItems = preValue;
        }
        else {
            for (let i = 0; i < this.correctOptions.length; i++) {
                preValue.push('');
            }
        }
        this.questionTitleSplits = [];
        let promptText = this.questionDetails1['promptText'];
        const assetList = promptText.match(/≡Assets-[0-9]\d?≡/gi);
        if (assetList) {
            assetList.forEach((test) => {
                if (promptText.indexOf(test) >= 0) {
                    promptText = promptText.replace(test, ' ' + test + ' ');
                }
            });
        }
        const reg = /(_{5,50})/g;
        promptText = promptText.replace(reg, ' ~input~ ');
        const questionParts = promptText
            .replace(/[]{2,}/g, ' ')
            .trim()
            .split(' ');
        questionParts.forEach((questionPart, index) => {
            const i = index + 1;
            const ngModel = [];
            const reg = /(_{5,50})/g;
            const assetReg = /≡Assets-[0-9]\d?≡/g;
            if (questionPart == '~input~') {
                this.count++;
                this.questionTitleSplits.push({
                    id: i,
                    name: `blank-${this.count}`,
                    isInputField: true,
                    ngModel: this.getCurrentAnswer(preValue),
                    count: this.count - 1
                });
            }
            else if (assetReg.test(questionPart)) {
                this.assetData.forEach(asset => {
                    if (asset.assetTextIdentifier === questionPart) {
                        let arr = [];
                        arr.push(asset);
                        // this.questionTitleSplits.push(arr);
                        this.questionTitleSplits.push({
                            id: i,
                            name: questionPart,
                            isAsset: true,
                            assets: arr
                        });
                    }
                });
            }
            else {
                this.questionTitleSplits.push({
                    id: i,
                    name: questionPart,
                    isText: true
                });
            }
        });
        this.valueChanged(preValue);
    }
    getCurrentAnswer(preValue) {
        if (preValue.length > 0) {
            if (preValue[0] && preValue[0] !== 'null') {
                return preValue[this.count - 1];
            }
            return [];
        }
        return [];
    }
    onInputFieldChange(option, index) {
        const selectedItemObj = option['ngModel'];
        this.tempSelectedItems[index] = selectedItemObj;
        this.selectBoxes = this.tempSelectedItems;
        this.valueChanged(this.selectBoxes);
    }
    validateUserInput(event, questionTitle) {
        if (questionTitle &&
            questionTitle['ngModel'] &&
            questionTitle['ngModel'].length === 0 &&
            event.which === 32) {
            return false;
        }
    }
};
FillInTheBlanksComponent.ctorParameters = () => [
    { type: ItemService }
];
__decorate([
    Input('questionDetails')
], FillInTheBlanksComponent.prototype, "questionCurrentData", null);
__decorate([
    Input()
], FillInTheBlanksComponent.prototype, "examEngineType", void 0);
__decorate([
    Input()
], FillInTheBlanksComponent.prototype, "isClearAnswer", void 0);
__decorate([
    Input()
], FillInTheBlanksComponent.prototype, "isShowHide", void 0);
__decorate([
    Input()
], FillInTheBlanksComponent.prototype, "imagePath", void 0);
__decorate([
    Input()
], FillInTheBlanksComponent.prototype, "checkQuizSubmission", void 0);
__decorate([
    Input()
], FillInTheBlanksComponent.prototype, "selectedTheme", void 0);
__decorate([
    Input()
], FillInTheBlanksComponent.prototype, "fontSize", void 0);
__decorate([
    Input()
], FillInTheBlanksComponent.prototype, "canShowMetadata", void 0);
__decorate([
    Input()
], FillInTheBlanksComponent.prototype, "preferredTextFormat", void 0);
FillInTheBlanksComponent = __decorate([
    Component({
        selector: 'fill-in-the-blanks',
        template: "<!-- ############################ QP Exam Engine Type #########################-->\n<ng-container *ngIf=\"examEngineType == 'QP' || examEngineType == 'NCLEX'\">\n  <!-- Question and Answer  Block-->\n  <div class=\"wk-row\">\n    <media-carousel\n      *ngIf=\"\n        questionDetails1.assets &&\n        questionDetails1.assets.length != 0 &&\n        assetPosition != 'Bottom' &&\n        assetPosition != 'WithinText'\n      \"\n      [imagePath]=\"imagePath\"\n      [assetData]=\"assetData\"\n      [assetsPosition]=\"assetPosition\"\n    ></media-carousel>\n\n    <div\n      [ngClass]=\"{\n        'wk-col-8':\n          questionDetails1.assets != undefined &&\n          questionDetails1.assets.length != 0 &&\n          assetPosition != 'WithinText',\n        'wk-col-12':\n          questionDetails1.assets == undefined ||\n          questionDetails1.assets.length == 0 ||\n          assetPosition == 'WithinText',\n        'right-assets-position-question fill-in-the-blank-right-wk-col-8':\n          assetPosition == 'Right',\n        'left-assets-position-question': assetPosition == 'Left',\n        'top-assets-position-question': assetPosition == 'Top',\n        'bottom-assets-position-question': assetPosition == 'Bottom'\n      }\"\n    >\n      <div class=\"wkqp-layout-item\">\n        <div class=\"wkqp-field-item normal-font mb0 \">\n          <div class=\"wkqp-field-header\">\n            <div class=\"mb20 normal-font\">\n              <form>\n                <div class=\"fill-in-the-blanks-ques-wrapper\">\n                  <ng-container\n                    *ngFor=\"\n                      let questionTitle of questionTitleSplits;\n                      let i = index\n                    \"\n                  >\n                    <ng-container *ngIf=\"questionTitle.isInputField\">\n                      <span>\n                        <input\n                          type=\"text\"\n                          name=\"{{ questionTitle.name }}\"\n                          class=\"wk-fill-inthe-blank-text\"\n                          (keyup)=\"\n                            onInputFieldChange(\n                              questionTitle,\n                              questionTitle.count\n                            )\n                          \"\n                          (keydown)=\"validateUserInput($event, questionTitle)\"\n                          [(ngModel)]=\"questionTitleSplits[i].ngModel\"\n                        />\n                      </span>\n                    </ng-container>\n                    <ng-container *ngIf=\"questionTitle.isAsset\">\n                      <div class=\"mb20\">\n                        <div class=\"wk-row\">\n                          <media-carousel\n                            [inline]=\"'inline'\"\n                            [assetData]=\"questionTitle.assets\"\n                          ></media-carousel>\n                        </div>\n                      </div>\n                    </ng-container>\n                    <ng-container *ngIf=\"questionTitle.isText\">\n                      {{ questionTitle.name }}\n                    </ng-container>\n                  </ng-container>\n                  <span class=\"color-red fs-1rem\"> </span>\n                </div>\n                <button\n                  hidden\n                  id=\"resetBtn\"\n                  type=\"reset\"\n                  value=\"reset\"\n                ></button>\n              </form>\n            </div>\n          </div>\n        </div>\n      </div>\n\n      <media-carousel\n        *ngIf=\"\n          questionDetails1.assets &&\n          questionDetails1.assets.length != 0 &&\n          assetPosition == 'Bottom' &&\n          assetPosition != 'WithinText'\n        \"\n        [imagePath]=\"imagePath\"\n        [assetData]=\"assetData\"\n        [assetsPosition]=\"assetPosition\"\n      ></media-carousel>\n      <div *ngIf=\"canShowMetadata && message != true\">\n        <lib-metadata [itemData]=\"questionDetails1\"></lib-metadata>\n      </div>\n      <!-- Your answer and correct answer-->\n      <ng-container *ngIf=\"message\">\n        <p\n          class=\"wkqp-prewrap   mb20\"\n          [ngClass]=\"\n            isUserAnswersCorrect()\n              ? 'wkqp-alert-success wkqp-success'\n              : 'wkqp-alert-danger wkqp-danger'\n          \"\n          *ngIf=\"userAnswer.length != 0\"\n        >\n          <strong>Your Response: </strong>\n          <ng-container *ngFor=\"let blanks of userAnswer; let i = index\">\n            <span\n              >{{ blanks ? blanks : 'No Response'\n              }}{{ i === userAnswer.length - 1 ? '' : ',' }}</span\n            >\n          </ng-container>\n        </p>\n\n        <div\n          class=\"wkqp-prewrap wkqp-alert-success wkqp-success  mb20 badge-normal\"\n          *ngIf=\"!isUserAnswersCorrect()\"\n        >\n          <strong>Correct Response: </strong>\n          <table class=\"table table-bordered m-t-20\">\n            <tbody>\n              <tr\n                *ngFor=\"\n                  let blanks of questionDetails1.textEntryInteraction\n                    .inlineChoices;\n                  let i = index\n                \"\n              >\n                <td width=\"10%\" class=\"ans-response\">\n                  <strong>Blank-{{ i + 1 }}</strong>\n                </td>\n                <td width=\"90%\">\n                  <span\n                    class=\"wkqp-badge\"\n                    *ngFor=\"let choice of blanks; let k = index\"\n                    style=\"margin-left: 5px\"\n                  >\n                    {{ choice }}\n                  </span>\n                </td>\n              </tr>\n            </tbody>\n          </table>\n        </div>\n        <div *ngIf=\"canShowMetadata\">\n          <lib-metadata [itemData]=\"questionDetails1\"></lib-metadata>\n        </div>\n      </ng-container>\n    </div>\n    <div class=\"rationale-remedation-block mb20\" *ngIf=\"message\">\n      <lib-rationale\n        [itemData]=\"questionDetails1.modelFeedback\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></lib-rationale>\n\n      <lib-remediation\n        [itemData]=\"questionDetails1.remediationLinks\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></lib-remediation>\n    </div>\n  </div>\n</ng-container>\n\n<!-- ############################ USMLE Exam Engine Type #########################-->\n<ng-container *ngIf=\"examEngineType == 'USMLE'\">\n  <!-- Question and Answer  Block-->\n  <div class=\"wk-row\">\n    <media-carousel\n      *ngIf=\"\n        questionDetails1.assets &&\n        questionDetails1.assets.length != 0 &&\n        assetPosition != 'Bottom' &&\n        assetPosition != 'WithinText'\n      \"\n      [imagePath]=\"imagePath\"\n      [assetData]=\"assetData\"\n      [assetsPosition]=\"assetPosition\"\n    ></media-carousel>\n\n    <div\n      [ngClass]=\"{\n        'wk-col-8':\n          questionDetails1.assets != undefined &&\n          questionDetails1.assets.length != 0 &&\n          assetPosition != 'WithinText',\n        'wk-col-12':\n          questionDetails1.assets == undefined ||\n          questionDetails1.assets.length == 0 ||\n          assetPosition == 'WithinText',\n        'right-assets-position-question': assetPosition == 'Right',\n        'left-assets-position-question': assetPosition == 'Left',\n        'top-assets-position-question': assetPosition == 'Top',\n        'bottom-assets-position-question': assetPosition == 'Bottom'\n      }\"\n    >\n      <div class=\"wkqp-layout-item\">\n        <div class=\"wkqp-field-item normal-font mb0 \">\n          <div class=\"wkqp-field-header\">\n            <div class=\"mb20 normal-font wkqp-prewrap\">\n              <!-- <input-type-configuration [userAttemptDetails]=\"userAttemptDetails\" [promptTxt]=\"promptTxt\" (valueChanged)='valueChanged($event)'>\n              </input-type-configuration> -->\n              <form>\n                <div>\n                  <span\n                    *ngFor=\"\n                      let questionTitle of questionTitleSplits;\n                      let i = index\n                    \"\n                  >\n                    <ng-container *ngIf=\"questionTitle.isInputField\">\n                      <input\n                        type=\"text\"\n                        name=\"{{ questionTitle.name }}\"\n                        class=\"wk-fill-inthe-blank-text\"\n                        (keyup)=\"\n                          onInputFieldChange(questionTitle, questionTitle.count)\n                        \"\n                        (keydown)=\"validateUserInput($event, questionTitle)\"\n                        [(ngModel)]=\"questionTitleSplits[i].ngModel\"\n                      />\n                    </ng-container>\n                    <ng-container *ngIf=\"questionTitle.isAsset\">\n                      <div style=\"padding-top: 20px;\" class=\"wk-row\">\n                        <media-carousel\n                          [inline]=\"'inline'\"\n                          [assetData]=\"questionTitle.assets\"\n                        ></media-carousel>\n                      </div>\n                    </ng-container>\n\n                    <ng-container *ngIf=\"questionTitle.isText\">\n                      {{ questionTitle.name }}\n                    </ng-container>\n                  </span>\n                  <span class=\"color-red fs-1rem\">\n                    <!-- {{invalidMessage}} -->\n                  </span>\n                </div>\n                <button\n                  hidden\n                  id=\"resetBtn\"\n                  type=\"reset\"\n                  value=\"reset\"\n                ></button>\n              </form>\n            </div>\n          </div>\n        </div>\n      </div>\n\n      <media-carousel\n        *ngIf=\"\n          questionDetails1.assets &&\n          questionDetails1.assets.length != 0 &&\n          assetPosition == 'Bottom' &&\n          assetPosition != 'WithinText'\n        \"\n        [imagePath]=\"imagePath\"\n        [assetData]=\"assetData\"\n        [assetsPosition]=\"assetPosition\"\n      ></media-carousel>\n      <!--User answer and correct answer-->\n      <ng-container *ngIf=\"checkQuizSubmission == true\">\n        <!-- {{userAnswer}}   {{showResponse}} -->\n        <p\n          class=\"wkqp-prewrap \"\n          [ngClass]=\"\n            isUserAnswersCorrect()\n              ? 'wkqp-alert-success wkqp-success'\n              : 'wkqp-alert-danger wkqp-danger'\n          \"\n          *ngIf=\"userAnswer.length != 0\"\n        >\n          <strong>Your Response: </strong>\n          <ng-container *ngFor=\"let blanks of userAnswer; let i = index\">\n            <span\n              >{{ blanks ? blanks : 'No Response'\n              }}{{ i === userAnswer.length - 1 ? '' : ',' }}</span\n            >\n          </ng-container>\n        </p>\n\n        <div\n          class=\"wkqp-prewrap wkqp-alert-success wkqp-success \"\n          *ngIf=\"!isUserAnswersCorrect()\"\n        >\n          <strong>Correct Response: </strong>\n          <table class=\"table table-bordered \" style=\"margin-top: 20px;\">\n            <tbody>\n              <tr\n                *ngFor=\"\n                  let blanks of questionDetails1.textEntryInteraction\n                    .inlineChoices;\n                  let i = index\n                \"\n              >\n                <td width=\"15%\" class=\"ans-response\">\n                  <strong>Blank-{{ i + 1 }}</strong>\n                </td>\n                <td width=\"85%\">\n                  <span\n                    class=\"wkqp-badge\"\n                    *ngFor=\"let choice of blanks; let k = index\"\n                    style=\"margin-left: 5px\"\n                  >\n                    {{ choice }}\n                  </span>\n                </td>\n              </tr>\n            </tbody>\n          </table>\n        </div>\n        <div *ngIf=\"canShowMetadata\">\n          <lib-metadata [itemData]=\"questionDetails1\"></lib-metadata>\n        </div>\n        <p *ngIf=\"questionDetails1.modelFeedback[0].length !== 0\">\n          <strong>Rationale:</strong>\n          <span>{{ questionDetails1.modelFeedback[0].feedbackText }}</span>\n        </p>\n        <div *ngIf=\"questionDetails1.remediationLinks.length !== 0\">\n          <strong>Remediation:</strong>\n          <div\n            *ngFor=\"\n              let Remediation of questionDetails1.remediationLinks;\n              let k = index\n            \"\n          >\n            <span *ngIf=\"Remediation.linkTypeId == 1\">{{\n              Remediation.linkText1\n            }}</span>\n            <span *ngIf=\"Remediation.linkTypeId != 1\">\n              {{ Remediation.linkText1 }}</span\n            >\n          </div>\n        </div>\n      </ng-container>\n    </div>\n  </div>\n</ng-container>\n",
        styles: [".ans-response{color:#000!important}.m-b-20{margin-bottom:20px!important}.m-t-20{margin-top:20px!important}.wkqp-field-item input.wk-fill-inthe-blank-text{width:20%;border-bottom:1px solid #474747;border-top:none;border-right:none;border-left:none;background-color:transparent;padding:0;height:2rem}.wkqp-field-item input.wk-fill-inthe-blank-text:focus{border-color:#474747;outline:0}.wkqp-field-item input.wk-fill-inthe-blank-text:hover{border-color:#474747}input.wk-fill-inthe-blank-text{border-bottom:1px solid #909090!important;border-top:none!important;border-right:none!important;border-left:none!important;background-color:transparent!important;padding:0!important;height:2rem!important;margin-bottom:20px;color:var(--text-color)}.leave-space{margin:2px}.fill-in-the-blank-right-wk-col-8{width:64%!important;padding:0}.badge-normal table tr td span.wkqp-badge{font-style:normal}.badge-normal table tr td.ans-response strong{color:#474747;font-size:.9375rem;font-style:normal}"]
    })
], FillInTheBlanksComponent);

let GraphicOptionComponent = class GraphicOptionComponent {
    constructor(modalService, itemService, _DomSanitizationService, formBuilder, quizService) {
        this.modalService = modalService;
        this.itemService = itemService;
        this._DomSanitizationService = _DomSanitizationService;
        this.formBuilder = formBuilder;
        this.quizService = quizService;
        // Declare the Variables
        this.userAnswer = [];
        this.correctAns = [];
        this.userResponse = false;
        this.assetData = [];
        this.userSelectedLabel = [];
        this.myInterval = 0;
        this.radioValue = {};
        this.questionDetails1 = [];
        this.assetPosition = [];
        this.incorrectRationale = [];
        this.imagePath = [];
    }
    get questionDetails() {
        return this.questionDetails;
    }
    set questionCurrentData(value) {
        if (value) {
            this.questionDetails1 = value;
            this.createQuestion();
        }
        else {
            this.questionDetails1 = [];
            this.createQuestion();
        }
    }
    /* Init */
    ngOnInit() {
        this.isOnlineEngine = this.quizService.isOnline;
    }
    ngOnChanges(changes) { }
    /* Do Check */
    ngDoCheck() {
        if (this.isClearAnswer === true) {
            this.clearUserInputs();
            this.itemService.userAnswerMethod([]);
            this.itemService.clearAnswerMethodFalse(false);
            this.itemService.hideAnswer(false);
        }
        if (this.isShowHide === true) {
            this.message = true;
        }
        else if (this.isShowHide === false) {
            this.message = false;
        }
    }
    /* function to get correct answer */
    correctAnswer() {
        for (const i of this.questionDetails1.choiceInteraction.simpleChoices) {
            if (i.correct === true) {
                this.correctAns = i;
            }
        }
        this.incorrectRationale = this.questionDetails1.choiceInteraction.simpleChoices.filter(item => item.rationale !== null && item.correct !== true);
    }
    /* function to get selected answer */
    selectAnswer(option) {
        //conosole.log("radioValue", this.form.controls["choices"].value);
        this.radioValue = option;
        this.userAnswer = this.radioValue['choiceId'];
        if (this.userAnswer !== undefined && this.userAnswer !== null) {
            const answerObj = [this.userAnswer];
            this.itemService.userAnswerMethod(answerObj);
            this.itemService.validateAnswerValueMethod(this.isUserAnswersCorrect());
        }
        else {
            this.itemService.userAnswerMethod([]);
            this.itemService.validateAnswerValueMethod(false);
        }
    }
    /* Check wheather the user answer is correct */
    isUserAnswersCorrect() {
        if (this.userAnswer === this.correctAns.choiceId) {
            return true;
        }
        else {
            return false;
        }
    }
    /* function to clear user inputs */
    clearUserInputs() {
        this.userAnswer = [];
        this.form.reset();
    }
    /* Get Choice class name */
    getChoiceClassName(choiceDetails) {
        if (choiceDetails.correct) {
            return 'wk-icon-checkmark green-checkmark';
        }
        else if (!choiceDetails.correct &&
            this.userAnswer === choiceDetails.choiceId) {
            return 'wk-icon-close wrong-checkmark';
        }
        else {
            return 'wk-icon-checkmark disabled-checkmark';
        }
    }
    /* Check the value changes */
    valueChanged() {
        if (this.userAnswer !== undefined && this.userAnswer !== null) {
            const answerObj = this.userAnswer.length !== 0 ? [this.userAnswer] : this.userAnswer;
            this.itemService.userAnswerMethod(answerObj);
            this.itemService.validateAnswerValueMethod(this.isUserAnswersCorrect());
        }
        else {
            this.itemService.userAnswerMethod([]);
            this.itemService.validateAnswerValueMethod(false);
        }
    }
    createQuestion() {
        this.radioValue = {};
        this.userAnswer = [];
        this.correctAns = [];
        this.itemService.userAnswerMethod([]);
        this.itemService.validateAnswerValueMethod(false);
        this.itemService.userAnswerState.subscribe(answer => (this.userAnswerService = answer));
        this.assetData = this.questionDetails1.assets;
        if (this.assetData.length !== 0) {
            this.assetPosition = this.questionDetails1.assets[0]['assetsPosition'];
        }
        if (this.questionDetails1.userAttemptDetails.userAnswer !== undefined &&
            Object.keys(this.questionDetails1.userAttemptDetails.userAnswer)
                .length !== 0) {
            for (const j of this.questionDetails1.choiceInteraction.simpleChoices) {
                if (this.questionDetails1.userAttemptDetails.userAnswer[0] ===
                    j['choiceId']) {
                    this.radioValue = j;
                    this.userAnswer = this.radioValue['choiceId'];
                }
            }
        }
        this.form = this.formBuilder.group({
            choices: [this.radioValue['choiceId']]
        });
        this.valueChanged();
        this.correctAnswer();
    }
    clickImage(template, slide) {
        if (this.quizService.isOnline) {
            this.imageUrl = slide.assetPath;
        }
        else {
            this.imageUrl =
                this.splitStringForType('image', slide.assetName) + slide.assetsContent;
        }
        if (this.imageUrl !== undefined) {
            this.modalRef = this.modalService.show(template);
        }
    }
    splitStringForType(type, value) {
        const name = value.split('.')[1];
        switch (type) {
            case 'image':
                return `data:image/${name};base64,`;
            case 'audio':
                return `data:audio/${name};base64,`;
            case 'video':
                return `data:video/${name};base64,`;
            default:
                break;
        }
    }
    loadImagePath(assetType, slide) {
        if (this.quizService.isOnline) {
            return slide.assetPath;
        }
        return this.splitStringForType(assetType, slide.assetName) + slide.assetsContent;
    }
    returnType(value) {
        const name = value.split('.')[1];
        return name;
    }
    loadImagePathinsideModal(imageUrl) {
        return imageUrl;
    }
};
GraphicOptionComponent.ctorParameters = () => [
    { type: BsModalService },
    { type: ItemService },
    { type: DomSanitizer },
    { type: FormBuilder },
    { type: QuizService }
];
__decorate([
    Input('questionDetails')
], GraphicOptionComponent.prototype, "questionCurrentData", null);
__decorate([
    Input()
], GraphicOptionComponent.prototype, "examEngineType", void 0);
__decorate([
    Input()
], GraphicOptionComponent.prototype, "isClearAnswer", void 0);
__decorate([
    Input()
], GraphicOptionComponent.prototype, "isShowHide", void 0);
__decorate([
    Input()
], GraphicOptionComponent.prototype, "imagePath", void 0);
__decorate([
    Input()
], GraphicOptionComponent.prototype, "checkQuizSubmission", void 0);
__decorate([
    Input()
], GraphicOptionComponent.prototype, "canShowMetadata", void 0);
__decorate([
    Input()
], GraphicOptionComponent.prototype, "preferredTextFormat", void 0);
GraphicOptionComponent = __decorate([
    Component({
        selector: 'graphic-option',
        template: "<!--###################### QP exam Engine Type ###############################-->\n<ng-container *ngIf=\"examEngineType == 'QP' || examEngineType == 'NCLEX'\">\n  <!--Question text-->\n  <div class=\"wk-row\">\n    <media-carousel\n      *ngIf=\"\n        questionDetails1.assets &&\n        questionDetails1.assets.length != 0 &&\n        assetPosition != 'Bottom' &&\n        assetPosition != 'WithinText'\n      \"\n      [imagePath]=\"imagePath\"\n      [assetData]=\"assetData\"\n      [assetsPosition]=\"assetPosition\"\n    ></media-carousel>\n\n    <div\n      [ngClass]=\"{\n        'wk-col-8':\n          questionDetails1.assets != undefined &&\n          questionDetails1.assets.length != 0 &&\n          assetPosition != 'WithinText' &&\n          assetPosition != 'WithinText',\n        'wk-col-12':\n          questionDetails1.assets == undefined ||\n          questionDetails1.assets.length == 0 ||\n          assetPosition == 'WithinText',\n        'right-assets-position-question graphic-opt-full-width ':\n          assetPosition == 'Right',\n        'left-assets-position-question adjust-width-col-8':\n          assetPosition == 'Left',\n        'top-assets-position-question': assetPosition == 'Top',\n        'bottom-assets-position-question': assetPosition == 'Bottom'\n      }\"\n    >\n      <div class=\"wkqp-layout-item\">\n        <div class=\"wkqp-field-item normal-font mb0 \">\n          <div class=\"wkqp-field-header\" *ngIf=\"assetPosition != 'WithinText'\">\n            <div\n              class=\"mb20 normal-font wkqp-prewrap\"\n              libGetFormatText\n              [preferredTextFormat]=\"preferredTextFormat\"\n              [plainText]=\"questionDetails1.promptText\"\n              [richText]=\"questionDetails1.richPromptText\"\n            ></div>\n          </div>\n          <div class=\"wkqp-field-header\" *ngIf=\"assetPosition == 'WithinText'\">\n            <item-text-assets\n              [promptText]=\"questionDetails1.promptText\"\n              [imagePath]=\"imagePath\"\n              [assetData]=\"assetData\"\n              [assetsPosition]=\"assetPosition\"\n            ></item-text-assets>\n          </div>\n        </div>\n      </div>\n      <media-carousel\n        *ngIf=\"\n          questionDetails1.assets &&\n          questionDetails1.assets.length != 0 &&\n          assetPosition == 'Bottom' &&\n          assetPosition != 'WithinText'\n        \"\n        [imagePath]=\"imagePath\"\n        [assetData]=\"assetData\"\n        [assetsPosition]=\"assetPosition\"\n      ></media-carousel>\n      <div\n        class=\"wkqp-table-permit-overflow assets-permit-mt25mb0 graphical-table-midwrap\"\n      >\n        <fieldset class=\"common-full-width mb20\">\n          <legend\n            class=\"offscreen\"\n            libGetFormatText\n            [preferredTextFormat]=\"preferredTextFormat\"\n            [plainText]=\"questionDetails1.promptText\"\n            [richText]=\"questionDetails1.richPromptText\"\n          ></legend>\n          <form [formGroup]=\"form\">\n            <table class=\"wkqp-table question-type-video\" role=\"presentation\">\n              <tbody>\n                <tr\n                  *ngFor=\"\n                    let option of questionDetails1.choiceInteraction\n                      .simpleChoices;\n                    let i = index\n                  \"\n                >\n                  <td width=\"5%\" align=\"center\" valign=\"middle\">\n                    <div class=\"wkqp-radio-field\">\n                      <span\n                        *ngIf=\"message\"\n                        [ngClass]=\"getChoiceClassName(option)\"\n                      ></span>\n                      <input\n                        type=\"radio\"\n                        [hidden]=\"message\"\n                        [value]=\"option.choiceId\"\n                        (change)=\"selectAnswer(option)\"\n                        formControlName=\"choices\"\n                      />\n                      <span\n                        libGetFormatText\n                        [preferredTextFormat]=\"preferredTextFormat\"\n                        [plainText]=\"option.label\"\n                        [richText]=\"option.richLabel\"\n                      ></span>\n                    </div>\n                  </td>\n                  <td width=\"95%\">\n                    <div class=\"media-width400\">\n                      <wkqp-image-scaling\n                        [slideData]=\"option.value\"\n                        [ImageSource]=\"loadImagePath('image', option.value)\"\n                        class=\"grap-opt-answer\"\n                      ></wkqp-image-scaling>\n\n                      <div\n                        class=\"img-go-enlarge-text\"\n                        *ngIf=\"option.value.assetTypeId == 1\"\n                      >\n                        <span class=\"graphic-img-text\"\n                          >Click on image to enlarge.</span\n                        >\n                      </div>\n\n                      <video\n                        title=\"{{ option.value.altTitle }}\"\n                        name=\"previewVideo\"\n                        id=\"previewVideo \"\n                        class=\"item-prev-video55\"\n                        *ngIf=\"option.value.assetTypeId == 3\"\n                      >\n                        <source [src]=\"loadImagePath('video', option.value)\" />\n                        <source\n                          [src]=\"loadImagePath('video', option.value)\"\n                          type='video/mp4; codecs=\"avc1.42E01E, mp4a.40.2\"'\n                        />\n                        <source\n                          [src]=\"loadImagePath('video', option.value)\"\n                          type='video/ogg; codecs=\"theora, vorbis\"'\n                        />\n                      </video>\n                      <app-media-controls\n                        *ngIf=\"option.value.assetTypeId == 3\"\n                        [assetId]=\"option.value.assetId\"\n                        [assetType]=\"'video'\"\n                      ></app-media-controls>\n                      <audio\n                        title=\"{{ option.value.altTitle }}\"\n                        class=\"item-prev-audio55\"\n                        *ngIf=\"option.value.assetTypeId == 2\"\n                        name=\"previewAudio\"\n                        class=\"item-prev-audio55\"\n                        id=\"previewAudio\"\n                      >\n                        <source [src]=\"loadImagePath('audio', option.value)\" />\n                      </audio>\n                      <app-media-controls\n                        *ngIf=\"option.value.assetTypeId == 2\"\n                        [assetId]=\"option.value.assetId\"\n                        [assetType]=\"'audio'\"\n                      ></app-media-controls>\n                      <wkqp-download-transcript\n                        *ngIf=\"isOnlineEngine && option.value.transcript\"\n                        [slideData]=\"option.value\"\n                      >\n                      </wkqp-download-transcript>\n                      <!-- <media-carousel [assetData]=\"option.value\" [assetsPosition]=\"'graphic'\"></media-carousel> -->\n                    </div>\n                    <div\n                      class=\"wkqp-alert-info wkqp-prewrap correct-rationale-section wkqp-prewrap\"\n                      *ngIf=\"message && option.rationale\"\n                    >\n                      <strong>Rationale: </strong>\n                      <span\n                        libGetFormatText\n                        [preferredTextFormat]=\"preferredTextFormat\"\n                        [plainText]=\"option.rationale\"\n                        [richText]=\"option.richRationale\"\n                      ></span>\n                    </div>\n                  </td>\n                </tr>\n              </tbody>\n            </table>\n          </form>\n        </fieldset>\n      </div>\n      <!--User answer and correct answer-->\n      <ng-container *ngIf=\"message\">\n        <!--Your response-->\n        <p\n          class=\"wkqp-prewrap mb20\"\n          [ngClass]=\"\n            isUserAnswersCorrect()\n              ? 'wkqp-alert-success wkqp-success'\n              : 'wkqp-alert-danger wkqp-danger'\n          \"\n          *ngIf=\"userAnswer.length != 0\"\n        >\n          <strong>Your Response:</strong>\n        </p>\n        <div *ngIf=\"userAnswer.length != 0\" class=\"wk-row media-width400 mb20\">\n          <wkqp-image-scaling\n            [slideData]=\"radioValue.value\"\n            [ImageSource]=\"loadImagePath('image', radioValue.value)\"\n            class=\"grap-opt-answer\"\n          ></wkqp-image-scaling>\n\n          <div\n            class=\"img-go-enlarge-text\"\n            *ngIf=\"radioValue.value.assetTypeId == 1\"\n          >\n            <span class=\"graphic-img-text\">Click on image to enlarge.</span>\n          </div>\n          <video\n            title=\"{{ radioValue.value.altTitle }}\"\n            name=\"previewVideo\"\n            id=\"previewVideo\"\n            class=\"item-prev-video55 full-width\"\n            *ngIf=\"radioValue.value.assetTypeId == 3\"\n          >\n            <source [src]=\"loadImagePath('video', radioValue.value)\" />\n            <source\n              [src]=\"loadImagePath('video', radioValue.value)\"\n              type='video/mp4; codecs=\"avc1.42E01E, mp4a.40.2\"'\n            />\n            <source\n              [src]=\"loadImagePath('video', radioValue.value)\"\n              type='video/ogg; codecs=\"theora, vorbis\"'\n            />\n          </video>\n          <app-media-controls\n            *ngIf=\"radioValue.value.assetTypeId == 3\"\n            [assetId]=\"radioValue.value.assetId\"\n            [assetType]=\"'video'\"\n            [controlsPosition]=\"'graphic'\"\n          ></app-media-controls>\n          <audio\n            title=\"{{ radioValue.value.altTitle }}\"\n            *ngIf=\"radioValue.value.assetTypeId == 2\"\n            name=\"previewAudio\"\n            class=\"item-prev-audio55 full-width\"\n            id=\"previewAudio\"\n          >\n            <source [src]=\"loadImagePath('audio', radioValue.value)\" />\n          </audio>\n          <app-media-controls\n            *ngIf=\"radioValue.value.assetTypeId == 2\"\n            [assetId]=\"radioValue.value.assetId\"\n            [assetType]=\"'audio'\"\n            [controlsPosition]=\"'graphic'\"\n          ></app-media-controls>\n          <wkqp-download-transcript\n            *ngIf=\"isOnlineEngine && radioValue.value.transcript\"\n            [slideData]=\"radioValue.value\"\n          >\n          </wkqp-download-transcript>\n          <!-- <media-carousel [assetData]=\"radioValue.value\" [assetsPosition]=\"'graphic'\"></media-carousel> -->\n        </div>\n\n        <!--Correct response-->\n        <p\n          class=\"wkqp-prewrap wkqp-alert-success wkqp-success  mb20\"\n          *ngIf=\"!isUserAnswersCorrect()\"\n        >\n          <strong>Correct Response:</strong>\n        </p>\n        <div *ngIf=\"!isUserAnswersCorrect()\" class=\"wk-row media-width400 mb20\">\n          <wkqp-image-scaling\n            [slideData]=\"correctAns.value\"\n            [ImageSource]=\"loadImagePath('image', correctAns.value)\"\n            class=\"grap-opt-answer\"\n          ></wkqp-image-scaling>\n          <div\n            class=\"img-go-enlarge-text\"\n            *ngIf=\"correctAns.value.assetTypeId == 1\"\n          >\n            <span class=\"graphic-img-text\">Click on image to enlarge.</span>\n          </div>\n          <video\n            title=\"{{ correctAns.value.altTitle }}\"\n            name=\"previewVideo\"\n            id=\"previewVideo\"\n            class=\"item-prev-video55 full-width\"\n            *ngIf=\"correctAns.value.assetTypeId == 3\"\n          >\n            <source [src]=\"loadImagePath('video', correctAns.value)\" />\n            <source\n              [src]=\"loadImagePath('video', correctAns.value)\"\n              type='video/mp4; codecs=\"avc1.42E01E, mp4a.40.2\"'\n            />\n            <source\n              [src]=\"loadImagePath('video', correctAns.value)\"\n              type='video/ogg; codecs=\"theora, vorbis\"'\n            />\n          </video>\n          <app-media-controls\n            *ngIf=\"correctAns.value.assetTypeId == 3\"\n            [assetId]=\"correctAns.value.assetId\"\n            [assetType]=\"'video'\"\n            [controlsPosition]=\"'graphic'\"\n          ></app-media-controls>\n          <audio\n            title=\"{{ correctAns.value.altTitle }}\"\n            class=\"item-prev-audio55 full-width\"\n            *ngIf=\"correctAns.value.assetTypeId == 2\"\n            name=\"previewAudio\"\n            id=\"previewAudio\"\n          >\n            <source [src]=\"loadImagePath('audio', correctAns.value)\" />\n          </audio>\n          <app-media-controls\n            *ngIf=\"correctAns.value.assetTypeId == 2\"\n            [assetId]=\"correctAns.value.assetId\"\n            [assetType]=\"'audio'\"\n            [controlsPosition]=\"'graphic'\"\n          ></app-media-controls>\n          <wkqp-download-transcript\n            *ngIf=\"isOnlineEngine && correctAns.value.transcript\"\n            [slideData]=\"correctAns.value\"\n          >\n          </wkqp-download-transcript>\n          <!-- <media-carousel [assetData]=\"correctAns.value\" [assetsPosition]=\"'graphic'\"></media-carousel> -->\n        </div>\n        <div *ngIf=\"canShowMetadata\">\n          <lib-metadata [itemData]=\"questionDetails1\"></lib-metadata>\n        </div>\n      </ng-container>\n    </div>\n  </div>\n  <div *ngIf=\"canShowMetadata && message != true\">\n    <lib-metadata [itemData]=\"questionDetails1\"></lib-metadata>\n  </div>\n\n  <div class=\"rationale-remedation-block mb20\" *ngIf=\"message\">\n    <!--Rationle-->\n    <lib-rationale\n      [itemData]=\"questionDetails1.modelFeedback\"\n      [preferredTextFormat]=\"preferredTextFormat\"\n    ></lib-rationale>\n    <!--Remediation-->\n    <lib-remediation\n      [itemData]=\"questionDetails1.remediationLinks\"\n      [preferredTextFormat]=\"preferredTextFormat\"\n    ></lib-remediation>\n  </div>\n</ng-container>\n\n<!--###################### USMLE exam Engine Type ###############################-->\n<ng-container *ngIf=\"examEngineType == 'USMLE'\">\n  <!--Question text-->\n  <div class=\"wk-row\">\n    <media-carousel\n      *ngIf=\"\n        questionDetails1.assets &&\n        questionDetails1.assets.length != 0 &&\n        assetPosition != 'Bottom' &&\n        assetPosition != 'WithinText'\n      \"\n      [imagePath]=\"imagePath\"\n      [assetData]=\"assetData\"\n      [assetsPosition]=\"assetPosition\"\n    ></media-carousel>\n\n    <div\n      [ngClass]=\"{\n        'wk-col-8':\n          questionDetails1.assets != undefined &&\n          questionDetails1.assets.length != 0 &&\n          assetPosition != 'WithinText',\n        'wk-col-12':\n          questionDetails1.assets == undefined ||\n          questionDetails1.assets.length == 0 ||\n          assetPosition == 'WithinText',\n        'right-assets-position-question': assetPosition == 'Right',\n        'left-assets-position-question': assetPosition == 'Left',\n        'top-assets-position-question': assetPosition == 'Top',\n        'bottom-assets-position-question': assetPosition == 'Bottom'\n      }\"\n    >\n      <div class=\"wkqp-layout-item\">\n        <div class=\"wkqp-field-item normal-font mb0 \">\n          <div class=\"wkqp-field-header\" *ngIf=\"assetPosition != 'WithinText'\">\n            <div class=\"mb20 normal-font wkqp-prewrap\">\n              {{ questionDetails1.promptText }}\n            </div>\n          </div>\n          <div class=\"wkqp-field-header\" *ngIf=\"assetPosition == 'WithinText'\">\n            <item-text-assets\n              [promptText]=\"questionDetails1.promptText\"\n              [imagePath]=\"imagePath\"\n              [assetData]=\"assetData\"\n              [assetsPosition]=\"assetPosition\"\n            ></item-text-assets>\n          </div>\n        </div>\n      </div>\n      <!--Question media answer-->\n      <div\n        class=\"wkqp-table-permit-overflow assets-permit-mt25mb0 graphical-table-midwrap\"\n      >\n        <fieldset>\n          <table class=\"wkqp-table question-type-video\" role=\"presentation\">\n            <tbody>\n              <fieldset class=\"common-full-width\">\n                <legend class=\"offscreen\">\n                  {{ questionDetails1.promptText }}\n                </legend>\n                <form [formGroup]=\"form\">\n                  <tr\n                    *ngFor=\"\n                      let option of questionDetails1.choiceInteraction\n                        .simpleChoices;\n                      let i = index\n                    \"\n                  >\n                    <td width=\"5%\" align=\"center\" valign=\"middle\">\n                      <div ng-class=\"wkqp-radio-field\">\n                        <!-- <input id=\"{{option.choiceId}}\" name=\"Answer Choices\" [attr.aria-label]=\"option.value.assetName\" [checked]=\"option.checked\"\n              type=\"radio\" name=\"choice\" [hidden]=\"message\" (change)=\"selectAnswer(option, i)\" [value]=\"option\"> -->\n                        <div>\n                          <span\n                            *ngIf=\"checkQuizSubmission == true\"\n                            [ngClass]=\"getChoiceClassName(option)\"\n                          ></span>\n                          <input\n                            type=\"radio\"\n                            [hidden]=\"checkQuizSubmission == true\"\n                            [value]=\"option.choiceId\"\n                            (change)=\"selectAnswer(option)\"\n                            formControlName=\"choices\"\n                          />\n                          <span>{{ option.label }}</span>\n                        </div>\n                      </div>\n                    </td>\n                    <td width=\"95%\">\n                      <div>\n                        <img\n                          [src]=\"\n                            _DomSanitizationService.bypassSecurityTrustUrl(\n                              splitStringForType(\n                                'image',\n                                option.value.assetName\n                              ) + option.value.assetsContent\n                            )\n                          \"\n                          *ngIf=\"option.value.assetTypeId == 1\"\n                          class=\"item-prev-img55 grap-opt-answer\"\n                          width=\"300px\"\n                          (enter)=\"\n                            clickImage(\n                              splitStringForType(\n                                'image',\n                                option.value.assetName\n                              ) + option.value.assetsContent,\n                              template\n                            )\n                          \"\n                          (click)=\"\n                            clickImage(\n                              splitStringForType(\n                                'image',\n                                option.value.assetName\n                              ) + option.value.assetsContent,\n                              template\n                            )\n                          \"\n                        />\n                        <video\n                          title=\"{{ option.value.altTitle }}\"\n                          name=\"previewVideo\"\n                          id=\"previewVideo \"\n                          class=\"item-prev-video55\"\n                          *ngIf=\"option.value.assetTypeId == 3\"\n                        >\n                          <source\n                            [src]=\"\n                              _DomSanitizationService.bypassSecurityTrustUrl(\n                                splitStringForType(\n                                  'video',\n                                  option.value.assetName\n                                ) + option.value.assetsContent\n                              )\n                            \"\n                          />\n                          <source\n                            [src]=\"\n                              _DomSanitizationService.bypassSecurityTrustUrl(\n                                splitStringForType(\n                                  'video',\n                                  option.value.assetName\n                                ) + option.value.assetsContent\n                              )\n                            \"\n                            type='video/mp4; codecs=\"avc1.42E01E, mp4a.40.2\"'\n                          />\n                          <source\n                            [src]=\"\n                              _DomSanitizationService.bypassSecurityTrustUrl(\n                                splitStringForType(\n                                  'video',\n                                  option.value.assetName\n                                ) + option.value.assetsContent\n                              )\n                            \"\n                            type='video/ogg; codecs=\"theora, vorbis\"'\n                          />\n                        </video>\n                        <app-media-controls\n                          *ngIf=\"option.value.assetTypeId == 3\"\n                          [assetId]=\"option.value.assetId\"\n                          [assetType]=\"'video'\"\n                        ></app-media-controls>\n                        <audio\n                          title=\"{{ option.value.altTitle }}\"\n                          class=\"item-prev-audio55\"\n                          *ngIf=\"option.value.assetTypeId == 2\"\n                          name=\"previewAudio\"\n                          class=\"item-prev-audio55\"\n                          id=\"previewAudio\"\n                        >\n                          <source\n                            [src]=\"\n                              _DomSanitizationService.bypassSecurityTrustUrl(\n                                splitStringForType(\n                                  'audio',\n                                  option.value.assetName\n                                ) + option.value.assetsContent\n                              )\n                            \"\n                          />\n                        </audio>\n                        <app-media-controls\n                          *ngIf=\"option.value.assetTypeId == 2\"\n                          [assetId]=\"option.value.assetId\"\n                          [assetType]=\"'audio'\"\n                        ></app-media-controls>\n                        <!-- <media-carousel [assetData]=\"option.value\" [assetsPosition]=\"'graphic'\"></media-carousel> -->\n                      </div>\n                      <div\n                        class=\"wkqp-alert-info wkqp-prewrap correct-rationale-section wkqp-prewrap\"\n                        *ngIf=\"checkQuizSubmission == true && option.rationale\"\n                      >\n                        <strong>Rationale: </strong>{{ option.rationale }}\n                      </div>\n                    </td>\n                  </tr>\n                </form>\n              </fieldset>\n            </tbody>\n          </table>\n        </fieldset>\n      </div>\n      <media-carousel\n        *ngIf=\"\n          questionDetails1.assets &&\n          questionDetails1.assets.length != 0 &&\n          assetPosition == 'Bottom' &&\n          assetPosition != 'WithinText'\n        \"\n        [imagePath]=\"imagePath\"\n        [assetData]=\"assetData\"\n        [assetsPosition]=\"assetPosition\"\n      ></media-carousel>\n    </div>\n  </div>\n\n  <!--User response and correct response-->\n  <ng-container *ngIf=\"checkQuizSubmission == true\">\n    <!--Your response-->\n    <p\n      class=\"wkqp-prewrap  \"\n      [ngClass]=\"\n        isUserAnswersCorrect()\n          ? 'wkqp-alert-success wkqp-success'\n          : 'wkqp-alert-danger wkqp-danger'\n      \"\n      *ngIf=\"userAnswer.length != 0\"\n    >\n      <strong>Your Response:</strong>\n    </p>\n    <div *ngIf=\"userAnswer.length != 0\" class=\"wk-row\">\n      <img\n        [src]=\"\n          _DomSanitizationService.bypassSecurityTrustUrl(\n            splitStringForType('image', radioValue.value.assetName) +\n              radioValue.value.assetsContent\n          )\n        \"\n        *ngIf=\"radioValue.value.assetTypeId == 1\"\n        class=\"item-prev-img55  grap-opt-answer\"\n        width=\"300px\"\n        (enter)=\"\n          clickImage(\n            splitStringForType('image', radioValue.value.assetName) +\n              radioValue.value.assetsContent,\n            template\n          )\n        \"\n        (click)=\"\n          clickImage(\n            splitStringForType('image', radioValue.value.assetName) +\n              radioValue.value.assetsContent,\n            template\n          )\n        \"\n      />\n      <video\n        title=\"{{ radioValue.altTitle }}\"\n        name=\"previewVideo\"\n        id=\"previewVideo\"\n        class=\"item-prev-video55 full-width\"\n        *ngIf=\"radioValue.value.assetTypeId == 3\"\n      >\n        <source\n          [src]=\"\n            _DomSanitizationService.bypassSecurityTrustUrl(\n              splitStringForType('video', radioValue.value.assetName) +\n                radioValue.value.assetsContent\n            )\n          \"\n        />\n        <source\n          [src]=\"\n            _DomSanitizationService.bypassSecurityTrustUrl(\n              splitStringForType('video', radioValue.value.assetName) +\n                radioValue.value.assetsContent\n            )\n          \"\n          type='video/mp4; codecs=\"avc1.42E01E, mp4a.40.2\"'\n        />\n        <source\n          [src]=\"\n            _DomSanitizationService.bypassSecurityTrustUrl(\n              splitStringForType('video', radioValue.value.assetName) +\n                radioValue.value.assetsContent\n            )\n          \"\n          type='video/ogg; codecs=\"theora, vorbis\"'\n        />\n      </video>\n      <app-media-controls\n        *ngIf=\"radioValue.value.assetTypeId == 3\"\n        [assetId]=\"radioValue.value.assetId\"\n        [assetType]=\"'video'\"\n        [controlsPosition]=\"'graphic'\"\n      ></app-media-controls>\n      <audio\n        title=\"{{ radioValue.value.altTitle }}\"\n        *ngIf=\"radioValue.value.assetTypeId == 2\"\n        name=\"previewAudio\"\n        class=\"item-prev-audio55 full-width\"\n        id=\"previewAudio\"\n      >\n        <source\n          [src]=\"\n            _DomSanitizationService.bypassSecurityTrustUrl(\n              splitStringForType('audio', radioValue.value.assetName) +\n                radioValue.value.assetsContent\n            )\n          \"\n        />\n      </audio>\n      <app-media-controls\n        *ngIf=\"radioValue.value.assetTypeId == 2\"\n        [assetId]=\"radioValue.value.assetId\"\n        [assetType]=\"'audio'\"\n        [controlsPosition]=\"'graphic'\"\n      ></app-media-controls>\n      <!-- <media-carousel [assetData]=\"radioValue.value\" [assetsPosition]=\"'graphic'\"></media-carousel> -->\n    </div>\n\n    <!--Correct response-->\n    <p\n      class=\"wkqp-prewrap wkqp-alert-success wkqp-success \"\n      *ngIf=\"!isUserAnswersCorrect()\"\n    >\n      <strong>Correct Response:</strong>\n    </p>\n    <div *ngIf=\"!isUserAnswersCorrect()\" class=\"wk-row\">\n      <img\n        [src]=\"\n          _DomSanitizationService.bypassSecurityTrustUrl(\n            splitStringForType('image', correctAns.value.assetName) +\n              correctAns.value.assetsContent\n          )\n        \"\n        *ngIf=\"correctAns.value.assetTypeId == 1\"\n        class=\"item-prev-img55  grap-opt-answer\"\n        width=\"300px\"\n        (enter)=\"\n          clickImage(\n            splitStringForType('image', correctAns.value.assetName) +\n              correctAns.value.assetsContent,\n            template\n          )\n        \"\n        (click)=\"\n          clickImage(\n            splitStringForType('image', correctAns.value.assetName) +\n              correctAns.value.assetsContent,\n            template\n          )\n        \"\n      />\n      <video\n        title=\"{{ correctAns.value.altTitle }}\"\n        name=\"previewVideo\"\n        id=\"previewVideo\"\n        class=\"item-prev-video55 full-width\"\n        *ngIf=\"correctAns.value.assetTypeId == 3\"\n      >\n        <source\n          [src]=\"\n            _DomSanitizationService.bypassSecurityTrustUrl(\n              splitStringForType('video', correctAns.value.assetName) +\n                correctAns.value.assetsContent\n            )\n          \"\n        />\n        <source\n          [src]=\"\n            _DomSanitizationService.bypassSecurityTrustUrl(\n              splitStringForType('video', correctAns.value.assetName) +\n                correctAns.value.assetsContent\n            )\n          \"\n          type='video/mp4; codecs=\"avc1.42E01E, mp4a.40.2\"'\n        />\n        <source\n          [src]=\"\n            _DomSanitizationService.bypassSecurityTrustUrl(\n              splitStringForType('video', correctAns.value.assetName) +\n                correctAns.value.assetsContent\n            )\n          \"\n          type='video/ogg; codecs=\"theora, vorbis\"'\n        />\n      </video>\n      <app-media-controls\n        *ngIf=\"correctAns.value.assetTypeId == 3\"\n        [assetId]=\"correctAns.value.assetId\"\n        [assetType]=\"'video'\"\n        [controlsPosition]=\"'graphic'\"\n      ></app-media-controls>\n      <audio\n        title=\"{{ correctAns.value.altTitle }}\"\n        class=\"item-prev-audio55 full-width\"\n        *ngIf=\"correctAns.value.assetTypeId == 2\"\n        name=\"previewAudio\"\n        id=\"previewAudio\"\n      >\n        <source\n          [src]=\"\n            _DomSanitizationService.bypassSecurityTrustUrl(\n              splitStringForType('audio', correctAns.value.assetName) +\n                correctAns.value.assetsContent\n            )\n          \"\n        />\n      </audio>\n      <app-media-controls\n        *ngIf=\"correctAns.value.assetTypeId == 2\"\n        [assetId]=\"correctAns.value.assetId\"\n        [assetType]=\"'audio'\"\n        [controlsPosition]=\"'graphic'\"\n      ></app-media-controls>\n      <!-- <media-carousel [assetData]=\"correctAns.value\" [assetsPosition]=\"'graphic'\"></media-carousel> -->\n    </div>\n\n    <!--Rationale-->\n    <p *ngIf=\"questionDetails1.modelFeedback[0].length !== 0\">\n      <strong>Rationale:</strong>\n      <span>{{ questionDetails1.modelFeedback[0].feedbackText }}</span>\n    </p>\n\n    <!--Remediation-->\n    <div *ngIf=\"questionDetails1.remediationLinks.length !== 0\">\n      <strong>Remediation:</strong>\n      <div\n        *ngFor=\"\n          let Remediation of questionDetails1.remediationLinks;\n          let k = index\n        \"\n      >\n        <span *ngIf=\"Remediation.linkTypeId == 1\">{{\n          Remediation.linkText1\n        }}</span>\n        <span *ngIf=\"Remediation.linkTypeId != 1\">\n          {{ Remediation.linkText1 }}</span\n        >\n      </div>\n    </div>\n  </ng-container>\n</ng-container>\n<ng-template #template>\n  <div class=\"modal-header\">\n    <button\n      type=\"button\"\n      class=\"close pull-right\"\n      aria-label=\"Close\"\n      (click)=\"modalRef.hide()\"\n    >\n      <span aria-hidden=\"true\" class=\"closeIcon\" style=\"font-size:30px;\"\n        >&times;</span\n      >\n    </button>\n  </div>\n  <div class=\"modal-body\">\n    <div class=\"image-center\">\n      <img\n        [src]=\"_DomSanitizationService.bypassSecurityTrustUrl(imageUrl)\"\n        alt=\"No Image\"\n      />\n    </div>\n  </div>\n</ng-template>\n",
        styles: [".modal-content{border-radius:0!important;border:0!important}.modal-header{border-radius:0!important;border:0!important;padding:10px!important;position:relative!important;height:45px!important}button.close{cursor:pointer!important;padding:0!important;margin:0!important;position:absolute!important;right:12px!important;top:7px!important}.close{opacity:1!important}.modal-header button.close:focus,.modal-header button.close:hover{background-color:transparent!important;color:#fff!important;outline:0!important;border:0!important;box-shadow:0 0 0!important}.closeIcon{color:#fff}video::-internal-media-controls-download-button{display:none}video::-webkit-media-controls-enclosure{overflow:hidden}video::-webkit-media-controls-panel{width:calc(100% + 30px)}audio::-internal-media-controls-download-button{display:none}audio::-webkit-media-controls-enclosure{overflow:hidden}audio::-webkit-media-controls-panel{width:calc(100% + 30px)}.full-width{float:left;width:500px;border:1px solid #a3a3a3;background-color:var(--secondary-color)}.graphic-img-text{color:var(--text-color);font-size:.9375rem}.image-center{text-align:center}.media-width400{width:400px;margin-left:0;margin-right:0}"]
    })
], GraphicOptionComponent);

let HotSpotComponent = class HotSpotComponent {
    constructor(itemService, _DomSanitizationService) {
        this.itemService = itemService;
        this._DomSanitizationService = _DomSanitizationService;
        // Declare the variables
        this.hotspot = true;
        this.userAnswer = [];
        this.correctAns = false;
        this.viewUserAnswer = "userResponse";
        this.viewCorrectAnswer = "correctAnswer";
        this.selectAnswer = "selectAnswer";
        this.userResponse = false;
        this.viewUserAnswerValue = [];
        this.questionDetails1 = [];
        this.imagePath = [];
    }
    get questionDetails() {
        return this.questionDetails;
    }
    set questionCurrentData(value) {
        if (value) {
            this.questionDetails1 = value;
            this.createQuestion();
        }
        else {
            this.questionDetails1 = [];
            this.createQuestion();
        }
    }
    /* Init */
    ngOnInit() { }
    /* Do check */
    ngDoCheck() {
        if (this.isClearAnswer === true) {
            this.itemService.clearAnswerMethodFalse(false);
            this.itemService.hideAnswer(false);
            this.itemService.userAnswerMethod([]);
            this.clearUserInputs();
        }
        if (this.isShowHide === true) {
            this.message = true;
        }
        else if (this.isShowHide === false) {
            this.message = false;
        }
    }
    /* Clear User Inputs */
    clearUserInputs() {
        const answerObj = [];
        this.userAnswer = [];
        this.itemService.userAnswerMethod(answerObj);
    }
    /* Check Empty asset */
    checkEmptyAsset() {
        return Object.keys(this.assetData).length === 0;
    }
    /* Validate the user answer */
    userAnswerValue(userAnswerValue) {
        console.log("useranswer from child", userAnswerValue);
        this.viewUserAnswerValue = userAnswerValue;
        this.correctAns = false;
        if (userAnswerValue &&
            this.questionDetails1.graphicInteraction.hotspotChoices[0] &&
            this.questionDetails1.graphicInteraction.hotspotChoices[0].shape === 1) {
            // Circle area validation
            let coordinates = this.questionDetails1.graphicInteraction.hotspotChoices[0].coords.split(",");
            const centerX = Number(coordinates[0]), centerY = Number(coordinates[1]), ansRadius = Number(coordinates[2]), userX = userAnswerValue[0], userY = userAnswerValue[1];
            const distance = Math.sqrt(Math.pow(userX - centerX, 2) + Math.pow(userY - centerY, 2));
            if (distance <= ansRadius) {
                this.questionDetails1.correct = true;
                this.correctAns = true;
            }
        }
        else if (userAnswerValue &&
            this.questionDetails1.graphicInteraction.hotspotChoices[0] &&
            this.questionDetails1.graphicInteraction.hotspotChoices[0].shape === 2) {
            // Rectangle area validation
            let coordinates = this.questionDetails1.graphicInteraction.hotspotChoices[0].coords.split(",");
            const ansX1 = coordinates[0], ansY1 = coordinates[1], ansX2 = coordinates[2], ansY2 = coordinates[3], userX = userAnswerValue[0], userY = userAnswerValue[1];
            if (userX >= ansX1 &&
                userX <= ansX2 &&
                userY >= ansY1 &&
                userY <= ansY2) {
                this.questionDetails1.correct = true;
                this.correctAns = true;
            }
        }
        this.userAnswer = userAnswerValue;
        const answerObj = userAnswerValue;
        this.itemService.userAnswerMethod(answerObj);
        this.itemService.validateAnswerValueMethod(this.correctAns);
    }
    /* Check the value has been changed */
    valueChanged() {
        if (this.questionDetails1.userAttemptDetails.userAnswer.length > 0 &&
            this.questionDetails1.graphicInteraction.hotspotChoices[0] &&
            this.questionDetails1.graphicInteraction.hotspotChoices[0].shape === 1) {
            // Circle area validation
            let coordinates = this.questionDetails1.graphicInteraction.hotspotChoices[0].coords.split(",");
            const centerX = Number(coordinates[0]), centerY = Number(coordinates[1]), ansRadius = Number(coordinates[2]), userX = this.questionDetails1.userAttemptDetails.userAnswer[0], userY = this.questionDetails1.userAttemptDetails.userAnswer[1];
            const distance = Math.sqrt(Math.pow(userX - centerX, 2) + Math.pow(userY - centerY, 2));
            if (distance <= ansRadius) {
                this.questionDetails1.correct = true;
                this.correctAns = true;
            }
            this.userAnswer = this.questionDetails1.userAttemptDetails;
            const answerObj = this.questionDetails1.userAttemptDetails.userAnswer;
            this.itemService.userAnswerMethod(answerObj);
            this.itemService.validateAnswerValueMethod(this.correctAns);
        }
        else if (this.questionDetails1.userAttemptDetails.userAnswer.length > 0 &&
            this.questionDetails1.graphicInteraction.hotspotChoices[0] &&
            this.questionDetails1.graphicInteraction.hotspotChoices[0].shape === 2) {
            // Rectangle area validation
            let coordinates = this.questionDetails1.graphicInteraction.hotspotChoices[0].coords.split(",");
            const ansX1 = coordinates[0], ansY1 = coordinates[1], ansX2 = coordinates[2], ansY2 = coordinates[3], userX = this.questionDetails1.userAttemptDetails.userAnswer[0], userY = this.questionDetails1.userAttemptDetails.userAnswer[1];
            if (userX >= ansX1 &&
                userX <= ansX2 &&
                userY >= ansY1 &&
                userY <= ansY2) {
                this.questionDetails1.correct = true;
                this.correctAns = true;
            }
            this.userAnswer = this.questionDetails1.userAttemptDetails;
            const answerObj = this.questionDetails1.userAttemptDetails.userAnswer;
            this.itemService.userAnswerMethod(answerObj);
            this.itemService.validateAnswerValueMethod(this.correctAns);
        }
    }
    createQuestion() {
        this.userAnswer = [];
        this.itemService.userAnswerMethod([]);
        this.itemService.validateAnswerValueMethod(this.correctAns);
        this.itemService.userAnswerState.subscribe(answer => (this.userAnswerService = answer));
        this.valueChanged();
    }
};
HotSpotComponent.ctorParameters = () => [
    { type: ItemService },
    { type: DomSanitizer }
];
__decorate([
    Input("questionDetails")
], HotSpotComponent.prototype, "questionCurrentData", null);
__decorate([
    Input()
], HotSpotComponent.prototype, "examEngineType", void 0);
__decorate([
    Input()
], HotSpotComponent.prototype, "canShowMetadata", void 0);
__decorate([
    Input()
], HotSpotComponent.prototype, "isClearAnswer", void 0);
__decorate([
    Input()
], HotSpotComponent.prototype, "isShowHide", void 0);
__decorate([
    Input()
], HotSpotComponent.prototype, "imagePath", void 0);
__decorate([
    Input()
], HotSpotComponent.prototype, "checkQuizSubmission", void 0);
__decorate([
    Input()
], HotSpotComponent.prototype, "selectedTheme", void 0);
__decorate([
    Input()
], HotSpotComponent.prototype, "fontSize", void 0);
__decorate([
    Input()
], HotSpotComponent.prototype, "preferredTextFormat", void 0);
HotSpotComponent = __decorate([
    Component({
        selector: "hot-spot",
        template: "<!--############## QP Exam Engine Type ############################-->\n<ng-container *ngIf=\"examEngineType == 'QP' || examEngineType == 'NCLEX'\">\n  <div class=\"wk-row\">\n    <div\n      class=\"wk-alert-info wk-alert-dismissible newalertdismissible\"\n      *ngIf=\"hotspot == true\"\n    >\n      <button\n        type=\"button\"\n        (click)=\"hotspot = false\"\n        class=\"wk-icon-close-empty\"\n      ></button>\n      <span class=\"icon-size wk-icon-info-outline\" style=\"float: left;\"></span>\n      <span\n        >This question type does not comply with Accessibility Standards. This\n        type does not support navigation to the hotspot area via a keyboard nor\n        will a screen reader describe the image beyond reading its alternate\n        text.</span\n      >\n    </div>\n    <!--Question text-->\n    <div class=\"wk-layout-item\">\n      <div class=\"wk-field-item normal-font mb0 \">\n        <div class=\"wk-field-header \">\n          <p\n            class=\"mb20 normal-font wk-prewrap question-prompt-text\"\n            libGetFormatText\n            [preferredTextFormat]=\"preferredTextFormat\"\n            [plainText]=\"questionDetails1.promptText\"\n            [richText]=\"questionDetails1.richPromptText\"\n          ></p>\n        </div>\n\n        <!--Hotspot image-->\n        <div *ngIf=\"questionDetails1.assets[0]\">\n          <hotspot-svg\n            class=\"hotspot-focus\"\n            [userAnswerDetails]=\"userAnswer\"\n            [isClearAnswer]=\"isClearAnswer\"\n            [imagePath]=\"imagePath\"\n            [imageType]=\"questionDetails1.assets[0].assetName\"\n            [imageSrc]=\"questionDetails1.assets[0]\"\n            (userAnswerFromChild)=\"userAnswerValue($event)\"\n            [accessType]=\"selectAnswer\"\n          ></hotspot-svg>\n        </div>\n      </div>\n    </div>\n    <div *ngIf=\"canShowMetadata && message != true\">\n      <lib-metadata [itemData]=\"questionDetails1\"></lib-metadata>\n    </div>\n\n    <!--your answer and correct answer-->\n    <ng-container *ngIf=\"message\">\n      <div class=\"wkqp-layout-item mb20\">\n        <div class=\"wkqp-field-item\">\n          <div tabindex=\"0\">\n            <!--Your Response-->\n            <p\n              class=\"wkqp-prewrap mb20\"\n              *ngIf=\"userAnswer.length !== 0\"\n              [ngClass]=\"\n                !correctAns\n                  ? 'wkqp-alert-danger wkqp-danger'\n                  : 'wkqp-alert-success wkqp-success'\n              \"\n            >\n              <strong>Your Response: </strong>\n            </p>\n            <div class=\"common-full-width mt10\" *ngIf=\"userAnswer.length !== 0\">\n              <hotspot-svg\n                class=\"hotspot-focus\"\n                [hideLabel]=\"true\"\n                [userAnswerDetails]=\"userAnswer\"\n                (userAnswerFromChild)=\"userAnswerValue($event)\"\n                [imageSrc]=\"questionDetails1.assets[0]\"\n                [imageType]=\"questionDetails1.assets[0].assetName\"\n                [accessType]=\"viewUserAnswer\"\n              ></hotspot-svg>\n            </div>\n\n            <!--Correct Response-->\n            <p\n              *ngIf=\"!correctAns || userAnswer.length === 0\"\n              class=\"wkqp-prewrap wkqp-alert-success wkqp-success mb20\"\n            >\n              <strong>Correct Response: </strong>\n            </p>\n            <div\n              class=\"common-full-width mt10\"\n              *ngIf=\"!correctAns || userAnswer.length === 0\"\n            >\n              <hotspot-svg\n                class=\"hotspot-focus\"\n                [hideLabel]=\"true\"\n                [correctAnswerDetails]=\"\n                  questionDetails1['graphicInteraction']['hotspotChoices'][0]\n                \"\n                [isClearAnswer]=\"isClearAnswer\"\n                [imagePath]=\"imagePath\"\n                [imageType]=\"questionDetails1.assets[0].assetName\"\n                [imageSrc]=\"questionDetails1.assets[0]\"\n                [accessType]=\"viewCorrectAnswer\"\n              ></hotspot-svg>\n            </div>\n            <div *ngIf=\"canShowMetadata\">\n              <lib-metadata [itemData]=\"questionDetails1\"></lib-metadata>\n            </div>\n          </div>\n        </div>\n      </div>\n    </ng-container>\n    <div class=\"common-full-width mb20\" *ngIf=\"message\">\n      <!--Rationale-->\n      <lib-rationale\n        [itemData]=\"questionDetails1.modelFeedback\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></lib-rationale>\n\n      <!--Remediation-->\n      <lib-remediation\n        [itemData]=\"questionDetails1.remediationLinks\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></lib-remediation>\n    </div>\n  </div>\n</ng-container>\n\n<!--############## USMLE Exam Engine Type ############################-->\n<ng-container *ngIf=\"examEngineType == 'USMLE'\">\n  <div class=\"wk-row\">\n    <div\n      class=\"wk-alert-info wk-alert-dismissible\"\n      *ngIf=\"hotspot == true\"\n      [ngStyle]=\"{\n        'background-color': selectedTheme == true ? 'black' : 'white',\n        color: selectedTheme == true ? 'white' : '#474747'\n      }\"\n    >\n      <button\n        type=\"button\"\n        (click)=\"hotspot = false\"\n        class=\"wk-icon-close-empty\"\n      ></button>\n      <span class=\"icon-size wk-icon-info-outline\" style=\"float: left;\"></span>\n      <span\n        >This question type does not comply with Accessibility Standards. This\n        type does not support navigation to the hotspot area via a keyboard nor\n        will a screen reader describe the image beyond reading its alternate\n        text.</span\n      >\n    </div>\n\n    <!--Question prompt text-->\n    <div class=\"wk-layout-item\">\n      <div class=\"wk-field-item normal-font mb0 \">\n        <div class=\"wk-field-header \">\n          <p class=\"mb20 normal-font wk-prewrap question-prompt-text\">\n            {{ questionDetails1.promptText }}\n          </p>\n        </div>\n        <div>\n          <hotspot-svg\n            [fontSize]=\"fontSize\"\n            [selectedTheme]=\"selectedTheme\"\n            [userAnswerDetails]=\"userAnswer\"\n            [isClearAnswer]=\"isClearAnswer\"\n            [imagePath]=\"imagePath\"\n            [imageType]=\"questionDetails1.assets[0].assetName\"\n            [imageSrc]=\"questionDetails1.assets[0].assetsContent\"\n            (userAnswerFromChild)=\"userAnswerValue($event)\"\n            [accessType]=\"selectAnswer\"\n          ></hotspot-svg>\n        </div>\n      </div>\n    </div>\n\n    <!--Your response and correct response-->\n    <ng-container *ngIf=\"checkQuizSubmission == true\">\n      <div class=\"wkqp-layout-item mb20  \">\n        <div class=\"wkqp-field-item\">\n          <div tabindex=\"0\">\n            <!--Your Response-->\n            <p\n              class=\"wkqp-prewrap \"\n              *ngIf=\"userAnswer.length !== 0\"\n              [ngClass]=\"\n                !correctAns\n                  ? 'wkqp-alert-danger wkqp-danger'\n                  : 'wkqp-alert-success wkqp-success'\n              \"\n            >\n              <strong>Your Response: </strong>\n            </p>\n            <div *ngIf=\"userAnswer.length !== 0\">\n              <hotspot-svg\n                [fontSize]=\"fontSize\"\n                [selectedTheme]=\"selectedTheme\"\n                [hideLabel]=\"true\"\n                [userAnswerDetails]=\"userAnswer\"\n                (userAnswerFromChild)=\"userAnswerValue($event)\"\n                [userAnswerDetails]=\"questionDetails1.userAttemptDetails\"\n                [isClearAnswer]=\"isClearAnswer\"\n                [imagePath]=\"imagePath\"\n                [imageType]=\"questionDetails1.assets[0].assetName\"\n                [imageSrc]=\"questionDetails1.assets[0].assetsContent\"\n                [isClearAnswer]=\"isClearAnswer\"\n                [accessType]=\"viewUserAnswer\"\n              ></hotspot-svg>\n            </div>\n\n            <!--Correct Response-->\n            <p\n              *ngIf=\"!correctAns\"\n              class=\"wkqp-prewrap  wkqp-alert-success wkqp-success\"\n            >\n              <strong>Correct Response: </strong>\n            </p>\n            <div *ngIf=\"!correctAns\">\n              <hotspot-svg\n                [fontSize]=\"fontSize\"\n                [selectedTheme]=\"selectedTheme\"\n                [hideLabel]=\"true\"\n                [correctAnswerDetails]=\"\n                  questionDetails1['graphicInteraction']['hotspotChoices']\n                    .length > 0\n                    ? questionDetails1['graphicInteraction'][\n                        'hotspotChoices'\n                      ][0]\n                    : []\n                \"\n                [isClearAnswer]=\"isClearAnswer\"\n                [imageType]=\"questionDetails1.assets[0].assetName\"\n                [imagePath]=\"imagePath\"\n                [imageSrc]=\"questionDetails1.assets[0].assetsContent\"\n                [accessType]=\"viewCorrectAnswer\"\n              ></hotspot-svg>\n            </div>\n\n            <!--Rationale-->\n            <p\n              class=\"correct-rationale-section\"\n              *ngIf=\"questionDetails1.modelFeedback[0].length !== 0\"\n            >\n              <strong>Rationale: </strong\n              >{{ questionDetails1.modelFeedback[0].feedbackText }}\n            </p>\n\n            <!--Remediation-->\n            <p\n              class=\"remediation-section\"\n              *ngIf=\"questionDetails1.remediationLinks.length !== 0\"\n            >\n              <strong>Remediation: </strong>\n            </p>\n            <div *ngFor=\"let remedies of questionDetails1.remediationLinks\">\n              <span *ngIf=\"questionDetails1.remediationLinks\">{{\n                remedies.linkText1\n              }}</span>\n            </div>\n          </div>\n        </div>\n      </div>\n    </ng-container>\n  </div>\n</ng-container>\n",
        styles: [""]
    })
], HotSpotComponent);

let FigureLabelingComponent = class FigureLabelingComponent {
    constructor(itemService, _DomSanitizationService, quizService) {
        this.itemService = itemService;
        this._DomSanitizationService = _DomSanitizationService;
        this.quizService = quizService;
        // Declare the variables
        this.userAnswer = [];
        this.assetData = [];
        this.duplicateKeyValue = false;
        this.questionDetails1 = [];
        this.hasAnswered = false;
        this.duplicatePresent = -1;
        this.duplicateIndexes = [];
        this.imagePath = [];
    }
    get questionDetails() {
        return this.questionDetails;
    }
    set questionCurrentData(value) {
        if (value) {
            this.questionDetails1 = value;
            this.userAnswer = [];
            this.correctOptions = [];
            this.createQuestion();
        }
        else {
            this.questionDetails1 = [];
            this.userAnswer = [];
            this.createQuestion();
        }
    }
    /* init */
    ngOnInit() { }
    ngOnChanges(changes) { }
    /* Do check */
    ngDoCheck() {
        if (this.isClearAnswer === true) {
            this.clearUserInputs();
            this.itemService.userAnswerMethod([]);
            this.itemService.clearAnswerMethodFalse(false);
            this.itemService.hideAnswer(false);
        }
        if (this.isShowHide === true) {
            this.message = true;
        }
        else if (this.isShowHide === false) {
            this.message = false;
        }
    }
    /* Shuffle */
    shuffle() {
        const properArray = [
            ...this.questionDetails1.graphicInteraction.figureLabelChoices
        ];
        let rand, index = -1;
        const length = properArray.length;
        const result = Array(length);
        while (++index < length) {
            rand = Math.floor(Math.random() * (index + 1));
            result[index] = result[rand];
            result[rand] = properArray[index];
            this.userAnswer[index] = '';
        }
        this.choiceArray = result;
    }
    /* Clear user inputs */
    clearUserInputs() {
        this.shuffle();
        this.itemService.duplicateValueMethod(false);
        this.itemService.validateCompleteEntryMethod(false);
    }
    /* Get choice class name */
    getChoiceClassName(choice, correctChoice) {
        const userChoice = Number(choice);
        if (choice === null || choice === '' || choice === '0') {
            return 'wk-icon-checkmark disabled-checkmark';
        }
        else if (userChoice === correctChoice) {
            return 'wk-icon-checkmark green-checkmark';
        }
        else {
            return 'wk-icon-close wrong-checkmark';
        }
    }
    /* Select answer */
    selectAnswer() {
        const checkAttempt = this.userAnswer.find(item => item !== '');
        this.userAnswer.forEach(element => {
            if (element !== null) {
                this.hasAnswered = true;
                const answerObj = checkAttempt === undefined && this.userAnswer.length !== 0
                    ? []
                    : this.userAnswer;
                this.itemService.userAnswerMethod(answerObj);
                this.itemService.validateAnswerValueMethod(this.checkingAnswer());
            }
            else {
                this.hasAnswered = false;
                this.itemService.userAnswerMethod([]);
                this.itemService.validateAnswerValueMethod(false);
                return;
            }
        });
    }
    /* Value changed */
    valueChanged() {
        const index = -1;
        if (this.questionDetails1.userAttemptDetails.userAnswer.length !== 0) {
            this.userAnswer = this.questionDetails1.userAttemptDetails.userAnswer.map(item => {
                if (item === 0 || item === '0' || !item) {
                    return (item = '');
                }
                else {
                    return item.toString();
                }
            });
        }
        const checkAttempt = this.userAnswer.find(item => item !== '');
        this.userAnswer.forEach(element => {
            if (element !== null) {
                this.hasAnswered = true;
                const answerObj = checkAttempt === undefined && this.userAnswer.length !== 0
                    ? []
                    : this.userAnswer;
                this.itemService.userAnswerMethod(answerObj);
                this.itemService.validateAnswerValueMethod(this.checkingAnswer());
            }
            else {
                this.hasAnswered = false;
                this.itemService.userAnswerMethod([]);
                this.itemService.validateAnswerValueMethod(false);
                return;
            }
        });
    }
    /* Checking answer */
    checkingAnswer() {
        const properArray = this.questionDetails1.graphicInteraction
            .figureLabelChoices;
        let check;
        if (this.userAnswer.length !== properArray.length) {
            check = false;
        }
        else {
            for (let i = 0; i < this.userAnswer.length; i++) {
                if (Number(this.userAnswer[i]) === properArray[i].choiceId) {
                    check = true;
                }
                else {
                    check = false;
                    return check;
                }
            }
        }
        return check;
    }
    /* Check duplicate values */
    checkDuplicate(index, abc) {
        this.duplicateIndexes = [];
        this.userAnswer.forEach((answer, ind) => {
            if (answer &&
                this.userAnswer.indexOf(answer) !== this.userAnswer.lastIndexOf(answer)) {
                this.duplicateIndexes.push(this.userAnswer.lastIndexOf(answer));
            }
        });
        this.itemService.duplicateValueMethod(this.duplicateIndexes.length > 0 ? true : false);
    }
    /* Check full entry */
    checkFullEntry() {
        const intialLength = this.userAnswer.length;
        this.isPartialEmpty =
            this.userAnswer.filter(item => item).length < intialLength ? true : false;
        this.iscompletlyEmpty =
            this.userAnswer.filter(item => item).length === 0 ? true : false;
        if (this.iscompletlyEmpty === true && this.isPartialEmpty === false) {
            this.itemService.validateCompleteEntryMethod(false);
        }
        else if (this.iscompletlyEmpty === false &&
            this.isPartialEmpty === true) {
            this.itemService.validateCompleteEntryMethod(true);
        }
        else {
            this.itemService.validateCompleteEntryMethod(false);
        }
    }
    createQuestion() {
        this.userAnswer = [];
        this.itemService.userAnswerMethod([]);
        this.itemService.validateAnswerValueMethod(false);
        this.itemService.userAnswerState.subscribe(answer => (this.userAnswerService = answer));
        this.itemService.duplicateValueMethod(false);
        this.itemService.duplicateValueState.subscribe(duplicate => (this.duplicateKeyValue = duplicate));
        this.correctOptions = [
            ...this.questionDetails1.graphicInteraction.figureLabelChoices
        ];
        this.assetData = this.questionDetails1.assets;
        this.checkingAnswer();
        this.shuffle();
        this.valueChanged();
    }
    splitStringForType(type, value) {
        const name = value.split('.')[1];
        switch (type) {
            case 'image':
                return `data:image/${name};base64,`;
            case 'audio':
                return `data:audio/${name};base64,`;
            case 'video':
                return `data:video/${name};base64,`;
            default:
                break;
        }
    }
    loadImagePath(assetType, slide) {
        if (this.quizService.isOnline) {
            return slide.assetPath;
        }
        return this.splitStringForType(assetType, slide.assetName) + slide.assetsContent;
    }
};
FigureLabelingComponent.ctorParameters = () => [
    { type: ItemService },
    { type: DomSanitizer },
    { type: QuizService }
];
__decorate([
    Input('questionDetails')
], FigureLabelingComponent.prototype, "questionCurrentData", null);
__decorate([
    Input()
], FigureLabelingComponent.prototype, "examEngineType", void 0);
__decorate([
    Input()
], FigureLabelingComponent.prototype, "canShowMetadata", void 0);
__decorate([
    Input()
], FigureLabelingComponent.prototype, "isClearAnswer", void 0);
__decorate([
    Input()
], FigureLabelingComponent.prototype, "isShowHide", void 0);
__decorate([
    Input()
], FigureLabelingComponent.prototype, "imagePath", void 0);
__decorate([
    Input()
], FigureLabelingComponent.prototype, "checkQuizSubmission", void 0);
__decorate([
    Input()
], FigureLabelingComponent.prototype, "selectedTheme", void 0);
__decorate([
    Input()
], FigureLabelingComponent.prototype, "fontSize", void 0);
__decorate([
    Input()
], FigureLabelingComponent.prototype, "preferredTextFormat", void 0);
FigureLabelingComponent = __decorate([
    Component({
        selector: 'figure-labeling',
        template: "<!--########################### QP Exam Engine type ####################-->\n<ng-container *ngIf=\"examEngineType == 'QP' || examEngineType == 'NCLEX'\">\n  <div class=\"wk-col-12\">\n    <div class=\"wk-layout-item mb20 wk-clear-box\">\n      <div class=\"wk-field-item \">\n        <!--Question Label Image-->\n        <div>\n          <figure-label\n            *ngIf=\"questionDetails1.assets[0].assetName\"\n            [correctOptions]=\"correctOptions\"\n            [userAnswer]=\"userAnswer\"\n            [imagePath]=\"imagePath\"\n            [assetData]=\"assetData\"\n          ></figure-label>\n        </div>\n        <div *ngIf=\"canShowMetadata && message != true\">\n          <lib-metadata [itemData]=\"questionDetails1\"></lib-metadata>\n        </div>\n        <p class=\"wkqp-prewrap mb20\" *ngIf=\"message && hasAnswered\">\n          <strong\n            [ngClass]=\"\n              checkingAnswer()\n                ? 'wkqp-alert-success wkqp-success'\n                : 'wkqp-alert-danger wkqp-danger'\n            \"\n          >\n            Your Response:\n          </strong>\n        </p>\n        <div class=\"wk-table-permit-overflow common-full-width mt10\">\n          <table class=\"wk-table assets-permit-mt25mb0\">\n            <thead>\n              <tr>\n                <th colspan=\"3\" class=\"figure-labeling-table-head\">\n                  Select the label that applies to the area marked with numbers\n                </th>\n              </tr>\n            </thead>\n            <tbody>\n              <tr\n                *ngFor=\"\n                  let labelDetails of questionDetails1.graphicInteraction\n                    .figureLabelChoices;\n                  let i = index\n                \"\n              >\n                <td width=\"10%\">\n                  <span class=\"wk-prewrap\">{{ i + 1 }}</span>\n                </td>\n                <td width=\"80%\">\n                  <div\n                    class=\"wk-select-field\"\n                    [class.wkqp-alert-error]=\"duplicateIndexes.indexOf(i) >= 0\"\n                  >\n                    <select\n                      attr.aria-label=\"Select the label {{ i + 1 }}\"\n                      id=\"figureLabel{{ i }}\"\n                      (change)=\"\n                        checkDuplicate(i, userAnswer[i]);\n                        selectAnswer();\n                        getChoiceClassName(\n                          userAnswer[i],\n                          labelDetails.choiceId\n                        );\n                        checkingAnswer();\n                        checkFullEntry()\n                      \"\n                      [(ngModel)]=\"userAnswer[i]\"\n                    >\n                      <option [value]=\"''\">Select</option>\n                      <option\n                        [value]=\"figureLabel.choiceId\"\n                        *ngFor=\"let figureLabel of choiceArray\"\n                        ><span\n                          libGetFormatText\n                          [preferredTextFormat]=\"preferredTextFormat\"\n                          [plainText]=\"figureLabel.label\"\n                          [richText]=\"figureLabel.richLabel\"\n                        ></span\n                      ></option>\n                    </select>\n                  </div>\n                  <div *ngIf=\"canShowMetadata\">\n                    <lib-metadata [itemData]=\"questionDetails1\"></lib-metadata>\n                  </div>\n                  <div\n                    class=\"wkqp-alert-info wkqp-prewrap correct-rationale-section wkqp-prewrap\"\n                    *ngIf=\"\n                      checkQuizSubmission == true && labelDetails.rationale\n                    \"\n                  >\n                    <strong>Rationale: </strong>\n                    <span\n                      libGetFormatText\n                      [preferredTextFormat]=\"preferredTextFormat\"\n                      [plainText]=\"labelDetails.rationale\"\n                      [richText]=\"labelDetails.richRationale\"\n                    ></span>\n                  </div>\n                </td>\n                <td *ngIf=\"message\">\n                  <span\n                    [ngClass]=\"\n                      getChoiceClassName(userAnswer[i], labelDetails.choiceId)\n                    \"\n                  ></span>\n                </td>\n              </tr>\n            </tbody>\n          </table>\n        </div>\n        <p\n          role=\"alert\"\n          aria-live=\"assertive\"\n          aria-atomic=\"(duplicateKeyValue)\"\n          class=\"wk-alert-danger\"\n          id=\"figureLabelError\"\n          *ngIf=\"duplicateIndexes.length != 0\"\n        >\n          <strong>\n            Error: Duplicate labels are selected\n          </strong>\n        </p>\n\n        <div class=\"wk-layout-item  mb20\" *ngIf=\"message\">\n          <div class=\"wk-field-item\">\n            <ng-container>\n              <p\n                class=\"wk-prewrap wkqp-alert-success wkqp-success mb20\"\n                *ngIf=\"!checkingAnswer()\"\n              >\n                <strong>Correct Response:</strong>\n              </p>\n              <img\n                [src]=\"loadImagePath('image', assetData[1])\"\n                class=\"img-responsive\"\n                alt=\"Image\"\n              />\n            </ng-container>\n          </div>\n        </div>\n      </div>\n      <div *ngIf=\"message\" class=\"common-full-width mb20\">\n        <lib-rationale\n          [itemData]=\"questionDetails1.modelFeedback\"\n          [preferredTextFormat]=\"preferredTextFormat\"\n        ></lib-rationale>\n\n        <lib-remediation\n          [itemData]=\"questionDetails1.remediationLinks\"\n          [preferredTextFormat]=\"preferredTextFormat\"\n        ></lib-remediation>\n      </div>\n    </div>\n  </div>\n</ng-container>\n\n<!--########################### USMLE Exam Engine type ####################-->\n<ng-container *ngIf=\"examEngineType == 'USMLE'\">\n  <div class=\"wk-col-12\">\n    <div class=\"wk-layout-item mb20 wk-clear-box\">\n      <div class=\"wk-field-item \">\n        <div>\n          <figure-label\n            *ngIf=\"questionDetails1.assets[0].assetName\"\n            [correctOptions]=\"correctOptions\"\n            [userAnswer]=\"userAnswer\"\n            [imagePath]=\"imagePath\"\n            [assetData]=\"assetData\"\n            [fontSize]=\"fontSize\"\n            [selectedTheme]=\"selectedTheme\"\n          ></figure-label>\n        </div>\n        <p\n          class=\"wk-prewrap \"\n          *ngIf=\"checkQuizSubmission == true && hasAnswered\"\n        >\n          <strong\n            [ngClass]=\"\n              checkingAnswer()\n                ? 'wkqp-alert-success wkqp-success'\n                : 'wkqp-alert-danger wkqp-danger'\n            \"\n          >\n            Your Response:\n          </strong>\n        </p>\n        <div class=\"wk-table-permit-overflow\">\n          <table class=\"wk-table assets-permit-mt25mb0\">\n            <thead>\n              <tr>\n                <th\n                  colspan=\"3\"\n                  class=\"figure-labeling-table-head\"\n                  [ngStyle]=\"{\n                    'background-color':\n                      selectedTheme == true ? 'black' : 'white',\n                    color: selectedTheme == true ? 'white' : '#474747',\n                    'font-size': fontSize\n                  }\"\n                >\n                  Select the label that applies to the area marked with numbers\n                </th>\n              </tr>\n            </thead>\n            <tbody>\n              <tr\n                *ngFor=\"\n                  let labelDetails of questionDetails1.graphicInteraction\n                    .figureLabelChoices;\n                  let i = index\n                \"\n              >\n                <td\n                  width=\"10%\"\n                  [ngStyle]=\"{\n                    'background-color':\n                      selectedTheme == true ? 'black' : 'white',\n                    color: selectedTheme == true ? 'white' : '#474747',\n                    'font-size': fontSize\n                  }\"\n                >\n                  <span class=\"wk-prewrap\">{{ i + 1 }}</span>\n                </td>\n                <td\n                  width=\"80%\"\n                  [ngStyle]=\"{\n                    'background-color':\n                      selectedTheme == true ? 'black' : 'white',\n                    color: selectedTheme == true ? 'white' : '#474747',\n                    'font-size': fontSize\n                  }\"\n                >\n                  <div\n                    class=\"wk-select-field\"\n                    [class.wkqp-alert-error]=\"duplicateIndexes.indexOf(i) >= 0\"\n                  >\n                    <select\n                      attr.aria-label=\"Select the label {{ i + 1 }}\"\n                      id=\"figureLabel{{ i }}\"\n                      (change)=\"\n                        selectAnswer();\n                        getChoiceClassName(\n                          userAnswer[i],\n                          labelDetails.choiceId\n                        );\n                        checkDuplicate(i, userAnswer[i]);\n                        checkingAnswer();\n                        checkFullEntry()\n                      \"\n                      [(ngModel)]=\"userAnswer[i]\"\n                      [ngStyle]=\"{\n                        'background-color':\n                          selectedTheme == true ? 'black' : 'white',\n                        color: selectedTheme == true ? 'white' : '#474747'\n                      }\"\n                    >\n                      <option [value]=\"''\">Select</option>\n                      <option\n                        [value]=\"figureLabel.choiceId\"\n                        *ngFor=\"let figureLabel of choiceArray\"\n                        >{{ figureLabel.label }}</option\n                      >\n                    </select>\n                  </div>\n                  <div\n                    class=\"wkqp-alert-info wkqp-prewrap correct-rationale-section wkqp-prewrap\"\n                    *ngIf=\"\n                      checkQuizSubmission == true && labelDetails.rationale\n                    \"\n                  >\n                    <strong>Rationale: </strong>{{ labelDetails.rationale }}\n                  </div>\n                </td>\n                <td *ngIf=\"checkQuizSubmission == true\">\n                  <span\n                    [ngClass]=\"\n                      getChoiceClassName(userAnswer[i], labelDetails.choiceId)\n                    \"\n                  ></span>\n                </td>\n              </tr>\n            </tbody>\n          </table>\n        </div>\n        <p\n          role=\"alert\"\n          aria-live=\"assertive\"\n          aria-label=\"Duplicate labels are selected\"\n          aria-atomic=\"true\"\n          class=\"wk-alert-danger\"\n          id=\"figureLabelError\"\n          *ngIf=\"duplicateIndexes.length != 0\"\n        >\n          <strong>\n            Error: Duplicate labels are selected\n          </strong>\n        </p>\n\n        <div class=\"wk-layout-item mb20  \" *ngIf=\"checkQuizSubmission == true\">\n          <div class=\"wk-field-item\">\n            <ng-container>\n              <p class=\"wk-prewrap wkqp-alert-success wkqp-success\">\n                <strong>Correct Response:</strong>\n              </p>\n              <img\n                [src]=\"loadImagePath('image', assetData[1])\"\n                class=\"img-responsive\"\n                alt=\"Image\"\n                width=\"300px\"\n              />\n              <p\n                *ngIf=\"\n                  questionDetails1.modelFeedback[0] &&\n                  questionDetails1.modelFeedback[0].length !== 0\n                \"\n              >\n                <strong>Rationale: </strong>\n                <span>{{\n                  questionDetails1.modelFeedback[0].feedbackText\n                }}</span>\n              </p>\n              <div\n                *ngIf=\"\n                  questionDetails1.remediationLinks &&\n                  questionDetails1.remediationLinks.length !== 0\n                \"\n              >\n                <strong>Remediation:</strong>\n                <div\n                  *ngFor=\"\n                    let Remediation of questionDetails1.remediationLinks;\n                    let k = index\n                  \"\n                >\n                  <span *ngIf=\"Remediation.linkTypeId == 1\">{{\n                    Remediation.linkText1\n                  }}</span>\n                  <span *ngIf=\"Remediation.linkTypeId != 1\">\n                    {{ Remediation.linkText1 }}</span\n                  >\n                </div>\n              </div>\n            </ng-container>\n          </div>\n        </div>\n      </div>\n    </div>\n  </div>\n</ng-container>\n",
        styles: [".wkqp-table>tfoot>tr>th,.wkqp-table>thead>tr>th.figure-labeling-table-head{text-transform:none;font-size:16px;font-family:'Helvetica Neue',Helvetica,Roboto,Arial,sans-serif!important}.wk-alert-danger{border:0;color:#e5202e;font-size:.87891rem;font-style:italic}.figure-labeling-table-head{font-size:16px}:focus{outline:-webkit-focus-ring-color auto 1px;outline:-moz-focus-ring-color auto 1px;border:none}@-moz-document url-prefix(){.wk-select-field>select:focus{box-shadow:0 0 2px #5f67ff;border:1px solid #5f67ff}}.wkqp-alert-error select{border:1px solid red!important;outline:0}"]
    })
], FigureLabelingComponent);

let DragAndDropComponent = class DragAndDropComponent {
    constructor(itemService) {
        this.itemService = itemService;
        // Declare the variables
        this.userAnswer = [];
        this.orginalArray = [];
        this.correctAns = [];
        this.properArray = [];
        this.shuffledArray = [];
        this.userActions = false;
        this.assetData = [];
        this.questionDetails1 = [];
        this.assetPosition = [];
        this.dropDownValues = [];
        this.choiceDropDown = [];
        this.selectedItem = {
            itemPosition: "",
            index: 0
        };
        this.todo = [];
        this.done = [];
        this.answerRefArr = [];
        this.imagePath = [];
    }
    get questionDetails() {
        return this.questionDetails;
    }
    set questionCurrentData(value) {
        if (value) {
            this.questionDetails1 = value;
            this.createQuestion();
        }
        else {
            this.questionDetails1 = [];
            this.createQuestion();
        }
    }
    /* Init */
    ngOnInit() { }
    ngOnChanges(changes) { }
    /* Do check */
    ngDoCheck() {
        // Clear user req
        if (this.isClearAnswer === true) {
            this.clearUserInputs();
            this.itemService.userAnswerMethod([]);
            this.itemService.clearAnswerMethodFalse(false);
            this.itemService.hideAnswer(false);
        }
        // Show or hide answer request
        if (this.isShowHide === true) {
            this.message = true;
            if (this.message) {
                this.userActions = this.compareOrginalArrayToUserArray();
            }
        }
        else if (this.isShowHide === false) {
            this.message = false;
        }
    }
    /* Comparing the original array to user array */
    compareOrginalArrayToUserArray() {
        if (this.templateType === 1) {
            for (let i = 0, length = this.orginalArray.length; i < length; i++) {
                if (this.shuffledArray[i].choiceId !== this.orginalArray[i].choiceId) {
                    return true;
                }
            }
            return false;
        }
        else {
            if (this.done.length > 0) {
                return true;
            }
            return false;
        }
    }
    /* Checking the order */
    checkingOrder() {
        let userArray = [];
        const userArray1 = [];
        this.userActions = this.compareOrginalArrayToUserArray();
        if (this.userActions === true) {
            this.userAnswer = this.shuffledArray;
            userArray = this.userAnswer;
            userArray.map(element => {
                userArray1.push(element.choiceId);
            });
            const answerObj = userArray1;
            this.itemService.userAnswerMethod(answerObj);
            this.itemService.validateAnswerValueMethod(this.validateUserAnswer());
        }
        else {
            this.userAnswer = [];
            this.itemService.userAnswerMethod([]);
            this.itemService.validateAnswerValueMethod(false);
        }
        for (let i = 0, length = this.correctAns.length; i < length; i++) {
            if (this.userAnswer[i] !== this.correctAns[i]) {
                return false;
            }
        }
        return true;
    }
    /* Clear the user inputs */
    clearUserInputs() {
        if (this.templateType == 2) {
            this.questionDetails1.userAttemptDetails.userAnswer = [];
        }
        this.createQuestion();
        this.shuffledArray = [
            ...this.questionDetails1.choiceInteraction.simpleChoices
        ];
        this.itemService.hideAnswer(false);
    }
    /* Check the value changes */
    valueChanged() {
        let userArray = [];
        const userArray1 = [];
        if (this.templateType === 1) {
            if (this.questionDetails1.userAttemptDetails.userAnswer.length > 0) {
                for (const i of this.questionDetails1.userAttemptDetails.userAnswer) {
                    for (const item of this.questionDetails1.choiceInteraction
                        .simpleChoices) {
                        if (i === item.choiceId) {
                            this.shuffledArray.push(item);
                        }
                    }
                }
                this.userAnswer = this.shuffledArray;
            }
            else {
                this.shuffledArray = [
                    ...this.questionDetails1.choiceInteraction.simpleChoices
                ];
                this.userAnswer = [];
            }
        }
        else {
            if (this.questionDetails1.userAttemptDetails.userAnswer.length !== 0) {
                //set the user answer in done list first
                this.questionDetails1.userAttemptDetails.userAnswer.forEach(answerVal => {
                    const item = this.questionDetails1.choiceInteraction.simpleChoices.find(choice => choice.choiceId == answerVal);
                    if (item) {
                        this.done.push(item);
                    }
                });
                for (const item of this.questionDetails1.choiceInteraction
                    .simpleChoices) {
                    if (this.questionDetails1.userAttemptDetails.userAnswer.indexOf(item.choiceId) < 0) {
                        this.todo.push(item);
                    }
                }
                this.userAnswer = this.done;
            }
            else {
                this.todo = [...this.questionDetails1.choiceInteraction.simpleChoices];
                this.done = [];
                this.userAnswer = [];
            }
        }
        // Call the service to form the user answer
        if (this.userAnswer.length !== 0) {
            userArray = this.userAnswer;
            userArray.map(element => {
                userArray1.push(element.choiceId);
            });
            const answerObj = userArray1;
            this.itemService.userAnswerMethod(answerObj);
            this.itemService.validateAnswerValueMethod(this.validateUserAnswer());
        }
        else {
            this.itemService.userAnswerMethod([]);
            this.itemService.validateAnswerValueMethod(false);
        }
    }
    // Check the empty assets
    checkEmptyAsset() {
        return Object.keys(this.assetData).length === 0;
    }
    createQuestion() {
        this.userAnswer = [];
        this.shuffledArray = [];
        this.orginalArray = [];
        this.correctAns = [];
        this.dropDownValues = [];
        this.choiceDropDown = [];
        this.todo = [];
        this.answerRefArr = [];
        this.done = [];
        this.itemService.userAnswerMethod([]);
        this.itemService.validateAnswerValueMethod(false);
        this.templateType = this.questionDetails1.template;
        /**End Template2 configuration */
        this.itemService.userAnswerState.subscribe(answer => (this.userAnswerService = answer));
        this.assetData = this.questionDetails1.assets;
        if (this.assetData.length !== 0) {
            this.assetPosition = this.questionDetails1.assets[0]["assetsPosition"];
        }
        this.correctAns = [
            ...this.questionDetails1.choiceInteraction.simpleChoices
        ];
        this.correctAns.sort((a, b) => {
            return a.order - b.order;
        });
        this.orginalArray = [
            ...this.questionDetails1.choiceInteraction.simpleChoices
        ];
        for (let i = 0; i < this.orginalArray.length; i++) {
            this.choiceDropDown.push(i + 1);
            this.dropDownValues.push(i + 1);
        }
        this.valueChanged();
    }
    validateUserAnswer() {
        for (let i = 0, length = this.correctAns.length; i < length; i++) {
            if (this.userAnswer[i] !== this.correctAns[i]) {
                return false;
            }
        }
        return true;
    }
    drop(event) {
        if (this.templateType === 1) {
            moveItemInArray(this.shuffledArray, event.previousIndex, event.currentIndex);
        }
        else {
            if (event.previousContainer === event.container) {
                moveItemInArray(event.container.data, event.previousIndex, event.currentIndex);
            }
            else {
                transferArrayItem(event.previousContainer.data, event.container.data, event.previousIndex, event.currentIndex);
            }
            this.selectItem("", null);
        }
    }
    sortByDropdown(oldValue, newValue) {
        this.dropDownValues[oldValue] = oldValue + 1;
        moveItemInArray(this.shuffledArray, Number(oldValue), Number(newValue - 1));
    }
    /**Functions for template2 actions */
    selectItem(position, index) {
        this.selectedItem.itemPosition = position;
        this.selectedItem.index = index;
    }
    moveToDoneList() {
        if (this.selectedItem.itemPosition === "LEFT" &&
            this.selectedItem.index >= 0) {
            this.done.push(this.todo[this.selectedItem.index]);
            this.todo.splice(this.selectedItem.index, 1);
        }
        else if (this.selectedItem.itemPosition === "RIGHT" &&
            this.selectedItem.index >= 0) {
            this.todo.push(this.done[this.selectedItem.index]);
            this.done.splice(this.selectedItem.index, 1);
        }
        else {
        }
        this.checkingOrderTemplate2();
        this.selectItem("", null);
    }
    moveSelectedItem(action) {
        if (action === "UP") {
            let temp = this.done[this.selectedItem.index];
            this.done[this.selectedItem.index] = this.done[this.selectedItem.index - 1];
            this.done[this.selectedItem.index - 1] = temp;
        }
        else {
            let temp = this.done[this.selectedItem.index];
            this.done[this.selectedItem.index] = this.done[this.selectedItem.index + 1];
            this.done[this.selectedItem.index + 1] = temp;
        }
        this.checkingOrderTemplate2();
        this.selectItem("", null);
    }
    validateButtons(arrow) {
        if (this.done.length < 2 || !this.selectedItem.itemPosition) {
            return true;
        }
        else {
            if (arrow === "UP") {
                if (this.selectedItem.itemPosition === "LEFT" ||
                    (this.selectedItem.itemPosition === "RIGHT" &&
                        this.selectedItem.index == 0)) {
                    return true;
                }
                else {
                    return false;
                }
            }
            else {
                if (this.selectedItem.itemPosition === "LEFT" ||
                    (this.selectedItem.itemPosition === "RIGHT" &&
                        this.selectedItem.index == this.done.length - 1)) {
                    return true;
                }
                else {
                    return false;
                }
            }
        }
    }
    checkingOrderTemplate2() {
        let userArray = [];
        const userArray1 = [];
        this.userActions = this.compareOrginalArrayToUserArray();
        if (this.userActions === true) {
            this.userAnswer = this.done;
            userArray = this.userAnswer;
            userArray.map(element => {
                userArray1.push(element.choiceId);
            });
            const answerObj = userArray1;
            this.itemService.userAnswerMethod(answerObj);
            this.itemService.validateAnswerValueMethod(this.checkUserAnswer());
        }
        else {
            this.userAnswer = [];
            this.itemService.userAnswerMethod([]);
            this.itemService.validateAnswerValueMethod(false);
        }
        for (let i = 0, length = this.correctAns.length; i < length; i++) {
            if (this.userAnswer[i] !== this.correctAns[i]) {
                return false;
            }
        }
        return true;
    }
    checkUserAnswer() {
        for (let i = 0, length = this.correctAns.length; i < length; i++) {
            if (this.userAnswer[i] !== this.correctAns[i]) {
                return false;
            }
        }
        return true;
    }
};
DragAndDropComponent.ctorParameters = () => [
    { type: ItemService }
];
__decorate([
    Input("questionDetails")
], DragAndDropComponent.prototype, "questionCurrentData", null);
__decorate([
    Input()
], DragAndDropComponent.prototype, "examEngineType", void 0);
__decorate([
    Input()
], DragAndDropComponent.prototype, "canShowMetadata", void 0);
__decorate([
    Input()
], DragAndDropComponent.prototype, "isClearAnswer", void 0);
__decorate([
    Input()
], DragAndDropComponent.prototype, "isShowHide", void 0);
__decorate([
    Input()
], DragAndDropComponent.prototype, "imagePath", void 0);
__decorate([
    Input()
], DragAndDropComponent.prototype, "checkQuizSubmission", void 0);
__decorate([
    Input()
], DragAndDropComponent.prototype, "selectedTheme", void 0);
__decorate([
    Input()
], DragAndDropComponent.prototype, "fontSize", void 0);
__decorate([
    Input()
], DragAndDropComponent.prototype, "preferredTextFormat", void 0);
DragAndDropComponent = __decorate([
    Component({
        selector: "drag-and-drop",
        template: "<!--######################## QP Exam Engine Type ########################s-->\n<ng-container *ngIf=\"examEngineType == 'QP'\">\n  <div class=\"wk-row\">\n    <media-carousel\n      [imagePath]=\"imagePath\"\n      [assetData]=\"questionDetails1.assets\"\n      [assetsPosition]=\"assetPosition\"\n      *ngIf=\"\n        questionDetails1.assets &&\n        questionDetails1.assets.length != 0 &&\n        assetPosition != 'Bottom' &&\n        assetPosition != 'WithinText'\n      \"\n    ></media-carousel>\n    <div\n      style=\"margin-right:0px;\"\n      [ngClass]=\"{\n        'drag-drop-ull-width':\n          questionDetails1.assets.length != undefined &&\n          questionDetails1.assets.length != 0,\n        'wk-col-12':\n          questionDetails1.assets == undefined ||\n          questionDetails1.assets.length == 0 ||\n          assetPosition == 'WithinText',\n        'drag-drop-right-wk-col-8 right-assets-position-question':\n          assetPosition == 'Right',\n        'left-assets-position-question wk-column-8-width ':\n          assetPosition == 'Left',\n        'top-assets-position-question': assetPosition == 'Top',\n        'bottom-assets-position-question': assetPosition == 'Bottom'\n      }\"\n    >\n      <div class=\"wkqp-layout-item\">\n        <div class=\"wkqp-field-item normal-font mb0\">\n          <media-carousel\n            [imagePath]=\"imagePath\"\n            [assetData]=\"questionDetails1.assets\"\n            [assetsPosition]=\"assetPosition\"\n            *ngIf=\"\n              questionDetails1.assets &&\n              questionDetails1.assets.length != 0 &&\n              assetPosition == 'Bottom' &&\n              assetPosition != 'WithinText'\n            \"\n          ></media-carousel>\n          <!--Question text-->\n          <div class=\"msg-draganddrop\">\n            Arrange the answers into the correct order. Mouse user arrange by\n            clicking and dragging each answer to the desired location. Keyboard\n            user can arrange though drop down by selecting the right order.\n          </div>\n          <br /><br />\n          <div class=\"wkqp-field-header\" *ngIf=\"assetPosition != 'WithinText'\">\n            <div\n              class=\"mb20 normal-font wkqp-prewrap heading-h2\"\n              libGetFormatText\n              [preferredTextFormat]=\"preferredTextFormat\"\n              [plainText]=\"questionDetails1.promptText\"\n              [richText]=\"questionDetails1.richPromptText\"\n            ></div>\n          </div>\n          <div class=\"wkqp-field-header\" *ngIf=\"assetPosition == 'WithinText'\">\n            <item-text-assets\n              [promptText]=\"questionDetails1.promptText\"\n              [imagePath]=\"imagePath\"\n              [assetData]=\"assetData\"\n              [assetsPosition]=\"assetPosition\"\n            ></item-text-assets>\n          </div>\n          <!-- <bs-sortable [(ngModel)]=\"shuffledArray\" fieldName=\"label\" itemClass=\"dragdrop-anslabel\" itemActiveClass=\"sortable-item-active\"\n            placeholderItem=\"Drag here\" placeholderClass=\"sortable-item\" wrapperClass=\"sortable-wrapper\" (onChange)=\"checkingOrder();\">\n          </bs-sortable> -->\n          <!-- Template 1 -->\n          <ng-container *ngIf=\"templateType == 1\">\n            <div\n              cdkDropList\n              class=\"example-list\n              bottom-assets-position-question\"\n              (cdkDropListDropped)=\"drop($event); checkingOrder()\"\n            >\n              <ng-container *ngFor=\"let choice of shuffledArray; let i = index\">\n                <div class=\"dragdrop-anslabel\" cdkDrag>\n                  <!-- <span class=\"glyphicon glyphicon-th-list\"></span> {{choice.label}} -->\n                  <div class=\"drag-and-drop-left\">\n                    <span\n                      libGetFormatText\n                      [preferredTextFormat]=\"preferredTextFormat\"\n                      [plainText]=\"choice.label\"\n                      [richText]=\"choice.richLabel\"\n                    ></span>\n                  </div>\n                  <div class=\"wk-select-field dd-jump-order jump-order-select\">\n                    <select\n                      name=\"indexDropDown\"\n                      class=\"form-control\"\n                      [(ngModel)]=\"dropDownValues[i]\"\n                      (change)=\"\n                        sortByDropdown(i, dropDownValues[i]); checkingOrder()\n                      \"\n                    >\n                      <option\n                        [value]=\"item\"\n                        *ngFor=\"let item of choiceDropDown; let j = index\"\n                        >{{ item }}</option\n                      >\n                    </select>\n                  </div>\n                </div>\n                <div\n                  class=\"wkqp-alert-info wkqp-prewrap correct-rationale-section wkqp-prewrap mb-15\"\n                  *ngIf=\"\n                    (checkQuizSubmission == true || message) && choice.rationale\n                  \"\n                >\n                  <strong>Rationale: </strong>\n                  <span\n                    libGetFormatText\n                    [preferredTextFormat]=\"preferredTextFormat\"\n                    [plainText]=\"choice.rationale\"\n                    [richText]=\"choice.richRationale\"\n                  ></span>\n                </div>\n              </ng-container>\n            </div>\n          </ng-container>\n\n          <!-- Template 2 -->\n          <ng-container *ngIf=\"templateType == 2\">\n            <div class=\"wk-row\">\n              <div class=\"slide-left\">\n                <div\n                  cdkDropList\n                  #todoList=\"cdkDropList\"\n                  [cdkDropListData]=\"todo\"\n                  [cdkDropListConnectedTo]=\"[doneList]\"\n                  (cdkDropListDropped)=\"drop($event); checkingOrderTemplate2()\"\n                  class=\"drag-drop-div\"\n                >\n                  <div\n                    class=\"example-box-temp2\"\n                    *ngFor=\"let item of todo; let i = index\"\n                    cdkDrag\n                    (click)=\"selectItem('LEFT', i)\"\n                    [class.selected-box]=\"\n                      selectedItem.itemPosition === 'LEFT' &&\n                      selectedItem.index == i\n                    \"\n                  >\n                    <span\n                      libGetFormatText\n                      [preferredTextFormat]=\"preferredTextFormat\"\n                      [plainText]=\"item.label\"\n                      [richText]=\"item.richLabel\"\n                    ></span>\n                  </div>\n                </div>\n              </div>\n              <div class=\"slide-center\">\n                <div class=\"drag-drop-btn-wrap\">\n                  <button\n                    class=\"drag-drop-right-arrow-btn\"\n                    [disabled]=\"true\"\n                    *ngIf=\"!selectedItem.itemPosition\"\n                  >\n                    <span class=\"wk-icon-angle-right\"></span>\n                  </button>\n                </div>\n                <div class=\"drag-drop-btn-wrap\">\n                  <button\n                    class=\"wkqp-button wk-button-primary drag-drop-select-btn-arrow\"\n                    (click)=\"moveToDoneList()\"\n                    *ngIf=\"selectedItem.itemPosition === 'LEFT'\"\n                  >\n                    <span class=\"wk-icon-angle-right\"></span>\n                  </button>\n                </div>\n                <button\n                  class=\"wkqp-button wk-button-primary\"\n                  (click)=\"moveToDoneList()\"\n                  *ngIf=\"selectedItem.itemPosition === 'RIGHT'\"\n                >\n                  <span class=\"wk-icon-angle-left\"></span>\n                </button>\n              </div>\n              <div class=\"slide-right\">\n                <div\n                  cdkDropList\n                  #doneList=\"cdkDropList\"\n                  [cdkDropListData]=\"done\"\n                  [cdkDropListConnectedTo]=\"[todoList]\"\n                  (cdkDropListDropped)=\"drop($event); checkingOrderTemplate2()\"\n                  class=\"drag-drop-div\"\n                >\n                  <div\n                    class=\"example-box-temp2\"\n                    *ngFor=\"let item of done; let i = index\"\n                    cdkDrag\n                    (click)=\"selectItem('RIGHT', i)\"\n                    [class.selected-box]=\"\n                      selectedItem.itemPosition === 'RIGHT' &&\n                      selectedItem.index == i\n                    \"\n                  >\n                    <span\n                      libGetFormatText\n                      [preferredTextFormat]=\"preferredTextFormat\"\n                      [plainText]=\"item.label\"\n                      [richText]=\"item.richLabel\"\n                    ></span>\n                  </div>\n                </div>\n              </div>\n              <div class=\"slide-upanddown\" *ngIf=\"done.length > 0\">\n                <div class=\"slide-up\">\n                  <button\n                    class=\"up-arrow-btn\"\n                    (click)=\"moveSelectedItem('UP')\"\n                    [hidden]=\"validateButtons('UP')\"\n                  >\n                    <span class=\"wk-icon-angle-up\"></span>\n                  </button>\n                </div>\n                <div class=\"slide-down\">\n                  <button\n                    class=\"down-arrow-btn\"\n                    (click)=\"moveSelectedItem('DOWN')\"\n                    [hidden]=\"validateButtons('DOWN')\"\n                  >\n                    <span class=\"wk-icon-angle-down\"></span>\n                  </button>\n                </div>\n              </div>\n            </div>\n          </ng-container>\n        </div>\n        <div *ngIf=\"canShowMetadata && message != true\">\n          <lib-metadata [itemData]=\"questionDetails1\"></lib-metadata>\n        </div>\n        <!--User answer and correct answer Block-->\n        <ng-container *ngIf=\"message\">\n          <p\n            class=\"wkqp-prewrap  mb20\"\n            [ngClass]=\"\n              checkingOrder()\n                ? 'wkqp-alert-success wkqp-success'\n                : 'wkqp-alert-danger wkqp-danger'\n            \"\n            *ngIf=\"userActions && templateType == 1\"\n          >\n            <strong>Your Response:</strong>\n          </p>\n          <p\n            class=\"wkqp-prewrap  mb20\"\n            [ngClass]=\"\n              checkingOrderTemplate2()\n                ? 'wkqp-alert-success\n            wkqp-success'\n                : 'wkqp-alert-danger wkqp-danger'\n            \"\n            *ngIf=\"userActions && templateType == 2\"\n          >\n            <strong>Your Response:</strong>\n          </p>\n          <div *ngIf=\"userActions\" class=\"mb20\">\n            <div *ngFor=\"let item of userAnswer; let i = index\">\n              <span class=\"pr1rem\">{{ i + 1 }}) </span>\n              <span\n                libGetFormatText\n                [preferredTextFormat]=\"preferredTextFormat\"\n                [plainText]=\"item.label\"\n                [richText]=\"item.richLabel\"\n              ></span>\n            </div>\n          </div>\n          <p\n            class=\"wkqp-prewrap wkqp-alert-success wkqp-success  mb20\"\n            *ngIf=\"\n              templateType == 1 ? !checkingOrder() : !checkingOrderTemplate2()\n            \"\n          >\n            <strong>Correct Response:</strong>\n          </p>\n          <div\n            *ngIf=\"\n              templateType == 1 ? !checkingOrder() : !checkingOrderTemplate2()\n            \"\n            class=\"mb20\"\n          >\n            <div *ngFor=\"let item of correctAns; let i = index\">\n              <span class=\"pr1rem\">{{ i + 1 }}) </span>\n              <span\n                libGetFormatText\n                [preferredTextFormat]=\"preferredTextFormat\"\n                [plainText]=\"item.label\"\n                [richText]=\"item.richLabel\"\n              ></span>\n            </div>\n          </div>\n          <div *ngIf=\"canShowMetadata\">\n            <lib-metadata [itemData]=\"questionDetails1\"></lib-metadata>\n          </div>\n        </ng-container>\n      </div>\n    </div>\n    <div class=\"rationale-remedation-block mb20\" *ngIf=\"message\">\n      <lib-rationale\n        [itemData]=\"questionDetails1.modelFeedback\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></lib-rationale>\n\n      <lib-remediation\n        [itemData]=\"questionDetails1.remediationLinks\"\n        [preferredTextFormat]=\"preferredTextFormat\"\n      ></lib-remediation>\n    </div>\n  </div>\n</ng-container>\n\n<!--######################## USMLE Exam Engine Type ########################s-->\n<ng-container *ngIf=\"examEngineType == 'USMLE'\">\n  <div class=\"wk-row\">\n    <media-carousel\n      [imagePath]=\"imagePath\"\n      [assetData]=\"questionDetails1.assets\"\n      [assetsPosition]=\"assetPosition\"\n      *ngIf=\"\n        questionDetails1.assets &&\n        questionDetails1.assets.length != 0 &&\n        assetPosition != 'Bottom' &&\n        assetPosition != 'WithinText'\n      \"\n    ></media-carousel>\n    <div\n      style=\"margin-right:0px;\"\n      [ngClass]=\"{\n        'wk-col-8':\n          questionDetails1.assets.length != undefined &&\n          questionDetails1.assets.length != 0,\n        'wk-col-12':\n          questionDetails1.assets == undefined ||\n          questionDetails1.assets.length == 0 ||\n          assetPosition == 'WithinText',\n        'right-assets-position-question': assetPosition == 'Right',\n        'left-assets-position-question': assetPosition == 'Left',\n        'top-assets-position-question': assetPosition == 'Top',\n        'bottom-assets-position-question': assetPosition == 'Bottom'\n      }\"\n    >\n      <div class=\"wkqp-layout-item\">\n        <div class=\"wkqp-field-item normal-font mb0\">\n          <media-carousel\n            [imagePath]=\"imagePath\"\n            [assetData]=\"questionDetails1.assets\"\n            [assetsPosition]=\"assetPosition\"\n            *ngIf=\"\n              questionDetails1.assets &&\n              questionDetails1.assets.length != 0 &&\n              assetPosition == 'Bottom' &&\n              assetPosition != 'WithinText'\n            \"\n          ></media-carousel>\n          <!--Question text-->\n          <div\n            class=\"msg-draganddrop\"\n            [ngStyle]=\"{\n              'background-color': selectedTheme == true ? 'black' : 'white',\n              color: selectedTheme == true ? 'white' : '#474747'\n            }\"\n          >\n            Arrange the answers into the correct order. Mouse user arrange by\n            clicking and dragging each answer to the desired location. Keyboard\n            user can arrange though drop down by selecting the right order.\n          </div>\n          <br /><br />\n          <div class=\"wkqp-field-header\" *ngIf=\"assetPosition != 'WithinText'\">\n            <div class=\"mb20 normal-font wkqp-prewrap heading-h2\">\n              {{ questionDetails1.promptText }}\n            </div>\n          </div>\n          <div class=\"wkqp-field-header\" *ngIf=\"assetPosition == 'WithinText'\">\n            <item-text-assets\n              [promptText]=\"questionDetails1.promptText\"\n              [imagePath]=\"imagePath\"\n              [assetData]=\"assetData\"\n              [assetsPosition]=\"assetPosition\"\n            ></item-text-assets>\n          </div>\n\n          <ng-container *ngIf=\"templateType == 1\">\n            <div\n              cdkDropList\n              class=\"example-list bottom-assets-position-question\"\n              (cdkDropListDropped)=\"drop($event); checkingOrder()\"\n            >\n              <ng-container *ngFor=\"let choice of shuffledArray; let i = index\">\n                <div\n                  class=\"dragdrop-anslabel\"\n                  cdkDrag\n                  [ngStyle]=\"{\n                    'background-color':\n                      selectedTheme == true ? 'black' : 'white',\n                    color: selectedTheme == true ? 'white' : '#474747',\n                    'font-size': fontSize\n                  }\"\n                >\n                  <!-- <span class=\"glyphicon glyphicon-th-list\"></span> {{choice.label}} -->\n                  <div class=\"drag-and-drop-left\">\n                    <span>{{ choice.label }}</span>\n                  </div>\n                  <div class=\"wkqp-select-field dd-jump-order\">\n                    <select\n                      name=\"indexDropDown\"\n                      class=\"form-control\"\n                      [(ngModel)]=\"dropDownValues[i]\"\n                      (change)=\"\n                        sortByDropdown(i, dropDownValues[i]); checkingOrder()\n                      \"\n                    >\n                      <option\n                        [value]=\"item\"\n                        *ngFor=\"let item of choiceDropDown; let j = index\"\n                        >{{ item }}</option\n                      >\n                    </select>\n                  </div>\n                </div>\n                <div\n                  class=\"wkqp-alert-info wkqp-prewrap correct-rationale-section wkqp-prewrap mb-10\"\n                  *ngIf=\"\n                    (checkQuizSubmission == true || message) && choice.rationale\n                  \"\n                >\n                  <strong>Rationale: </strong>{{ choice.rationale }}\n                </div>\n              </ng-container>\n            </div>\n          </ng-container>\n\n          <!-- Template 2 -->\n          <ng-container *ngIf=\"templateType == 2\">\n            <div class=\"wk-row\">\n              <div class=\"wk-col-4\">\n                <div class=\"example-container-temp2\">\n                  <div\n                    cdkDropList\n                    #todoList=\"cdkDropList\"\n                    [cdkDropListData]=\"todo\"\n                    [cdkDropListConnectedTo]=\"[doneList]\"\n                    class=\"example-list-temp2\"\n                    (cdkDropListDropped)=\"\n                      drop($event); checkingOrderTemplate2()\n                    \"\n                    [ngStyle]=\"{\n                      'background-color':\n                        selectedTheme == true ? 'black' : 'white',\n                      color: selectedTheme == true ? 'white' : '#474747',\n                      'font-size': fontSize\n                    }\"\n                  >\n                    <div\n                      class=\"example-box-temp2\"\n                      *ngFor=\"let item of todo; let i = index\"\n                      cdkDrag\n                      (click)=\"selectItem('LEFT', i)\"\n                      [class.selected-box]=\"\n                        selectedItem.itemPosition === 'LEFT' &&\n                        selectedItem.index == i\n                      \"\n                    >\n                      {{ item.label }}\n                    </div>\n                  </div>\n                </div>\n              </div>\n              <div class=\"wk-col-1\">\n                <button\n                  class=\"wkqp-button wk-button-primary\"\n                  [disabled]=\"true\"\n                  *ngIf=\"!selectedItem.itemPosition\"\n                >\n                  <span class=\"wk-icon-angle-right\"></span>\n                </button>\n\n                <button\n                  class=\"wkqp-button wk-button-primary\"\n                  (click)=\"moveToDoneList()\"\n                  *ngIf=\"selectedItem.itemPosition === 'LEFT'\"\n                >\n                  <span class=\"wk-icon-angle-right\"></span>\n                </button>\n\n                <button\n                  class=\"wkqp-button wk-button-primary\"\n                  (click)=\"moveToDoneList()\"\n                  *ngIf=\"selectedItem.itemPosition === 'RIGHT'\"\n                >\n                  <span class=\"wk-icon-angle-left\"></span>\n                </button>\n              </div>\n              <div class=\"wk-col-4\">\n                <div class=\"example-container-temp2\">\n                  <div\n                    cdkDropList\n                    #doneList=\"cdkDropList\"\n                    [cdkDropListData]=\"done\"\n                    [cdkDropListConnectedTo]=\"[todoList]\"\n                    class=\"example-list-temp2\"\n                    (cdkDropListDropped)=\"\n                      drop($event); checkingOrderTemplate2()\n                    \"\n                    [ngStyle]=\"{\n                      'background-color':\n                        selectedTheme == true ? 'black' : 'white',\n                      color: selectedTheme == true ? 'white' : '#474747',\n                      'font-size': fontSize\n                    }\"\n                  >\n                    <div\n                      class=\"example-box-temp2\"\n                      *ngFor=\"let item of done; let i = index\"\n                      cdkDrag\n                      (click)=\"selectItem('RIGHT', i)\"\n                      [class.selected-box]=\"\n                        selectedItem.itemPosition === 'RIGHT' &&\n                        selectedItem.index == i\n                      \"\n                    >\n                      {{ item.label }}\n                    </div>\n                  </div>\n                </div>\n              </div>\n              <div class=\"wk-col-1 pull-left\" *ngIf=\"done.length > 0\">\n                <button\n                  class=\"wkqp-button wk-button-primary m-1px\"\n                  (click)=\"moveSelectedItem('UP')\"\n                  [disabled]=\"validateButtons('UP')\"\n                >\n                  <span class=\"wk-icon-angle-up\"></span>\n                </button>\n                <button\n                  class=\"wkqp-button wk-button-primary m-1px\"\n                  (click)=\"moveSelectedItem('DOWN')\"\n                  [disabled]=\"validateButtons('DOWN')\"\n                >\n                  <span class=\"wk-icon-angle-down\"></span>\n                </button>\n              </div>\n            </div>\n          </ng-container>\n\n          <!--User answer and correct answer Block-->\n          <ng-container *ngIf=\"checkQuizSubmission == true\">\n            <p\n              class=\"wkqp-prewrap \"\n              [ngClass]=\"\n                checkingOrder()\n                  ? 'wkqp-alert-success wkqp-success'\n                  : 'wkqp-alert-danger\n              wkqp-danger'\n              \"\n              *ngIf=\"userActions && templateType == 1\"\n            >\n              <strong>Your Response:</strong>\n            </p>\n            <p\n              class=\"wkqp-prewrap \"\n              [ngClass]=\"\n                checkingOrderTemplate2()\n                  ? 'wkqp-alert-success\n              wkqp-success'\n                  : 'wkqp-alert-danger wkqp-danger'\n              \"\n              *ngIf=\"userActions && templateType == 2\"\n            >\n              <strong>Your Response:</strong>\n            </p>\n            <div *ngIf=\"userActions\" class=\"pb10\">\n              <div *ngFor=\"let item of userAnswer; let i = index\">\n                <span>{{ i + 1 }}) </span>\n                <span>{{ item.label }}</span>\n              </div>\n            </div>\n            <p\n              class=\"wkqp-prewrap wkqp-alert-success wkqp-success \"\n              *ngIf=\"\n                templateType == 1 ? !checkingOrder() : !checkingOrderTemplate2()\n              \"\n            >\n              <strong>Correct Response:</strong>\n            </p>\n            <div\n              *ngIf=\"\n                templateType == 1 ? !checkingOrder() : !checkingOrderTemplate2()\n              \"\n              class=\"pb10\"\n            >\n              <div *ngFor=\"let item of correctAns; let i = index\">\n                <span>{{ i + 1 }}) </span>\n                <span>{{ item.label }}</span>\n              </div>\n            </div>\n            <p\n              *ngIf=\"\n                questionDetails1.modelFeedback[0] &&\n                questionDetails1.modelFeedback[0].length !== 0\n              \"\n            >\n              <strong>Rationale: </strong>\n              <span>{{ questionDetails1.modelFeedback[0].feedbackText }}</span>\n            </p>\n            <div\n              *ngIf=\"\n                questionDetails1.remediationLinks &&\n                questionDetails1.remediationLinks.length !== 0\n              \"\n            >\n              <strong>Remediation:</strong>\n              <div\n                *ngFor=\"\n                  let Remediation of questionDetails1.remediationLinks;\n                  let k = index\n                \"\n              >\n                <span *ngIf=\"Remediation.linkTypeId == 1\">{{\n                  Remediation.linkText1\n                }}</span>\n                <span *ngIf=\"Remediation.linkTypeId != 1\">\n                  {{ Remediation.linkText1 }}</span\n                >\n              </div>\n            </div>\n          </ng-container>\n        </div>\n      </div>\n    </div>\n  </div>\n</ng-container>\n\n<!--DRAG & DROP FOR NCLEX -->\n<ng-container *ngIf=\"examEngineType == 'NCLEX'\">\n  <div class=\"wk-row\">\n    <media-carousel\n      [imagePath]=\"imagePath\"\n      [assetData]=\"questionDetails1.assets\"\n      [assetsPosition]=\"assetPosition\"\n      *ngIf=\"\n        questionDetails1.assets &&\n        questionDetails1.assets.length != 0 &&\n        assetPosition != 'Bottom' &&\n        assetPosition != 'WithinText'\n      \"\n    ></media-carousel>\n    <div\n      style=\"margin-right:0px;\"\n      [ngClass]=\"{\n        'wk-col-8':\n          questionDetails1.assets.length != undefined &&\n          questionDetails1.assets.length != 0,\n        'wk-col-12':\n          questionDetails1.assets == undefined ||\n          questionDetails1.assets.length == 0 ||\n          assetPosition == 'WithinText',\n        'right-assets-position-question': assetPosition == 'Right',\n        'left-assets-position-question': assetPosition == 'Left',\n        'top-assets-position-question': assetPosition == 'Top',\n        'bottom-assets-position-question': assetPosition == 'Bottom'\n      }\"\n    >\n      <div class=\"wkqp-layout-item\">\n        <div class=\"wkqp-field-item normal-font mb0\">\n          <div class=\"wkqp-field-header\" *ngIf=\"assetPosition == 'WithinText'\">\n            <item-text-assets\n              [promptText]=\"questionDetails1.promptText\"\n              [imagePath]=\"imagePath\"\n              [assetData]=\"assetData\"\n              [assetsPosition]=\"assetPosition\"\n            ></item-text-assets>\n          </div>\n          <div class=\"msg-draganddrop\">\n            Arrange the answers into the correct order. Mouse user arrange by\n            clicking and dragging each answer to the desired location. Keyboard\n            user can arrange though drop down by selecting the right order.\n          </div>\n          <!-- <div class=\"wkqp-field-header\" ng-if=\"assetPosition=='WithinText'\">\n              <item-text-assets prompttext=\"{{questionDetails1.promptText}}\" itemtype=\"questionDetails1.labelText\" assets=\"questionDetails1.assets\"></item-text-assets>\n            </div> -->\n          <media-carousel\n            [imagePath]=\"imagePath\"\n            [assetData]=\"questionDetails1.assets\"\n            [assetsPosition]=\"assetPosition\"\n            *ngIf=\"\n              questionDetails1.assets &&\n              questionDetails1.assets.length != 0 &&\n              assetPosition == 'Bottom' &&\n              assetPosition != 'WithinText'\n            \"\n          ></media-carousel>\n          <!--Question text-->\n          <div class=\"wkqp-field-header\" *ngIf=\"assetPosition != 'WithinText'\">\n            <div class=\"mb20 normal-font wkqp-prewrap\">\n              {{ questionDetails1.promptText }}\n            </div>\n          </div>\n          <!-- <bs-sortable [(ngModel)]=\"shuffledArray\" fieldName=\"label\" itemClass=\"dragdrop-anslabel\" itemActiveClass=\"sortable-item-active\"\n              placeholderItem=\"Drag here\" placeholderClass=\"sortable-item\" wrapperClass=\"sortable-wrapper\" (onChange)=\"checkingOrder();\">\n            </bs-sortable> -->\n          <!-- Template 1 -->\n          <ng-container *ngIf=\"templateType == 1\">\n            <div\n              cdkDropList\n              class=\"example-list bottom-assets-position-question\"\n              (cdkDropListDropped)=\"drop($event); checkingOrder()\"\n            >\n              <div\n                class=\"dragdrop-anslabel\"\n                *ngFor=\"let choice of shuffledArray; let i = index\"\n                cdkDrag\n              >\n                <!-- <span class=\"glyphicon glyphicon-th-list\"></span> {{choice.label}} -->\n                <div class=\"drag-and-drop-left\">\n                  <span>{{ choice.label }}</span>\n                </div>\n                <div class=\"wkqp-select-field dd-jump-order\">\n                  <select\n                    name=\"indexDropDown\"\n                    class=\"form-control\"\n                    [(ngModel)]=\"dropDownValues[i]\"\n                    (change)=\"\n                      sortByDropdown(i, dropDownValues[i]); checkingOrder()\n                    \"\n                  >\n                    <option\n                      [value]=\"item\"\n                      *ngFor=\"let item of choiceDropDown; let j = index\"\n                      >{{ item }}</option\n                    >\n                  </select>\n                </div>\n              </div>\n            </div>\n          </ng-container>\n\n          <!-- Template 2 -->\n          <ng-container *ngIf=\"templateType == 2\">\n            <div class=\"wk-row\">\n              <div class=\"wk-col-4\">\n                <div class=\"example-container-temp2\">\n                  <div\n                    cdkDropList\n                    #todoList=\"cdkDropList\"\n                    [cdkDropListData]=\"todo\"\n                    [cdkDropListConnectedTo]=\"[doneList]\"\n                    class=\"example-list-temp2\"\n                    (cdkDropListDropped)=\"\n                      drop($event); checkingOrderTemplate2()\n                    \"\n                  >\n                    <div\n                      class=\"example-box-temp2\"\n                      *ngFor=\"let item of todo; let i = index\"\n                      cdkDrag\n                      (click)=\"selectItem('LEFT', i)\"\n                      [class.selected-box]=\"\n                        selectedItem.itemPosition === 'LEFT' &&\n                        selectedItem.index == i\n                      \"\n                    >\n                      {{ item.label }}\n                    </div>\n                  </div>\n                </div>\n              </div>\n              <div class=\"wk-col-1\">\n                <button\n                  class=\"wkqp-button wk-button-primary\"\n                  [disabled]=\"true\"\n                  *ngIf=\"!selectedItem.itemPosition\"\n                >\n                  <span class=\"wk-icon-angle-right\"></span>\n                </button>\n\n                <button\n                  class=\"wkqp-button wk-button-primary\"\n                  (click)=\"moveToDoneList()\"\n                  *ngIf=\"selectedItem.itemPosition === 'LEFT'\"\n                >\n                  <span class=\"wk-icon-angle-right\"></span>\n                </button>\n\n                <button\n                  class=\"wkqp-button wk-button-primary\"\n                  (click)=\"moveToDoneList()\"\n                  *ngIf=\"selectedItem.itemPosition === 'RIGHT'\"\n                >\n                  <span class=\"wk-icon-angle-left\"></span>\n                </button>\n              </div>\n              <div class=\"wk-col-4\">\n                <div class=\"example-container-temp2\">\n                  <div\n                    cdkDropList\n                    #doneList=\"cdkDropList\"\n                    [cdkDropListData]=\"done\"\n                    [cdkDropListConnectedTo]=\"[todoList]\"\n                    class=\"example-list-temp2\"\n                    (cdkDropListDropped)=\"\n                      drop($event); checkingOrderTemplate2()\n                    \"\n                  >\n                    <div\n                      class=\"example-box-temp2\"\n                      *ngFor=\"let item of done; let i = index\"\n                      cdkDrag\n                      (click)=\"selectItem('RIGHT', i)\"\n                      [class.selected-box]=\"\n                        selectedItem.itemPosition === 'RIGHT' &&\n                        selectedItem.index == i\n                      \"\n                    >\n                      {{ item.label }}\n                    </div>\n                  </div>\n                </div>\n              </div>\n              <div class=\"wk-col-1 pull-left\" *ngIf=\"done.length > 0\">\n                <button\n                  class=\"wkqp-button wk-button-primary m-1px\"\n                  (click)=\"moveSelectedItem('UP')\"\n                  [disabled]=\"validateButtons('UP')\"\n                >\n                  <span class=\"wk-icon-angle-up\"></span>\n                </button>\n                <button\n                  class=\"wkqp-button wk-button-primary m-1px\"\n                  (click)=\"moveSelectedItem('DOWN')\"\n                  [disabled]=\"validateButtons('DOWN')\"\n                >\n                  <span class=\"wk-icon-angle-down\"></span>\n                </button>\n              </div>\n            </div>\n          </ng-container>\n        </div>\n      </div>\n      <!--User answer and correct answer Block-->\n      <ng-container *ngIf=\"checkQuizSubmission == true\">\n        <p\n          class=\"wkqp-prewrap \"\n          [ngClass]=\"\n            templateType == 1\n              ? checkingOrder()\n              : checkingOrderTemplate2()\n              ? 'wkqp-alert-success\n          wkqp-success'\n              : 'wkqp-alert-danger wkqp-danger'\n          \"\n          *ngIf=\"userActions\"\n        >\n          <strong>Your Response:</strong>\n        </p>\n        <div *ngIf=\"userActions\" class=\"pb10\">\n          <div *ngFor=\"let item of userAnswer; let i = index\">\n            <span>{{ i + 1 }}) </span>\n            <span>{{ item.label }}</span>\n          </div>\n        </div>\n        <p\n          class=\"wkqp-prewrap wkqp-alert-success wkqp-success \"\n          *ngIf=\"\n            templateType == 1 ? !checkingOrder() : !checkingOrderTemplate2()\n          \"\n        >\n          <strong>Correct Response:</strong>\n        </p>\n        <div\n          *ngIf=\"\n            templateType == 1 ? !checkingOrder() : !checkingOrderTemplate2()\n          \"\n          class=\"pb10\"\n        >\n          <div *ngFor=\"let item of correctAns; let i = index\">\n            <span>{{ i + 1 }}) </span>\n            <span>{{ item.label }}</span>\n          </div>\n        </div>\n        <p\n          *ngIf=\"\n            questionDetails1.modelFeedback[0] &&\n            questionDetails1.modelFeedback[0].length !== 0\n          \"\n        >\n          <strong>Rationale: </strong>\n          <span>{{ questionDetails1.modelFeedback[0].feedbackText }}</span>\n        </p>\n        <div\n          *ngIf=\"\n            questionDetails1.remediationLinks &&\n            questionDetails1.remediationLinks.length !== 0\n          \"\n        >\n          <strong>Remediation:</strong>\n          <div\n            *ngFor=\"\n              let Remediation of questionDetails1.remediationLinks;\n              let k = index\n            \"\n          >\n            <span *ngIf=\"Remediation.linkTypeId == 1\">{{\n              Remediation.linkText1\n            }}</span>\n            <span *ngIf=\"Remediation.linkTypeId != 1\">\n              {{ Remediation.linkText1 }}</span\n            >\n          </div>\n        </div>\n      </ng-container>\n    </div>\n  </div>\n</ng-container>\n",
        styles: [".example-container{width:400px;max-width:100%;margin:0 25px 25px 0;display:inline-block;vertical-align:top}.example-list{border:1px solid #ccc;min-height:60px;background:#fff;border-radius:4px;overflow:hidden;display:block}.example-box{padding:20px 10px;border-bottom:1px solid #ccc;color:rgba(0,0,0,.87);display:flex;flex-direction:row;align-items:center;justify-content:space-between;box-sizing:border-box;cursor:move;background:#fff;font-size:14px}.cdk-drag-preview{box-sizing:border-box;border-radius:4px;box-shadow:0 5px 5px -3px rgba(0,0,0,.2),0 8px 10px 1px rgba(0,0,0,.14),0 3px 14px 2px rgba(0,0,0,.12)}.cdk-drag-placeholder{opacity:0}.cdk-drag-animating{transition:transform 250ms cubic-bezier(0,0,.2,1)}.example-box:last-child{border:none}.example-list.cdk-drop-list-dragging .example-box:not(.cdk-drag-placeholder){transition:transform 250ms cubic-bezier(0,0,.2,1)}.sortable-item{padding:6px 12px;margin-bottom:4px;font-size:14px;line-height:1.4em;text-align:center;cursor:-webkit-grab;cursor:grab;border:1px solid #adadad;border-radius:4px}.dragdrop-anslabel{padding:10px 10px 10px 40px;border:1px solid #dadada;float:left;width:100%;font-size:16px;cursor:pointer;margin-bottom:5px}.drag-and-drop-left{padding-top:7px;float:left}.dragdrop-anslabel .wkqp-select-field.dd-jump-order{margin-bottom:0}.wkqp-select-field>select{font-family:'Helvetica Neue',Helvetica,Roboto,Arial,sans-serif!important;color:#000!important}.wkqp-select-field{position:relative}.dd-jump-order{float:right;width:15%}.selected-box{border:2px solid #1d6ea775!important}.m-1px{margin:.25vh!important}.example-container-temp2{width:400px;max-width:100%;margin:0 25px 10px 0;display:inline-block;vertical-align:top}.example-list-temp2{min-height:60px;background:#fff;border-radius:4px;overflow:hidden;display:block;height:54vh}.example-box-temp2{padding:10px 10px 10px 15px;border:1px solid #dadada;float:left;width:100%;font-size:16px;cursor:pointer;margin-bottom:5px}.wkqp-button:disabled{color:#000!important;font-weight:700!important;background-color:#eee!important}.temp-draganddrop{float:left;width:100%;margin:0;padding-bottom:10px;color:#000}.mb-15{margin-bottom:15px}.example-box-temp2:hover{border:1px solid!important;color:var(--text-color);background-color:var(--secondary-color)}.drag-drop-right-wk-col-8{width:64%!important;padding:0}.drag-drop-div{width:100%;min-height:100%}.jump-order-select select{height:2.3rem;line-height:1;padding:.4875rem 1rem;border-radius:0;border:1px solid #dadada;outline:0}.jump-order-select select:focus,.jump-order-select select:hover{border:1px solid #474747;border-radius:0;outline:0}.wk-select-field.jump-order-select::after{top:.5em}"]
    })
], DragAndDropComponent);

let InlineChoiceComponent = class InlineChoiceComponent {
    constructor(itemService) {
        this.itemService = itemService;
        this.count = 0;
        this.userAnswers = [];
        this.correctAnswers = [];
        this.assetPositions = AssetPosition;
    }
    get questionDetails() {
        return this.questionDetails;
    }
    ngOnChanges(changes) {
        if (changes && changes.itemDetails && changes.itemDetails.currentValue) {
            this.count = 0;
            this.createQuestion();
        }
        if (this.isShowHide) {
            this.setUserAnswerAndCorrectanswer();
        }
        if (this.isClearAnswer) {
            this.clearAnswer();
        }
    }
    /* Init */
    ngOnInit() { }
    createQuestion() {
        this.correctOptions = [];
        this.promptTxt = this.itemDetails.promptText;
        this.assetData = this.itemDetails.assets;
        if (this.assetData.length !== 0) {
            this.assetPosition = this.itemDetails.assets[0]['assetsPosition'];
        }
        this.options = this.itemDetails.textEntryInteraction.inlineChoices;
        this.correctOptions = this.itemDetails.textEntryInteraction.inlineChoices
            ? this.itemDetails.textEntryInteraction.inlineChoices
            : [];
        this.correctOptions = this.correctOptions.map(item => {
            item = item.filter(subItem => subItem.correct);
            return item;
        });
        this.questionTitleSplits = [];
        let promptText = this.itemDetails.promptText;
        const assetList = promptText.match(/≡Assets-[0-9]\d?≡/gi);
        if (assetList) {
            assetList.forEach((test) => {
                if (promptText.indexOf(test) >= 0) {
                    promptText = promptText.replace(test, ' ' + test + ' ');
                }
            });
        }
        const reg = /(_{1,50})/g;
        promptText = promptText.replace(reg, ' ' + reg + ' ');
        const questionParts = promptText
            .replace(/[]{2,}/g, ' ')
            .trim()
            .split(' ');
        this.formatQuestionArray(questionParts);
    }
    /*
     *Splitting the questions parts to fetch out the the blanks and assets
     */
    formatQuestionArray(questionParts) {
        questionParts.forEach((questionPart, index) => {
            const i = index + 1;
            const ngModel = '';
            const reg = /(_{1,50})/g;
            const assetReg = /≡Assets-[0-9]\d?≡/g;
            if (reg.test(questionPart)) {
                this.count++;
                this.questionTitleSplits.push({
                    id: i,
                    name: `blank-${this.count}`,
                    isInputField: true,
                    ngModel,
                    selectedItems: this.formatUserAnswer(this.options[this.count - 1]),
                    list: this.options[this.count - 1],
                    count: this.count - 1
                });
            }
            else if (assetReg.test(questionPart)) {
                this.assetData.forEach(asset => {
                    if (asset.assetTextIdentifier === questionPart) {
                        let arr = [];
                        arr.push(asset);
                        this.questionTitleSplits.push({
                            id: i,
                            name: questionPart,
                            isAsset: true,
                            assets: arr
                        });
                    }
                });
            }
            else {
                this.questionTitleSplits.push({
                    id: i,
                    name: questionPart,
                    isText: true
                });
            }
        });
        this.validateUserAnswer();
    }
    /*
     *Validate user answer
     */
    validateUserAnswer() {
        const choiceRef = this.questionTitleSplits.filter(data => {
            if (data.isInputField) {
                return data;
            }
        });
        let userAnswer = choiceRef
            .map(data => {
            if (data && data.selectedItems && data.selectedItems.length > 0) {
                return data.selectedItems;
            }
        })
            .flat(1);
        userAnswer = userAnswer.map(item => {
            if (item) {
                return item;
            }
        });
        const isCorrect = this.isCorrectAsnwer(choiceRef, userAnswer);
        const result = {
            userAnswer: userAnswer,
            correct: isCorrect
        };
        this.itemService.userAnswers = result;
        return result;
    }
    /*
     * To check the user entered answer is correct or not
     */
    isCorrectAsnwer(choiceRef, userAnswer) {
        let isCorrect = false;
        let count = 0;
        choiceRef.forEach(element => {
            if (element) {
                element.list.forEach(data => {
                    if (data && data.correct) {
                        if (userAnswer.indexOf(data.choiceId) >= 0) {
                            count++;
                        }
                        else {
                            count = 0;
                            isCorrect = false;
                        }
                    }
                });
            }
        });
        if (userAnswer.length > 0 && count === userAnswer.length) {
            isCorrect = true;
        }
        return isCorrect;
    }
    /*
     *Format user anaswers(choiceId) to the required format
     */
    formatUserAnswer(currentArray) {
        let resultArray = [];
        if (!this.itemDetails.userAttemptDetails.userAnswer) {
            return [];
        }
        const userAnswerArray = this.itemDetails.userAttemptDetails.userAnswer.map(x => +x);
        if (userAnswerArray && userAnswerArray.length > 0) {
            resultArray = [];
            currentArray.forEach(element => {
                if (element && userAnswerArray.indexOf(element.choiceId) >= 0) {
                    resultArray.push(element.choiceId);
                }
            });
        }
        return resultArray;
    }
    /*
     *
     */
    checkUserAnswerStatus() {
        const result = this.validateUserAnswer();
        if (result && result.correct) {
            return true;
        }
        return false;
    }
    setUserAnswerAndCorrectanswer() {
        //Update user answer in service
        this.validateUserAnswer();
        /*
        Filtering the blanks object from the question splitted list
         */
        const choiceRef = this.questionTitleSplits.filter(data => {
            if (data.isInputField) {
                return data;
            }
        });
        /*
        Filtering correct answers from the blanks objects
         */
        this.correctAnswers = choiceRef.map(obj => {
            return obj.list.filter(el => {
                if (el.correct) {
                    return el.label;
                }
            });
        });
        /*
        Filtering user answers from the blanks objects
         */
        this.userAnswers = choiceRef
            .map(obj => {
            return obj.list.filter(el => {
                if (obj.selectedItems.indexOf(el.choiceId) >= 0) {
                    return el.label;
                }
            });
        })
            .flat(1);
    }
    /* When is clear answer valur became true then this function will be called */
    clearAnswer() {
        this.questionTitleSplits.map(element => {
            if (element.isInputField) {
                element.selectedItems = [];
            }
            return element;
        });
        this.itemService.userAnswers = [];
    }
};
InlineChoiceComponent.ctorParameters = () => [
    { type: ItemService }
];
__decorate([
    Input()
], InlineChoiceComponent.prototype, "examEngineType", void 0);
__decorate([
    Input()
], InlineChoiceComponent.prototype, "canShowMetadata", void 0);
__decorate([
    Input()
], InlineChoiceComponent.prototype, "isClearAnswer", void 0);
__decorate([
    Input()
], InlineChoiceComponent.prototype, "isShowHide", void 0);
__decorate([
    Input()
], InlineChoiceComponent.prototype, "imagePath", void 0);
__decorate([
    Input()
], InlineChoiceComponent.prototype, "checkQuizSubmission", void 0);
__decorate([
    Input()
], InlineChoiceComponent.prototype, "preferredTextFormat", void 0);
__decorate([
    Input('questionDetails')
], InlineChoiceComponent.prototype, "itemDetails", void 0);
InlineChoiceComponent = __decorate([
    Component({
        selector: 'inline-choice',
        template: "<!-- ######################### QP Exam Engine Type #############################-->\n<ng-container *ngIf=\"examEngineType == 'QP' || examEngineType == 'NCLEX'\">\n  <div class=\"wk-row\">\n    <media-carousel\n      *ngIf=\"\n        itemDetails.assets &&\n        itemDetails.assets.length != 0 &&\n        assetPosition != assetPositions.bottom &&\n        assetPosition != assetPositions.withInText\n      \"\n      [imagePath]=\"imagePath\"\n      [assetData]=\"assetData\"\n      [assetsPosition]=\"assetPosition\"\n    ></media-carousel>\n\n    <div\n      [ngClass]=\"{\n        'wk-col-8':\n          itemDetails.assets != undefined &&\n          itemDetails.assets.length != 0 &&\n          assetPosition != assetPositions.withInText,\n        'wk-col-12':\n          itemDetails.assets == undefined ||\n          itemDetails.assets.length == 0 ||\n          assetPosition == assetPositions.withInText,\n        'right-assets-position-question': assetPosition == assetPositions.right,\n        'left-assets-position-question': assetPosition == assetPositions.left,\n        'top-assets-position-question': assetPosition == assetPositions.top,\n        'bottom-assets-position-question':\n          assetPosition == assetPositions.bottom\n      }\"\n    >\n      <div class=\"wkqp-layout-item\">\n        <div class=\"wkqp-field-item normal-font mb0 \">\n          <div class=\"wkqp-field-header\">\n            <div class=\"mb20 normal-font wkqp-prewrap\">\n              <!-- <select-type-configuration [questionCurrentData]=\"itemDetails\" [options]=\"options\" [promptTxt]=\"promptTxt\" (valueChanged)='valueChanged($event)'></select-type-configuration> -->\n              <form>\n                <div>\n                  <ng-container\n                    *ngFor=\"\n                      let questionTitle of questionTitleSplits;\n                      let i = index\n                    \"\n                    [class.choose-option-top10]=\"\n                      questionTitle.isInputField && examEngineType == 'NCLEX'\n                    \"\n                  >\n                    <ng-container *ngIf=\"questionTitle.isInputField\">\n                      <span>\n                        <mat-select\n                          class=\"inline-choice-select-box-main\"\n                          multiple\n                          [(ngModel)]=\"questionTitle.selectedItems\"\n                          name=\"{{ questionTitle.id }}\"\n                          (selectionChange)=\"setUserAnswerAndCorrectanswer()\"\n                          placeholder=\"Choose Answer..\"\n                        >\n                          <mat-option\n                            *ngFor=\"let option of questionTitle.list\"\n                            [value]=\"option.choiceId\"\n                            >{{ option.label }}</mat-option\n                          >\n                        </mat-select>\n                      </span>\n                    </ng-container>\n\n                    <ng-container *ngIf=\"questionTitle.isAsset\">\n                      <div style=\"padding-top: 20px;\" class=\"wk-row\">\n                        <media-carousel\n                          [inline]=\"'inline'\"\n                          [assetData]=\"questionTitle.assets\"\n                        ></media-carousel>\n                      </div>\n                    </ng-container>\n\n                    <ng-container *ngIf=\"questionTitle.isText\">\n                      {{ questionTitle.name }}\n                    </ng-container>\n                  </ng-container>\n                  <span class=\"color-red fs-1rem\"> </span>\n                </div>\n                <button\n                  hidden\n                  id=\"resetBtn\"\n                  type=\"reset\"\n                  value=\"reset\"\n                ></button>\n              </form>\n            </div>\n          </div>\n        </div>\n      </div>\n\n      <media-carousel\n        *ngIf=\"\n          itemDetails.assets &&\n          itemDetails.assets.length != 0 &&\n          assetPosition == assetPositions.bottom\n        \"\n        [imagePath]=\"imagePath\"\n        [assetData]=\"assetData\"\n        [assetsPosition]=\"assetPosition\"\n      ></media-carousel>\n      <div *ngIf=\"canShowMetadata && isShowHide != true\">\n        <lib-metadata [itemData]=\"itemDetails\"></lib-metadata>\n      </div>\n      <!-- User answer and correct answer block-->\n      <ng-container *ngIf=\"isShowHide == true\">\n        <div\n          class=\"m-b-20\"\n          [ngClass]=\"\n            checkUserAnswerStatus()\n              ? 'wkqp-alert-success wkqp-success'\n              : 'wkqp-alert-danger wkqp-danger'\n          \"\n          *ngIf=\"userAnswers.length > 0\"\n        >\n          <strong>Your Response: </strong>\n          <ng-container>\n            <ng-container *ngFor=\"let blank of userAnswers; let i = index\">\n              <span\n                >{{ blank.label\n                }}{{ i === userAnswers.length - 1 ? '' : ',' }}</span\n              >\n            </ng-container>\n          </ng-container>\n        </div>\n\n        <div\n          class=\"wkqp-alert-success wkqp-success badge-normal mb20\"\n          *ngIf=\"!checkUserAnswerStatus()\"\n        >\n          <strong>Correct Response:</strong>\n          <table\n            class=\"table table-bordered m-t-20\"\n            *ngIf=\"!checkUserAnswerStatus()\"\n          >\n            <tbody>\n              <tr *ngFor=\"let blanks of correctOptions; let i = index\">\n                <td width=\"10%\" class=\"table-label\">\n                  <strong>Blank-{{ i + 1 }}</strong>\n                </td>\n                <td width=\"90%\">\n                  <span\n                    class=\"wkqp-badge\"\n                    *ngFor=\"let choice of blanks; let k = index\"\n                    style=\"margin-left: 5px\"\n                    libGetFormatText\n                    [preferredTextFormat]=\"preferredTextFormat\"\n                    [plainText]=\"choice.label\"\n                    [richText]=\"choice.richLabel\"\n                  >\n                  </span>\n                </td>\n              </tr>\n            </tbody>\n          </table>\n        </div>\n        <div class=\"common-full-width mb20\" *ngIf=\"canShowMetadata\">\n          <lib-metadata [itemData]=\"itemDetails\"></lib-metadata>\n        </div>\n      </ng-container>\n      <div class=\"common-full-width mb20\" *ngIf=\"isShowHide == true\">\n        <lib-rationale\n          [itemData]=\"itemDetails.modelFeedback\"\n          [preferredTextFormat]=\"preferredTextFormat\"\n        ></lib-rationale>\n\n        <lib-remediation\n          [itemData]=\"itemDetails.remediationLinks\"\n          [preferredTextFormat]=\"preferredTextFormat\"\n        ></lib-remediation>\n      </div>\n    </div>\n  </div>\n</ng-container>\n\n<!-- ######################### USMLE Exam Engine Type #############################-->\n<ng-container *ngIf=\"examEngineType == 'USMLE'\">\n  <!-- Question and Answer  Block-->\n  <div class=\"wk-row\">\n    <media-carousel\n      *ngIf=\"\n        itemDetails.assets &&\n        itemDetails.assets.length != 0 &&\n        assetPosition != assetPositions.bottom &&\n        assetPosition != assetPositions.withInText\n      \"\n      [imagePath]=\"imagePath\"\n      [assetData]=\"assetData\"\n      [assetsPosition]=\"assetPosition\"\n    ></media-carousel>\n\n    <div\n      [ngClass]=\"{\n        'wk-col-8':\n          itemDetails.assets != undefined &&\n          itemDetails.assets.length != 0 &&\n          assetPosition != assetPositions.withInText,\n        'wk-col-12':\n          itemDetails.assets == undefined ||\n          itemDetails.assets.length == 0 ||\n          assetPosition == assetPositions.withInText,\n        'right-assets-position-question': assetPosition == assetPositions.right,\n        'left-assets-position-question': assetPosition == assetPositions.left,\n        'top-assets-position-question': assetPosition == assetPositions.top,\n        'bottom-assets-position-question':\n          assetPosition == assetPositions.bottom\n      }\"\n    >\n      <div class=\"wkqp-layout-item\">\n        <div class=\"wkqp-field-item normal-font mb0 \">\n          <div class=\"wkqp-field-header\">\n            <div class=\"mb20 normal-font wkqp-prewrap\">\n              <div>\n                <span\n                  *ngFor=\"\n                    let questionTitle of questionTitleSplits;\n                    let i = index\n                  \"\n                >\n                  <ng-container *ngIf=\"questionTitle.isInputField\">\n                    <ng-multiselect-dropdown\n                      ngDefaultControl\n                      [ngModelOptions]=\"{ standalone: true }\"\n                      [placeholder]=\"'Choose Option'\"\n                      [data]=\"questionTitle.list\"\n                      [(ngModel)]=\"questionTitle.selectedItems\"\n                    >\n                      >\n                    </ng-multiselect-dropdown>\n                  </ng-container>\n                  <ng-container *ngIf=\"questionTitle.isAsset\">\n                    <div style=\"padding-top: 20px;\" class=\"wk-row\">\n                      <media-carousel\n                        [inline]=\"'inline'\"\n                        [assetData]=\"questionTitle.assets\"\n                      ></media-carousel>\n                    </div>\n                  </ng-container>\n\n                  <ng-container *ngIf=\"questionTitle.isText\">\n                    {{ questionTitle.name }}\n                  </ng-container>\n                </span>\n                <span class=\"color-red fs-1rem\"> </span>\n              </div>\n            </div>\n          </div>\n        </div>\n      </div>\n\n      <media-carousel\n        *ngIf=\"\n          itemDetails.assets &&\n          itemDetails.assets.length != 0 &&\n          assetPosition == assetPositions.bottom\n        \"\n        [imagePath]=\"imagePath\"\n        [assetData]=\"assetData\"\n        [assetsPosition]=\"assetPosition\"\n      ></media-carousel>\n      <!-- User answer and correct answer block-->\n      <ng-container *ngIf=\"checkQuizSubmission == true\">\n        <div\n          [ngClass]=\"\n            checkUserAnswerStatus()\n              ? 'wkqp-alert-success wkqp-success'\n              : 'wkqp-alert-danger wkqp-danger'\n          \"\n          *ngIf=\"userAnswers.length !== 0\"\n        >\n          <strong>Your Response:</strong>\n          <ng-container *ngFor=\"let blank of userAnswers; let i = index\">\n            <span\n              *ngFor=\"let choice of blank; let k = index\"\n              style=\"margin-left: 5px\"\n              >{{ choice.label\n              }}{{\n                i === userAnswers.length - 1 && k === blank.length - 1\n                  ? ''\n                  : ','\n              }}</span\n            >\n          </ng-container>\n        </div>\n\n        <div\n          class=\"wkqp-alert-success wkqp-success \"\n          *ngIf=\"!checkUserAnswerStatus()\"\n        >\n          <strong>Correct Response:</strong>\n          <table class=\"table table-bordered\" *ngIf=\"!checkUserAnswerStatus()\">\n            <tbody>\n              <tr *ngFor=\"let blanks of correctOptions; let i = index\">\n                <td width=\"15%\" style=\"color: #000\">\n                  <strong>Blank-{{ i + 1 }}</strong>\n                </td>\n                <td width=\"85%\">\n                  <span\n                    class=\"wkqp-badge\"\n                    *ngFor=\"let choice of blanks; let k = index\"\n                    style=\"margin-left: 5px\"\n                    >{{ choice.label }}\n                  </span>\n                </td>\n              </tr>\n            </tbody>\n          </table>\n        </div>\n\n        <p *ngIf=\"itemDetails.modelFeedback[0].length !== 0\">\n          <strong>Rationale:</strong>\n          <span>{{ itemDetails.modelFeedback[0].feedbackText }}</span>\n        </p>\n        <div *ngIf=\"itemDetails.remediationLinks.length !== 0\">\n          <strong>Remediation:</strong>\n          <div\n            *ngFor=\"\n              let Remediation of itemDetails.remediationLinks;\n              let k = index\n            \"\n          >\n            <span *ngIf=\"Remediation.linkTypeId == 1\">{{\n              Remediation.linkText1\n            }}</span>\n            <span *ngIf=\"Remediation.linkTypeId != 1\">\n              {{ Remediation.linkText1 }}</span\n            >\n          </div>\n        </div>\n      </ng-container>\n    </div>\n  </div>\n</ng-container>\n",
        styles: [".dropdown-list{margin-top:0!important}.choose-option-top10{position:relative;top:10px}.table-label{color:#000!important}.m-b-20{margin-bottom:20px!important}.m-t-20{margin-top:20px!important}.badge-normal table tr td span.wkqp-badge{font-style:normal}.badge-normal table tr td.table-label strong{color:#474747;font-size:.9375rem;font-style:normal}.ques-num-content{margin-top:4px;display:inline-block;vertical-align:middle}"]
    })
], InlineChoiceComponent);

let HotspotSvgComponent = class HotspotSvgComponent {
    constructor(itemService, _DomSanitizationService, quizService, cd) {
        this.itemService = itemService;
        this._DomSanitizationService = _DomSanitizationService;
        this.quizService = quizService;
        this.cd = cd;
        this.assets = {};
        this.clearAnswer = false;
        // Input and output variables
        this.userAnswerFromChild = new EventEmitter();
        this.imagePath = [];
        /*Image loading..*/
        this.imageLoaded = function () {
            const img = new Image();
            img.src = this.imagePathLocal;
            img.onload = () => {
                this.imageWidth = img.width;
                this.imageHeight = img.height;
                this.cd.detectChanges();
            };
        };
    }
    set setAnswerDetails(value) {
        if (value) {
            this.correctAnswerDetails = value;
        }
    }
    set imageSrcCurrent(value) {
        if (value) {
            if (this.quizService.isOnline) {
                this.imagePathLocal = value.assetPath;
            }
            else {
                this.imageSrc1 = value ? value.assetsContent : '';
                this.imagePathLocal =
                    this.splitStringForType('image', value.assetName) + this.imageSrc1;
            }
            const img = new Image();
            img.src = this.imagePathLocal;
            img.onload = () => {
                this.imageWidth = img.width;
                this.imageHeight = img.height;
                this.cd.detectChanges();
            };
            this.assignShapeDetails();
        }
        else {
            console.log('imageSrc', value);
        }
    }
    /* Init */
    ngOnInit() {
    }
    ngOnChanges(changes) {
    }
    /* Do check */
    ngDoCheck() {
        if (this.isClearAnswer === true) {
            this.userAnswerValue = [];
            this.path = '';
            this.itemService.clearAnswerMethodFalse(false);
            this.itemService.hideAnswer(false);
        }
    }
    /* select the user answer */
    drawToggle(event) {
        if (this.accessType === 'selectAnswer') {
            this.shapeDetails = {};
            this.isDrawStart = true;
            this.shapeDetails.ansCx = event.offsetX ? event.offsetX : 0;
            this.shapeDetails.ansCy = event.offsetY ? event.offsetY : 0;
            this.userAnswer = [this.shapeDetails.ansCx, this.shapeDetails.ansCy];
            this.path = this.drawCross();
        }
        this.userAnswerFromChild.emit(this.userAnswer);
    }
    /*Assign the shape details */
    assignShapeDetails() {
        this.shapeDetails = {};
        if ((this.hotspotDetails || this.correctAnswerDetails)) {
            if (this.correctAnswerDetails) {
                if (this.correctAnswerDetails.shape) {
                    this.shapeType = this.correctAnswerDetails.shape;
                }
                this.dimension =
                    this.correctAnswerDetails && this.correctAnswerDetails.coords
                        ? this.correctAnswerDetails.coords.split(',')
                        : '';
            }
            else {
                if (this.hotspotDetails.shape) {
                    this.shapeType = this.hotspotDetails.shape;
                }
                this.dimension =
                    this.hotspotDetails && this.hotspotDetails.coords
                        ? this.hotspotDetails.coords.split(',')
                        : '';
            }
            if (this.shapeType === 2) {
                // rectangle
                this.shapeDetails.rx1 = Number(this.dimension[0]);
                this.shapeDetails.ry1 = Number(this.dimension[1]);
                this.shapeDetails.rx2 = Number(this.dimension[2]);
                this.shapeDetails.ry2 = Number(this.dimension[3]);
                this.shapeDetails.rWidth =
                    this.shapeDetails.rx2 - this.shapeDetails.rx1 > 0
                        ? this.shapeDetails.rx2 - this.shapeDetails.rx1
                        : 0;
                this.shapeDetails.rHeight =
                    this.shapeDetails.ry2 - this.shapeDetails.ry1 > 0
                        ? this.shapeDetails.ry2 - this.shapeDetails.ry1
                        : 0;
            }
            else if (this.shapeType === 1) {
                // Circle
                this.shapeDetails.cx = Number(this.dimension[0]);
                this.shapeDetails.cy = Number(this.dimension[1]);
                this.shapeDetails.cr = Number(this.dimension[2]);
            }
        }
        // debugger;
        if (this.userAnswerDetails) {
            // this.shapeDetails = {};
            this.isDrawStart = true;
            this.shapeDetails.ansCr = 7.5;
            if (this.userAnswerDetails.userAnswer !== undefined) {
                this.answerX = this.userAnswerDetails.userAnswer[0];
                this.answerY = this.userAnswerDetails.userAnswer[1];
            }
            else if (this.userAnswerDetails !== undefined) {
                this.answerX = this.userAnswerDetails[0];
                this.answerY = this.userAnswerDetails[1];
            }
            else {
                this.answerX = this.userAnswerValue.userAnswer[0];
                this.answerY = this.userAnswerValue.userAnswer[1];
            }
            this.shapeDetails.ansCx = Number(this.answerX);
            this.shapeDetails.ansCy = Number(this.answerY);
            this.path = this.drawCross();
        }
    }
    /*To draw the cross symbol */
    drawCross() {
        if (this.shapeDetails.ansCx && this.shapeDetails.ansCy) {
            const x = this.shapeDetails.ansCx;
            const y = this.shapeDetails.ansCy;
            const crossLength = 13;
            const crossPath = 'M' +
                (x - crossLength) +
                ',' +
                (y - crossLength) +
                ' L' +
                (x + crossLength) +
                ',' +
                (y + crossLength) +
                ' M' +
                (x + crossLength) +
                ',' +
                (y - crossLength) +
                ' L' +
                (x - crossLength) +
                ',' +
                (y + crossLength);
            return crossPath;
        }
    }
    /* Disable right click */
    onRightClick() {
        return false;
    }
    splitStringForType(type, value) {
        const name = value.split('.')[1];
        switch (type) {
            case 'image':
                return `data:image/${name};base64,`;
            case 'audio':
                return `data:audio/${name};base64,`;
            case 'video':
                return `data:video/${name};base64,`;
            default:
                break;
        }
    }
};
HotspotSvgComponent.ctorParameters = () => [
    { type: ItemService },
    { type: DomSanitizer },
    { type: QuizService },
    { type: ChangeDetectorRef }
];
__decorate([
    Output()
], HotspotSvgComponent.prototype, "userAnswerFromChild", void 0);
__decorate([
    Input('accessType')
], HotspotSvgComponent.prototype, "accessType", void 0);
__decorate([
    Input('accessTypeCorrect')
], HotspotSvgComponent.prototype, "accessTypeCorrect", void 0);
__decorate([
    Input('accessTypeUser')
], HotspotSvgComponent.prototype, "accessTypeUser", void 0);
__decorate([
    Input()
], HotspotSvgComponent.prototype, "userAnswerDetails", void 0);
__decorate([
    Input()
], HotspotSvgComponent.prototype, "imageType", void 0);
__decorate([
    Input()
], HotspotSvgComponent.prototype, "imagePath", void 0);
__decorate([
    Input()
], HotspotSvgComponent.prototype, "isClearAnswer", void 0);
__decorate([
    Input()
], HotspotSvgComponent.prototype, "hideLabel", void 0);
__decorate([
    Input()
], HotspotSvgComponent.prototype, "selectedTheme", void 0);
__decorate([
    Input()
], HotspotSvgComponent.prototype, "fontSize", void 0);
__decorate([
    Input('correctAnswerDetails')
], HotspotSvgComponent.prototype, "setAnswerDetails", null);
__decorate([
    Input('imageSrc')
], HotspotSvgComponent.prototype, "imageSrcCurrent", null);
HotspotSvgComponent = __decorate([
    Component({
        selector: 'hotspot-svg',
        template: "<div class=\"wk-row mb20\" [class.disable-block]=\"hideLabel\">\n  <div class=\"wk-image-panel-wrapper\">\n    <h2 *ngIf=\"!hideLabel\">\n      <span class=\"msg-hotspot mb20\">\n        Click to select correct part of the image.\n      </span>\n    </h2>\n    <div class=\"wk-image-panel-body\">\n      <div class=\"hopspot-svgcontainer\">\n        <svg\n          (contextmenu)=\"onRightClick()\"\n          class=\"hotspot-parent\"\n          xmlns=\"http://www.w3.org/2000/svg\"\n          xmlns:xlink=\"http://www.w3.org/1999/xlink\"\n          [ngStyle]=\"{\n            cursor: accessType == 'selectAnswer' ? 'crosshair' : 'default'\n          }\"\n          [attr.height]=\"imageHeight\"\n          [attr.width]=\"imageWidth\"\n          (mousedown)=\"drawToggle($event)\"\n          (mouseup)=\"drawToggle($event)\"\n        >\n          <!--Loading Hotspot image-->\n          <image\n            [attr.xlink:href]=\"imagePathLocal\"\n            onError=\"/app/images/no_image_available.jpeg\"\n            imageonload=\"imageLoaded()\"\n            [attr.alt]=\"assets.altTitle\"\n            style=\"pointer-events: none;\"\n            [attr.id]=\"assets.assetId\"\n          ></image>\n\n          <!--Hotspot Area-->\n          <g style=\"pointer-events: none;\">\n            <!--Circle Shape Type-->\n            <circle\n              *ngIf=\"shapeType == 1 && accessType == 'correctAnswer'\"\n              [attr.cx]=\"shapeDetails.cx\"\n              [attr.cy]=\"shapeDetails.cy\"\n              [attr.r]=\"shapeDetails.cr\"\n              style=\"stroke-width:2px;stroke:#ff0000;fill:#ccc;fill-opacity:0.3;\"\n            ></circle>\n\n            <!--Rectangle Shape Type-->\n            <rect\n              *ngIf=\"shapeType == 2 && accessType == 'correctAnswer'\"\n              [attr.x]=\"shapeDetails.rx1\"\n              [attr.y]=\"shapeDetails.ry1\"\n              [attr.width]=\"shapeDetails.rWidth\"\n              [attr.height]=\"shapeDetails.rHeight\"\n              style=\"stroke-width:2px;stroke:#ff0000;fill:#ccc;fill-opacity:0.3;\"\n            ></rect>\n\n            <!--Cross image -->\n            <path\n              [attr.d]=\"path\"\n              fill=\"black\"\n              stroke=\"#000000\"\n              stroke-width=\"3.5\t\"\n              stroke-linecap=\"round\"\n            ></path>\n          </g>\n        </svg>\n      </div>\n    </div>\n  </div>\n</div>\n",
        styles: [".disable-block{pointer-events:none}.hotspot-parent{background-color:#ccc;border:0 solid #fff;margin-top:10px;top:0;left:0;position:relative}.msg-hotspot{width:100%;margin:0;padding:0;font-size:13px;font-weight:300}.hopspot-svgcontainer{overflow:auto;width:100%;max-height:500px}.wk-image-panel-body{float:left;width:100%;padding:15px;border:1px solid #ccc;text-align:center}.wk-image-panel-body svg{border:1px solid #ccc!important}"]
    })
], HotspotSvgComponent);

let InputTypeConfigurationComponent = class InputTypeConfigurationComponent {
    constructor(domSanitizer, renderer, el, itemService) {
        this.domSanitizer = domSanitizer;
        this.renderer = renderer;
        this.el = el;
        this.itemService = itemService;
        this.inputArrays = [];
        this.noOfBlanks = 0;
        this.blankValues = [];
        this.valueChanged = new EventEmitter();
    }
    /* Init */
    ngOnInit() {
        if (this.promptTxt) {
            this.handleQuestionText(this.promptTxt);
        }
    }
    /* Do Check */
    ngDoCheck() {
        if (this.isClearAnswer === true) {
            document.getElementById('resetBtn').click();
            this.itemService.userAnswerMethod([]);
            this.itemService.clearAnswerMethodFalse(false);
            this.itemService.hideAnswer(false);
        }
    }
    /* Typed */
    typed(event) {
        this.emittedValue = [];
        const arr = Array.prototype.slice.call(this.d.nativeElement.children);
        arr.forEach((element, i) => {
            this.emittedValue.push(element.value);
        });
        this.valueForInput();
    }
    /* Handle Question text */
    handleQuestionText(question) {
        if (question && question.changingThisBreaksApplicationSecurity) {
            return;
        }
        if (!question) {
            return;
        }
        const reg = /(_{1,50})/g;
        this.stringArray = question.split(reg);
        console.log(this.stringArray);
        let noOfInputs = 0;
        for (const str of this.stringArray) {
            const test = reg.test(str);
            if (test === true) {
                console.log('inout');
                const i = this.renderer.createElement('input');
                // this.inputArrays.push(i);
                this.renderer.addClass(i, 'wk-fill-inthe-blank-text');
                this.renderer.appendChild(this.d.nativeElement, i);
                this.renderer.setProperty(i, 'name', noOfInputs++);
                this.renderer.setProperty(i, 'aria-label', 'input your answer');
                // this.renderer.setValue(i, 'name', 'try');
                this.renderer.listen(i, 'keyup', this.typed.bind(this));
                if (this.userAttemptDetails.length !== 0) {
                    this.renderer.setProperty(i, 'value', this.userAttemptDetails);
                    // this.renderer.listen(i, 'change', this.typed.bind(this.userAttemptDetails.userSelectedAnswer));
                }
            }
            else {
                const sPart = this.renderer.createText(str);
                this.renderer.appendChild(this.d.nativeElement, sPart);
            }
        }
    }
    // Check the value
    valueForInput() {
        this.valueChanged.emit(this.emittedValue);
    }
};
InputTypeConfigurationComponent.ctorParameters = () => [
    { type: DomSanitizer },
    { type: Renderer2 },
    { type: ElementRef },
    { type: ItemService }
];
__decorate([
    ViewChild('d', { static: true })
], InputTypeConfigurationComponent.prototype, "d", void 0);
__decorate([
    Input()
], InputTypeConfigurationComponent.prototype, "isClearAnswer", void 0);
__decorate([
    Input('promptTxt')
], InputTypeConfigurationComponent.prototype, "promptTxt", void 0);
__decorate([
    Input('userAttemptDetails')
], InputTypeConfigurationComponent.prototype, "userAttemptDetails", void 0);
__decorate([
    Input()
], InputTypeConfigurationComponent.prototype, "clearAnswer", void 0);
__decorate([
    Output()
], InputTypeConfigurationComponent.prototype, "valueChanged", void 0);
InputTypeConfigurationComponent = __decorate([
    Component({
        selector: 'input-type-configuration',
        template: "<form>\n  <div class=\"\" #d></div>\n  <button hidden id=\"resetBtn\" type=\"reset\" value=\"reset\"></button>\n</form>\n",
        styles: [""]
    })
], InputTypeConfigurationComponent);

let SelectTypeConfigurationComponent = class SelectTypeConfigurationComponent {
    constructor(domSanitizer, renderer, el, itemService) {
        this.domSanitizer = domSanitizer;
        this.renderer = renderer;
        this.el = el;
        this.itemService = itemService;
        this.inputArrays = [];
        this.questionCurrentData = [];
        this.valueChanged = new EventEmitter();
        this.noOfBlanks = 0;
        this.blankValues = [];
        this.emittedValue = [];
        this.userAnsweredValue = [];
    }
    ngOnInit() {
        console.log(this.blankMatches);
        console.log('options', this.options);
        console.log('questionCurrentData', this.questionCurrentData.userAttemptDetails);
        this.userAnsweredValue = this.questionCurrentData.userAttemptDetails.userAnswer;
        Object.keys(this.userAnsweredValue).map((id, i) => {
            const result = i;
            this.userAnsweredValue[result] = this.userAnsweredValue[id];
            delete this.userAnsweredValue[id];
        });
        this.itemService.currentAnswerState.subscribe(clear => this.clearAnswer = clear);
        if (this.promptTxt) {
            this.handleQuestionText(this.promptTxt);
        }
    }
    ngDoCheck() {
        if (this.isClearAnswer === true) {
            for (const item of this.options) {
                item.checked = false;
            }
            this.setUlToDisplayNone();
            document.getElementById('resetBtn').click();
            for (let i = 1; i < this.emittedValue.length; i++) {
                const btnEleme = document.getElementById(`blank${i}`);
                if (btnEleme !== undefined && btnEleme !== null) {
                    btnEleme.innerText = 'Choose Option';
                }
                else {
                    break;
                }
            }
            this.emittedValue = [];
            this.itemService.userAnswerMethod([]);
            this.itemService.clearAnswerMethodFalse(false);
            this.itemService.hideAnswer(false);
        }
    }
    toggleUl(event) {
        if (event && event.srcElement) {
            const id = event.srcElement.id;
            const domElem = document.getElementById(id + 'ul').style;
            domElem.display === 'none' ? domElem.display = 'block' : domElem.display = 'none';
        }
    }
    optionCheckboxChange(event) {
        const selectedItem = Number(event.srcElement.value);
        const selectedItemId = event.srcElement.name;
        for (const i of this.options) {
            if (i[i.findIndex(x => x.choiceId === selectedItem)]) {
                this.selectedItemObj = i[i.findIndex(x => x.choiceId === selectedItem)];
                this.selectedItemObj.name = selectedItemId;
            }
        }
        const index = this.emittedValue.findIndex((item) => item.choiceId === this.selectedItemObj.choiceId);
        if (index > -1) {
            this.emittedValue = this.emittedValue.filter((item) => item.choiceId !== this.selectedItemObj.choiceId);
        }
        else {
            this.emittedValue.push(this.selectedItemObj);
            // if (this.emittedValue.length !== 0) {
            //   this.spanText = this.emittedValue.name;
            // } else {
            //   this.spanText = 'Choose Option';
            // }
            console.log('emittedvalue pushed', this.emittedValue);
        }
        let selectedChecks = '';
        for (const item of this.emittedValue) {
            if (item.name === selectedItemId) {
                selectedChecks += '' + item.label + ',';
            }
        }
        const btnEleme = document.getElementById(selectedItemId);
        btnEleme.innerText = selectedChecks ? selectedChecks : 'Choose Option';
        this.valueForInput();
    }
    // createInput() {
    //   const i = this.renderer.createElement('select');
    //   this.renderer.appendChild(this.d.nativeElement, i);
    //   this.renderer.listen(i, 'keyup', this.typed);
    // }
    // ngOnChanges(changes: SimpleChanges): void {
    //   if (changes['promptTxt']) {
    //     this.handleQuestionText(this.promptTxt);
    //   }
    //   console.log(this.blankMatches);
    // }
    handleQuestionText(question) {
        console.log('inside QQQ', this.questionCurrentData.userAttemptDetails.userAnswer);
        if (question && question.changingThisBreaksApplicationSecurity) {
            return;
        }
        if (!question) {
            return;
        }
        const reg = /(_{1,50})/g;
        const stringArray = question.split(reg);
        console.log('string array', stringArray);
        let noOfInputs = 0;
        for (const str of stringArray) {
            const test = reg.test(str);
            if (test === true) {
                const ulContainer = this.renderer.createElement('div');
                const spanText = this.renderer.createText('Choose Option');
                const spanElem = this.renderer.createElement('button');
                this.renderer.addClass(spanElem, 'btn');
                this.renderer.addClass(spanElem, 'btn-default');
                this.renderer.addClass(spanElem, 'btn-block');
                const blankNo = noOfInputs + 1;
                this.renderer.setAttribute(spanElem, 'id', 'blank' + blankNo);
                const iconElem = this.renderer.createElement('i');
                this.renderer.setAttribute(iconElem, 'id', 'blank' + blankNo);
                this.renderer.addClass(iconElem, 'fas');
                this.renderer.addClass(iconElem, 'fa-caret-down');
                this.renderer.appendChild(spanElem, spanText);
                this.renderer.appendChild(spanElem, iconElem);
                const ulElem = this.renderer.createElement('ul');
                this.renderer.setAttribute(ulElem, 'id', 'blank' + blankNo + 'ul');
                this.renderer.setAttribute(ulElem, 'class', 'blanksul');
                for (const option of this.options[noOfInputs]) {
                    const liElem = this.renderer.createElement('li');
                    const inputElem = this.renderer.createElement('input');
                    this.renderer.setAttribute(inputElem, 'name', spanElem.id);
                    this.renderer.setAttribute(inputElem, 'id', option.choiceId);
                    this.renderer.setAttribute(inputElem, 'value', option.choiceId);
                    this.renderer.setAttribute(inputElem, 'type', 'checkbox');
                    if (Object.keys(this.userAnsweredValue).length !== 0) {
                        if (this.userAnsweredValue[noOfInputs].find((testItem) => option.choiceId === testItem.choiceId)) {
                            this.renderer.setAttribute(inputElem, 'checked', 'true');
                            // this.optionCheckboxChange({choiceId : option.choiceId, name : spanElem.id});
                        }
                    }
                    this.renderer.appendChild(liElem, inputElem);
                    const labelElem = this.renderer.createElement('label');
                    this.renderer.addClass(labelElem, 'labeling');
                    this.renderer.appendChild(labelElem, this.renderer.createText(option.label));
                    this.renderer.setAttribute(labelElem, 'for', option.choiceId);
                    this.renderer.appendChild(liElem, labelElem);
                    this.renderer.appendChild(ulElem, liElem);
                    this.renderer.listen(inputElem, 'change', this.optionCheckboxChange.bind(this));
                }
                // console.log('inout');
                // this.inputArrays.push(i);
                this.renderer.appendChild(ulContainer, ulElem);
                this.renderer.insertBefore(ulContainer, spanElem, ulElem);
                noOfInputs++;
                // this.renderer.setProperty(ulContainer, 'name', 'blank' + ++noOfInputs);
                this.renderer.appendChild(this.d.nativeElement, ulContainer);
                // this.renderer.setValue(i, 'name', 'try');
                this.renderer.listen(spanElem, 'click', this.toggleUl.bind(this));
            }
            else {
                const sPart = this.renderer.createText(str);
                this.renderer.appendChild(this.d.nativeElement, sPart);
            }
        }
        console.log(question);
        this.setUlToDisplayNone();
    }
    setUlToDisplayNone() {
        const uls = document.getElementsByClassName('blanksul');
        console.log(uls);
        const ulKeys = Object.keys(uls);
        for (const key of ulKeys) {
            const ulElement = uls[key];
            if (ulElement && ulElement.style) {
                ulElement.style.display = 'none';
            }
        }
    }
    // replaceAt(index, position, question, matchedString) {
    //   return question.substr(0, index) + this.inputElements[position] + question.substr(index + matchedString.length);
    // }
    valueForInput() {
        this.valueChanged.emit(this.emittedValue);
        // console.log(event);
    }
};
SelectTypeConfigurationComponent.ctorParameters = () => [
    { type: DomSanitizer },
    { type: Renderer2 },
    { type: ElementRef },
    { type: ItemService }
];
__decorate([
    ViewChild('d', { static: true })
], SelectTypeConfigurationComponent.prototype, "d", void 0);
__decorate([
    Input()
], SelectTypeConfigurationComponent.prototype, "promptTxt", void 0);
__decorate([
    Input()
], SelectTypeConfigurationComponent.prototype, "questionCurrentData", void 0);
__decorate([
    Input()
], SelectTypeConfigurationComponent.prototype, "options", void 0);
__decorate([
    Input()
], SelectTypeConfigurationComponent.prototype, "isClearAnswer", void 0);
__decorate([
    Output()
], SelectTypeConfigurationComponent.prototype, "valueChanged", void 0);
SelectTypeConfigurationComponent = __decorate([
    Component({
        selector: 'select-type-configuration',
        template: "<form>\n  <div class=\"question-container\" #d></div>\n  <button hidden id=\"resetBtn\" type=\"reset\"></button>\n</form>",
        styles: [".question-container{display:flex;white-space:normal}:host ::ng-deep .question-container ul{list-style:none;padding-left:0;z-index:1;display:none;width:100%;box-shadow:0 6px 12px rgba(0,0,0,.175)}.question-container span{border:1px solid grey;opacity:.8;padding:2px 10px;cursor:pointer}.question-container span:hover{opacity:1}.question-container div{padding:0 10px;position:relative}.btn-default{color:#333;background-color:#fff;border-color:#ccc;width:267px;text-overflow:ellipsis;display:inline-block;overflow:hidden}.wkqp-button.wk-button-warning,button:focus,button:hover{background-color:var(--tertiary-color)!important;color:#000!important}.fa,.fas{padding-left:5px}.labeling{padding-left:10px;padding-top:5px}"]
    })
], SelectTypeConfigurationComponent);

let FigureLabelComponent = class FigureLabelComponent {
    constructor(_DomSanitizationService, quizService, cd) {
        this._DomSanitizationService = _DomSanitizationService;
        this.quizService = quizService;
        this.cd = cd;
        // Declare the variables
        this.labelCircleRadius = 12;
        this.type = 'create';
    }
    /* Init */
    ngOnInit() {
        this.extractCoords();
        this.imageLoaded();
        this.altTitle = this.assetData[0].altTitle;
    }
    ngOnChanges(changes) {
        this.extractCoords();
        this.imageLoaded();
    }
    ngDoCheck() {
        this.extractCoords();
    }
    /* Image loaded */
    imageLoaded() {
        this.imageSrc = this.loadImagePath('image', this.assetData[0]);
        const img = new Image();
        img.src = this.imageSrc;
        img.onload = () => {
            this.imageWidth = img.width;
            this.imageHeight = img.height;
            this.cd.detectChanges();
        };
    }
    /* Extract coordinates */
    extractCoords() {
        this.correctOptions.forEach(element => {
            element.fillColor = false;
            this.offsetX = element.coords.split(',')[0];
            this.offsetY = element.coords.split(',')[1];
            element.offsetX = this.offsetX;
            element.offsetY = this.offsetY;
        });
        if (this.userAnswer && this.userAnswer instanceof Array) {
            this.userAnswer.forEach((answer, key) => {
                if (this.correctOptions.find(element => {
                    return answer == element.choiceId;
                })) {
                    this.correctOptions[key].fillColor = true;
                }
            });
        }
        else if (this.userAnswer && typeof this.userAnswer === 'object') {
            // for summary page convert to array
            this.userAnswer = Object.keys(this.userAnswer);
            this.userAnswer.forEach((answer, key) => {
                if (this.correctOptions.find(element => {
                    return answer == element.choiceId;
                })) {
                    this.correctOptions[key].fillColor = true;
                }
            });
        }
    }
    splitStringForType(type, value) {
        const name = value.split('.')[1];
        switch (type) {
            case 'image':
                return `data:image/${name};base64,`;
            case 'audio':
                return `data:audio/${name};base64,`;
            case 'video':
                return `data:video/${name};base64,`;
            default:
                break;
        }
    }
    loadImagePath(assetType, slide) {
        if (this.quizService.isOnline) {
            return slide.assetPath;
        }
        return this.splitStringForType(assetType, slide.assetName) + slide.assetsContent;
    }
};
FigureLabelComponent.ctorParameters = () => [
    { type: DomSanitizer },
    { type: QuizService },
    { type: ChangeDetectorRef }
];
__decorate([
    Input()
], FigureLabelComponent.prototype, "assetData", void 0);
__decorate([
    Input()
], FigureLabelComponent.prototype, "imagePath", void 0);
__decorate([
    Input()
], FigureLabelComponent.prototype, "userAnswer", void 0);
__decorate([
    Input()
], FigureLabelComponent.prototype, "correctOptions", void 0);
__decorate([
    Input()
], FigureLabelComponent.prototype, "selectedTheme", void 0);
__decorate([
    Input()
], FigureLabelComponent.prototype, "fontSize", void 0);
FigureLabelComponent = __decorate([
    Component({
        selector: 'figure-label',
        template: "<div class=\"wk-row mb20\" *ngIf=\"imageSrc\">\n  <div class=\"wk-image-panel-wrapper\">\n    <div class=\"rationale-remedation-block\">\n      <div class=\"figurelabel-svgcontainer\">\n        <svg\n          class=\"figurelabel-parent\"\n          xmlns=\"http://www.w3.org/2000/svg\"\n          xmlns:xlink=\"http://www.w3.org/1999/xlink\"\n          [ngStyle]=\"{ cursor: 'default' }\"\n          [attr.height]=\"imageHeight\"\n          [attr.width]=\"imageWidth\"\n        >\n          <image\n            disable-right-click\n            [attr.x]=\"0\"\n            [attr.y]=\"0\"\n            [attr.xlink:href]=\"imageSrc\"\n            [attr.height]=\"imageHeight\"\n            [attr.width]=\"imageWidth\"\n            style=\"pointer-events: none;\"\n          ></image>\n          <g\n            style=\"pointer-events: none;\"\n            *ngFor=\"let labelDetails of correctOptions; let i = index\"\n          >\n            <circle\n              [attr.cx]=\"labelDetails.offsetX\"\n              [attr.cy]=\"labelDetails.offsetY\"\n              [attr.r]=\"12\"\n              style=\"stroke-width:2px;stroke:#474747;fill-opacity:1;\"\n              [ngStyle]=\"{fill: !labelDetails.fillColor ? 'white' : '#00BFFF'}\"\n            ></circle>\n            <text\n              [attr.x]=\"labelDetails.offsetX\"\n              [attr.y]=\"labelDetails.offsetY\"\n              text-anchor=\"middle\"\n              style=\"fill:#474747;\"\n              dy=\".4em\"\n            >\n              {{ i + 1 }}\n            </text>\n            <!-- <span *ngIf=\"userAnswer[i] !== ''\" class=\"off-screen\">{{i+1}} Answered</span> -->\n          </g>\n        </svg>\n      </div>\n    </div>\n  </div>\n</div>\n",
        styles: [""]
    })
], FigureLabelComponent);

let CarouselComponent = class CarouselComponent {
    constructor(modalService, itemService, _DomSanitizationService, quizService) {
        this.modalService = modalService;
        this.itemService = itemService;
        this._DomSanitizationService = _DomSanitizationService;
        this.quizService = quizService;
        this.imagePath = [];
        this.myInterval = 0;
    }
    ngOnChanges(changes) { }
    /* Init */
    ngOnInit() {
        this.isOnlineEngine = this.quizService.isOnline;
    }
    /* Click image */
    clickImage(template, slide) {
        this.fileName = slide && slide.fileName ? slide.fileName : '';
        if (this.quizService.isOnline) {
            this.imageUrl = slide.assetPath;
        }
        else {
            this.imageUrl =
                this.splitStringForType('image', slide.assetName) + slide.assetsContent;
        }
        if (this.imageUrl !== undefined) {
            this.modalRef = this.modalService.show(template);
        }
    }
    goFullscreen() {
        const videoPlayer = document.getElementById('videoId');
        videoPlayer.webkitEnterFullScreen();
    }
    splitStringForType(type, value) {
        const name = value.split('.')[1];
        switch (type) {
            case 'image':
                return `data:image/${name};base64,`;
            case 'audio':
                return `data:audio/${name};base64,`;
            case 'video':
                return `data:video/${name};base64,`;
            default:
                break;
        }
    }
    loadImagePath(assetType, slide) {
        if (this.quizService.isOnline) {
            return slide.assetPath;
        }
        return (this.splitStringForType(assetType, slide.assetName) + slide.assetsContent);
    }
    loadImagePathinsideModal(imageUrl) {
        if (this.quizService.isOnline) {
            return imageUrl;
        }
        else {
            return imageUrl;
        }
    }
};
CarouselComponent.ctorParameters = () => [
    { type: BsModalService },
    { type: ItemService },
    { type: DomSanitizer },
    { type: QuizService }
];
__decorate([
    Input('assetData')
], CarouselComponent.prototype, "assetData", void 0);
__decorate([
    Input('imagePath')
], CarouselComponent.prototype, "imagePath", void 0);
__decorate([
    Input('assetsPosition')
], CarouselComponent.prototype, "assetsPosition", void 0);
__decorate([
    Input('inline')
], CarouselComponent.prototype, "inline", void 0);
CarouselComponent = __decorate([
    Component({
        selector: 'media-carousel',
        template: "<div\n  class=\"video-preview\"\n  [ngClass]=\"{\n    'right-assets-position-media wkqp-fullwidth mr0': assetsPosition == 'Right',\n    'left-assets-position-media wkqp-fullwidth': assetsPosition == 'Left',\n    'top-assets-position-media': assetsPosition == 'Top',\n    'bottom-assets-position-media': assetsPosition == 'Bottom',\n    'wk-col-6 video-preview-width-small':\n      assetsPosition == 'graphic' || inline == 'inline',\n    'wk-col-4': assetsPosition != 'graphic' && inline != 'inline'\n  }\"\n>\n  <carousel [interval]=\"myInterval\">\n    <slide *ngFor=\"let slide of assetData; let index = index\">\n      <div class=\"que-prev-title-head\">{{ slide.fileName }}</div>\n      <wkqp-image-scaling\n        [slideData]=\"slide\"\n        [ImageSource]=\"loadImagePath('image', slide)\"\n      ></wkqp-image-scaling>\n\n      <video\n        *ngIf=\"slide.assetTypeId == 3\"\n        class=\"item-prev-video55\"\n        id=\"videoId\"\n      >\n        <source [src]=\"loadImagePath('video', slide)\" />\n        <source\n          [src]=\"loadImagePath('video', slide)\"\n          type='video/mp4; codecs=\"avc1.42E01E, mp4a.40.2\"'\n        />\n        <source\n          [src]=\"loadImagePath('video', slide)\"\n          type='video/ogg; codecs=\"theora, vorbis\"'\n        />\n      </video>\n      <app-media-controls\n        *ngIf=\"slide.assetTypeId == 3\"\n        [assetId]=\"slide.assetId\"\n        [assetType]=\"'video'\"\n      ></app-media-controls>\n      <!-- <i class=\"fas fa-arrows-alt\" (click)=\"goFullscreen()\"></i> -->\n      <audio *ngIf=\"slide.assetTypeId == 2\" class=\"item-prev-audio55\">\n        <source [src]=\"loadImagePath('audio', slide)\" />\n      </audio>\n      <app-media-controls\n        *ngIf=\"slide.assetTypeId == 2\"\n        [assetId]=\"slide.assetId\"\n        [assetType]=\"'audio'\"\n      ></app-media-controls>\n      <div class=\"carousel-caption\">\n        <p>{{ slide.text }}</p>\n      </div>\n      <div\n        class=\"img-enlarge img-enlarge-text\"\n        style=\"text-align:center;\"\n        *ngIf=\"slide.assetTypeId == 1\"\n      >\n        <span>Click on image to enlarge.</span>\n      </div>\n      <wkqp-download-transcript\n        *ngIf=\"isOnlineEngine && slide.transcript\"\n        [slideData]=\"slide\"\n      >\n      </wkqp-download-transcript>\n    </slide>\n  </carousel>\n</div>\n<ng-template #template>\n  <div>\n    <div class=\"modal-title-main\">\n      {{ fileName }}\n    </div>\n    <button\n      type=\"button\"\n      class=\"wk-icon-close-empty\"\n      aria-label=\"Close\"\n      (click)=\"modalRef.hide()\"\n    ></button>\n  </div>\n  <div class=\"modal-body\">\n    <div>\n      <img\n        class=\"enlarge-img-border\"\n        [src]=\"loadImagePathinsideModal(imageUrl)\"\n        alt=\"No Image\"\n      />\n    </div>\n  </div>\n</ng-template>\n",
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: [".close{color:#fff!important}video::-internal-media-controls-download-button{display:none}video::-webkit-media-controls-enclosure{overflow:hidden}video::-webkit-media-controls-panel{width:calc(100% + 30px)}audio::-internal-media-controls-download-button{display:none}audio::-webkit-media-controls-enclosure{overflow:hidden}audio::-webkit-media-controls-panel{width:calc(100% + 30px)}.video-preview-width-small{width:382px}.modal-header{min-height:inherit!important;float:left;width:100%;padding:10px!important;color:#fff;background-color:var(--primary-color)!important;border-radius:0!important;border:0!important;position:relative!important;height:45px!important}.modal-header button.close:focus,.modal-header button.close:hover{background-color:transparent!important;color:#fff!important;outline:0!important;border:0!important;box-shadow:0 0 0!important}.mr0{margin-right:0!important}"]
    })
], CarouselComponent);

let ItemTextAssetsComponent = class ItemTextAssetsComponent {
    constructor(modalService, _DomSanitizationService) {
        this.modalService = modalService;
        this._DomSanitizationService = _DomSanitizationService;
        this.imagePath = [];
        this.replaceAsset = [];
        this.myInterval = 0;
        this.assetArray = [];
        this.assetCurrentData = [];
    }
    ngOnChanges(changes) {
        if (this.assetData) {
            this.assetCurrentData = this.assetData;
            this.createQuestion();
        }
        else {
            this.assetCurrentData = [];
            this.createQuestion();
        }
    }
    ngOnInit() {
    }
    allReplace(retStr, obj) {
        // tslint:disable-next-line:forin
        for (let x in obj) {
            retStr = retStr.replace(x, obj[x]);
        }
        return retStr;
    }
    splitStringForType(type, value) {
        const name = value.split('.')[1];
        switch (type) {
            case 'Image':
                return `data:image/${name};base64,`;
            case 'Audio':
                return `data:audio/${name};base64,`;
            case 'Video':
                return `data:video/${name};base64,`;
            default:
                break;
        }
    }
    /* Click image */
    clickImage(e, template) {
        this.imageUrl = e;
        if (this.imageUrl !== undefined) {
            this.modalRef = this.modalService.show(template);
        }
    }
    createQuestion() {
        const typeofPromptText = typeof this.promptText;
        if (this.promptText) {
            const assetList = this.promptText.match(/≡Assets-[0-9]\d?≡/gi);
            assetList.forEach((test) => {
                const index = this.promptText.indexOf(test);
                if (index >= 0) {
                    if (typeofPromptText === 'string') {
                        this.promptText = this.promptText.replace(test, ' ' + test + ' ');
                    }
                    else {
                        this.promptText = this.promptText.splice(index, 1, ' ' + test + ' ');
                    }
                }
            });
        }
        let tempArr = [];
        this.promptText = this.promptText.trim().split(' ');
        this.promptText.forEach((element, index, arr) => {
            if (element.indexOf('≡Assets-') >= 0) {
                let objet = {
                    type: 'ASSET',
                    assetType: '',
                    src: '',
                    asset: []
                };
                this.assetCurrentData.forEach(innerEl => {
                    if (innerEl.assetTextIdentifier === element) {
                        let arr = [];
                        arr.push(innerEl);
                        objet.assetType = innerEl.assetTypeName;
                        objet.src = this.splitStringForType(innerEl.assetTypeName, innerEl.assetName) + innerEl.assetsContent;
                        objet.asset = arr;
                    }
                });
                tempArr.push(objet);
            }
            else {
                let objet = {
                    type: 'text',
                    assetType: '',
                    src: element + ' '
                };
                tempArr.push(objet);
            }
        });
        this.assetArray = tempArr;
    }
};
ItemTextAssetsComponent.ctorParameters = () => [
    { type: BsModalService },
    { type: DomSanitizer }
];
__decorate([
    Input('assetData')
], ItemTextAssetsComponent.prototype, "assetData", void 0);
__decorate([
    Input('imagePath')
], ItemTextAssetsComponent.prototype, "imagePath", void 0);
__decorate([
    Input('assetsPosition')
], ItemTextAssetsComponent.prototype, "assetsPosition", void 0);
__decorate([
    Input('promptText')
], ItemTextAssetsComponent.prototype, "promptText", void 0);
ItemTextAssetsComponent = __decorate([
    Component({
        selector: 'item-text-assets',
        template: "<div class=\"mb20\">\n  <ng-container *ngFor=\"let obj of assetArray\">\n    <ng-container *ngIf=\"obj.type == 'text'; else assets\">{{\n      obj.src\n    }}</ng-container>\n    <ng-template #assets>\n      <div class=\"wk-row mb20\">\n        <media-carousel\n          [inline]=\"'inline'\"\n          [assetData]=\"obj.asset\"\n        ></media-carousel>\n      </div>\n    </ng-template>\n  </ng-container>\n</div>\n",
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: [".close{color:#fff!important}video::-internal-media-controls-download-button{display:none}video::-webkit-media-controls-enclosure{overflow:hidden}video::-webkit-media-controls-panel{width:calc(100% + 30px)}audio::-internal-media-controls-download-button{display:none}audio::-webkit-media-controls-enclosure{overflow:hidden}audio::-webkit-media-controls-panel{width:calc(100% + 30px)}"]
    })
], ItemTextAssetsComponent);

let ExhibitModal = class ExhibitModal {
    constructor(modalService) {
        this.modalService = modalService;
        this.currentTab = 0;
        this.exhibitData = [];
        this.exhibitContent = null;
        this.isExhibit = 0;
        this.index = 0;
    }
    set questionCurrentData(value) {
        /** template2 ---> initializing template type and creatig todo list. */
        if (value) {
            this.isExhibit = value.isExhibit || (value.exhibitData && value.exhibitData.length > 0);
            this.exhibitData = value.exhibitData ? value.exhibitData : [];
            this.exhibitContent =
                this.exhibitData.length > 0
                    ? this.exhibitData[0].content
                    : '<h4 class="text-center"><strong>Exhibit data not found...!!</strong></h4>';
        }
    }
    moveToExhibitContent(index, content) {
        this.exhibitContent =
            content.content.length > 0
                ? content.content
                : '<h4 class="text-center"><strong>Exhibit data not found...!!</strong></h4>';
        switch (this.examEngineType) {
            case "QP":
                this.currentTab = index;
                this.index = index;
                break;
            case "USMLE":
                this.currentTab = index;
                this.index = index;
                break;
            case "NCLEX":
                this.index = index;
                break;
            default:
                console.log("Something went wrong --->> Engine is ", this.examEngineType);
        }
    }
    openModal() {
        this.exhibitContent =
            this.exhibitData[0].content.length > 0
                ? this.exhibitData[0].content
                : '<h4 class="text-center"><strong>Exhibit data not found...!!</strong></h4>';
        switch (this.examEngineType) {
            case "QP":
                this.currentTab = 0;
                this.qpExhibitModal.show();
                break;
            case "USMLE":
                this.currentTab = 0;
                this.qpExhibitModal.show();
                break;
            case "NCLEX":
                this.index = 0;
                this.nclexModal.show();
                break;
            default:
        }
    }
    changeTab(index, content) {
        this.exhibitContent =
            content.content.length > 0
                ? content.content
                : '<h4 class="text-center"><strong>Exhibit data not found...!!</strong></h4>';
        this.index = index;
    }
};
ExhibitModal.ctorParameters = () => [
    { type: BsModalService }
];
__decorate([
    Input()
], ExhibitModal.prototype, "examEngineType", void 0);
__decorate([
    ViewChild("nclexExhibitModal", { static: false })
], ExhibitModal.prototype, "nclexModal", void 0);
__decorate([
    ViewChild("qpExhibitModal", { static: false })
], ExhibitModal.prototype, "qpExhibitModal", void 0);
__decorate([
    Input()
], ExhibitModal.prototype, "selectedTheme", void 0);
__decorate([
    Input()
], ExhibitModal.prototype, "fontSize", void 0);
__decorate([
    Input("questionDetails")
], ExhibitModal.prototype, "questionCurrentData", null);
ExhibitModal = __decorate([
    Component({
        selector: "app-exhibit-modal",
        template: "<ng-container *ngIf=\"isExhibit\">\n  <div\n    class=\"wk-layout-50-50 mb20 exhibit-add-btn\"\n    *ngIf=\"examEngineType == 'QP' || examEngineType == 'USMLE'\"\n  >\n    <div class=\"wk-layout-item text-right\">\n      <button class=\"wkqp-button wk-button-primary\" (click)=\"openModal()\">\n        Exhibit\n      </button>\n    </div>\n  </div>\n  <div *ngIf=\"examEngineType == 'NCLEX'\">\n    <button\n      type=\"button\"\n      class=\"btn btn-primary exhibit-btn-margin\"\n      (click)=\"openModal()\"\n    >\n      Exhibit\n    </button>\n  </div>\n  <div\n    class=\"hor-line\"\n    *ngIf=\"examEngineType == 'QP' || examEngineType == 'USMLE'\"\n  ></div>\n</ng-container>\n\n<!-- QP Exhibit modal -->\n<div\n  bsModal\n  #qpExhibitModal=\"bs-modal\"\n  class=\"modal fade exhibit-preview-modal\"\n  [id]=\"examEngineType == 'USMLE' ? 'usmle-exhibit-wrapper' : 'qp-modal'\"\n  tabindex=\"-1\"\n  role=\"dialog\"\n  aria-labelledby=\"dialog-sizes-name1\"\n  [config]=\"{ backdrop: true }\"\n>\n  <div\n    class=\"modal-dialog modal-lg\"\n    [class.usmle-exhitbit-modal]=\"examEngineType == 'USMLE'\"\n  >\n    <div class=\"modal-content\">\n      <div class=\"modal-header\">\n        <h3 id=\"dialog-sizes-name1\" class=\"modal-title pull-left\">\n          Exhibit Question\n        </h3>\n        <a\n          class=\"qp-modal-close\"\n          (click)=\"qpExhibitModal.hide()\"\n          [ngStyle]=\"{\n            color: selectedTheme == true ? 'black' : '#474747'\n          }\"\n        >\n          <span class=\"wk-icon-close-outline\"></span>\n        </a>\n      </div>\n      <div class=\"hor-line\"></div>\n      <div class=\"modal-body\">\n        <div>\n          <tabset class=\"exhibit-preview\">\n            <tab\n              *ngFor=\"let tab of exhibitData; let i = index\"\n              [heading]=\"tab.title\"\n            >\n              <span [innerHTML]=\"tab?.content\"></span>\n            </tab>\n          </tabset>\n        </div>\n        <ng-template #emptyContent>\n          <div class=\"exhibit-content-div\" [innerHTML]=\"exhibitContent\">\n            <h4 style=\"text-align: center\">\n              <strong>Exhibit data not found...!!</strong>\n            </h4>\n          </div>\n        </ng-template>\n      </div>\n    </div>\n  </div>\n</div>\n\n<!-- NCLEX Echibit modal -->\n<div\n  class=\"modal fade\"\n  id=\"nclex-modal\"\n  bsModal\n  #nclexExhibitModal1=\"bs-modal\"\n  [config]=\"{ backdrop: false }\"\n  tabindex=\"-1\"\n  role=\"dialog\"\n  aria-labelledby=\"dialog-static-name\"\n>\n  <div class=\"modal-dialog\">\n    <div class=\"modal-content\">\n      <div class=\"modal-body\">\n        <button\n          type=\"button\"\n          class=\"close pull-right close-round-btn\"\n          aria-label=\"Close\"\n          (click)=\"nclexExhibitModal1.hide()\"\n        >\n          <span class=\"wk-icon-close-outline close-icon\"></span>\n        </button>\n        <div\n          class=\"exhibit-tabs\"\n          *ngIf=\"exhibitData.length > 0; else emptyContent\"\n        >\n          <!-- <tabset #staticTabs>\n                  <tab heading=\"Static title\"><div class=\"exhibit-content-div\"></div></tab>\n                  <tab heading=\"Static Title 1\"><div class=\"exhibit-content-div\"></div></tab>\n                  <tab heading=\"Static Title 2\"><div class=\"exhibit-content-div\"></div></tab>\n                  <tab heading=\"Static Title 3\"><div class=\"exhibit-content-div\"></div></tab>\n                </tabset> -->\n\n          <ul class=\"nav nav-tabs nclex-exhibit-tabs\">\n            <li\n              [class.test-wrapper]=\"currentTab != i\"\n              class=\"padding-1vh\"\n              *ngFor=\"let tab of exhibitData; let i = index\"\n              [ngClass]=\"{\n                'active-tab nclextab-width': currentTab == i,\n                'li-responsive': exhibitData.length > 3,\n                'bg-eee': currentTab != i\n              }\"\n              (click)=\"moveToExhibitContent(i, tab)\"\n              style=\"border-radius: 2px; \"\n            >\n              <a class=\"text-container\">{{ tab.title }}</a>\n            </li>\n          </ul>\n          <div class=\"exhibit-content-div\" [innerHTML]=\"exhibitContent\"></div>\n        </div>\n        <ng-template #emptyContent>\n          <div class=\"exhibit-content-div\" [innerHTML]=\"exhibitContent\">\n            <h4 style=\"text-align: center\">\n              <strong>Exhibit data not found...!!</strong>\n            </h4>\n          </div>\n        </ng-template>\n      </div>\n    </div>\n  </div>\n</div>\n\n<!-- NCLEX Echibit modal -->\n<div\n  class=\"modal fade\"\n  bsModal\n  id=\"nclex-modal\"\n  #nclexExhibitModal=\"bs-modal\"\n  [config]=\"{ backdrop: false }\"\n  tabindex=\"-1\"\n  role=\"dialog\"\n  aria-labelledby=\"dialog-static-name\"\n>\n  <div class=\"modal-dialog\">\n    <div class=\"modal-content\">\n      <div class=\"modal-body\">\n        <button\n          type=\"button\"\n          class=\"close pull-right close-round-btn\"\n          aria-label=\"Close\"\n          (click)=\"nclexExhibitModal.hide()\"\n        >\n          <span class=\"wk-icon-close-outline close-icon\"></span>\n        </button>\n        <div style=\"height: 40vh;\">\n          <ul class=\"tabs\">\n            <li\n              class=\"tab\"\n              *ngFor=\"let tab of exhibitData; let i = index\"\n              [class.seleted-tab]=\"index == i\"\n            >\n              <input\n                type=\"radio\"\n                name=\"tabs\"\n                checked=\"checked\"\n                id=\"tab{{ i + 1 }}\"\n                (change)=\"changeTab(i, tab)\"\n              />\n              <label\n                for=\"tab{{ i + 1 }}\"\n                [class.seleted-tab-content]=\"index == i\"\n                [class.unselected-tab]=\"index != i\"\n                >{{ tab.title }}</label\n              >\n              <div\n                style=\"height: 34vh;overflow: auto\"\n                id=\"tab-content{{ i + 1 }}\"\n                class=\"content wxhibit-cont\"\n                [innerHTML]=\"exhibitContent\"\n              ></div>\n            </li>\n          </ul>\n        </div>\n      </div>\n    </div>\n  </div>\n</div>\n",
        styles: [".modal-lg{width:600px;min-width:600px}.modal-header{min-height:auto;background-color:#fff!important;border-bottom:1px solid #e5e5e5!important;padding:15px!important;height:65px!important}.modal-content{border-radius:0;border:0;height:auto!important;max-height:calc(100vh - 30px)!important}.modal-content .modal-body{float:left;width:100%;background-color:#fff}.exhibit-preview-modal .modal-lg{width:100%;max-width:75rem}.exhibit-preview-modal .modal-body{min-height:472px}.exhibit-preview-modal .modal-body .tab-content{height:400px;overflow-y:auto;border:1px solid #a3a3a3;padding:15px;border-top:0}.exhibit-preview-modal .wk-icon-close-outline:before{font-size:30px}.exhibit-preview-modal .wk-icon-close-outline{position:relative;left:7px;cursor:pointer}.exhibit-preview-modal .wk-layout-50-50{max-width:100%}.exhibit-add-btn{border-bottom:1px solid #a3a3a3;padding-bottom:20px}"]
    })
], ExhibitModal);

let MetadataComponent = class MetadataComponent {
    constructor() { }
    set itemDetails(data) {
        if (data) {
            this.itemData = data;
            this.metaDataList = this.createMetadataList();
        }
    }
    ngOnInit() { }
    createMetadataList() {
        let metadataAssoc = this.itemData.metadataAssoc;
        let selectedMetaDetails = this.itemData.selectedMetaDetails;
        let refObject = {};
        for (var key in metadataAssoc) {
            if (key !== 'metadataDisplaySettings' &&
                metadataAssoc &&
                metadataAssoc['metadataDisplaySettings'][key]['displayMetadata']) {
                refObject[key] = {
                    answerRef: metadataAssoc[key],
                    displayMetadata: metadataAssoc['metadataDisplaySettings'][key].displayMetadata,
                    displayOrder: metadataAssoc['metadataDisplaySettings'][key].displayOrder
                };
            }
        }
        if (selectedMetaDetails) {
            selectedMetaDetails = selectedMetaDetails.filter(element => {
                if (element.metadataValues.length > 0) {
                    element['displayOrder'] = refObject[element.id]
                        ? refObject[element.id].displayOrder
                        : null;
                    if (element['displayOrder']) {
                        element['selectedMetadataValue'] = [];
                        if (element.tagTypeId === 3) {
                            if (refObject[element.id] && refObject[element.id].answerRef) {
                                element['selectedMetadataValue'] =
                                    refObject[element.id].answerRef;
                            }
                        }
                        else if (element.tagTypeId === 1) {
                            if (refObject[element.id]) {
                                element['selectedMetadataValue'] = refObject[element.id];
                            }
                        }
                        else {
                            element.metadataValues.forEach(value => {
                                if (refObject[element.id] &&
                                    refObject[element.id].answerRef.indexOf(value.id) >= 0) {
                                    element['selectedMetadataValue'].push(value);
                                }
                            });
                            element.selectedMetadataValue = element.selectedMetadataValue.sort((a, b) => {
                                return a.sequence - b.sequence;
                            });
                        }
                        return element;
                    }
                }
            });
            selectedMetaDetails = selectedMetaDetails.sort((a, b) => {
                return a.displayOrder - b.displayOrder;
            });
            return selectedMetaDetails;
        }
        return [];
    }
};
__decorate([
    Input('canShowMetadata')
], MetadataComponent.prototype, "canShowMetadata", void 0);
__decorate([
    Input('itemData')
], MetadataComponent.prototype, "itemDetails", null);
MetadataComponent = __decorate([
    Component({
        selector: 'lib-metadata',
        template: "<ng-container *ngIf=\"metaDataList && metaDataList.length > 0\">\n  <div class=\"metatda-container\">\n    <h4 class=\"mb10 addtional-font-size\">\n      <strong>Additional Details (Preview Only)</strong>\n    </h4>\n    <table class=\"wk-table\">\n      <tbody>\n        <ng-container *ngFor=\"let metadata of metaDataList\">\n          <tr>\n            <td>{{ metadata.displayLabel }}</td>\n            <td>\n              <ng-container\n                *ngIf=\"\n                  metadata.selectedMetadataValue &&\n                  metadata.selectedMetadataValue.length > 0\n                \"\n              >\n                <div *ngFor=\"let data of metadata.selectedMetadataValue\">\n                  {{ data.value }}\n                </div>\n              </ng-container>\n            </td>\n          </tr>\n        </ng-container>\n      </tbody>\n    </table>\n  </div>\n</ng-container>\n",
        styles: [".metatda-container{margin-top:5px}td{border:1px solid #a3a3a3;padding:15px}.addtional-font-size{font-size:16px}.wk-table tbody tr td{color:#474747;font-size:.9375rem;padding:.625rem;border-top:1px solid #a3a3a3}"]
    })
], MetadataComponent);

let RationaleComponent = class RationaleComponent {
    constructor() {
        this.RationaleValuesEnum = RationaleType;
        this.AssetPositionValuesEnum = AssetPosition;
    }
    ngOnInit() { }
    ngOnChanges(changes) {
        this.getRationaleDataDetails();
    }
    getRationaleDataDetails() {
        if (this.rationaleData && this.rationaleData.length > 0) {
            this.rationaleData.forEach(element => {
                if (element.outcomeType === this.RationaleValuesEnum.correctRationale && element.feedbackText != null) {
                    this.itemDetailsData = element;
                }
                else if (element.outcomeType === this.RationaleValuesEnum.correctRationale && element.feedbackText != null) {
                    this.itemDetailsData = element;
                }
            });
            this.rationaleAssets = this.itemDetailsData.rationaleAssets &&
                this.itemDetailsData.rationaleAssets.length > 0
                ? this.itemDetailsData.rationaleAssets
                : [];
            if (this.rationaleAssets && this.rationaleAssets.length > 0) {
                this.rationaleAssetPosition = this.rationaleAssets[0].assetsPosition;
            }
            this.showRationale = true;
        }
        else {
            this.showRationale = false;
        }
    }
};
__decorate([
    Input('itemData')
], RationaleComponent.prototype, "rationaleData", void 0);
__decorate([
    Input()
], RationaleComponent.prototype, "preferredTextFormat", void 0);
RationaleComponent = __decorate([
    Component({
        selector: 'lib-rationale',
        template: "<div class=\"common-full-width inline-paragraph\" *ngIf=\"showRationale\">\n  <ng-container *ngIf=\"rationaleAssets.length == 0; else rationaleWithAsset\">\n    <p\n      class=\"correct-rationale-section pt0-correct-rationale rational-strong-block\"\n    >\n      <strong>Rationale: </strong>\n      <span\n        libGetFormatText\n        [preferredTextFormat]=\"preferredTextFormat\"\n        [plainText]=\"itemDetailsData.feedbackText\"\n        [richText]=\"itemDetailsData.richFeedbackText\"\n      ></span>\n    </p>\n  </ng-container>\n  <ng-template #rationaleWithAsset>\n    <p class=\"correct-rationale-section pt0-correct-rationale\">\n      <strong>Rationale: </strong>\n    </p>\n    <media-carousel\n      [imagePath]=\"rationaleAssets[0].assetPath\"\n      [assetData]=\"rationaleAssets\"\n      [assetsPosition]=\"rationaleAssetPosition\"\n      *ngIf=\"\n        rationaleAssetPosition != AssetPositionValuesEnum.bottom &&\n        rationaleAssetPosition != AssetPositionValuesEnum.withInText\n      \"\n    ></media-carousel>\n    <div\n      class=\"wkqp-col-8\"\n      style=\"margin-right:0px;\"\n      [ngClass]=\"{\n        'wkqp-col-8': rationaleAssets.length != 0,\n        'wkqp-col-12':\n          rationaleAssets.length == 0 ||\n          rationaleAssetPosition == AssetPositionValuesEnum.withInText,\n        'right-assets-position-question':\n          rationaleAssetPosition == AssetPositionValuesEnum.right,\n        'left-assets-position-question':\n          rationaleAssetPosition == AssetPositionValuesEnum.left,\n        'top-assets-position-question':\n          rationaleAssetPosition == AssetPositionValuesEnum.top,\n        'bottom-assets-position-question':\n          rationaleAssetPosition == AssetPositionValuesEnum.bottom\n      }\"\n    >\n      <div class=\"wkqp-layout-item\">\n        <div class=\"wkqp-field-item normal-font mb0\">\n          <!--Prompt text-->\n          <div\n            class=\"wk-field-header mb20\"\n            *ngIf=\"rationaleAssetPosition != AssetPositionValuesEnum.withInText\"\n          >\n            <span\n              libGetFormatText\n              [preferredTextFormat]=\"preferredTextFormat\"\n              [plainText]=\"itemDetailsData.feedbackText\"\n              [richText]=\"itemDetailsData.richFeedbackText\"\n            ></span>\n          </div>\n\n          <div\n            class=\"wk-field-header mb0\"\n            *ngIf=\"rationaleAssetPosition == AssetPositionValuesEnum.withInText\"\n          >\n            <item-text-assets\n              [promptText]=\"itemDetailsData.feedbackText\"\n              [imagePath]=\"rationaleAssets[0].assetPath\"\n              [assetData]=\"rationaleAssets\"\n              [assetsPosition]=\"AssetPositionValuesEnum.withInText\"\n            ></item-text-assets>\n          </div>\n          <media-carousel\n            [imagePath]=\"rationaleAssets[0].assetPath\"\n            [assetData]=\"rationaleAssets\"\n            [assetsPosition]=\"rationaleAssetPosition\"\n            *ngIf=\"rationaleAssetPosition === AssetPositionValuesEnum.bottom\"\n          ></media-carousel>\n        </div>\n      </div>\n    </div>\n  </ng-template>\n</div>\n",
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: [".right-assets-position-question{float:left!important;padding-right:15px;width:64%}.left-assets-position-question{float:left!important;width:66%}"]
    })
], RationaleComponent);

let RemediationComponent = class RemediationComponent {
    constructor(quizService) {
        this.quizService = quizService;
        this.remediaionValuesEnum = RemediaionType;
    }
    ngOnInit() {
    }
    ngOnChanges(changes) {
        if (this.remediationList && this.remediationList.length > 0) {
            this.isOnline = this.quizService.isOnline;
            this.showRemeditaion = true;
            // Check whether the system is offline and 
            // has atleast one remediation to be shown
            // otherwise don't show the remediation
            if (!this.isOnline) {
                let checkRemediation = this.remediationList.some(remediation => ((remediation.linkTypeId == this.remediaionValuesEnum.textType) ||
                    (remediation.linkTypeId == this.remediaionValuesEnum.linkType)));
                if (!checkRemediation) {
                    this.showRemeditaion = false;
                }
            }
        }
        else {
            this.showRemeditaion = false;
        }
    }
};
RemediationComponent.ctorParameters = () => [
    { type: QuizService }
];
__decorate([
    Input('itemData')
], RemediationComponent.prototype, "remediationList", void 0);
__decorate([
    Input()
], RemediationComponent.prototype, "preferredTextFormat", void 0);
RemediationComponent = __decorate([
    Component({
        selector: 'lib-remediation',
        template: "<ng-container *ngIf=\"showRemeditaion\" class=\"remedies-wrapper-mi\">\n  <strong>Remediation:</strong>\n  <div\n    *ngFor=\"let remediation of remediationList; let k = index\"\n    class=\"common-full-width\"\n  >\n    <div *ngIf=\"isOnline\">\n      <span *ngIf=\"remediation.linkTypeId == remediaionValuesEnum.linkType\">\n        <a\n          href=\"{{ remediation.linkText2 }}\"\n          target=\"_blank\"\n          title=\"{{ remediation.linkText3 }}\"\n        >\n          <span\n            libGetFormatText\n            [preferredTextFormat]=\"preferredTextFormat\"\n            [plainText]=\"remediation.linkText1\"\n            [richText]=\"remediation.richLinkText1\"\n          >\n          </span>\n        </a>\n      </span>\n      <span\n        *ngIf=\"remediation.linkTypeId == remediaionValuesEnum.textType\"\n        class=\"remediation-text\"\n        libGetFormatText\n        [preferredTextFormat]=\"preferredTextFormat\"\n        [plainText]=\"remediation.linkText1\"\n        [richText]=\"remediation.richLinkText1\"\n      >\n      </span>\n      <div\n        *ngIf=\"remediation.linkTypeId == remediaionValuesEnum.PhoenixVideoAsset\"\n        class=\"mb20\"\n      >\n        <iframe\n          [src]=\"remediation.phoenixVideoLink\"\n          class=\"video-iframe\"\n        ></iframe>\n      </div>\n    </div>\n    <span *ngIf=\"!isOnline\">\n      <span\n        libGetFormatText\n        [preferredTextFormat]=\"preferredTextFormat\"\n        [plainText]=\"remediation.linkText1\"\n        [richText]=\"remediation.richLinkText1\"\n      ></span>\n    </span>\n  </div>\n</ng-container>\n",
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: [".video-iframe{border:1px solid #ccc;width:100%;height:600px}.remediation-text{clear:both;display:block}"]
    })
], RemediationComponent);

let SharedService = class SharedService {
    constructor(httpClient) {
        this.httpClient = httpClient;
        this.testId = JSON.parse(localStorage.getItem('testId'));
        this.instanceId = JSON.parse(localStorage.getItem('instanceId'));
        this.assetImagePath = `../../assets/media/${this.testId}/${this.instanceId}/Image`;
        this.assetVideoPath = `../../assets/media/${this.testId}/${this.instanceId}/Video`;
        this.assetAudioPath = `../../assets/media/${this.testId}/${this.instanceId}/Audio`;
        //load = require('lodash');
        this.hideShow = new BehaviorSubject(false);
        this.currentState = this.hideShow.asObservable();
        this.clearAnswer = new BehaviorSubject(false);
        this.currentAnswerState = this.clearAnswer.asObservable();
        this.userAnswer = new BehaviorSubject([]);
        this.userAnswerState = this.userAnswer.asObservable();
        this.duplicateValue = new BehaviorSubject(false);
        this.duplicateValueState = this.duplicateValue.asObservable();
        this.validateAnswerValue = new BehaviorSubject(false);
        this.validateAnswerValueState = this.validateAnswerValue.asObservable();
        this.validateCompleteEntry = new BehaviorSubject(false);
        this.validateCompleteEntryState = this.validateCompleteEntry.asObservable();
    }
    // Function to show answer event
    showAnswer(state) {
        this.hideShow.next(true);
    }
    // Function to hide answer event
    hideAnswer(state) {
        this.hideShow.next(false);
    }
    // Function to clear answer event
    clearAnswerMethod(state) {
        this.clearAnswer.next(state);
    }
    clearAnswerMethodFalse(state) {
        this.clearAnswer.next(false);
    }
    userAnswerMethod(data) {
        this.userAnswer.next(data);
    }
    duplicateValueMethod(data) {
        this.duplicateValue.next(data);
    }
    validateAnswerValueMethod(data) {
        this.validateAnswerValue.next(data);
    }
    validateCompleteEntryMethod(data) {
        this.validateCompleteEntry.next(data);
    }
    changeToCamelCase(data) {
        Object.keys(data).map(id => {
            if (id.match(/_/)) {
                // const result = this.load.camelCase(id);
                // data[result] = data[id];
                // delete data[id];
            }
        });
        return of(data);
    }
    convertTime(sec, type) {
        if (type === 'min') {
            // return $filter('number')(sec / 60, 2) + 'min';
        }
        else if (type === 'time') {
            if (sec !== undefined && typeof (sec) === 'number') {
                const hours = Math.floor((sec) / 3600);
                const minutes = Math.floor((sec - (hours * 3600)) / 60);
                const seconds = sec - (hours * 3600) - (minutes * 60);
                let hoursStr, minutesStr, secondsStr;
                if (hours < 10) {
                    hoursStr = '0' + hours;
                }
                else {
                    hoursStr = Number(hours.toString());
                }
                if (minutes < 10) {
                    minutesStr = '0' + minutes;
                }
                else {
                    minutesStr = Number(minutes.toString());
                }
                if (seconds < 10) {
                    secondsStr = '0' + seconds;
                }
                else {
                    secondsStr = Number(seconds.toString());
                }
                if (hoursStr !== '00') {
                    return hoursStr + ':' + minutesStr + ':' + secondsStr;
                }
                else {
                    return '00:' + minutesStr + ':' + secondsStr;
                }
            }
            else {
                return '00:00';
            }
        }
    }
};
SharedService.ctorParameters = () => [
    { type: HttpClient }
];
SharedService.ɵprov = ɵɵdefineInjectable({ factory: function SharedService_Factory() { return new SharedService(ɵɵinject(HttpClient)); }, token: SharedService, providedIn: "root" });
SharedService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], SharedService);

class SummaryBase {
    constructor(sharedService) {
        this.sharedService = sharedService;
        this.RemediaionValuesEnum = RemediaionType;
        this.AssetPositionValuesEnum = AssetPosition;
        this.render = true;
        this.currentTime = '';
    }
    convertTime2(sec, type) {
        const result = this.sharedService.convertTime(sec, 'time');
        return result;
    }
    // Get Question progress
    getQuestionProgressClass(questionList) {
        if (questionList.userResponse !== null) {
            if (questionList.userResponse.length > 0 && questionList.isCorrect === 1) {
                return 'wk-icon-checkmark green-checkmark';
            }
            else if (questionList.userResponse.length > 0 && questionList.isCorrect === 2) {
                return 'wk-icon-close wrong-checkmark';
            }
            else if (questionList.userResponse.length === 0 && questionList.isCorrect === 0) {
                return 'wkqp-unattempted';
            }
        }
        else {
            return 'wkqp-unattempted';
        }
    }
    // Get Selected response class
    getSelectedResponseClass(userAttemptDetails) {
        if (userAttemptDetails.isCorrect === 2) {
            return 'wkqp-alert-danger';
        }
        else if (userAttemptDetails.isCorrect === 1) {
            return 'wkqp-alert-success wkqp-success';
        }
    }
    // Get Over time limit class
    getOvertimelimitClass(question) {
        if (question.questionTimeSpent > question.questionTime) {
            return 'wkqp-badge-danger';
        }
    }
    splitStringForType(type, value) {
        const name = value.split('.')[1];
        switch (type) {
            case 'image':
                return `data:image/${name};base64,`;
            case 'audio':
                return `data:audio/${name};base64,`;
            case 'video':
                return `data:video/${name};base64,`;
            default:
                break;
        }
    }
    formattingAnswers() {
        if (this.correctAnswer) {
            this.correctAnswer = this.correctAnswer.replace(/,\s*$/, '');
        }
        if (this.selectedAnswer) {
            this.selectedAnswer = this.selectedAnswer.replace(/,\s*$/, '');
        }
        return;
    }
    classBindForAssetPosition(question) {
        let asset;
        let assetsPosition;
        let classVal;
        const classArray = [];
        if (question.parentDetails && question.parentDetails.assets) {
            asset = question.parentDetails.assets;
            assetsPosition = question.parentDetails.assets[0].assetsPosition;
        }
        else if (question.assets) {
            asset = question.assets;
            assetsPosition = question.assets[0].assetsPosition;
        }
        const classes = {
            'wkqp-col-8': asset && asset.length > 0,
            'wkqp-col-12': asset &&
                asset.length === 0 ||
                assetsPosition === 'WithinText',
            'right-assets-position-question': assetsPosition === 'Right',
            'left-assets-position-question': assetsPosition === 'Left',
            'top-assets-position-question': assetsPosition === 'Top',
            'bottom-assets-position-question': assetsPosition === 'Bottom'
        };
        const entries = Object.entries(classes);
        entries.forEach((element, index, array) => {
            if (element[1]) {
                classArray.push(element[0]);
            }
        });
        classVal = classArray.join(' ');
        return classes;
    }
}

let SummaryHeaderDetailsComponent = class SummaryHeaderDetailsComponent extends SummaryBase {
    constructor(sharedService, modalService, quizService) {
        super(sharedService);
        this.sharedService = sharedService;
        this.modalService = modalService;
        this.quizService = quizService;
        this.Editor = ClassicEditor;
        this.sendSuccess = false;
        this.sendError = false;
        this.isSubmitDisabled = false;
        this.myColumnNames = ['Question', 'Count'];
        this.myOptions = {
            colors: ['#85BC20', '#E5202E', '#007AC3'],
            is3D: true
        };
        this.myData = [];
        this.summaryData = [];
        this.render = true;
        this.options = {
            floor: 0,
            ceil: 100,
            showSelectionBar: true,
            hideLimitLabels: true,
            hidePointerLabels: true,
            getSelectionBarColor: (value) => {
                return '#429ce3';
            }
        };
        this.pageLoader = false;
        this.reportContentErrorDetails = new EventEmitter();
        this.reportMailContentDetails = new EventEmitter();
    }
    ngOnChanges(changes) {
        if (this.question) {
            this.initialLoadForsummaryData(this.question);
            this.clientDetails = this.question.clientDetails;
        }
        if (this.mailSuccessDataDetails) {
            this.isSubmitDisabled = true;
            this.sendSuccess = true;
        }
        else {
            this.sendError = true;
        }
    }
    ngOnInit() {
        this.convertedTime = this.convertTime2(this.question.totalTimeSpent, 'time');
        this.instanceData = this.quizService.instanceDetails;
    }
    initialLoadForsummaryData(data) {
        if (data) {
            this.summaryData = data;
            const date = new Date(this.summaryData.testCompletedDateUT * 1000);
            this.completedDate = date.toISOString();
            this.timeSpent = this.summaryData.totalTimeSpent;
            this.totalQuestions = this.summaryData.totalQuestions;
            this.totalCorrect = this.summaryData.totalCorrect;
            this.totalAnswered =
                this.summaryData.totalCorrect + this.summaryData.totalIncorrect;
            this.render = true;
            this.summaryDisplay = this.summaryData.summaryDisplay;
            this.summaryPredefinedText = this.summaryData.summaryPredefinedText;
            this.myData = [
                ['Correct', this.summaryData.totalCorrect],
                ['Incorrect', this.summaryData.totalIncorrect],
                ['Unattempted', this.summaryData.totalUnattempted]
            ];
        }
    }
    // Get the total percentage
    getTotalCorrectPrecent() {
        let percentage = ((this.totalCorrect * 100) /
            this.totalQuestions).toString();
        return (this.totalCorrect + ' (' + Number.parseFloat(percentage).toFixed(1) + '%)');
    }
    reportContentErrorTemplate(template) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.reportContentErrorDetails.emit(this.clientDetails);
            setTimeout(() => {
                this.reportContentError(template);
            }, 1000);
        });
    }
    // generate modal to report quiz content error to quiz provider
    reportContentError(template) {
        if (this.templateDataDetails) {
            this.sendSuccess = false;
            this.modalRef = this.modalService.show(template);
        }
    }
    sendmail() {
        this.sendMailData = new EmailDetails();
        this.sendMailData.feedBack = this.templateDataDetails.templateContent;
        this.sendMailData.to = this.clientDetails.supportEmailAddress;
        this.sendMailData.subject = this.templateDataDetails.subject;
        this.sendMailData.from = this.clientDetails.userEmail;
        this.sendMailData.clientId = this.clientDetails.clientId;
        this.sendMailData.userId = this.clientDetails.userId;
        this.sendMailData.userTestPkId = this.instanceData.id;
        this.sendMailData.userName = this.clientDetails.userName;
        this.reportMailContentDetails.emit(this.sendMailData);
    }
};
SummaryHeaderDetailsComponent.ctorParameters = () => [
    { type: SharedService },
    { type: BsModalService },
    { type: QuizService }
];
__decorate([
    Output('reportContentError')
], SummaryHeaderDetailsComponent.prototype, "reportContentErrorDetails", void 0);
__decorate([
    Output('reportMailContent')
], SummaryHeaderDetailsComponent.prototype, "reportMailContentDetails", void 0);
__decorate([
    Input('summaryData')
], SummaryHeaderDetailsComponent.prototype, "question", void 0);
__decorate([
    Input('templateData')
], SummaryHeaderDetailsComponent.prototype, "templateDataDetails", void 0);
__decorate([
    Input('mailSuccessData')
], SummaryHeaderDetailsComponent.prototype, "mailSuccessDataDetails", void 0);
SummaryHeaderDetailsComponent = __decorate([
    Component({
        selector: 'lib-summary-header-details',
        template: "<script src=\"https://cdn.ckeditor.com/4.13.1/full/ckeditor.js\"></script>\n<div style=\"width:70%;text-align: center; overflow:auto;\" *ngIf=\"!render\">\n  <span\n    style=\"font-size:80px;color:#007bff\"\n    class=\"wk-icon-spin wk-spin wkqp-spin-center\"\n  ></span>\n  <h2\n    style=\"font-size:24px;text-align: center;width:100%;margin:0px;padding:0px;\"\n  >\n    Loading Summary...\n  </h2>\n</div>\n<div *ngIf=\"render === true && summaryDisplay !== 3\" [hidden]=\"pageLoader\">\n  <h1 class=\"quiz-main-title pb10\">Quiz Results</h1>\n  <div class=\"wk-row\">\n    <div class=\"wk-col-12 wkqp-register-bg mb20\">\n      <div class=\"wk-col-6\">\n        <div class=\"wk-layout-50-50\">\n          <div class=\"wk-layout-item\">\n            <div class=\"wk-field-item\">\n              <div class=\"wk-field-header summary-label\">\n                <span>Quiz Name</span>\n              </div>\n              <span>{{ summaryData.title }}</span>\n            </div>\n          </div>\n          <div class=\"wk-layout-item\">\n            <div class=\"wk-field-item\">\n              <div class=\"wk-field-header summary-label\">\n                <span>Completed Date</span>\n              </div>\n              <span>{{\n                (completedDate | date: 'yyyy-MM-dd HH:mm:ss') || 'NA'\n              }}</span>\n            </div>\n          </div>\n        </div>\n        <div class=\"wk-layout-50-50\">\n          <div class=\"wk-layout-item\">\n            <div class=\"wk-field-item\">\n              <div class=\"wk-field-header summary-label\">\n                <span>Quiz Completed in</span>\n              </div>\n              <span>{{ convertedTime }}</span>\n            </div>\n          </div>\n          <div class=\"wk-layout-item\">\n            <div class=\"wk-field-item\">\n              <div class=\"wk-field-header summary-label\">\n                <span>Total Questions</span>\n              </div>\n              <span>{{ totalQuestions }}</span>\n            </div>\n          </div>\n        </div>\n        <div class=\"wk-layout-50-50\">\n          <div class=\"wk-layout-item\">\n            <div class=\"wk-field-item\">\n              <div class=\"wk-field-header summary-label\">\n                <span>Questions Answered</span>\n              </div>\n              <span>{{ totalAnswered }}</span>\n            </div>\n          </div>\n          <div class=\"wk-layout-item\">\n            <div class=\"wk-field-item\">\n              <div class=\"wk-field-header summary-label\">\n                <span>Answered Correctly</span>\n              </div>\n              <span [innerText]=\"getTotalCorrectPrecent()\"></span>\n            </div>\n          </div>\n        </div>\n        <!-- report content error btn -->\n        <div class=\"box\" *ngIf=\"clientDetails.enableReportError\">\n          <button\n            type=\"button\"\n            (click)=\"reportContentErrorTemplate(template)\"\n            class=\"wk-button-primary report-content-btn\"\n          >\n            Report content error\n          </button>\n        </div>\n      </div>\n      <div class=\"wk-col-6\">\n        <div class=\"wk-layout\">\n          <div class=\"wk-field-item\">\n            <google-chart\n              class=\"chat-wrapper\"\n              [title]=\"myTitle\"\n              [type]=\"'PieChart'\"\n              [data]=\"myData\"\n              [columnNames]=\"myColumnNames\"\n              [options]=\"myOptions\"\n            >\n            </google-chart>\n          </div>\n        </div>\n      </div>\n\n      <!-- report content error btn -->\n    </div>\n\n    <div class=\"wk-layout quiz-ans-section\" *ngIf=\"summaryDisplay === 1\">\n      <div class=\"wk-layout-item\">\n        <h2 class=\"wkqp-module-heading pb20\">Quiz Answers</h2>\n      </div>\n    </div>\n  </div>\n</div>\n<div\n  class=\"wk-summary-3\"\n  *ngIf=\"summaryPredefinedText != null && summaryDisplay === 3\"\n>\n  {{ summaryPredefinedText }}\n</div>\n\n<!-- report content modal -->\n<ng-template #template class=\"modal-dialog modal-lg\">\n  <div class=\"modal-content\">\n    <div class=\"modal-title-main\">\n      Report content error\n    </div>\n    <button\n      aria-label=\"close dialog\"\n      class=\"wk-icon-close-empty\"\n      role=\"button\"\n      type=\"button\"\n      (click)=\"modalRef.hide()\"\n    ></button>\n    <div class=\"modal-body\" id=\"modal-body\">\n      <div class=\"wk-field-item mb20\">\n        <div class=\"wk-field-header\">\n          <label for=\"TO\">To <span class=\"mandatory-fields\">*</span></label>\n        </div>\n        <div>\n          <input\n            maxlength=\"80\"\n            id=\"TO\"\n            type=\"text\"\n            placeholder=\"clientDetails.supportEmailAddress\"\n            [(ngModel)]=\"clientDetails.supportEmailAddress\"\n            readonly=\"clientDetails.supportEmailAddress\"\n          />\n        </div>\n      </div>\n      <div class=\"wk-field-item mb20\">\n        <div class=\"wk-field-header\">\n          <label for=\"SUBJECT\"\n            >Subject <span class=\"mandatory-fields\">*</span></label\n          >\n        </div>\n        <div>\n          <input\n            maxlength=\"80\"\n            id=\"SUBJECT\"\n            type=\"text\"\n            placeholder=\"templateDataDetails.subject\"\n            [(ngModel)]=\"templateDataDetails.subject\"\n            readonly=\"templateDataDetails.subject\"\n          />\n        </div>\n      </div>\n      <div class=\"wk-field-item mb20\">\n        <div>\n          <ckeditor\n            tagName=\"textarea\"\n            [editor]=\"Editor\"\n            [(ngModel)]=\"templateDataDetails.templateContent\"\n            [config]=\"{ uiColor: '#99000' }\"\n          >\n          </ckeditor>\n        </div>\n      </div>\n      <div *ngIf=\"sendSuccess\" class=\"wk-field-success mb20\">\n        Email sent successfully\n      </div>\n      <div *ngIf=\"sendError\" class=\"wk-field-error mb20\">\n        Something went wrong\n      </div>\n    </div>\n    <div class=\"modal-footer\">\n      <button\n        class=\"wkqp-button wkqp-button-danger\"\n        type=\"button\"\n        (click)=\"modalRef.hide()\"\n      >\n        Cancel\n      </button>\n      <button\n        class=\"wkqp-button wkqp-button-warning\"\n        [ngClass]=\"{ 'custom-icon-disabled': isSubmitDisabled }\"\n        type=\"button\"\n        (click)=\"sendmail()\"\n      >\n        Send\n      </button>\n    </div>\n  </div>\n</ng-template>\n<!-- report content modal -->\n",
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: [".wkqp-badge-danger{top:-4px}.chat-wrapper{background-color:#fff;border:1px solid #a3a3a3;width:572px;height:278px}.modal-dialog{margin:0 auto!important;top:50%!important;transform:translate(-50%,-50%)!important;-ms-transform:translate(-50%,-50%)!important;position:absolute!important;left:50%;width:550px;min-width:550px}.modal-footer{float:left;width:100%;padding:15px;text-align:right;border-top:0 solid #e5e5e5!important}.close.pull-right .wk-icon-close-empty{background-color:transparent;border:0;padding:0;border-radius:0;color:#80bde1;font-size:40px;font-weight:300!important}.close.pull-right .wk-icon-close-empty:before{font-weight:300!important}.close.pull-right .wk-icon-close-empty:hover{color:#fff;background-color:transparent}button.close:focus,button.close:hover{background-color:transparent!important;color:#fff}.wk-field-success{color:#3d854d;font-weight:600;border:1px solid #3d854d;padding:10px;font-style:oblique}"]
    })
], SummaryHeaderDetailsComponent);

let ClinicalSymptomsSummaryComponent = class ClinicalSymptomsSummaryComponent extends SummaryBase {
    constructor(sharedService) {
        super(sharedService);
        this.sharedService = sharedService;
    }
    ngOnChanges(changes) {
        if (this.question) {
            this.getAnswers();
            this.convertedTime = this.convertTime2(this.question.questionTimeSpent, 'time');
        }
    }
    ngOnInit() {
    }
    getAnswers() {
        this.correctAnswer = '';
        this.selectedAnswer = '';
        this.question.rationale = '';
        this.question.correct = false;
        const correctIds = [];
        const selectedIds = [];
        if (this.question) {
            if (this.question.parentDetails && this.question.parentDetails.assets[0]) {
                this.question.parentDetails.assetsPosition = this.question.parentDetails.assets[0].assetsPosition;
                this.question.assetsPosition = this.question.parentDetails.assets[0].assetsPosition;
            }
            for (const choice of this.question.choiceInteraction.simpleChoices) {
                if (choice.correct === true) {
                    correctIds.push(choice.choiceId);
                    if (this.correctAnswer !== '') {
                        this.correctAnswer = this.correctAnswer + ',' + choice.label;
                    }
                    else {
                        this.correctAnswer = choice.label;
                    }
                }
                if (this.question.userResponse.indexOf(choice.choiceId) !== -1) {
                    selectedIds.push(choice.choiceId);
                    if (this.selectedAnswer !== '') {
                        this.selectedAnswer = this.selectedAnswer + ',' + choice.label;
                    }
                    else {
                        this.selectedAnswer = choice.label;
                    }
                }
            }
            this.formattingAnswers();
            if (correctIds === selectedIds) {
                this.question.correct = true;
            }
        }
        return true;
    }
};
ClinicalSymptomsSummaryComponent.ctorParameters = () => [
    { type: SharedService }
];
__decorate([
    Input('summaryData')
], ClinicalSymptomsSummaryComponent.prototype, "question", void 0);
ClinicalSymptomsSummaryComponent = __decorate([
    Component({
        selector: 'lib-clinical-symptoms-summary',
        template: "<ng-container *ngIf=\"question.parentDetails\">\n  <div class=\"wk-row\">\n    <div class=\"wkqp-field-header \">\n      <span class=\"medicalcase-label\"> Clinical Presenting Symptoms</span>\n    </div>\n    <media-carousel\n      [imagePath]=\"question.parentDetails.assets[0].assetPath\"\n      [assetData]=\"question.parentDetails.assets\"\n      [assetsPosition]=\"question.parentDetails.assetsPosition\"\n      *ngIf=\"\n        question &&\n        question.parentDetails &&\n        question.parentDetails.assets &&\n        question.parentDetails.assets.length > 0 &&\n        question.parentDetails.assetsPosition !=\n          AssetPositionValuesEnum.withInText &&\n        question.parentDetails.assetsPosition != AssetPositionValuesEnum.bottom\n      \"\n    ></media-carousel>\n\n    <div\n      [ngClass]=\"{\n        'wk-col-8 asset-left-width66':\n          question &&\n          question.parentDetails.assets != undefined &&\n          question.parentDetails.assets.length != 0 &&\n          question.parentDetails.assetsPosition !=\n            AssetPositionValuesEnum.withInText,\n        'wk-col-12':\n          (question &&\n            question.parentDetails &&\n            question.parentDetails.assets == undefined) ||\n          (question &&\n            question.parentDetails &&\n            question.parentDetails.assets.length == 0) ||\n          (question &&\n            question.parentDetails &&\n            question.parentDetails.assetsPosition ==\n              AssetPositionValuesEnum.withInText),\n        'right-assets-position-question':\n          question &&\n          question.parentDetails.assets != undefined &&\n          question.parentDetails.assets.length != 0 &&\n          question.parentDetails.assetsPosition ==\n            AssetPositionValuesEnum.right,\n        'left-assets-position-question':\n          question &&\n          question.parentDetails.assets != undefined &&\n          question.parentDetails.assets.length != 0 &&\n          question.parentDetails.assetsPosition == AssetPositionValuesEnum.left,\n        'top-assets-position-question':\n          question &&\n          question.parentDetails.assets != undefined &&\n          question.parentDetails.assets.length != 0 &&\n          question.parentDetails.assetsPosition == AssetPositionValuesEnum.top,\n        'bottom-assets-position-question':\n          question &&\n          question.parentDetails.assets != undefined &&\n          question.parentDetails.assets.length != 0 &&\n          question.parentDetails.assetsPosition ==\n            AssetPositionValuesEnum.bottom\n      }\"\n    >\n      <div class=\"wkqp-layout-item\">\n        <div class=\"wkqp-field-item normal-font mb0 \">\n          <div\n            class=\"wkqp-field-header\"\n            *ngIf=\"\n              question.parentDetails.assetsPosition !=\n              AssetPositionValuesEnum.withInText\n            \"\n          >\n            <p\n              class=\"mb20 normal-font wkqp-prewrap heading-h3 headingh3-res question-parent-text\"\n            >\n              <span\n                libGetFormatText\n                [preferredTextFormat]=\"question.preferredTextFormat\"\n                [plainText]=\"question.parentDetails.promptText\"\n                [richText]=\"question.parentDetails.richPromptText\"\n              ></span>\n            </p>\n          </div>\n          <div\n            class=\"wkqp-field-header\"\n            *ngIf=\"\n              question.parentDetails.assetsPosition ==\n              AssetPositionValuesEnum.withInText\n            \"\n          >\n            <strong>\n              <item-text-assets\n                [promptText]=\"question.parentDetails.promptText\"\n                [assetData]=\"question.parentDetails.assets\"\n                [assetsPosition]=\"AssetPositionValuesEnum.withInText\"\n              ></item-text-assets>\n            </strong>\n          </div>\n        </div>\n      </div>\n\n      <media-carousel\n        *ngIf=\"\n          question.parentDetails.assets &&\n          question.parentDetails.assets.length != 0 &&\n          question.parentDetails.assetsPosition ==\n            AssetPositionValuesEnum.bottom\n        \"\n        [assetData]=\"question.parentDetails.assets\"\n        [assetsPosition]=\"question.parentDetails.assetsPosition\"\n      ></media-carousel>\n    </div>\n  </div>\n  <div class=\"common-full-width \">\n    <div class=\"wkqp-layout-item summary2-mb0\">\n      <div class=\"wk-row gray-bg-result mb20\">\n        <!--Child Question prompt text-->\n        <div class=\"wk-col-8 responsive-pl15\">\n          <span class=\"wkqb-question-number\">\n            <strong>{{ question.sequence }}</strong>\n          </span>\n          <span class=\"qp-ts-number-right\" *ngIf=\"question.promptText\">\n            <strong class=\"wkqp-prewrap\">{{ question.promptText }}</strong>\n          </span>\n        </div>\n\n        <!--Question time spent-->\n        <div class=\"wk-col-4 responsive-timespent time-qu-pt-remove\">\n          <span\n            class=\"que-mob-left mr10\"\n            [ngClass]=\"getQuestionProgressClass(question)\"\n          ></span>\n          <span\n            class=\"wkqp-badge time-mob-right\"\n            [ngClass]=\"getOvertimelimitClass(question)\"\n          >\n            Time Spent -\n            {{ convertedTime }}\n          </span>\n        </div>\n      </div>\n    </div>\n\n    <!--Child question user response-->\n    <div class=\"wkqp-layout-item mb20 summary3-mb0 common-full-width\">\n      <div class=\"wkqp-field-item summary5-mb0\">\n        <div\n          *ngIf=\"question.userResponse[0] && question.userResponse.length > 0\"\n        >\n          <!--Your Response-->\n          <p\n            class=\"wkqp-prewrap mb20\"\n            ng-show=\"question.userResponse.length > 0\"\n            [ngClass]=\"getSelectedResponseClass(question)\"\n          >\n            <strong>Your Response: </strong>\n            <label class=\"response-inline\">{{ selectedAnswer }}</label>\n          </p>\n\n          <!--Correct Response-->\n          <p\n            *ngIf=\"question.isCorrect != 1\"\n            class=\"wkqp-prewrap wkqp-alert-success wkqp-success mb20\"\n          >\n            <strong>Correct Response: </strong>\n            <label class=\"response-inline\">{{ correctAnswer }}</label>\n          </p>\n        </div>\n        <div\n          class=\"common-full-width\"\n          *ngIf=\"!question.userResponse || question.userResponse.length == 0\"\n        >\n          <p class=\"wkqp-alert-danger\">\n            <strong>You did not answer this question</strong>\n          </p>\n        </div>\n        <div class=\"common-full-width mb20\">\n          <lib-rationale [itemData]=\"question.modelFeedback\"></lib-rationale>\n\n          <lib-remediation\n            [itemData]=\"question.remediationLinks\"\n          ></lib-remediation>\n        </div>\n      </div>\n    </div>\n  </div>\n</ng-container>\n",
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: [""]
    })
], ClinicalSymptomsSummaryComponent);

let DragAndDropSummaryComponent = class DragAndDropSummaryComponent extends SummaryBase {
    constructor(sharedService) {
        super(sharedService);
        this.sharedService = sharedService;
    }
    ngOnChanges(changes) {
        if (this.question) {
            this.getAnswers();
        }
    }
    ngOnInit() {
        this.convertedTime = this.convertTime2(this.question.questionTimeSpent, 'time');
    }
    getAnswers() {
        this.correctAnswer = '';
        this.selectedAnswer = '';
        this.question.correct = false;
        if (this.question) {
            // Create user response order
            if (this.question.userResponse !== undefined && this.question.userResponse !== null) {
                this.question.selectedAnswer = [];
                for (const answer of this.question.choiceInteraction.simpleChoices) {
                    const index = this.question.userResponse.indexOf(answer.choiceId);
                    this.question.selectedAnswer[index] = answer;
                }
                this.selectedAnswer = this.question.selectedAnswer;
            }
            // Create correct answer order
            this.correctAnswer = [];
            for (const answer of this.question.choiceInteraction.simpleChoices) {
                const order = answer.order - 1;
                // Create answer list in correct order
                this.correctAnswer[order] = answer.label;
            }
        }
        return true;
    }
};
DragAndDropSummaryComponent.ctorParameters = () => [
    { type: SharedService }
];
__decorate([
    Input('summaryData')
], DragAndDropSummaryComponent.prototype, "question", void 0);
DragAndDropSummaryComponent = __decorate([
    Component({
        selector: 'lib-drag-and-drop-summary',
        template: "<ng-container *ngIf=\"question.itemType == 13\">\n  <div class=\"wk-row\">\n    <media-carousel\n      [imagePath]=\"question.assets[0].assetPath\"\n      [assetData]=\"question.assets\"\n      [assetsPosition]=\"question.assetsPosition\"\n      *ngIf=\"\n        question &&\n        question.assets &&\n        question.assets.length != 0 &&\n        question.assets != undefined &&\n        question.assetsPosition != AssetPositionValuesEnum.withInText &&\n        question.assetsPosition != AssetPositionValuesEnum.bottom\n      \"\n    ></media-carousel>\n    <div\n      [ngClass]=\"{\n        'wk-col-8 asset-left-width66':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition != AssetPositionValuesEnum.withInText,\n        'wk-col-12':\n          (question && question.assets == undefined) ||\n          (question && question.assets.length == 0) ||\n          (question &&\n            question.assetsPosition == AssetPositionValuesEnum.withInText),\n        'right-assets-position-question':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.right,\n        'left-assets-position-question':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.left,\n        'top-assets-position-question':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.top,\n        'bottom-assets-position-question':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.bottom\n      }\"\n    >\n      <div class=\"wkqp-layout-item summary4-mb0 common-full-width mb20\">\n        <div class=\"wkqp-field-item summary5-mb0\">\n          <div class=\"wk-row gray-bg-result mb20\">\n            <div class=\"wk-col-8 responsive-pl15\">\n              <!--Question sequence-->\n              <span class=\"wkqb-question-number\">\n                <strong>{{ question.sequence }}</strong>\n              </span>\n              <!--Question Prompt text-->\n              <span\n                class=\"qp-ts-number-right\"\n                *ngIf=\"\n                  question.assetsPosition != AssetPositionValuesEnum.withInText\n                \"\n              >\n                <strong class=\"wkqp-prewrap\">{{ question.promptText }}</strong>\n              </span>\n              <span\n                *ngIf=\"\n                  question.assetsPosition == AssetPositionValuesEnum.withInText\n                \"\n              >\n                <item-text-assets\n                  [promptText]=\"question.promptText\"\n                  [assetData]=\"question.assets\"\n                  [assetsPosition]=\"AssetPositionValuesEnum.withInText\"\n                ></item-text-assets>\n              </span>\n            </div>\n            <media-carousel\n              [imagePath]=\"question.assets[0].assetPath\"\n              [assetData]=\"question.assets\"\n              [assetsPosition]=\"question.assetsPosition\"\n              *ngIf=\"\n                question &&\n                question.assets &&\n                question.assets.length != 0 &&\n                question.assets != undefined &&\n                question.assetsPosition != AssetPositionValuesEnum.withInText &&\n                question.assetsPosition == AssetPositionValuesEnum.bottom\n              \"\n            ></media-carousel>\n            <!--Question Time spent-->\n            <div class=\"wk-col-4 responsive-timespent time-qu-pt-remove\">\n              <span\n                class=\"que-mob-left mr10\"\n                [ngClass]=\"getQuestionProgressClass(question)\"\n              >\n              </span>\n              <span\n                class=\"wkqp-badge time-mob-right\"\n                [ngClass]=\"getOvertimelimitClass(question)\"\n              >\n                Time spent -\n                {{ convertedTime }}\n              </span>\n            </div>\n          </div>\n\n          <div\n            class=\"common-full-width mb20\"\n            *ngIf=\"question.userResponse[0] && question.userResponse.length > 0\"\n          >\n            <!--Your Response-->\n            <p\n              class=\"wkqp-prewrap mb20\"\n              [ngClass]=\"getSelectedResponseClass(question)\"\n            >\n              <strong>Your Response: </strong>\n            </p>\n            <div class=\"common-full-width mb20\">\n              <div\n                *ngFor=\"\n                  let userResponseDetails of selectedAnswer;\n                  let i = index\n                \"\n              >\n                <span class=\"dragdrop-correctanslabel\">\n                  <span class=\"pr1rem\">{{ i + 1 }})</span>\n                  <span>{{ userResponseDetails.label }}</span>\n                </span>\n              </div>\n            </div>\n\n            <!--Correct Response-->\n            <div *ngIf=\"question.isCorrect != 1\">\n              <p class=\"wkqp-alert-success wkqp-prewrap wkqp-success  mb20\">\n                <strong>Correct Response: </strong>\n              </p>\n              <div\n                class=\"mb20\"\n                *ngFor=\"let choiceValue of correctAnswer; let i = index\"\n              >\n                <span class=\"dragdrop-correctanslabel\">\n                  <span class=\"pr1rem\">{{ i + 1 }})</span>\n                  <span>{{ choiceValue }}</span>\n                </span>\n              </div>\n            </div>\n          </div>\n\n          <!--Unattempted Response-->\n          <div class=\"common-full-width mb20\" *ngIf=\"!question.userResponse[0]\">\n            <p class=\"wkqp-alert-danger\">\n              <strong>You did not answer this question</strong>\n            </p>\n          </div>\n        </div>\n      </div>\n    </div>\n    <div class=\"common-full-width mb20\">\n      <!--Rationale-->\n      <lib-rationale [itemData]=\"question.modelFeedback\"></lib-rationale>\n      <!-- remediation -->\n      <lib-remediation [itemData]=\"question.remediationLinks\"></lib-remediation>\n    </div>\n  </div>\n</ng-container>\n",
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: [""]
    })
], DragAndDropSummaryComponent);

let FigureLabelingSummaryComponent = class FigureLabelingSummaryComponent extends SummaryBase {
    constructor(sharedService, quizService, _DomSanitizationService) {
        super(sharedService);
        this.sharedService = sharedService;
        this.quizService = quizService;
        this._DomSanitizationService = _DomSanitizationService;
    }
    ngOnChanges(changes) {
        if (this.question) {
            this.getAnswers();
        }
    }
    ngOnInit() {
        this.convertedTime = this.convertTime2(this.question.questionTimeSpent, 'time');
    }
    getAnswers() {
        this.correctAnswer = '';
        this.selectedAnswer = '';
        if (this.question) {
            // Used the data from server
            this.userAnswerView = {};
            this.userAnswerViewDetails = [];
            if (this.question.userResponse.length !== 0) {
                for (const i of this.question.userResponse) {
                    for (const item of this.question.graphicInteraction
                        .figureLabelChoices) {
                        if (Number(i) === item.choiceId) {
                            this.userAnswerView[item.choiceId] = item.label;
                            this.userAnswerViewDetails.push(item);
                        }
                    }
                }
            }
        }
        return true;
    }
    loadImagePath(assetType, slide) {
        if (this.quizService.isOnline) {
            return slide.assetPath;
        }
        return this._DomSanitizationService.bypassSecurityTrustUrl(this.splitStringForType(assetType, slide.assetName) + slide.assetsContent);
    }
};
FigureLabelingSummaryComponent.ctorParameters = () => [
    { type: SharedService },
    { type: QuizService },
    { type: DomSanitizer }
];
__decorate([
    Input('summaryData')
], FigureLabelingSummaryComponent.prototype, "question", void 0);
FigureLabelingSummaryComponent = __decorate([
    Component({
        selector: 'lib-figure-labeling-summary',
        template: "<ng-container *ngIf=\"question.itemType == 17\">\n  <div class=\"wk-row\">\n    <div class=\"wkqp-col-12\">\n      <div class=\"wkqp-layout-item mb20 summary4-mb0\">\n        <div class=\"wkqp-field-item summary5-mb0\">\n          <div\n            class=\"wk-row gray-bg-result fig-lab-que-wrapper mb20\"\n            id=\"svg-container\"\n          >\n            <span class=\"wkqb-question-number seq-left\">\n              <strong>{{ question.sequence }}</strong>\n            </span>\n            <div\n              class=\"wk-col-4 responsive-timespent time-qu-pt-remove pull-right time-qu-prmr0\"\n            >\n              <span\n                class=\"que-mob-left\"\n                [ngClass]=\"getQuestionProgressClass(question)\"\n              >\n              </span>\n              <span\n                class=\"wkqp-badge time-mob-right \"\n                [ngClass]=\"getOvertimelimitClass(question)\"\n              >\n                Time spent -\n                {{ convertedTime }}\n              </span>\n            </div>\n            <div class=\"wkqp-fullwidth\">\n              <figure-label\n                *ngIf=\"question.assets[0].assetName\"\n                [correctOptions]=\"\n                  question.graphicInteraction.figureLabelChoices\n                \"\n                [userAnswer]=\"userAnswerView\"\n                [assetData]=\"question.assets\"\n              ></figure-label>\n            </div>\n          </div>\n          <br *ngIf=\"!question.userResponse[0]\" />\n\n          <div\n            class=\"common-full-width\"\n            *ngIf=\"\n              question.userResponse &&\n              question.userResponse.length > 0 &&\n              question.userResponse[0] !== null\n            \"\n          >\n            <!--Your Response-->\n            <p\n              class=\"wkqp-prewrap mb20\"\n              [ngClass]=\"getSelectedResponseClass(question)\"\n            >\n              <strong>Your Response: </strong>\n            </p>\n            <table class=\"wk-table assets-permit-mt25mb0 mb20\">\n              <tbody>\n                <tr\n                  *ngFor=\"\n                    let labelDetails of userAnswerViewDetails;\n                    let i = index\n                  \"\n                >\n                  <td width=\"10%\">\n                    <span class=\"wk-prewrap\">{{ i + 1 }}</span>\n                  </td>\n                  <td width=\"80%\">\n                    {{ labelDetails.label }}\n                  </td>\n                </tr>\n              </tbody>\n            </table>\n            <!--Correct Response-->\n            <div class=\"mb20\" *ngIf=\"question.isCorrect != 1\">\n              <p class=\"wkqp-alert-success wkqp-prewrap wkqp-success mb20\">\n                <strong>Correct Response: </strong>\n              </p>\n              <img\n                [src]=\"loadImagePath('image', question.assets[1])\"\n                class=\"img-responsive\"\n                alt=\"Image\"\n                width=\"300px\"\n              />\n            </div>\n          </div>\n          <div *ngIf=\"!question.userResponse[0]\">\n            <p class=\"wkqp-alert-danger\">\n              <strong>You did not answer this question</strong>\n            </p>\n          </div>\n          <div class=\"common-full-width mb20\">\n            <!--Rationale-->\n            <lib-rationale [itemData]=\"question.modelFeedback\"></lib-rationale>\n            <!-- remediation -->\n            <lib-remediation\n              [itemData]=\"question.remediationLinks\"\n            ></lib-remediation>\n          </div>\n        </div>\n      </div>\n    </div>\n  </div>\n</ng-container>\n",
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: [".wk-col-4.responsive-timespent.time-qu-pt-remove.pull-right.time-qu-prmr0{margin-right:0;padding-right:0}"]
    })
], FigureLabelingSummaryComponent);

let FillInTheBlanksSummaryComponent = class FillInTheBlanksSummaryComponent extends SummaryBase {
    constructor(sharedService) {
        super(sharedService);
        this.sharedService = sharedService;
    }
    ngOnChanges(changes) {
        if (this.question) {
            this.getAnswers();
        }
    }
    ngOnInit() {
        this.convertedTime = this.convertTime2(this.question.questionTimeSpent, 'time');
    }
    getAnswers() {
        this.correctAnswer = '';
        this.selectedAnswer = '';
        if (this.question) {
            if (this.question.parentDetails &&
                this.question.parentDetails.assets[0]) {
                this.question.parentDetails.assetsPosition = this.question.parentDetails.assets[0].assetsPosition;
                this.question.assetsPosition = this.question.parentDetails.assets[0].assetsPosition;
            }
            for (const answer of this.question.userResponse) {
                if (this.selectedAnswer) {
                    this.selectedAnswer = this.selectedAnswer + ',' + (answer ? answer : 'No Response');
                }
                else {
                    this.selectedAnswer = answer ? answer : 'No Response';
                }
            }
            this.formattingAnswers();
        }
        return true;
    }
};
FillInTheBlanksSummaryComponent.ctorParameters = () => [
    { type: SharedService }
];
__decorate([
    Input('summaryData')
], FillInTheBlanksSummaryComponent.prototype, "question", void 0);
FillInTheBlanksSummaryComponent = __decorate([
    Component({
        selector: 'lib-fill-in-the-blanks-summary',
        template: "<ng-container *ngIf=\"question.itemType == 3\">\n  <div class=\"wk-row\">\n    <media-carousel\n      [imagePath]=\"question.assets[0].assetPath\"\n      [assetData]=\"question.assets\"\n      [assetsPosition]=\"question.assetsPosition\"\n      *ngIf=\"\n        question &&\n        question.assets &&\n        question.assets.length != 0 &&\n        question.assets != undefined &&\n        question.assetsPosition != AssetPositionValuesEnum.withInText &&\n        question.assetsPosition != AssetPositionValuesEnum.bottom\n      \"\n    ></media-carousel>\n    <div\n      [ngClass]=\"{\n        'wk-col-8 asset-left-width66':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition != AssetPositionValuesEnum.withInText,\n        'wk-col-12':\n          (question && question.assets == undefined) ||\n          (question && question.assets.length == 0) ||\n          (question &&\n            question.assetsPosition == AssetPositionValuesEnum.withInText),\n        'right-assets-position-question':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.right,\n        'left-assets-position-question':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.left,\n        'top-assets-position-question':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.top,\n        'bottom-assets-position-question':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.bottom\n      }\"\n    >\n      <div class=\"wkqp-layout-item mb20 summary4-mb0 \">\n        <div class=\"summary5-mb0 common-full-width \">\n          <div class=\"wk-row gray-bg-result mb20\">\n            <div class=\"wk-col-8 responsive-pl15\">\n              <!--Question sequence-->\n              <span class=\"wkqb-question-number\">\n                <strong>{{ question.sequence }}</strong>\n              </span>\n              <!--Question prompt text-->\n              <span\n                class=\"qp-ts-number-right\"\n                *ngIf=\"\n                  question.assetsPosition != AssetPositionValuesEnum.withInText\n                \"\n              >\n                <strong class=\"wkqp-prewrap\">\n                  {{ question.promptText }}\n                </strong>\n              </span>\n              <div class=\"common-full-width\">\n                <span\n                  *ngIf=\"\n                    question.assetsPosition ==\n                    AssetPositionValuesEnum.withInText\n                  \"\n                >\n                  <strong>\n                    <item-text-assets\n                      [promptText]=\"question.promptText\"\n                      [assetData]=\"question.assets\"\n                      [assetsPosition]=\"AssetPositionValuesEnum.withInText\"\n                    ></item-text-assets>\n                  </strong>\n                </span>\n              </div>\n            </div>\n            <media-carousel\n              [imagePath]=\"question.assets[0].assetPath\"\n              [assetData]=\"question.assets\"\n              [assetsPosition]=\"question.assetsPosition\"\n              *ngIf=\"\n                question &&\n                question.assets &&\n                question.assets.length != 0 &&\n                question.assets != undefined &&\n                question.assetsPosition != AssetPositionValuesEnum.withInText &&\n                question.assetsPosition == AssetPositionValuesEnum.bottom\n              \"\n            ></media-carousel>\n            <!--Question Time spent-->\n            <div class=\"wk-col-4 responsive-timespent time-qu-pt-remove\">\n              <span\n                class=\"que-mob-left mr10\"\n                [ngClass]=\"getQuestionProgressClass(question)\"\n              ></span>\n              <span\n                class=\"wkqp-badge time-mob-right\"\n                [ngClass]=\"getOvertimelimitClass(question)\"\n              >\n                Time Spent -\n                {{ convertedTime }}</span\n              >\n            </div>\n          </div>\n\n          <div\n            class=\"common-full-width\"\n            *ngIf=\"question.userResponse && question.userResponse.length > 0\"\n          >\n            <!--Your Response-->\n            <p\n              class=\"wkqp-prewrap mb20\"\n              [ngClass]=\"getSelectedResponseClass(question)\"\n            >\n              <strong>Your Response: </strong>\n              {{ selectedAnswer }}\n            </p>\n\n            <!--Correct Response-->\n            <div\n              class=\"wkqp-alert-success wkqp-prewrap wkqp-success correct-response-success-box badge-normal mb20\"\n              *ngIf=\"question.isCorrect != 1\"\n            >\n              <strong class=\"cr-pb10\">Correct Response: </strong>\n              <table\n                class=\"table table-bordered wkqp-table wkqp-table-permit-overflow correct-inline-text table table-bordered cr-table-mb5\"\n                *ngIf=\"!question.correct\"\n              >\n                <tbody>\n                  <tr\n                    *ngFor=\"\n                      let blanks of question.textEntryInteraction.inlineChoices;\n                      let blankNum = index\n                    \"\n                  >\n                    <td width=\"15%\" class=\"ans-response\">\n                      <strong>Blank-{{ blankNum + 1 }}</strong>\n                    </td>\n                    <td\n                      *ngIf=\"question.labelText == 'FILL_IN_THE_BLANK'\"\n                      width=\"85%\"\n                    >\n                      <span\n                        class=\"wkqp-badge\"\n                        *ngFor=\"let choice of blanks; let choiceNum = index\"\n                      >\n                        {{ choice }}\n                      </span>\n                    </td>\n                  </tr>\n                </tbody>\n              </table>\n            </div>\n          </div>\n\n          <!--Unattempted Response-->\n          <div class=\"common-full-width\" *ngIf=\"!question.userResponse[0]\">\n            <p class=\"wkqp-alert-danger\">\n              <strong>You did not answer this question</strong>\n            </p>\n          </div>\n        </div>\n      </div>\n    </div>\n    <div class=\"common-full-width mb20\">\n      <!--Rationale-->\n      <lib-rationale [itemData]=\"question.modelFeedback\"></lib-rationale>\n      <!-- remediation -->\n      <lib-remediation [itemData]=\"question.remediationLinks\"></lib-remediation>\n    </div>\n  </div>\n</ng-container>\n",
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: [".wkqp-alert-success.wkqp-prewrap.wkqp-success.correct-response-success-box .cr-pb10{padding-bottom:10px;display:inline-block}.wkqp-alert-success.wkqp-prewrap.wkqp-success.correct-response-success-box .cr-table-mb5{margin-bottom:5px}.badge-normal table tr td span.wkqp-badge{font-style:normal}.badge-normal table tr td.ans-response strong{color:#474747;font-size:.9375rem;font-style:normal}"]
    })
], FillInTheBlanksSummaryComponent);

let GraphicOptionSummaryComponent = class GraphicOptionSummaryComponent extends SummaryBase {
    constructor(quizService, sharedService, _DomSanitizationService) {
        super(sharedService);
        this.quizService = quizService;
        this.sharedService = sharedService;
        this._DomSanitizationService = _DomSanitizationService;
    }
    ngOnChanges(changes) {
        if (this.question) {
            this.getAnswers();
        }
    }
    ngOnInit() {
        this.isOnlineEngine = this.quizService.isOnline;
        this.convertedTime = this.convertTime2(this.question.questionTimeSpent, 'time');
    }
    getAnswers() {
        this.correctAnswer = '';
        this.selectedAnswer = '';
        this.question.selectedAnswer = [];
        this.question.rationale = '';
        this.question.correct = false;
        const correctIds = [];
        const selectedIds = [];
        if (this.question) {
            for (const choice of this.question.choiceInteraction.simpleChoices) {
                if (choice.correct === true) {
                    correctIds.push(choice.choiceId);
                    this.correctAnswer = choice.value;
                }
                if (this.question.userResponse.indexOf(choice.choiceId) !== -1) {
                    selectedIds.push(choice.choiceId);
                    this.selectedAnswer = choice.value;
                }
            }
            if (correctIds === selectedIds) {
                this.question.correct = true;
            }
        }
        return true;
    }
    loadImagePath(assetType, slide) {
        if (this.quizService.isOnline) {
            return slide.assetPath;
        }
        return this._DomSanitizationService.bypassSecurityTrustUrl(this.splitStringForType(assetType, slide.assetName) + slide.assetsContent);
    }
};
GraphicOptionSummaryComponent.ctorParameters = () => [
    { type: QuizService },
    { type: SharedService },
    { type: DomSanitizer }
];
__decorate([
    Input('summaryData')
], GraphicOptionSummaryComponent.prototype, "question", void 0);
GraphicOptionSummaryComponent = __decorate([
    Component({
        selector: 'lib-graphic-option-summary',
        template: "<ng-container *ngIf=\"question.itemType == 23\">\n  <div class=\"wk-row\">\n    <media-carousel\n      [imagePath]=\"question.assets[0].assetPath\"\n      [assetData]=\"question.assets\"\n      [assetsPosition]=\"question.assetsPosition\"\n      *ngIf=\"\n        question &&\n        question.assets &&\n        question.assets.length != 0 &&\n        question.assets != undefined &&\n        question.assetsPosition != AssetPositionValuesEnum.withInText &&\n        question.assetsPosition != AssetPositionValuesEnum.bottom\n      \"\n    ></media-carousel>\n\n    <div\n      [ngClass]=\"{\n        'wk-col-8 asset-left-width66':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition != AssetPositionValuesEnum.withInText,\n        'wk-col-12':\n          (question && question.assets == undefined) ||\n          (question && question.assets.length == 0) ||\n          (question &&\n            question.assetsPosition == AssetPositionValuesEnum.withInText),\n        'right-assets-position-question':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.right,\n        'left-assets-position-question':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.left,\n        'top-assets-position-question':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.top,\n        'bottom-assets-position-question':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.bottom\n      }\"\n    >\n      <div class=\"wkqp-layout-item summary4-mb0 common-full-width \">\n        <div class=\"wkqp-field-item summary5-mb0\">\n          <div class=\"wk-row gray-bg-result mb20\">\n            <div class=\"wk-col-8 responsive-pl15\">\n              <!--Question number-->\n              <span class=\"wkqb-question-number\">\n                <strong>{{ question.sequence }}</strong>\n              </span>\n\n              <!--Question prompt text-->\n              <span\n                class=\"qp-ts-number-right\"\n                *ngIf=\"\n                  question.assetsPosition != AssetPositionValuesEnum.withInText\n                \"\n              >\n                <strong class=\"wkqp-prewrap\">{{\n                  question.promptText\n                }}</strong></span\n              >\n              <span\n                *ngIf=\"\n                  question.assetsPosition == AssetPositionValuesEnum.withInText\n                \"\n              >\n                <item-text-assets\n                  [promptText]=\"question.promptText\"\n                  [assetData]=\"question.assets\"\n                  [assetsPosition]=\"AssetPositionValuesEnum.withInText\"\n                ></item-text-assets>\n              </span>\n            </div>\n            <media-carousel\n              [imagePath]=\"question.assets[0].assetPath\"\n              [assetData]=\"question.assets\"\n              [assetsPosition]=\"question.assetsPosition\"\n              *ngIf=\"\n                question &&\n                question.assets &&\n                question.assets.length != 0 &&\n                question.assets != undefined &&\n                question.assetsPosition != AssetPositionValuesEnum.withInText &&\n                question.assetsPosition == AssetPositionValuesEnum.bottom\n              \"\n            ></media-carousel>\n            <!--Question Time spent-->\n            <div class=\"wk-col-4 responsive-timespent time-qu-pt-remove\">\n              <span\n                class=\"que-mob-left mr10\"\n                [ngClass]=\"getQuestionProgressClass(question)\"\n              ></span>\n              <span\n                class=\"wkqp-badge time-mob-right\"\n                [ngClass]=\"getOvertimelimitClass(question)\"\n              >\n                Time spent -\n                {{ convertedTime }}\n              </span>\n            </div>\n          </div>\n        </div>\n\n        <div class=\"common-full-width mb20\">\n          <div class=\"wkqp-col-12\">\n            <div class=\"mb20  \">\n              <div class=\"wkqp-field-item summary5-mb0\">\n                <div\n                  *ngIf=\"\n                    question.userResponse[0] && question.userResponse.length > 0\n                  \"\n                >\n                  <!--Your Response-->\n                  <p\n                    [ngClass]=\"getSelectedResponseClass(question)\"\n                    class=\"response-mb20\"\n                  >\n                    <strong>Your Response: </strong>\n                  </p>\n                  <div class=\"go-summary-answer media-width400\">\n                    <img\n                      [src]=\"loadImagePath('image', selectedAnswer)\"\n                      *ngIf=\"selectedAnswer.assetTypeId == 1\"\n                      class=\"item-prev-img55\"\n                      width=\"300px\"\n                    />\n\n                    <video\n                      title=\"{{ selectedAnswer.altTitle }}\"\n                      name=\"previewVideo\"\n                      id=\"previewVideo\"\n                      width=\"400px\"\n                      *ngIf=\"selectedAnswer.assetTypeId == 3\"\n                    >\n                      <source [src]=\"loadImagePath('video', selectedAnswer)\" />\n                      <source\n                        [src]=\"loadImagePath('video', selectedAnswer)\"\n                        type='video/mp4; codecs=\"avc1.42E01E, mp4a.40.2\"'\n                      />\n                      <source\n                        [src]=\"loadImagePath('video', selectedAnswer)\"\n                        type='video/ogg; codecs=\"theora, vorbis\"'\n                      />\n                    </video>\n                    <app-media-controls\n                      *ngIf=\"selectedAnswer.assetTypeId == 3\"\n                      [assetId]=\"selectedAnswer.assetId\"\n                      [assetType]=\"'video'\"\n                    ></app-media-controls>\n                    <audio\n                      title=\"{{ selectedAnswer.altTitle }}\"\n                      *ngIf=\"selectedAnswer.assetTypeId == 2\"\n                      name=\"previewAudio\"\n                      id=\"previewAudio\"\n                      [src]=\"loadImagePath('image', selectedAnswer)\"\n                    ></audio>\n                    <app-media-controls\n                      *ngIf=\"selectedAnswer.assetTypeId == 2\"\n                      [assetId]=\"selectedAnswer.assetId\"\n                      [assetType]=\"'audio'\"\n                    ></app-media-controls>\n                    <wkqp-download-transcript\n                      *ngIf=\"isOnlineEngine && selectedAnswer.transcript\"\n                      [slideData]=\"selectedAnswer\"\n                    >\n                    </wkqp-download-transcript>\n                    <div\n                      class=\"img-go-enlarge-text\"\n                      *ngIf=\"selectedAnswer.assetTypeId == 1\"\n                    >\n                      <span class=\"graphic-img-text\"\n                        >Click on image to enlarge.</span\n                      >\n                    </div>\n                  </div>\n\n                  <!--Correct Response-->\n                  <div\n                    class=\"correct-response-width\"\n                    *ngIf=\"question.isCorrect != 1\"\n                  >\n                    <p\n                      *ngIf=\"!question.correct\"\n                      class=\"wkqp-alert-success wkqp-success mb20\"\n                    >\n                      <strong>Correct Response: </strong>\n                    </p>\n                    <div\n                      ng-show=\"question.correct == false\"\n                      class=\"go-summary-answer wk-row\"\n                    >\n                      <img\n                        [src]=\"loadImagePath('image', correctAnswer)\"\n                        *ngIf=\"correctAnswer.assetTypeId == 1\"\n                        class=\"item-prev-img55\"\n                        width=\"300px\"\n                      />\n\n                      <video\n                        title=\"{{ correctAnswer.altTitle }}\"\n                        name=\"previewVideo\"\n                        id=\"previewVideo\"\n                        width=\"400px\"\n                        *ngIf=\"correctAnswer.assetTypeId == 3\"\n                      >\n                        <source [src]=\"loadImagePath('video', correctAnswer)\" />\n                        <source\n                          [src]=\"loadImagePath('video', correctAnswer)\"\n                          type='video/mp4; codecs=\"avc1.42E01E, mp4a.40.2\"'\n                        />\n                        <source\n                          [src]=\"loadImagePath('video', correctAnswer)\"\n                          type='video/ogg; codecs=\"theora, vorbis\"'\n                        />\n                      </video>\n                      <app-media-controls\n                        *ngIf=\"correctAnswer.assetTypeId == 3\"\n                        [assetId]=\"correctAnswer.assetId\"\n                        [assetType]=\"'video'\"\n                      ></app-media-controls>\n                      <audio\n                        title=\"{{ correctAnswer.altTitle }}\"\n                        *ngIf=\"correctAnswer.assetTypeId == 2\"\n                        name=\"previewAudio\"\n                        id=\"previewAudio\"\n                        [src]=\"loadImagePath('image', correctAnswer)\"\n                      ></audio>\n                      <app-media-controls\n                        *ngIf=\"correctAnswer.assetTypeId == 2\"\n                        [assetId]=\"correctAnswer.assetId\"\n                        [assetType]=\"'audio'\"\n                      ></app-media-controls>\n                      <wkqp-download-transcript\n                        *ngIf=\"isOnlineEngine && correctAnswer.transcript\"\n                        [slideData]=\"correctAnswer\"\n                      >\n                      </wkqp-download-transcript>\n                      <div\n                        class=\"img-go-enlarge-text\"\n                        *ngIf=\"correctAnswer.assetTypeId == 1\"\n                      >\n                        <span class=\"graphic-img-text\"\n                          >Click on image to enlarge.</span\n                        >\n                      </div>\n                    </div>\n                  </div>\n                </div>\n\n                <!--Unattempted response-->\n                <div *ngIf=\"!question.userResponse[0]\">\n                  <p class=\"wkqp-alert-danger\">\n                    <strong>You did not answer this question</strong>\n                  </p>\n                </div>\n              </div>\n            </div>\n          </div>\n        </div>\n      </div>\n    </div>\n    <div class=\"common-full-width mb20\">\n      <!--Rationale-->\n      <lib-rationale [itemData]=\"question.modelFeedback\"></lib-rationale>\n      <!-- remediation -->\n      <lib-remediation [itemData]=\"question.remediationLinks\"></lib-remediation>\n    </div>\n  </div>\n</ng-container>\n",
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: [".go-summary-answer .media-controls{float:left;width:500px;background-color:var(--primary-color);padding:10px;clear:both}.go-summary-answer video#previewVideo,audio#previewAudio{float:left;clear:both;width:500px}.go-summary-answer .download-transcript{font-size:13px;padding-left:0}.item-prev-img55{border:1px solid #ccc}.media-width400{width:400px;margin-left:0;margin-right:0}.correct-response-width{float:left;width:100%}"]
    })
], GraphicOptionSummaryComponent);

let SummaryPaginationComponent = class SummaryPaginationComponent {
    constructor(quizService) {
        this.quizService = quizService;
        this.pageLoader = false;
        this.showBoundaryLinks = true;
        this.rotate = true;
        this.paginationChanged = new EventEmitter();
    }
    ngOnChanges(changes) {
    }
    ngOnInit() {
    }
    pageChanged(event) {
        this.paginationChanged.emit(event.page);
    }
};
SummaryPaginationComponent.ctorParameters = () => [
    { type: QuizService }
];
__decorate([
    Input('currentPage')
], SummaryPaginationComponent.prototype, "currentPage", void 0);
__decorate([
    Input('totalquestions')
], SummaryPaginationComponent.prototype, "totalItems", void 0);
__decorate([
    Output('pageChanged')
], SummaryPaginationComponent.prototype, "paginationChanged", void 0);
SummaryPaginationComponent = __decorate([
    Component({
        selector: 'lib-summary-pagination',
        template: "<div class=\"wk-row \">\n  <div class=\"wk-layout-50-50 gray-bg mb20 fullwidth-wklayout\">\n    <div class=\"wk-button-bar \">\n      <div class=\"wk-button-group-right\">\n        <!--Pagination-->\n        <div class=\"wk-row\" style=\"float: right\">\n          <pagination\n            [rotate]=\"rotate\"\n            [maxSize]=\"maxSize\"\n            [totalItems]=\"totalItems\"\n            [itemsPerPage]=\"5\"\n            [(ngModel)]=\"currentPage\"\n            (pageChanged)=\"pageChanged($event)\"\n            [boundaryLinks]=\"showBoundaryLinks\"\n          ></pagination>\n        </div>\n      </div>\n    </div>\n  </div>\n</div>\n",
        styles: ["#svg-container .wkqp-fullwidth{float:none!important}h1.quiz-main-title{margin-top:0!important;margin-bottom:20px!important}.summary-label span{display:inline-block;margin-bottom:5px;font-weight:600}.quiz-ans-section{float:left;width:100%}.quiz-ans-section h2.wkqp-module-heading{color:var(--primary-color);font-size:1.2rem;font-weight:600;margin:0;padding:0 0 10px}.quiz-ans-section .wkqp-layout-item{margin-bottom:0}.footer-btn-close{background:0 0;color:#fff;font-weight:700;opacity:unset;padding:0 0 0 5px}.footer-btn-close:focus,.footer-btn-close:hover{background-color:transparent!important;border:0;outline:0;box-shadow:0 0 0!important}.summary-position-bottom{position:absolute;bottom:5px;right:15px}#tip{margin:auto auto -6px;width:30px;border:10px solid #000;border-radius:15px;display:block}#battery{position:relative;margin:auto;width:90px;height:164px;border:10px solid #000;border-radius:15px;display:block}#cell{position:absolute;bottom:0;width:100%;font-size:51px;color:#000;font-weight:700;z-index:1;display:block;left:0}#indicator{position:absolute;z-index:100;width:100%;text-align:center}#indicator img{margin-top:25%;height:40px;opacity:.2}.battery-wrapper{transform:scale(.2) rotate(90deg);display:block;position:absolute;bottom:-77px;width:128px;left:26px}.examTaker-nav-button-text.pr65{padding-right:55px;position:relative;top:3px}.engine-title{position:relative;top:8px;padding:0 0 0 15px;font-size:14px;font-weight:600}.examTaker-nav-button-text.pr65 strong{font-size:14px}.battery-percentage{display:block;transform:rotate(-90deg);position:relative;left:1px;padding:0;bottom:10px;width:100%}.stepBarClass{width:90%;height:10px;background:#d3d3d3;border-radius:5px}.stepSliderClass{width:20px;height:20px;background:#d3d3d3;border-radius:50%;border:1px solid #4169e1;bottom:-50%!important}.stephighlightClass{background:#4169e1}.audio-volume-icon{margin:0 5px 0 10px;cursor:pointer;position:relative;top:8px}.volume-slider{position:absolute;right:15px;bottom:38px;background-color:#474747;width:340px;margin:0;padding:0 55px;height:98px;z-index:10}.audio-volume-static{position:absolute;bottom:56px;right:316px;color:#fff;font-size:18px;z-index:1000000000000!important}.audio-volume-static .fa.fa-volume-up{font-size:20px}.volume-level{font-size:18px;color:#fff;position:absolute;bottom:57px;right:38px;z-index:100000;font-weight:600}.volume-title{font-size:15px;color:#fff;position:absolute;bottom:105px;right:173px;z-index:100000;font-weight:600}.footer-btn-close .fa-power-off:before{color:#000!important;font-size:28px!important;font-weight:300!important;position:relative!important;top:8px}.audio-volume-icon i.fa-volume-up{font-size:30px!important}.wifi-icon{font-size:28px!important;position:relative!important;top:8px!important}.qp-seb{float:left;width:100%;background:#ccc;height:40px;padding:0;position:absolute;bottom:0;left:0;right:0}"]
    })
], SummaryPaginationComponent);

let TrueFalseSummaryComponent = class TrueFalseSummaryComponent extends SummaryBase {
    constructor(sharedService) {
        super(sharedService);
        this.sharedService = sharedService;
    }
    ngOnChanges(changes) {
        if (this.question) {
            this.getAnswers();
        }
    }
    ngOnInit() {
        this.convertedTime = this.convertTime2(this.question.questionTimeSpent, 'time');
    }
    getAnswers() {
        this.correctAnswer = '';
        this.selectedAnswer = '';
        this.question.rationale = '';
        this.question.correct = false;
        const correctIds = [];
        const selectedIds = [];
        if (this.question) {
            if (this.question.parentDetails &&
                this.question.parentDetails.assets[0]) {
                this.question.parentDetails.assetsPosition = this.question.parentDetails.assets[0].assetsPosition;
                this.question.assetsPosition = this.question.parentDetails.assets[0].assetsPosition;
            }
            for (const choice of this.question.choiceInteraction.simpleChoices) {
                if (choice.correct === true) {
                    correctIds.push(choice.choiceId);
                    if (this.correctAnswer !== '') {
                        this.correctAnswer = this.correctAnswer + ',' + choice.label;
                    }
                    else {
                        this.correctAnswer = choice.label;
                    }
                }
                if (this.question.userResponse.indexOf(choice.choiceId) !== -1) {
                    selectedIds.push(choice.choiceId);
                    if (this.selectedAnswer !== '') {
                        this.selectedAnswer = this.selectedAnswer + ',' + choice.label;
                    }
                    else {
                        this.selectedAnswer = choice.label;
                    }
                }
            }
            this.formattingAnswers();
            if (correctIds === selectedIds) {
                this.question.correct = true;
            }
        }
        return true;
    }
};
TrueFalseSummaryComponent.ctorParameters = () => [
    { type: SharedService }
];
__decorate([
    Input('summaryData')
], TrueFalseSummaryComponent.prototype, "question", void 0);
TrueFalseSummaryComponent = __decorate([
    Component({
        selector: 'lib-true-false-summary',
        template: "<ng-container *ngIf=\"question\">\n  <div class=\"wk-row\">\n    <ng-container>\n      <media-carousel\n        [imagePath]=\"question.assets[0].assetPath\"\n        [assetData]=\"question.assets\"\n        [assetsPosition]=\"question.assetsPosition\"\n        *ngIf=\"\n          question.assets &&\n          question.assets.length != 0 &&\n          question.assets[0] != undefined &&\n          question.assetsPosition != AssetPositionValuesEnum.withInText &&\n          question.assetsPosition != AssetPositionValuesEnum.bottom\n        \"\n      ></media-carousel>\n    </ng-container>\n    <div\n      [ngClass]=\"{\n        'wk-col-8 asset-left-width66':\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition != AssetPositionValuesEnum.withInText,\n        'wk-col-12':\n          question.assets == undefined ||\n          question.assets.length == 0 ||\n          question.assetsPosition == AssetPositionValuesEnum.withInText,\n        'right-assets-position-question':\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.right,\n        'left-assets-position-question':\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.left,\n        'top-assets-position-question':\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.top,\n        'bottom-assets-position-question':\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.bottom\n      }\"\n    >\n      <div class=\"wkqp-layout-item mb20 summary4-mb0 common-full-width \">\n        <div class=\"wkqp-field-item summary5-mb0\">\n          <div class=\"wk-row gray-bg-result mb20\">\n            <div class=\"wk-col-8 responsive-pl15\">\n              <!--Item Sequence-->\n              <span class=\"wkqb-question-number\">\n                <strong>{{ question.sequence }}</strong>\n              </span>\n\n              <!--Prompt Text-->\n              <span\n                class=\"qp-ts-number-right\"\n                *ngIf=\"\n                  question.assetsPosition != AssetPositionValuesEnum.withInText\n                \"\n              >\n                <strong class=\"wkqp-prewrap\">{{ question.promptText }}</strong>\n              </span>\n              <span\n                *ngIf=\"\n                  question.assetsPosition == AssetPositionValuesEnum.withInText\n                \"\n              >\n                <item-text-assets\n                  [promptText]=\"question.promptText\"\n                  [assetData]=\"question.assets\"\n                  [assetsPosition]=\"AssetPositionValuesEnum.withInText\"\n                ></item-text-assets>\n              </span>\n            </div>\n            <media-carousel\n              [imagePath]=\"question.assets[0].assetPath\"\n              [assetData]=\"question.assets\"\n              [assetsPosition]=\"question.assetsPosition\"\n              *ngIf=\"\n                question.assets &&\n                question.assets.length != 0 &&\n                question.assets[0] != undefined &&\n                question.assetsPosition != AssetPositionValuesEnum.withInText &&\n                question.assetsPosition == AssetPositionValuesEnum.bottom\n              \"\n            ></media-carousel>\n            <!--Question time spent-->\n            <div class=\"wk-col-4 responsive-timespent time-qu-pt-remove\">\n              <span\n                class=\"que-mob-left mr10\"\n                [ngClass]=\"getQuestionProgressClass(question)\"\n              >\n              </span>\n              <span\n                class=\"time-mob-right wkqp-badge\"\n                [ngClass]=\"getOvertimelimitClass(question)\"\n              >\n                Time Spent -\n                {{ convertedTime }}\n              </span>\n            </div>\n          </div>\n\n          <div\n            class=\"common-full-width\"\n            *ngIf=\"question.userResponse && question.userResponse.length > 0\"\n          >\n            <!--Your response-->\n            <p\n              class=\"wkqp-prewrap mb20\"\n              [ngClass]=\"getSelectedResponseClass(question)\"\n            >\n              <strong>Your Response: </strong>\n              <label>{{ selectedAnswer }}</label>\n            </p>\n\n            <!--Correct Response-->\n            <p\n              class=\"wkqp-alert-success wkqp-prewrap wkqp-success mb20\"\n              *ngIf=\"question.isCorrect != 1\"\n            >\n              <strong>Correct Response: </strong>\n              <label>{{ correctAnswer }}</label>\n            </p>\n          </div>\n          <!--Unattempted response-->\n          <div class=\"common-full-width\" *ngIf=\"!question.userResponse[0]\">\n            <p class=\"wkqp-alert-danger\">\n              <strong>You did not answer this question</strong>\n            </p>\n          </div>\n        </div>\n      </div>\n    </div>\n    <div class=\"common-full-width mb20\">\n      <!--Rationale-->\n      <lib-rationale [itemData]=\"question.modelFeedback\"></lib-rationale>\n      <!-- remediation -->\n      <lib-remediation [itemData]=\"question.remediationLinks\"></lib-remediation>\n    </div>\n  </div>\n</ng-container>\n",
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: ["label{margin-bottom:0}"]
    })
], TrueFalseSummaryComponent);

let HotSpotSummaryComponent = class HotSpotSummaryComponent extends SummaryBase {
    constructor(sharedService, itemService) {
        super(sharedService);
        this.sharedService = sharedService;
        this.itemService = itemService;
        this.imagePath = [];
    }
    ngOnChanges(changes) {
        if (this.question) {
            this.convertedTime = this.convertTime2(this.question.questionTimeSpent, 'time');
        }
    }
    ngOnInit() {
    }
};
HotSpotSummaryComponent.ctorParameters = () => [
    { type: SharedService },
    { type: ItemService }
];
__decorate([
    Input('summaryData')
], HotSpotSummaryComponent.prototype, "question", void 0);
__decorate([
    Input()
], HotSpotSummaryComponent.prototype, "imagePath", void 0);
HotSpotSummaryComponent = __decorate([
    Component({
        selector: 'lib-hot-spot-summary',
        template: "<ng-container *ngIf=\"question.itemType == 12\">\n  <div class=\"wk-row\">\n    <div class=\"wkqp-col-12\">\n      <div class=\"wkqp-layout-item mb20 summary4-mb0\">\n        <div class=\"wkqp-field-item summary5-mb0\">\n          <div class=\"wk-row mb20  gray-bg-result\">\n            <div class=\"wk-col-8 responsive-pl15\">\n              <!--Question sequence-->\n              <span class=\"wkqb-question-number\">\n                <strong>{{ question.sequence }}</strong>\n              </span>\n\n              <!--Question Prompt text-->\n              <span\n                class=\"qp-ts-number-right\"\n                *ngIf=\"\n                  question.assetsPosition != AssetPositionValuesEnum.withInText\n                \"\n              >\n                <strong class=\"wkqp-prewrap\">{{ question.promptText }}</strong>\n              </span>\n              <span\n                *ngIf=\"\n                  question.assetsPosition == AssetPositionValuesEnum.withInText\n                \"\n              >\n                <item-text-assets\n                  [promptText]=\"question.promptText\"\n                  [assetData]=\"question.assets\"\n                  [assetsPosition]=\"AssetPositionValuesEnum.withInText\"\n                ></item-text-assets>\n              </span>\n            </div>\n\n            <!--Question Time spent-->\n            <div class=\"wk-col-4 responsive-timespent time-qu-pt-remove\">\n              <span\n                class=\"que-mob-left\"\n                [ngClass]=\"getQuestionProgressClass(question)\"\n              >\n              </span>\n              <span\n                class=\"wkqp-badge time-mob-right\"\n                [ngClass]=\"getOvertimelimitClass(question)\"\n              >\n                Time spent -\n                {{ convertedTime }}\n              </span>\n            </div>\n          </div>\n          <div\n            class=\"common-full-width\"\n            *ngIf=\"question.userResponse[0] && question.userResponse.length > 0\"\n          >\n            <!--Your Response-->\n            <p\n              class=\"wkqp-prewrap mb20\"\n              [ngClass]=\"getSelectedResponseClass(question)\"\n            >\n              <strong>Your Response: </strong>\n            </p>\n            <ng-container *ngIf=\"question\">\n              <hotspot-svg\n                [hideLabel]=\"true\"\n                [userAnswerDetails]=\"question.userResponse\"\n                [imageSrc]=\"question.assets[0]\"\n                [imageType]=\"question.assets[0].assetName\"\n                [accessType]=\"'userResponse'\"\n              ></hotspot-svg>\n            </ng-container>\n\n            <!--Correct Response-->\n            <div *ngIf=\"question.isCorrect != 1\">\n              <p\n                class=\"wkqp-alert-success wkqp-prewrap wkqp-success  response-mb20\"\n              >\n                <strong>Correct Response: </strong>\n              </p>\n\n              <ng-container *ngIf=\"question\">\n                <div>\n                  <hotspot-svg\n                    [hideLabel]=\"true\"\n                    [correctAnswerDetails]=\"\n                      question['graphicInteraction']['hotspotChoices'][0]\n                    \"\n                    [imagePath]=\"imagePath\"\n                    [imageType]=\"question.assets[0].assetName\"\n                    [imageSrc]=\"question.assets[0]\"\n                    [accessType]=\"'correctAnswer'\"\n                  ></hotspot-svg>\n                </div>\n              </ng-container>\n            </div>\n          </div>\n          <div *ngIf=\"!question.userResponse[0]\">\n            <p class=\"wkqp-alert-danger\">\n              <strong>You did not answer this question</strong>\n            </p>\n          </div>\n          <div class=\"common-full-width mb20\">\n            <!--Rationale-->\n            <lib-rationale [itemData]=\"question.modelFeedback\"></lib-rationale>\n            <!-- remediation -->\n            <lib-remediation\n              [itemData]=\"question.remediationLinks\"\n            ></lib-remediation>\n          </div>\n        </div>\n      </div>\n    </div>\n  </div>\n</ng-container>\n",
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: [""]
    })
], HotSpotSummaryComponent);

let InlineChoiceSummaryComponent = class InlineChoiceSummaryComponent extends SummaryBase {
    constructor(sharedService) {
        super(sharedService);
        this.sharedService = sharedService;
        this.userAnswerTypes = UserAnswerTypes;
    }
    ngOnChanges(changes) {
        if (this.question) {
            this.createQuestion();
            this.setUserAnswer();
        }
    }
    ngOnInit() {
        this.convertedTime = this.convertTime2(this.question.questionTimeSpent, 'time');
    }
    createQuestion() {
        const options = this.question.textEntryInteraction.inlineChoices;
        let count = 0;
        let promptText = this.question.promptText;
        let assetData = this.question.assets;
        for (let i = 0; i <= 4; i++) {
            const test = '≡Assets-' + (i + 1) + '≡';
            if (promptText.indexOf(test) >= 0) {
                promptText = promptText.replace(test, ' ≡Assets-' + (i + 1) + '≡ ');
            }
        }
        const reg = /(_{1,50})/g;
        promptText = promptText.replace(reg, ' ' + reg + ' ');
        const questionParts = promptText
            .replace(/[]{2,}/g, ' ')
            .trim()
            .split(' ');
        this.questionTitleSplits = [];
        questionParts.forEach((questionPart, index) => {
            const i = index + 1;
            const ngModel = '';
            const reg = /(_{1,50})/g;
            const assetReg = /≡Assets-1≡|≡Assets-2≡|≡Assets-3≡/g;
            if (reg.test(questionPart)) {
                count++;
                this.questionTitleSplits.push({
                    id: i,
                    name: `blank-${count}`,
                    isInputField: true,
                    list: options[count - 1],
                    count: count - 1
                });
            }
            else if (assetReg.test(questionPart)) {
                assetData.forEach(asset => {
                    if (asset.assetTextIdentifier === questionPart) {
                        let arr = [];
                        arr.push(asset);
                        this.questionTitleSplits.push({
                            id: i,
                            name: questionPart,
                            isAsset: true,
                            assets: arr
                        });
                    }
                });
            }
            else {
                this.questionTitleSplits.push({
                    id: i,
                    name: questionPart,
                    isText: true
                });
            }
        });
    }
    setUserAnswer() {
        /*
        Filtering the blanks object from the question splitted list
         */
        const choiceRef = this.questionTitleSplits.filter(data => {
            if (data.isInputField) {
                return data;
            }
        });
        const userAnswer = this.question.userResponse;
        /*
        Filtering user answers from the blanks objects
         */
        this.userAnswer = choiceRef
            .map(obj => {
            return obj.list.filter(el => {
                if (userAnswer.indexOf(String(el.choiceId)) >= 0) {
                    return el.label;
                }
            });
        })
            .flat(1);
    }
};
InlineChoiceSummaryComponent.ctorParameters = () => [
    { type: SharedService }
];
__decorate([
    Input('summaryData')
], InlineChoiceSummaryComponent.prototype, "question", void 0);
InlineChoiceSummaryComponent = __decorate([
    Component({
        selector: 'lib-inline-choice-summary',
        template: "<ng-container *ngIf=\"question.itemType == 24\">\n  <div class=\"wk-row\">\n    <media-carousel\n      [imagePath]=\"question.assets[0].assetPath\"\n      [assetData]=\"question.assets\"\n      [assetsPosition]=\"question.assetsPosition\"\n      *ngIf=\"\n        question &&\n        question.assets &&\n        question.assets.length != 0 &&\n        question.assets != undefined &&\n        question.assetsPosition != AssetPositionValuesEnum.withInText &&\n        question.assetsPosition != AssetPositionValuesEnum.bottom\n      \"\n    ></media-carousel>\n    <div\n      [ngClass]=\"{\n        'wk-col-8 asset-left-width66':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition != AssetPositionValuesEnum.withInText,\n        'wk-col-12':\n          (question && question.assets == undefined) ||\n          (question && question.assets.length == 0) ||\n          (question &&\n            question.assetsPosition == AssetPositionValuesEnum.withInText),\n        'right-assets-position-question':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.right,\n        'left-assets-position-question':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.left,\n        'top-assets-position-question':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.top,\n        'bottom-assets-position-question':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.bottom\n      }\"\n    >\n      <div class=\"wkqp-layout-item mb20 summary4-mb0 \">\n        <div class=\"wkqp-field-item summary5-mb0 common-full-width \">\n          <div class=\"wk-row gray-bg-result mb20\">\n            <div class=\"wk-col-8 responsive-pl15\">\n              <!--Question sequence-->\n              <span class=\"wkqb-question-number\">\n                <strong>{{ question.sequence }}</strong>\n              </span>\n              <!--Question prompt text-->\n              <span\n                class=\"qp-ts-number-right\"\n                *ngIf=\"\n                  question.assetsPosition != AssetPositionValuesEnum.withInText\n                \"\n              >\n                <span class=\"wkqp-prewrap inline-choice-ques-wrapper\">\n                  <span\n                    class=\"ques-num-content\"\n                    *ngFor=\"\n                      let questionTitle of questionTitleSplits;\n                      let i = index\n                    \"\n                  >\n                    <ng-container *ngIf=\"questionTitle.isInputField\">\n                      <mat-select\n                        placeholder=\"Choose Answer..\"\n                        class=\"inline-choice-select-box-main\"\n                        multiple\n                      >\n                        <mat-option\n                          disabled\n                          *ngFor=\"let option of questionTitle.list\"\n                          [value]=\"option.choiceId\"\n                          >{{ option.label }}</mat-option\n                        >\n                      </mat-select>\n                    </ng-container>\n\n                    <ng-container *ngIf=\"questionTitle.isAsset\">\n                      <div style=\"padding-top: 20px;\" class=\"wk-row\">\n                        <media-carousel\n                          [inline]=\"'inline'\"\n                          [assetData]=\"questionTitle.assets\"\n                        ></media-carousel>\n                      </div>\n                    </ng-container>\n\n                    <ng-container *ngIf=\"questionTitle.isText\">\n                      {{ questionTitle.name }}\n                    </ng-container>\n                  </span>\n                </span>\n              </span>\n              <span\n                *ngIf=\"\n                  question.assetsPosition == AssetPositionValuesEnum.withInText\n                \"\n              >\n                <item-text-assets\n                  [promptText]=\"question.promptText\"\n                  [assetData]=\"question.assets\"\n                  [assetsPosition]=\"AssetPositionValuesEnum.withInText\"\n                ></item-text-assets>\n              </span>\n            </div>\n            <media-carousel\n              [imagePath]=\"question.assets[0].assetPath\"\n              [assetData]=\"question.assets\"\n              [assetsPosition]=\"question.assetsPosition\"\n              *ngIf=\"\n                question &&\n                question.assets &&\n                question.assets.length != 0 &&\n                question.assets != undefined &&\n                question.assetsPosition != AssetPositionValuesEnum.withInText &&\n                question.assetsPosition == AssetPositionValuesEnum.bottom\n              \"\n            ></media-carousel>\n            <!--Question Time spent-->\n            <div class=\"wk-col-4 responsive-timespent time-qu-pt-remove\">\n              <span\n                class=\"que-mob-left mr10\"\n                [ngClass]=\"getQuestionProgressClass(question)\"\n              ></span>\n              <span\n                class=\"wkqp-badge time-mob-right\"\n                [ngClass]=\"getOvertimelimitClass(question)\"\n              >\n                Time spent -\n                {{ convertedTime }}</span\n              >\n            </div>\n          </div>\n\n          <div\n            class=\"common-full-width\"\n            *ngIf=\"\n              question.userResponse &&\n              question.userResponse != null &&\n              question.userResponse.length > 0\n            \"\n          >\n            <!--Your Response-->\n            <ng-container>\n              <p\n                class=\"wkqp-prewrap response-mb20\"\n                [ngClass]=\"getSelectedResponseClass(question)\"\n              >\n                <strong>Your Response: </strong>\n                <ng-container\n                  *ngIf=\"question.isCorrect !== userAnswerTypes.UnAttempted\"\n                >\n                  <span *ngFor=\"let blank of userAnswer; let i = index\">\n                    {{ blank.label\n                    }}{{ i === userAnswer.length - 1 ? '' : ',' }}\n                  </span>\n                </ng-container>\n              </p>\n            </ng-container>\n            <ng-container\n              *ngIf=\"question.isCorrect == userAnswerTypes.Incorrect\"\n            >\n              <div\n                class=\"wkqp-alert-success wkqp-prewrap wkqp-success  badge-normal mb20\"\n              >\n                <strong>Correct Response: </strong>\n                <table\n                  class=\"table table-bordered wkqp-table wkqp-table-permit-overflow correct-inline-text\"\n                >\n                  <tbody>\n                    <tr\n                      *ngFor=\"\n                        let blanks of question.textEntryInteraction\n                          .inlineChoices;\n                        let blankNum = index\n                      \"\n                    >\n                      <td width=\"10%\" class=\"table-label\">\n                        <strong>Blank-{{ blankNum + 1 }}</strong>\n                      </td>\n                      <td\n                        *ngIf=\"question.labelText == 'INLINE_CHOICE'\"\n                        width=\"90%\"\n                      >\n                        <span\n                          class=\"wkqp-badge\"\n                          *ngFor=\"let choice of blanks; let choiceNum = index\"\n                          [hidden]=\"choice.correct !== true\"\n                        >\n                          <span *ngIf=\"choice.correct === true\">{{\n                            choice.label\n                          }}</span>\n                        </span>\n                      </td>\n                    </tr>\n                  </tbody>\n                </table>\n              </div>\n            </ng-container>\n          </div>\n\n          <!--Unattempted Response-->\n          <ng-container\n            *ngIf=\"question.isCorrect == userAnswerTypes.UnAttempted\"\n          >\n            <div class=\"common-full-width\">\n              <p class=\"wkqp-alert-danger\">\n                <strong>You did not answer this question</strong>\n              </p>\n            </div>\n          </ng-container>\n        </div>\n      </div>\n    </div>\n    <div class=\"common-full-width mb20\">\n      <!--Rationale-->\n      <lib-rationale [itemData]=\"question.modelFeedback\"></lib-rationale>\n      <!-- remediation -->\n      <lib-remediation [itemData]=\"question.remediationLinks\"></lib-remediation>\n    </div>\n  </div>\n</ng-container>\n",
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: [".inline-choice-ques-wrapper span{float:left;padding-right:4px;white-space:normal}.wkqb-question-number{margin-top:4px;display:inline-block}.ques-num-content{margin-top:4px;display:inline-block;vertical-align:middle}.wkqp-unattempted{top:0}.badge-normal table tr td span.wkqp-badge{font-style:normal}.badge-normal table tr td.table-label strong{color:#474747;font-size:.9375rem;font-style:normal}"]
    })
], InlineChoiceSummaryComponent);

let MedicalCaseSummaryComponent = class MedicalCaseSummaryComponent extends SummaryBase {
    constructor(sharedService) {
        super(sharedService);
        this.sharedService = sharedService;
    }
    ngOnChanges(changes) {
        if (this.question) {
            this.getAnswers();
        }
    }
    ngOnInit() {
        this.convertedTime = this.convertTime2(this.question.questionTimeSpent, 'time');
    }
    getAnswers() {
        this.correctAnswer = '';
        this.selectedAnswer = '';
        this.question.rationale = '';
        this.question.correct = false;
        const correctIds = [];
        const selectedIds = [];
        if (this.question) {
            if (this.question.parentDetails && this.question.parentDetails.assets[0]) {
                this.question.parentDetails.assetsPosition = this.question.parentDetails.assets[0].assetsPosition;
                this.question.assetsPosition = this.question.parentDetails.assets[0].assetsPosition;
            }
            for (const choice of this.question.choiceInteraction.simpleChoices) {
                if (choice.correct === true) {
                    correctIds.push(choice.choiceId);
                    if (this.correctAnswer !== '') {
                        this.correctAnswer = this.correctAnswer + ',' + choice.label;
                    }
                    else {
                        this.correctAnswer = choice.label;
                    }
                }
                if (this.question.userResponse.indexOf(choice.choiceId) !== -1) {
                    selectedIds.push(choice.choiceId);
                    if (this.selectedAnswer !== '') {
                        this.selectedAnswer = this.selectedAnswer + ',' + choice.label;
                    }
                    else {
                        this.selectedAnswer = choice.label;
                    }
                }
            }
            this.formattingAnswers();
            if (correctIds === selectedIds) {
                this.question.correct = true;
            }
        }
        return true;
    }
};
MedicalCaseSummaryComponent.ctorParameters = () => [
    { type: SharedService }
];
__decorate([
    Input('summaryData')
], MedicalCaseSummaryComponent.prototype, "question", void 0);
MedicalCaseSummaryComponent = __decorate([
    Component({
        selector: 'lib-medical-case-summary',
        template: "<ng-container *ngIf=\"question.parentDetails\">\n  <div class=\"wk-row\">\n    <div class=\"wkqp-field-header \">\n      <span class=\"medicalcase-label\"> Case Scenario/Description</span>\n    </div>\n    <media-carousel\n      [imagePath]=\"question.parentDetails.assets[0].assetPath\"\n      [assetData]=\"question.parentDetails.assets\"\n      [assetsPosition]=\"question.parentDetails.assetsPosition\"\n      *ngIf=\"\n        question &&\n        question.parentDetails &&\n        question.parentDetails.assets &&\n        question.parentDetails.assets.length > 0 &&\n        question.parentDetails.assetsPosition !=\n          AssetPositionValuesEnum.withInText &&\n        question.parentDetails.assetsPosition != AssetPositionValuesEnum.bottom\n      \"\n    ></media-carousel>\n\n    <div\n      [ngClass]=\"{\n        'wk-col-8 asset-left-width66':\n          question &&\n          question.parentDetails.assets != undefined &&\n          question.parentDetails.assets.length != 0 &&\n          question.parentDetails.assetsPosition !=\n            AssetPositionValuesEnum.withInText,\n        'wk-col-12':\n          (question &&\n            question.parentDetails &&\n            question.parentDetails.assets == undefined) ||\n          (question &&\n            question.parentDetails &&\n            question.parentDetails.assets.length == 0) ||\n          (question &&\n            question.parentDetails &&\n            question.parentDetails.assetsPosition ==\n              AssetPositionValuesEnum.withInText),\n        'right-assets-position-question':\n          question &&\n          question.parentDetails.assets != undefined &&\n          question.parentDetails.assets.length != 0 &&\n          question.parentDetails.assetsPosition ==\n            AssetPositionValuesEnum.right,\n        'left-assets-position-question':\n          question &&\n          question.parentDetails.assets != undefined &&\n          question.parentDetails.assets.length != 0 &&\n          question.parentDetails.assetsPosition == AssetPositionValuesEnum.left,\n        'top-assets-position-question':\n          question &&\n          question.parentDetails.assets != undefined &&\n          question.parentDetails.assets.length != 0 &&\n          question.parentDetails.assetsPosition == AssetPositionValuesEnum.top,\n        'bottom-assets-position-question':\n          question &&\n          question.parentDetails.assets != undefined &&\n          question.parentDetails.assets.length != 0 &&\n          question.parentDetails.assetsPosition ==\n            AssetPositionValuesEnum.bottom\n      }\"\n    >\n      <div class=\"wkqp-layout-item\">\n        <div class=\"wkqp-field-item normal-font mb0 \">\n          <div\n            class=\"wkqp-field-header\"\n            *ngIf=\"\n              question.parentDetails.assetsPosition !=\n              AssetPositionValuesEnum.withInText\n            \"\n          >\n            <p\n              class=\"mb20 normal-font wkqp-prewrap heading-h3 headingh3-res question-parent-text\"\n            >\n              <span\n                libGetFormatText\n                [preferredTextFormat]=\"question.preferredTextFormat\"\n                [plainText]=\"question.parentDetails.promptText\"\n                [richText]=\"question.parentDetails.richPromptText\"\n              ></span>\n            </p>\n          </div>\n          <div\n            class=\"wkqp-field-header\"\n            *ngIf=\"\n              question.parentDetails.assetsPosition ==\n              AssetPositionValuesEnum.withInText\n            \"\n          >\n            <item-text-assets\n              [promptText]=\"question.parentDetails.promptText\"\n              [assetData]=\"question.parentDetails.assets\"\n              [assetsPosition]=\"AssetPositionValuesEnum.withInText\"\n            ></item-text-assets>\n          </div>\n        </div>\n      </div>\n\n      <media-carousel\n        *ngIf=\"\n          question.parentDetails &&\n          question.parentDetails.assets &&\n          question.parentDetails.assets.length != 0 &&\n          question.parentDetails.assetsPosition ==\n            AssetPositionValuesEnum.bottom\n        \"\n        [imagePath]=\"question.parentDetails.assets[0].assetPath\"\n        [assetData]=\"question.parentDetails.assets\"\n        [assetsPosition]=\"question.parentDetails.assetsPosition\"\n      ></media-carousel>\n    </div>\n  </div>\n  <div class=\"common-full width\">\n    <span\n      class=\"wkqp-field-header\"\n      *ngIf=\"\n        question.parentDetails.assetsPosition ==\n        AssetPositionValuesEnum.withInText\n      \"\n    >\n      <item-text-assets\n        [promptText]=\"question.parentDetails.promptText\"\n        [assetData]=\"question.parentDetails.assets\"\n        [assetsPosition]=\"AssetPositionValuesEnum.withInText\"\n      ></item-text-assets>\n    </span>\n  </div>\n  <div class=\"common-full-width \">\n    <div class=\"wkqp-layout-item summary2-mb0\">\n      <div class=\"wk-row gray-bg-result\">\n        <!--Child Question prompt text-->\n        <div class=\"wk-col-8 responsive-pl15\">\n          <span class=\"wkqb-question-number\">\n            <strong>{{ question.sequence }}</strong>\n          </span>\n          <span\n            class=\"qp-ts-number-right\"\n            *ngIf=\"\n              question.parentDetails.assetsPosition !=\n              AssetPositionValuesEnum.withInText\n            \"\n          >\n            <strong class=\"wkqp-prewrap\">{{ question.promptText }}</strong>\n          </span>\n          <span\n            *ngIf=\"\n              question.parentDetails.assetsPosition ==\n              AssetPositionValuesEnum.withInText\n            \"\n          >\n            <item-text-assets\n              [promptText]=\"question.parentDetails.promptText\"\n              [assetData]=\"question.parentDetails.assets\"\n              [assetsPosition]=\"AssetPositionValuesEnum.withInText\"\n            ></item-text-assets>\n          </span>\n        </div>\n\n        <!--Question time spent-->\n        <div class=\"wk-col-4 responsive-timespent time-qu-pt-remove\">\n          <span\n            class=\"que-mob-left mr10\"\n            [ngClass]=\"getQuestionProgressClass(question)\"\n          ></span>\n          <span\n            class=\"wkqp-badge time-mob-right\"\n            [ngClass]=\"getOvertimelimitClass(question)\"\n          >\n            Time Spent -\n            {{ convertedTime }}\n          </span>\n        </div>\n      </div>\n    </div>\n\n    <!--Child question user response-->\n    <div class=\"wkqp-layout-item mb20  summary3-mb0 common-full-width\">\n      <div class=\"wkqp-field-item summary5-mb0\">\n        <div\n          *ngIf=\"question.userResponse[0] && question.userResponse.length > 0\"\n        >\n          <!--Your Response-->\n          <p\n            class=\"wkqp-prewrap mb20\"\n            ng-show=\"question.userResponse[0]\"\n            [ngClass]=\"getSelectedResponseClass(question)\"\n          >\n            <strong>Your Response: </strong>\n            <label class=\"response-inline\">{{ selectedAnswer }}</label>\n          </p>\n\n          <!--Correct Response-->\n          <p\n            *ngIf=\"question.isCorrect != 1\"\n            class=\"wkqp-prewrap wkqp-alert-success wkqp-success mb20\"\n          >\n            <strong>Correct Response: </strong>\n            <label class=\"response-inline\">{{ correctAnswer }}</label>\n          </p>\n        </div>\n        <div class=\"common-full-width\" *ngIf=\"!question.userResponse[0]\">\n          <p class=\"wkqp-alert-danger\">\n            <strong>You did not answer this question</strong>\n          </p>\n        </div>\n        <div class=\"common-full-width mb20\">\n          <!--Rationale-->\n          <lib-rationale [itemData]=\"question.modelFeedback\"></lib-rationale>\n          <!-- remediation -->\n          <lib-remediation\n            [itemData]=\"question.remediationLinks\"\n          ></lib-remediation>\n        </div>\n      </div>\n    </div>\n  </div>\n</ng-container>\n",
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: [""]
    })
], MedicalCaseSummaryComponent);

let MultipleChoiceSummaryComponent = class MultipleChoiceSummaryComponent extends SummaryBase {
    constructor(sharedService) {
        super(sharedService);
        this.sharedService = sharedService;
    }
    ngOnChanges(changes) {
        if (this.question) {
            this.getAnswers();
        }
    }
    ngOnInit() {
        this.convertedTime = this.convertTime2(this.question.questionTimeSpent, 'time');
    }
    getAnswers() {
        this.correctAnswer = '';
        this.selectedAnswer = '';
        this.question.rationale = '';
        this.question.correct = false;
        const correctIds = [];
        const selectedIds = [];
        if (this.question) {
            if (this.question.parentDetails &&
                this.question.parentDetails.assets[0]) {
                this.question.parentDetails.assetsPosition = this.question.parentDetails.assets[0].assetsPosition;
                this.question.assetsPosition = this.question.parentDetails.assets[0].assetsPosition;
            }
            for (const choice of this.question.choiceInteraction.simpleChoices) {
                if (choice.correct === true) {
                    correctIds.push(choice.choiceId);
                    if (this.correctAnswer !== '') {
                        this.correctAnswer = this.correctAnswer + ',' + choice.label;
                    }
                    else {
                        this.correctAnswer = choice.label;
                    }
                }
                if (this.question.userResponse.indexOf(choice.choiceId) !== -1) {
                    selectedIds.push(choice.choiceId);
                    if (this.selectedAnswer !== '') {
                        this.selectedAnswer = this.selectedAnswer + ',' + choice.label;
                    }
                    else {
                        this.selectedAnswer = choice.label;
                    }
                }
            }
            this.formattingAnswers();
            if (correctIds === selectedIds) {
                this.question.correct = true;
            }
        }
        return true;
    }
};
MultipleChoiceSummaryComponent.ctorParameters = () => [
    { type: SharedService }
];
__decorate([
    Input('summaryData')
], MultipleChoiceSummaryComponent.prototype, "question", void 0);
MultipleChoiceSummaryComponent = __decorate([
    Component({
        selector: 'lib-multiple-choice-summary',
        template: "<ng-container *ngIf=\"!question.parentDetails\">\n  <div class=\"wk-row\">\n    <ng-container *ngIf=\"!question.parentDetails\"\n      ><media-carousel\n        [imagePath]=\"question.assets[0].assetPath\"\n        [assetData]=\"question.assets\"\n        [assetsPosition]=\"question.assetsPosition\"\n        *ngIf=\"\n          question &&\n          question.assets &&\n          question.assets.length != 0 &&\n          question.assets != undefined &&\n          question.assetsPosition != AssetPositionValuesEnum.withInText &&\n          question.assetsPosition != AssetPositionValuesEnum.bottom\n        \"\n      ></media-carousel>\n    </ng-container>\n    <div\n      [ngClass]=\"{\n        'wk-col-8 asset-left-width66':\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition != AssetPositionValuesEnum.withInText,\n        'wk-col-12':\n          question.assets == undefined ||\n          question.assets.length == 0 ||\n          question.assetsPosition == AssetPositionValuesEnum.withInText,\n        'right-assets-position-question':\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.right,\n        'left-assets-position-question':\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.left,\n        'top-assets-position-question':\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.top,\n        'bottom-assets-position-question':\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.bottom\n      }\"\n    >\n      <div class=\"wkqp-layout-item mb20 summary4-mb0 common-full-width \">\n        <div class=\"wkqp-field-item summary5-mb0\">\n          <div class=\"wk-row gray-bg-result mb20\">\n            <div class=\"wk-col-8 responsive-pl15\">\n              <!--Item Sequence-->\n              <span class=\"wkqb-question-number\">\n                <strong>{{ question.sequence }}</strong>\n              </span>\n\n              <!--Prompt Text-->\n              <span\n                class=\"qp-ts-number-right\"\n                *ngIf=\"\n                  question.assetsPosition != AssetPositionValuesEnum.withInText\n                \"\n              >\n                <strong class=\"wkqp-prewrap\">{{ question.promptText }}</strong>\n              </span>\n              <span\n                *ngIf=\"\n                  question &&\n                  question.assetsPosition == AssetPositionValuesEnum.withInText\n                \"\n              >\n                <item-text-assets\n                  [promptText]=\"question.promptText\"\n                  [assetData]=\"question && question.assets\"\n                  [assetsPosition]=\"AssetPositionValuesEnum.withInText\"\n                ></item-text-assets>\n              </span>\n            </div>\n            <media-carousel\n              [imagePath]=\"question.assets[0].assetPath\"\n              [assetData]=\"question.assets\"\n              [assetsPosition]=\"question.assetsPosition\"\n              *ngIf=\"\n                question &&\n                question.assets &&\n                question.assets.length != 0 &&\n                question.assets != undefined &&\n                question.assetsPosition != AssetPositionValuesEnum.withInText &&\n                question.assetsPosition == AssetPositionValuesEnum.bottom\n              \"\n            ></media-carousel>\n            <!--Question time spent-->\n            <div class=\"wk-col-4 responsive-timespent time-qu-pt-remove\">\n              <span\n                class=\"que-mob-left mr10\"\n                [ngClass]=\"getQuestionProgressClass(question)\"\n              >\n              </span>\n              <span\n                class=\"time-mob-right wkqp-badge\"\n                [ngClass]=\"getOvertimelimitClass(question)\"\n              >\n                Time Spent -\n                {{ convertedTime }}\n              </span>\n            </div>\n          </div>\n\n          <div\n            class=\"common-full-width\"\n            *ngIf=\"question.userResponse && question.userResponse.length > 0\"\n          >\n            <!--Your response-->\n            <p\n              class=\"wkqp-prewrap mb20\"\n              [ngClass]=\"getSelectedResponseClass(question)\"\n            >\n              <strong>Your Response: </strong>\n              <label class=\"response-inline\">{{ selectedAnswer }}</label>\n            </p>\n\n            <!--Correct Response-->\n            <p\n              class=\"wkqp-alert-success wkqp-prewrap wkqp-success mb20\"\n              *ngIf=\"question.isCorrect != 1\"\n            >\n              <strong>Correct Response: </strong>\n              <label class=\"response-inline\">{{ correctAnswer }}</label>\n            </p>\n          </div>\n\n          <!--Unattempted response-->\n          <div class=\"common-full-width\" *ngIf=\"!question.userResponse[0]\">\n            <p class=\"wkqp-alert-danger\">\n              <strong>You did not answer this question</strong>\n            </p>\n          </div>\n        </div>\n      </div>\n    </div>\n    <div class=\"common-full-width mb20\">\n      <!--Rationale-->\n      <lib-rationale [itemData]=\"question.modelFeedback\"></lib-rationale>\n      <!-- remediation -->\n      <lib-remediation [itemData]=\"question.remediationLinks\"></lib-remediation>\n    </div>\n  </div>\n</ng-container>\n",
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: [""]
    })
], MultipleChoiceSummaryComponent);

let MultipleResponseSummaryComponent = class MultipleResponseSummaryComponent extends SummaryBase {
    constructor(sharedService) {
        super(sharedService);
        this.sharedService = sharedService;
    }
    ngOnChanges(changes) {
        if (this.question) {
            this.getAnswers();
        }
    }
    ngOnInit() {
        this.convertedTime = this.convertTime2(this.question.questionTimeSpent, "time");
    }
    getAnswers() {
        this.correctAnswer = '';
        this.selectedAnswer = '';
        this.question.rationale = '';
        this.question.correct = false;
        const correctIds = [];
        const selectedIds = [];
        if (this.question) {
            for (const choice of this.question.choiceInteraction.simpleChoices) {
                if (choice.correct === true) {
                    correctIds.push(choice.choiceId);
                    if (this.correctAnswer !== '') {
                        this.correctAnswer = this.correctAnswer + ',' + choice.label;
                    }
                    else {
                        this.correctAnswer = choice.label;
                    }
                }
                if (this.question.userResponse.indexOf(choice.choiceId) !== -1) {
                    selectedIds.push(choice.choiceId);
                    if (this.selectedAnswer !== '') {
                        this.selectedAnswer = this.selectedAnswer + ',' + choice.label;
                    }
                    else {
                        this.selectedAnswer = choice.label;
                    }
                }
            }
            this.formattingAnswers();
            if (correctIds === selectedIds) {
                this.question.correct = true;
            }
        }
        return true;
    }
};
MultipleResponseSummaryComponent.ctorParameters = () => [
    { type: SharedService }
];
__decorate([
    Input('summaryData')
], MultipleResponseSummaryComponent.prototype, "question", void 0);
MultipleResponseSummaryComponent = __decorate([
    Component({
        selector: 'lib-multiple-response-summary',
        template: "<!-- <div *ngFor=\"let question of questionList; let i = index\"> -->\n<ng-container *ngIf=\"!question.parentDetails\">\n  <div class=\"wk-row \">\n    <ng-container *ngIf=\"!question.parentDetails\"\n      ><media-carousel\n        [imagePath]=\"question.assets[0].assetPath\"\n        [assetData]=\"question.assets\"\n        [assetsPosition]=\"question.assetsPosition\"\n        *ngIf=\"\n          question &&\n          question.assets &&\n          question.assets.length != 0 &&\n          question.assets != undefined &&\n          question.assetsPosition != AssetPositionValuesEnum.withInText &&\n          question.assetsPosition != AssetPositionValuesEnum.bottom\n        \"\n      ></media-carousel>\n    </ng-container>\n    <div\n      [ngClass]=\"{\n        'wk-col-8 asset-left-width66':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition != AssetPositionValuesEnum.withInText,\n        'wk-col-12':\n          (question && question.assets == undefined) ||\n          (question && question.assets.length == 0) ||\n          (question &&\n            question.assetsPosition == AssetPositionValuesEnum.withInText),\n        'right-assets-position-question':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.right,\n        'left-assets-position-question':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.left,\n        'top-assets-position-question':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.top,\n        'bottom-assets-position-question':\n          question &&\n          question.assets != undefined &&\n          question.assets.length != 0 &&\n          question.assetsPosition == AssetPositionValuesEnum.bottom\n      }\"\n    >\n      <div class=\"wkqp-layout-item mb20 summary4-mb0 common-full-width \">\n        <div class=\"wkqp-field-item summary5-mb0\">\n          <div class=\"wk-row gray-bg-result mb20\">\n            <div class=\"wk-col-8 responsive-pl15\">\n              <!--Item Sequence-->\n              <span class=\"wkqb-question-number\">\n                <strong>{{ question.sequence }}</strong>\n              </span>\n\n              <!--Prompt Text-->\n              <span\n                class=\"qp-ts-number-right\"\n                *ngIf=\"\n                  (question &&\n                    question.assetsPosition !=\n                      AssetPositionValuesEnum.withInText) ||\n                  !question.parentDetails\n                \"\n              >\n                <strong class=\"wkqp-prewrap\">{{ question.promptText }}</strong>\n              </span>\n              <span\n                *ngIf=\"\n                  question &&\n                  question.assetsPosition == AssetPositionValuesEnum.withInText\n                \"\n              >\n                <item-text-assets\n                  [promptText]=\"question.promptText\"\n                  [assetData]=\"question && question.assets\"\n                  [assetsPosition]=\"AssetPositionValuesEnum.withInText\"\n                ></item-text-assets>\n              </span>\n            </div>\n            <media-carousel\n              [imagePath]=\"question.assets[0].assetPath\"\n              [assetData]=\"question.assets\"\n              [assetsPosition]=\"question.assetsPosition\"\n              *ngIf=\"\n                question &&\n                question.assets &&\n                question.assets.length != 0 &&\n                question.assets != undefined &&\n                question.assetsPosition != AssetPositionValuesEnum.withInText &&\n                question.assetsPosition == AssetPositionValuesEnum.bottom\n              \"\n            ></media-carousel>\n            <!--Question time spent-->\n            <div class=\"wk-col-4 responsive-timespent time-qu-pt-remove\">\n              <span\n                class=\"que-mob-left mr10\"\n                [ngClass]=\"getQuestionProgressClass(question)\"\n              >\n              </span>\n              <span\n                class=\"time-mob-right wkqp-badge\"\n                [ngClass]=\"getOvertimelimitClass(question)\"\n              >\n                Time Spent -\n                {{ convertedTime }}\n              </span>\n            </div>\n          </div>\n\n          <div\n            class=\"common-full-width\"\n            *ngIf=\"question.userResponse && question.userResponse.length > 0\"\n          >\n            <!--Your response-->\n            <p\n              class=\"wkqp-prewrap mb20\"\n              [ngClass]=\"getSelectedResponseClass(question)\"\n            >\n              <strong>Your Response: </strong>\n              <label class=\"response-inline\">{{ selectedAnswer }}</label>\n            </p>\n\n            <!--Correct Response-->\n            <p\n              class=\"wkqp-alert-success wkqp-prewrap wkqp-success mb20\"\n              *ngIf=\"question.isCorrect != 1\"\n            >\n              <strong>Correct Response: </strong>\n              <label class=\"response-inline\">{{ correctAnswer }}</label>\n            </p>\n          </div>\n\n          <!--Unattempted response-->\n          <div class=\"common-full-width\" *ngIf=\"!question.userResponse[0]\">\n            <p class=\"wkqp-alert-danger\">\n              <strong>You did not answer this question</strong>\n            </p>\n          </div>\n        </div>\n      </div>\n    </div>\n    <div class=\"common-full-width mb20\">\n      <!--Rationale-->\n      <lib-rationale [itemData]=\"question.modelFeedback\"></lib-rationale>\n      <!-- remediation -->\n      <lib-remediation [itemData]=\"question.remediationLinks\"></lib-remediation>\n    </div>\n  </div>\n</ng-container>\n<!-- </div> -->\n",
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: [""]
    })
], MultipleResponseSummaryComponent);

var prefferedText;
(function (prefferedText) {
    prefferedText[prefferedText["plainTextData"] = 1] = "plainTextData";
    prefferedText[prefferedText["richTextData"] = 2] = "richTextData";
})(prefferedText || (prefferedText = {}));
let GetFormatTextDirective = class GetFormatTextDirective {
    constructor(sanitized, el, renderer) {
        this.sanitized = sanitized;
        this.el = el;
        this.renderer = renderer;
    }
    ngOnInit() {
        let displayData;
        //setting the display data
        let objDisplayData = this.setDisplayData(this.preferredTextFormat, this.plainText, this.richText);
        displayData = objDisplayData.displayText;
        this.el.nativeElement.innerHTML = displayData;
        if (objDisplayData.preferredTextFormatType == 2) {
            // adding the common class name for the rich text
            this.renderer.addClass(this.el.nativeElement, 'rich-text-html-content');
        }
    }
    ngOnChanges() { }
    //setting the display data, preferred text and the sanitised data 0=plain text and 1=rich text
    setDisplayData(preferredTextFormat, plainText, richText) {
        let returnValue = {
            preferredTextFormatType: prefferedText.plainTextData,
            displayText: plainText
        };
        if (preferredTextFormat === 2) {
            returnValue.preferredTextFormatType = preferredTextFormat;
            let txt = document.createElement('textarea');
            txt.innerHTML = richText;
            txt.innerHTML = txt.innerHTML;
            returnValue.displayText = this.sanitized.sanitize(SecurityContext.HTML, this.sanitized.bypassSecurityTrustHtml(txt.value));
            returnValue.preferredTextFormatType = prefferedText.richTextData;
            if (!richText) {
                returnValue.preferredTextFormatType = prefferedText.plainTextData;
                returnValue.displayText = plainText;
            }
        }
        return returnValue;
    }
};
GetFormatTextDirective.ctorParameters = () => [
    { type: DomSanitizer },
    { type: ElementRef },
    { type: Renderer2 }
];
__decorate([
    Input()
], GetFormatTextDirective.prototype, "libGetFormatText", void 0);
__decorate([
    Input()
], GetFormatTextDirective.prototype, "preferredTextFormat", void 0);
__decorate([
    Input()
], GetFormatTextDirective.prototype, "plainText", void 0);
__decorate([
    Input()
], GetFormatTextDirective.prototype, "richText", void 0);
GetFormatTextDirective = __decorate([
    Directive({
        selector: '[libGetFormatText]'
    })
], GetFormatTextDirective);

let ImageScalingComponent = class ImageScalingComponent {
    constructor(modalService, _DomSanitizationService, quizService, changeDetectorRef) {
        this.modalService = modalService;
        this._DomSanitizationService = _DomSanitizationService;
        this.quizService = quizService;
        this.changeDetectorRef = changeDetectorRef;
        this.targetWidth = this.quizService.systemConfig.imageScaledW;
        this.targetHeight = this.quizService.systemConfig.imageScaledHe;
    }
    ngOnInit() {
        this.createImage();
    }
    createImage() {
        const imageObj = new Image();
        imageObj.src = this.ImageSource;
        this.onloadImage(imageObj);
    }
    onloadImage(imageObj) {
        imageObj.onload = () => {
            const srcImageWidth = imageObj.width;
            const srcImageHeight = imageObj.height;
            let imgTargetWidth = 0;
            let imgTargetHeight = 0;
            const srcRatio = srcImageWidth / srcImageHeight;
            const targetRatio = this.targetWidth / this.targetHeight;
            if (srcImageWidth <= this.targetWidth &&
                srcImageHeight <= this.targetHeight) {
                imgTargetWidth = srcImageWidth;
                imgTargetHeight = srcImageHeight;
            }
            else if (targetRatio > srcRatio) {
                imgTargetWidth = this.targetHeight * srcRatio;
                imgTargetHeight = this.targetHeight;
            }
            else {
                imgTargetWidth = this.targetWidth;
                imgTargetHeight = this.targetWidth / srcRatio;
            }
            const canvasElement = this.canvasRef.nativeElement;
            const ctx = canvasElement.getContext('2d');
            const widthDiff = this.targetWidth - imgTargetWidth;
            const heightDiff = this.targetHeight - imgTargetHeight;
            let targetX = widthDiff / 2;
            let targetY = heightDiff / 2;
            targetX = targetX > 0 ? targetX : 0;
            targetY = targetY > 0 ? targetY : 0;
            canvasElement.width = this.targetWidth;
            canvasElement.height = this.targetHeight;
            ctx.drawImage(imageObj, targetX, targetY, imgTargetWidth, imgTargetHeight);
            this.changeDetectorRef.detectChanges();
        };
    }
    /* Click image */
    clickImage(slide) {
        this.fileName = slide && slide.fileName ? slide.fileName : '';
        if (this.quizService.isOnline) {
            this.imageUrl = slide.assetPath;
        }
        else {
            this.imageUrl =
                this.splitStringForType('image', slide.assetName) + slide.assetsContent;
        }
        if (this.imageUrl) {
            this.modalRef = this.modalService.show(this.templateRef);
        }
    }
    splitStringForType(type, value) {
        const name = value.split('.')[1];
        switch (type) {
            case 'image':
                return `data:image/${name};base64,`;
            case 'audio':
                return `data:audio/${name};base64,`;
            case 'video':
                return `data:video/${name};base64,`;
            default:
                break;
        }
    }
    loadImagePath(assetType, slide) {
        if (this.quizService.isOnline) {
            return slide.assetPath;
        }
        return this._DomSanitizationService.bypassSecurityTrustUrl(this.splitStringForType(assetType, slide.assetName) + slide.assetsContent);
    }
    loadImagePathinsideModal(imageUrl) {
        if (this.quizService.isOnline) {
            return imageUrl;
        }
        else {
            return imageUrl;
        }
    }
};
ImageScalingComponent.ctorParameters = () => [
    { type: BsModalService },
    { type: DomSanitizer },
    { type: QuizService },
    { type: ChangeDetectorRef }
];
__decorate([
    ViewChild('canvasImage')
], ImageScalingComponent.prototype, "canvasRef", void 0);
__decorate([
    ViewChild('modalBoxTemplate', { static: false })
], ImageScalingComponent.prototype, "templateRef", void 0);
__decorate([
    Input()
], ImageScalingComponent.prototype, "slideData", void 0);
__decorate([
    Input()
], ImageScalingComponent.prototype, "ImageSource", void 0);
ImageScalingComponent = __decorate([
    Component({
        selector: 'wkqp-image-scaling',
        template: "<canvas\n  #canvasImage\n  (enter)=\"clickImage(slideData)\"\n  (click)=\"clickImage(slideData)\"\n  class=\"item-prev-img55\"\n  *ngIf=\"slideData.assetTypeId == 1\"\n></canvas>\n<ng-template #modalBoxTemplate>\n  <div>\n    <strong class=\"modal-title-main\">\n      {{ fileName }}\n    </strong>\n    <button\n      type=\"button\"\n      class=\"wk-icon-close-empty\"\n      aria-label=\"Close\"\n      (click)=\"modalRef.hide()\"\n    ></button>\n  </div>\n  <div class=\"modal-body\">\n    <div class=\"image-modal-center\">\n      <img\n        class=\"enlarge-img-border\"\n        [src]=\"loadImagePathinsideModal(imageUrl)\"\n        alt=\"No Image\"\n      />\n    </div>\n  </div>\n</ng-template>\n",
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: [".item-prev-img55{border:1px solid #ccc;cursor:pointer}.image-modal-center{text-align:center}.modal-header{border-radius:0}.close.pull-right .wk-icon-close-empty{background-color:transparent;border:0;padding:0;border-radius:0;color:#80bde1;font-size:40px;font-weight:300!important}.close.pull-right .wk-icon-close-empty:before{font-weight:300!important}.close.pull-right .wk-icon-close-empty:hover{color:#fff;background-color:transparent}button.close:focus,button.close:hover{color:#fff;background-color:transparent!important}button.close{right:0!important;top:0!important;font-weight:300!important}"]
    })
], ImageScalingComponent);

let DownloadTranscriptComponent = class DownloadTranscriptComponent {
    constructor() { }
    ngOnInit() { }
    downloadTranscript() {
        window.open(this.slideData.transcript.downloadTranscriptURL);
    }
};
__decorate([
    Input()
], DownloadTranscriptComponent.prototype, "slideData", void 0);
DownloadTranscriptComponent = __decorate([
    Component({
        selector: 'wkqp-download-transcript',
        template: "<div class=\"img-enlarge img-enlarge-text\">\n  <span class=\"link-underline\" (click)=\"downloadTranscript()\">\n    Download Text Transcript File\n  </span>\n</div>\n",
        styles: [""]
    })
], DownloadTranscriptComponent);

let ItemTypesModule = class ItemTypesModule {
};
ItemTypesModule = __decorate([
    NgModule({
        imports: [
            CommonModule,
            FormsModule,
            SortableModule,
            CarouselModule.forRoot(),
            ModalModule,
            ReactiveFormsModule,
            DragDropModule,
            NgMultiSelectDropDownModule.forRoot(),
            TabsModule.forRoot(),
            CKEditorModule,
            PaginationModule.forRoot(),
            GoogleChartsModule,
            MatSelectModule
        ],
        declarations: [
            MultipleChoiceComponent,
            MultipleResponseComponent,
            ItemTypeWrapperComponent,
            ClinicalMultipleChoiceComponent,
            ClinicalMultipleResponseComponent,
            TrueFalseComponent,
            MedicalMultipleChoiceComponent,
            MedicalMultipleResponseComponent,
            FillInTheBlanksComponent,
            GraphicOptionComponent,
            HotSpotComponent,
            FigureLabelingComponent,
            DragAndDropComponent,
            InlineChoiceComponent,
            HotspotSvgComponent,
            InputTypeConfigurationComponent,
            SelectTypeConfigurationComponent,
            FigureLabelComponent,
            CarouselComponent,
            ItemTextAssetsComponent,
            MediaControlsComponent,
            ExhibitModal,
            MetadataComponent,
            RationaleComponent,
            RemediationComponent,
            SummaryHeaderDetailsComponent,
            ClinicalSymptomsSummaryComponent,
            DragAndDropSummaryComponent,
            FigureLabelingSummaryComponent,
            FillInTheBlanksSummaryComponent,
            GraphicOptionSummaryComponent,
            HotSpotSummaryComponent,
            InlineChoiceSummaryComponent,
            MedicalCaseSummaryComponent,
            MultipleChoiceSummaryComponent,
            MultipleResponseSummaryComponent,
            TrueFalseSummaryComponent,
            SummaryPaginationComponent,
            GetFormatTextDirective,
            ImageScalingComponent,
            DownloadTranscriptComponent
        ],
        exports: [
            ItemTypeWrapperComponent,
            MediaControlsComponent,
            HotspotSvgComponent,
            CarouselComponent,
            RationaleComponent,
            RemediationComponent,
            MetadataComponent,
            RationaleComponent,
            RemediationComponent,
            SummaryHeaderDetailsComponent,
            ClinicalSymptomsSummaryComponent,
            DragAndDropSummaryComponent,
            FigureLabelingSummaryComponent,
            FillInTheBlanksSummaryComponent,
            GraphicOptionSummaryComponent,
            HotSpotSummaryComponent,
            InlineChoiceSummaryComponent,
            MedicalCaseSummaryComponent,
            MultipleChoiceSummaryComponent,
            MultipleResponseSummaryComponent,
            TrueFalseSummaryComponent,
            SummaryPaginationComponent
        ],
        schemas: [],
        providers: []
    })
], ItemTypesModule);

let UsmleExamCalculatorComponent = class UsmleExamCalculatorComponent {
    constructor() {
        this.expression = '';
        this.updateResetValue = new EventEmitter();
    }
    ngOnChanges(changes) {
        if (this.resetFeature) {
            this.calculatorOpen = false;
        }
    }
    ngOnInit() { }
    /**
     * Close the calculator
     */
    closeCal() {
        this.calculatorOpen = false;
    }
    /**
     * Concat the expression in the calculator
     * @param calcValue
     */
    concatNumber(calcValue) {
        switch (calcValue) {
            case 'CE':
                this.expression = '';
                break;
            case 'M+':
                this.memoryPlus = isNaN(parseInt(this.memory))
                    ? ''
                    : parseInt(this.memory) + '+';
                if (this.memoryPlus !== '') {
                    this.expression = this.memoryPlus;
                }
                break;
            case 'MR':
                if (this.memory !== undefined && this.memory !== '') {
                    this.expression = this.memory;
                }
                break;
            case 'MC':
                this.memory = '';
                this.expression = '';
                break;
            case 'C':
                const splitted = this.expression.toString().slice(0, -1);
                this.expression = splitted;
                break;
            case 'sqrt':
                this.expression = String(Math.sqrt(parseInt(this.expression)));
                break;
            default:
                if (this.expression.length === 1 &&
                    this.expression === '0' &&
                    (calcValue === '+' || calcValue === '/' || calcValue === '*')) {
                    this.expression = '';
                }
                else {
                    if (this.expression.length === 1 && this.expression === '0') {
                        this.expression = calcValue;
                    }
                    else {
                        this.expression += calcValue;
                    }
                }
                break;
        }
    }
    /**
     * Arithemetic operation
     */
    operation() {
        if (this.expression.length === 0) {
            return false;
        }
        this.expression = eval(this.expression);
        this.memory = this.expression;
        return this.expression;
    }
    /**
     * validating display expression
     * @param event
     */
    validateKey(event) {
        const calcValue = event.key;
        const restrictedKeys = [186, 187, 188, 192, 220, 222];
        const condition1 = event.which && event.which >= 65 && event.which <= 90;
        const condition2 = this.expression.length === 0 &&
            (calcValue === '+' ||
                calcValue === '/' ||
                calcValue === '*' ||
                calcValue === '=');
        if (condition1 || condition2 || restrictedKeys.indexOf(event.which) >= 0) {
            return false;
        }
        if (this.expression.length === 1 && this.expression === '0') {
            this.expression = '';
        }
    }
    /**
     * to show calculator dialog box
     */
    showCalculatorDialogBox() {
        this.updateResetValue.emit();
        this.calculatorOpen = !this.calculatorOpen;
    }
};
__decorate([
    Input()
], UsmleExamCalculatorComponent.prototype, "resetFeature", void 0);
__decorate([
    Output()
], UsmleExamCalculatorComponent.prototype, "updateResetValue", void 0);
UsmleExamCalculatorComponent = __decorate([
    Component({
        selector: 'wkqp-usmle-exam-calculator',
        template: "<div class=\"qp-feature-menu\">\n  <div class=\"calculator-menu\">\n    <button style=\"background: none;\" (click)=\"showCalculatorDialogBox()\">\n      <span>\n        <img\n          alt=\"Calculator\"\n          class=\"examTaker-nav-button-icon\"\n          src=\"./assets/engine-icons/calculator-icon.png\"\n        />\n      </span>\n      <span class=\"pt3\">Calculator</span>\n    </button>\n\n    <!--Calculator Content-->\n    <div\n      *ngIf=\"calculatorOpen && !resetFeature\"\n      class=\"calculator-modal\"\n      cdkDrag\n    >\n      <div\n        style=\"background-color:black;\"\n        id=\"calcuLatorMain\"\n        class=\"calcuLator-wrapper ember-view draggable-area\"\n      >\n        <div class=\"ember-view calcuLator\">\n          <div id=\"calcuLatorHeader\" class=\"calcuLator-header\">\n            <span>Calculator</span>\n          </div>\n          <img\n            alt=\"Dialog-close\"\n            (click)=\"closeCal()\"\n            src=\"assets/engine-icons/calculator-close-icon.png\"\n            class=\"wk-icon-close calc-close\"\n            aria-hidden=\"true\"\n          />\n          <div class=\"calcuLator-main\">\n            <div class=\"calcuLator-display\">\n              <input\n                type=\"text\"\n                name=\"display\"\n                id=\"display\"\n                [(ngModel)]=\"expression\"\n                (keydown)=\"validateKey($event)\"\n              />\n            </div>\n\n            <div class=\"calcuLator-buttons\">\n              <button\n                (click)=\"concatNumber('M+')\"\n                class=\"calcuLator-button _memory _memoryPlus\"\n                data-ember-action=\"2056\"\n              >\n                M+\n              </button>\n\n              <button\n                (click)=\"concatNumber('MR')\"\n                class=\"calcuLator-button _memory _memoryRecall\"\n                data-ember-action=\"2057\"\n              >\n                MR\n              </button>\n\n              <button\n                (click)=\"concatNumber('MC')\"\n                class=\"calcuLator-button _memory _memoryClear\"\n                data-ember-action=\"2058\"\n              >\n                MC\n              </button>\n\n              <button\n                (click)=\"concatNumber('CE')\"\n                class=\"calcuLator-button _clear _clearEntry\"\n                data-ember-action=\"2059\"\n              >\n                CE\n              </button>\n\n              <button\n                (click)=\"concatNumber('C')\"\n                class=\"calcuLator-button _clear _clearAll\"\n                data-ember-action=\"2060\"\n              >\n                C\n              </button>\n\n              <button\n                (click)=\"concatNumber('7')\"\n                class=\"calcuLator-button _number _7\"\n                data-ember-action=\"2061\"\n              >\n                7\n              </button>\n\n              <button\n                (click)=\"concatNumber('8')\"\n                class=\"calcuLator-button _number _8\"\n                data-ember-action=\"2062\"\n              >\n                8\n              </button>\n\n              <button\n                (click)=\"concatNumber('9')\"\n                class=\"calcuLator-button _number _9\"\n                data-ember-action=\"2063\"\n              >\n                9\n              </button>\n\n              <button\n                (click)=\"concatNumber('*')\"\n                class=\"calcuLator-button _operation _multiply\"\n                data-ember-action=\"2064\"\n              >\n                \u00D7\n              </button>\n\n              <button\n                (click)=\"concatNumber('-')\"\n                class=\"calcuLator-button _operation _subtract\"\n                data-ember-action=\"2065\"\n              >\n                \u2212\n              </button>\n\n              <button\n                (click)=\"concatNumber('4')\"\n                class=\"calcuLator-button _number _4\"\n                data-ember-action=\"2066\"\n              >\n                4\n              </button>\n\n              <button\n                (click)=\"concatNumber('5')\"\n                class=\"calcuLator-button _number _5\"\n                data-ember-action=\"2067\"\n              >\n                5\n              </button>\n\n              <button\n                (click)=\"concatNumber('6')\"\n                class=\"calcuLator-button _number _6\"\n                data-ember-action=\"2068\"\n              >\n                6\n              </button>\n\n              <button\n                (click)=\"concatNumber('/')\"\n                class=\"calcuLator-button _operation _divide\"\n                data-ember-action=\"2069\"\n              >\n                \u00F7\n              </button>\n\n              <button\n                (click)=\"concatNumber('+')\"\n                class=\"calcuLator-button _operation _add\"\n                data-ember-action=\"2070\"\n              >\n                +\n              </button>\n\n              <button\n                (click)=\"concatNumber('1')\"\n                class=\"calcuLator-button _number _1\"\n                data-ember-action=\"2071\"\n              >\n                1\n              </button>\n\n              <button\n                (click)=\"concatNumber('2')\"\n                class=\"calcuLator-button _number _2\"\n                data-ember-action=\"2072\"\n              >\n                2\n              </button>\n\n              <button\n                (click)=\"concatNumber('3')\"\n                class=\"calcuLator-button _number _3\"\n                data-ember-action=\"2073\"\n              >\n                3\n              </button>\n\n              <button\n                (click)=\"concatNumber('sqrt')\"\n                class=\"calcuLator-button _operation _sqrt\"\n                data-ember-action=\"2074\"\n              >\n                \u221A\n              </button>\n\n              <button class=\"calcuLator-button _filler\"></button>\n\n              <button\n                (click)=\"concatNumber('\u00B1')\"\n                class=\"calcuLator-button _operation _sign\"\n                data-ember-action=\"2075\"\n              >\n                \u00B1\n              </button>\n\n              <button\n                (click)=\"concatNumber('0')\"\n                class=\"calcuLator-button _number _0\"\n                data-ember-action=\"2076\"\n              >\n                0\n              </button>\n\n              <button\n                (click)=\"concatNumber('.')\"\n                class=\"calcuLator-button _number _dot\"\n                data-ember-action=\"2077\"\n              >\n                .\n              </button>\n\n              <button\n                class=\"calcuLator-button _operation _equal\"\n                data-ember-action=\"2078\"\n                (click)=\"operation()\"\n              >\n                =\n              </button>\n            </div>\n          </div>\n        </div>\n      </div>\n    </div>\n  </div>\n</div>\n",
        styles: [".calcuLator-header .wk-icon-close.calcuLator-close,.calcuLator-header .wk-icon-close.calcuLator-close:before{margin:0;font-size:16px;color:#fff}.examTaker-content .calcuLator-wrapper{z-index:9999}.examTaker-content .calcuLator-wrapper.draggable-area{position:absolute;bottom:1px;right:1px}.calcuLatorHeader{padding:10px;cursor:move;z-index:10;background-color:#2196f3;color:#fff}.calcuLator-header{height:22px;display:flex;justify-content:center;align-items:center;position:relative;border:0;background-color:var(--primary-color);color:#fff;font-family:arial,sans-serif;font-size:14px;font-weight:700}.calcuLator-header .calcuLator-close{position:absolute;top:50%;transform:translate(0,-50%);right:3px}.calcuLator-close{cursor:pointer}.calcuLator-main{padding:7px;background-color:#dadada}.calcuLator-main .calcuLator-display{margin-bottom:7px}.calcuLator-buttons{display:flex;flex-wrap:wrap;margin-right:-7px;margin-bottom:-7px}.calcuLator-button:hover,.calcuLator-buttons:hover{color:#000}.calcuLator-buttons .calcuLator-button._equal{width:calc(40% - 7px)}.calcuLator-buttons .calcuLator-button._add{height:67px;margin-bottom:-30px}.calcuLator-buttons .calcuLator-button{width:calc(20% - 7px);height:30px;margin-right:7px;margin-bottom:7px}.calcuLator-button._memory{color:#fff;padding-top:8px;padding-left:9px}.calcuLator-button._clear{font-weight:700;padding-top:8px;padding-left:9px}.calcuLator-button._number,.calcuLator-button._operation{font-size:1.2em;background-color:#fff;color:#000;padding-top:8px;padding-left:9px}.calcuLator-button._filler{visibility:hidden;pointer-events:none}.calculator-menu{position:relative}.calculator-menu button{padding:0;text-align:center}.calculator-menu button span{color:#474747;text-align:center;display:block;font-size:14px}.pt3{padding-top:3px}.calculator-modal{right:inherit;top:46px;left:0;position:absolute;width:260px;z-index:100000}.calc-close{margin:0!important;position:absolute;top:3px;right:5px}.ember-view.calcuLator{border:1px solid #000}.calcuLator-display input[type=text]{height:2rem;border-bottom:1px solid #d0d0d0;border-right:1px solid #d0d0d0;border-top:1px solid #474747;border-left:1px solid #474747;line-height:normal;padding:3px 10px;text-align:right}button.calcuLator-button._memory._memoryClear,button.calcuLator-button._memory._memoryPlus,button.calcuLator-button._memory._memoryRecall{background-color:#716d89;border-bottom:1px solid #6b6974;border-right:1px solid #6b6974;border-top:1px solid #d4d3da;border-left:1px solid #d4d3da;color:#fff}button.calcuLator-button._clearAll,button.calcuLator-button._clearEntry{background-color:#eab049;border-bottom:1px solid #908164;border-right:1px solid #908164;border-top:1px solid #f3e9d8;border-left:1px solid #f3e9d8;color:#000}button.calcuLator-button._number,button.calcuLator-button._operation{background-color:#d0cfdc;border-bottom:1px solid #878787;border-right:1px solid #878787;border-top:1px solid #f5f5f5;border-left:1px solid #f5f5f5;color:#000}"]
    })
], UsmleExamCalculatorComponent);

let NclexExamCalculatorComponent = class NclexExamCalculatorComponent {
    constructor() {
        this.expression = '0';
        this.updateResetValue = new EventEmitter();
    }
    ngOnChanges(changes) {
        if (this.resetFeature) {
            this.calculatorOpen = false;
        }
    }
    ngOnInit() { }
    /**
     * Close the calculator
     */
    closeCal() {
        this.calculatorOpen = false;
    }
    /**
     * Concat the expression in the calculator
     * @param calcValue
     */
    concatNumber(calcValue) {
        switch (calcValue) {
            case 'CE':
                this.expression = '0';
                break;
            case 'M+':
                this.memoryPlus = isNaN(parseInt(this.memory))
                    ? ''
                    : parseInt(this.memory) + '+';
                if (this.memoryPlus !== '') {
                    this.expression = this.memoryPlus;
                }
                break;
            case 'M-':
                this.memoryMinus = isNaN(parseInt(this.memory))
                    ? ''
                    : parseInt(this.memory) + '-';
                if (this.memoryMinus !== '') {
                    this.expression = this.memoryMinus;
                }
                break;
            case 'MR':
                if (this.memory !== undefined && this.memory !== '') {
                    this.expression = this.memory;
                }
                break;
            case 'MC':
                this.memory = '';
                this.expression = '0';
                break;
            case 'C':
                const splitted = this.expression.toString().slice(0, -1);
                this.expression = splitted;
                break;
            case 'sqrt':
                this.expression = String(Math.sqrt(parseInt(this.expression)));
                break;
            case '±':
                const format = /[ !@#$%^&*()_+\-=\[\]{};':'\\|,<>\/?]/;
                const expLength = this.expression.length;
                if (expLength > 0 && !format.test(this.expression)) {
                    this.expression = String(Number(this.expression) * -1);
                }
                else if (expLength > 0 && format.test(this.expression)) {
                    console.log('this.expression.substring(1,expLength - 1)    ', this.expression.substring(1));
                    if (expLength === 1 && this.expression === '-') {
                        this.memory = '';
                        this.expression = '';
                    }
                    else if (!format.test(this.expression.charAt(expLength - 1))) {
                        if (this.expression.charAt(0) === '-' &&
                            !format.test(this.expression.substring(1))) {
                            this.expression = this.expression.substring(1);
                        }
                        else {
                            const temp = this.expression.charAt(expLength - 1);
                            this.expression =
                                this.expression.substring(0, expLength - 1) + '-' + temp;
                        }
                    }
                }
                else {
                    this.memory = '-';
                    this.expression = '-';
                }
                break;
            default:
                if (this.expression.length === 1 &&
                    this.expression === '0' &&
                    (calcValue === '+' || calcValue === '/' || calcValue === '*')) {
                    this.expression = '';
                }
                else {
                    if (this.expression.length === 1 && this.expression === '0') {
                        this.expression = calcValue;
                    }
                    else {
                        this.expression += calcValue;
                    }
                }
                break;
        }
        this.vc.first.nativeElement.focus();
    }
    /**
     * Arithemetic operation
     */
    operation() {
        if (this.expression.length === 0) {
            return false;
        }
        this.expression = eval(this.expression);
        this.memory = this.expression;
        return this.expression;
    }
    /**
     * validating display expression
     * @param event
     */
    validateUserInput(event) {
        const calcValue = event.key;
        const restrictedKeys = [186, 187, 188, 192, 220, 222];
        const condition1 = event.which && event.which >= 65 && event.which <= 90;
        const condition2 = this.expression.length === 0 &&
            (calcValue === '+' ||
                calcValue === '/' ||
                calcValue === '*' ||
                calcValue === '=');
        if (condition1 || condition2 || restrictedKeys.indexOf(event.which) >= 0) {
            return false;
        }
        if (this.expression.length === 1 && this.expression === '0') {
            this.expression = '';
        }
    }
    /**
     * to show calculator dialog box
     */
    showCalculatorDialogBox() {
        this.updateResetValue.emit();
        this.calculatorOpen = !this.calculatorOpen;
    }
};
__decorate([
    ViewChildren('input')
], NclexExamCalculatorComponent.prototype, "vc", void 0);
__decorate([
    Input()
], NclexExamCalculatorComponent.prototype, "resetFeature", void 0);
__decorate([
    Output()
], NclexExamCalculatorComponent.prototype, "updateResetValue", void 0);
NclexExamCalculatorComponent = __decorate([
    Component({
        selector: 'wkqp-nclex-exam-calculator',
        template: "<div class=\"qp-feature-menu\">\n  <div class=\"calculator-menu\">\n    <button\n      (click)=\"showCalculatorDialogBox()\"\n      style=\"\n      background: none;\n  \"\n    >\n      <span>\n        <img\n          alt=\"Calculator\"\n          class=\"examTaker-nav-button-icon\"\n          src=\"assets/engine-icons/calculator-icon.png\"\n        />\n      </span>\n      <span class=\"pt3\">Calculator</span>\n    </button>\n\n    <div class=\"calculator-modal\" *ngIf=\"calculatorOpen && !resetFeature\">\n      <div\n        id=\"calcuLatorMain\"\n        class=\"calcuLator-wrapper ember-view draggable-area nclex-calc-outer\"\n        cdkDrag\n      >\n        <div class=\"ember-view calcuLator\">\n          <img\n            alt=\"Dialog-close\"\n            (click)=\"closeCal()\"\n            src=\"assets/engine-icons/calculator-close-icon.png\"\n            class=\"calc-close\"\n            aria-hidden=\"true\"\n          />\n\n          <div class=\"calcuLator-main\">\n            <table style=\"margin-top:15px;height: 100%;\">\n              <tr>\n                <td colspan=\"4\">\n                  <input\n                    #input\n                    (keydown)=\"validateUserInput($event)\"\n                    type=\"text\"\n                    class=\"calc-textbox\"\n                    style=\"text-align: right\"\n                    [(ngModel)]=\"expression\"\n                  />\n                </td>\n              </tr>\n              <tr>\n                <td>\n                  <input\n                    (click)=\"concatNumber('MC')\"\n                    class=\"btn-normal calc-btn-color1\"\n                    type=\"button\"\n                    value=\"mc\"\n                  />\n                </td>\n                <td>\n                  <input\n                    (click)=\"concatNumber('M+')\"\n                    class=\"btn-normal calc-btn-color1\"\n                    type=\"button\"\n                    value=\"m+\"\n                  />\n                </td>\n                <td>\n                  <input\n                    (click)=\"concatNumber('M-')\"\n                    class=\"btn-normal calc-btn-color1\"\n                    type=\"button\"\n                    value=\"m-\"\n                  />\n                </td>\n                <td>\n                  <input\n                    (click)=\"concatNumber('MR')\"\n                    class=\"btn-normal calc-btn-color1\"\n                    type=\"button\"\n                    value=\"mr\"\n                  />\n                </td>\n              </tr>\n              <tr>\n                <td>\n                  <input\n                    (click)=\"concatNumber('CE')\"\n                    class=\"btn-normal calc-btn-color2\"\n                    type=\"button\"\n                    value=\"AC\"\n                  />\n                </td>\n                <td>\n                  <input\n                    (click)=\"concatNumber('\u00B1')\"\n                    class=\"btn-normal calc-btn-color2\"\n                    type=\"button\"\n                    value=\"+/-\"\n                  />\n                </td>\n                <td>\n                  <input\n                    (click)=\"concatNumber('/')\"\n                    class=\"btn-normal calc-btn-color2\"\n                    type=\"button\"\n                    value=\"&divide;\"\n                  />\n                </td>\n                <td>\n                  <input\n                    (click)=\"concatNumber('*')\"\n                    class=\"btn-normal calc-btn-color2\"\n                    type=\"button\"\n                    value=\"&times;\"\n                  />\n                </td>\n              </tr>\n              <tr>\n                <td>\n                  <input\n                    (click)=\"concatNumber('7')\"\n                    class=\"btn-normal calc-btn\"\n                    type=\"button\"\n                    value=\"7\"\n                  />\n                </td>\n                <td>\n                  <input\n                    (click)=\"concatNumber('8')\"\n                    class=\"btn-normal calc-btn\"\n                    type=\"button\"\n                    value=\"8\"\n                  />\n                </td>\n                <td>\n                  <input\n                    (click)=\"concatNumber('9')\"\n                    class=\"btn-normal calc-btn\"\n                    type=\"button\"\n                    value=\"9\"\n                  />\n                </td>\n                <td>\n                  <input\n                    (click)=\"concatNumber('-')\"\n                    class=\"btn-normal calc-btn-color2\"\n                    type=\"button\"\n                    value=\"-\"\n                  />\n                </td>\n              </tr>\n              <tr>\n                <td>\n                  <input\n                    (click)=\"concatNumber('4')\"\n                    class=\"btn-normal calc-btn\"\n                    type=\"button\"\n                    value=\"4\"\n                  />\n                </td>\n                <td>\n                  <input\n                    (click)=\"concatNumber('5')\"\n                    class=\"btn-normal calc-btn\"\n                    type=\"button\"\n                    value=\"5\"\n                  />\n                </td>\n                <td>\n                  <input\n                    (click)=\"concatNumber('6')\"\n                    class=\"btn-normal calc-btn\"\n                    type=\"button\"\n                    value=\"6\"\n                  />\n                </td>\n                <td>\n                  <input\n                    (click)=\"concatNumber('+')\"\n                    class=\"btn-normal calc-btn-color2\"\n                    type=\"button\"\n                    value=\"+\"\n                  />\n                </td>\n              </tr>\n              <tr>\n                <td>\n                  <input\n                    (click)=\"concatNumber('1')\"\n                    class=\"btn-normal calc-btn\"\n                    type=\"button\"\n                    value=\"1\"\n                  />\n                </td>\n                <td>\n                  <input\n                    (click)=\"concatNumber('2')\"\n                    class=\"btn-normal calc-btn\"\n                    type=\"button\"\n                    value=\"2\"\n                  />\n                </td>\n                <td>\n                  <input\n                    (click)=\"concatNumber('3')\"\n                    class=\"btn-normal calc-btn\"\n                    type=\"button\"\n                    value=\"3\"\n                  />\n                </td>\n                <td rowspan=\"2\">\n                  <input\n                    type=\"button\"\n                    (click)=\"operation()\"\n                    class=\"btn-equal\"\n                    value=\"=\"\n                  />\n                </td>\n              </tr>\n              <tr>\n                <td colspan=\"2\">\n                  <input\n                    class=\"btn-normal calc-btn\"\n                    (click)=\"concatNumber('0')\"\n                    type=\"button\"\n                    value=\"0\"\n                  />\n                </td>\n                <td>\n                  <input\n                    (click)=\"concatNumber('.')\"\n                    class=\"btn-normal calc-btn\"\n                    type=\"button\"\n                    value=\".\"\n                  />\n                </td>\n              </tr>\n            </table>\n          </div>\n        </div>\n      </div>\n    </div>\n  </div>\n</div>\n",
        styles: [".clear-box{float:left;width:100%}.calculator-block{margin-bottom:2vh!important}.header-child-wrapper{float:left;width:100%;background-color:#1d6ea775;padding-bottom:3px}.engine-header-record-column-nclex{width:auto;padding:0;display:block}.btn-icon{background:0 0;padding:0;margin-top:1vh}.btn-icon:hover{background:0 0!important}.child-header-body{color:#ffff;margin:1vw 0 0 1vw;font-size:1.25vw}.fa-calculator:before{content:\"\\f1ec\"}.calculator-modal{right:inherit;top:46px;left:0;position:absolute;width:260px;z-index:100000}.wkqp-row .test-header1{width:17%}.wkqp-row .test-header2{width:14%}.wkqp-row .test-header3{width:6%}.wkqp-row .test-header4{width:7%}.wkqp-row .test-header5{width:10%}.wkqp-row .test-header6{width:15%}.wkqp-row .test-header7{width:11%}.wkqp-row .test-header8{width:7%}.nclex-calc-outer{background-color:#000!important;border-radius:8px!important}.cal-btn-row{margin-bottom:9px}.nclex-calc-modal{width:200px;height:250px;background:0 0}.nclex-calc-modal-body{background-color:#000}.title{margin-bottom:10px;text-align:center;width:210px;color:#515451;border:2px solid #000}input[type=button]{color:#fff;border:2px solid #000;height:25px;border-radius:5px;padding:1px;box-shadow:inset 0 1px 9px -3px!important;font-size:12px!important;font-weight:700!important}.modal-body{position:relative!important;padding:10px!important}.btn-equal{height:9vh!important;background-color:#d87005!important;margin:-2px 0 0!important}.btn-equal:hover{border:2px solid #000!important}.calc-close{margin:0!important;position:absolute;top:1px;right:2px}.calcuLatorHeader{padding:10px;cursor:move;z-index:10;background-color:#000;color:#fff}.calcuLator-header{height:22px;display:flex;justify-content:center;align-items:center;position:relative;background-color:#000;color:#fff;font-family:arial,sans-serif;font-size:14px;font-weight:700;border-radius:15px}.calcuLator-header .calcuLator-close{position:absolute;top:50%;transform:translate(0,-50%);right:3px}.wk-alert-dismissible.newalertdismissible .wk-icon-close-empty{position:static;float:right;margin:-17px -15px 0 0}.calcuLator-close{cursor:pointer}.calcuLator-main{padding:1px 10px 20px;background-color:#000;border-radius:10px;height:270px;margin-top:0}.calcuLator-main .calcuLator-display{margin-bottom:7px}.calc-textbox{background-color:#e4e4d1!important;border-radius:6px!important;width:100%;border:none!important;box-shadow:inset 0 -9px 28px -4px #999c65;font-size:35px!important;font-weight:700!important}.calcuLator-display input{background-color:#eef7f6!important;font-weight:700}.calcuLator-buttons{display:flex;flex-wrap:wrap;margin-right:-7px;margin-bottom:-7px}.calcuLator-buttons .calcuLator-button{width:calc(20% - 7px);height:30px;margin-right:7px;margin-bottom:7px}.calcuLator-button:hover,.calcuLator-buttons:hover{color:#000}.calcuLator-buttons .calcuLator-button._equal{width:calc(40% - 7px);background-color:#cc5c0d!important}.calcuLator-buttons .calcuLator-button._add{height:67px;margin-bottom:-30px}.btn-normal{width:95%;height:0;border-radius:3px;padding:11px;background-color:#2d2c2c;line-height:0}.btn-normal:hover{border:2px solid #000!important}.calc-btn-color1{background-color:#647179!important}.calc-btn-color2{background-color:#352323!important}.calc-btn{background-color:#000!important}.calcuLator-button._memory{background-color:#76718f;border-color:#adaabc;color:#fff;padding-top:8px;padding-left:9px}.calcuLator-button._clear{background-color:#f4b74c;border-color:#fadeac;font-weight:700;padding-top:8px;padding-left:9px}.calcuLator-button._number,.calcuLator-button._operation{font-size:1.2em;background-color:#fff;color:#000;padding-top:8px;padding-left:9px}.calcuLator-button._filler{visibility:hidden;pointer-events:none}.examTaker-header-region-right-inner .examTaker-nav-button._calc .examTaker-nav-button-icon,.examTaker-header-region-right-inner .examTaker-nav-button._lab .examTaker-nav-button-icon,.examTaker-header-region-right-inner .examTaker-nav-button._notes .examTaker-nav-button-icon,.examTaker-header-region-right-inner .examTaker-nav-button._reverse .examTaker-nav-button-icon,.examTaker-header-region-right-inner .examTaker-nav-button._text_zoom .examTaker-nav-button-icon{margin-bottom:3px}.calculator-menu{position:relative}.calculator-menu button{padding:0;color:#474747;text-align:center;background-color:transparent}.calculator-menu button span{color:#474747;text-align:center;display:block;font-size:14px}.pt3{padding-top:3px}"]
    })
], NclexExamCalculatorComponent);

let TimerComponent = class TimerComponent {
    constructor(utilService) {
        this.utilService = utilService;
        this.timeExceeded = new EventEmitter();
    }
    ngOnChanges(changes) {
        if (changes.timer && changes.timer.currentValue) {
            this.clearInterval();
            this.createTimer();
        }
    }
    createTimer() {
        this.interval = setInterval(() => {
            if (this.timer.isIncrement) {
                this.timer.timer++;
                if (this.timer.limit && this.timer.timer > this.timer.limit) {
                    this.timeExceeded.emit();
                }
            }
            else {
                this.timer.timer--;
                if (this.timer.limit && this.timer.timer < this.timer.limit) {
                    this.timeExceeded.emit();
                }
            }
            this.displayTime = this.utilService.convertSecondsToTimerFormat(this.timer.timer);
        }, 1000);
    }
    getTimer() {
        return this.timer.timer;
    }
    clearInterval() {
        clearInterval(this.interval);
    }
    ngOnInit() { }
};
TimerComponent.ctorParameters = () => [
    { type: UtilTimeService }
];
__decorate([
    Input('timerConfig')
], TimerComponent.prototype, "timer", void 0);
__decorate([
    Output('timeExceeded')
], TimerComponent.prototype, "timeExceeded", void 0);
TimerComponent = __decorate([
    Component({
        selector: 'lib-timer',
        template: "{{ displayTime }}\n",
        styles: [""]
    })
], TimerComponent);

let ItemBookmarkComponent = class ItemBookmarkComponent {
    constructor() {
        this.updatedBookMarkStatus = new EventEmitter();
    }
    ngOnInit() { }
    updateBookmark(event) {
        this.updatedBookMarkStatus.emit(event.target.checked);
    }
};
__decorate([
    Input()
], ItemBookmarkComponent.prototype, "isBookMarked", void 0);
__decorate([
    Output()
], ItemBookmarkComponent.prototype, "updatedBookMarkStatus", void 0);
ItemBookmarkComponent = __decorate([
    Component({
        selector: 'wkqp-item-bookmark',
        template: "<div class=\"qp-feature-menu\">\n  <div class=\"bookmark-menu\">\n    <span\n      ><input\n        aria-label=\"Bookmark Question\"\n        type=\"checkbox\"\n        name=\"mark\"\n        [(ngModel)]=\"isBookMarked\"\n        (change)=\"updateBookmark($event)\"\n      />\n      <img\n        alt=\"BookMark Question\"\n        class=\"examTaker-marked-icon\"\n        src=\"assets/engine-icons/mark-icon.png\"\n        style=\"padding-bottom: 4px\"\n      />\n    </span>\n    <span class=\"pt3\">Mark</span>\n  </div>\n</div>\n",
        styles: [".bookmark-menu span{display:block;text-align:center;color:#474747;font-size:14px}.pt3{padding-top:3px}.examTaker-marked-icon{left:5px;position:relative;top:-2px}.bookmark-menu input[type=checkbox]{margin-right:0}.bookmark-menu span:first-child{position:relative;top:8px}@-moz-document url-prefix(){.bookmark-menu{position:relative;top:-6px}}"]
    })
], ItemBookmarkComponent);

let ItemNotesComponent = class ItemNotesComponent {
    constructor() {
        this.updatedNotes = new EventEmitter();
        this.updateResetValue = new EventEmitter();
    }
    ngOnChanges(changes) {
        if (this.resetFeature) {
            this.canShowNotes = false;
        }
    }
    ngOnInit() { }
    /**
     * to delete notes
     */
    deleteNotes() {
        this.currentNotes = '';
        this.updatedNotes.emit(this.currentNotes);
    }
    /**
     * to add notes and close notes dialog box
     */
    updateNotesAndClose() {
        this.canShowNotes = false;
        this.updatedNotes.emit(this.currentNotes);
    }
    /**
     * to show notes dialog box
     */
    showNotesDialogBox() {
        this.updateResetValue.emit();
        this.canShowNotes = !this.canShowNotes;
    }
};
__decorate([
    Input()
], ItemNotesComponent.prototype, "currentNotes", void 0);
__decorate([
    Input()
], ItemNotesComponent.prototype, "resetFeature", void 0);
__decorate([
    Output()
], ItemNotesComponent.prototype, "updatedNotes", void 0);
__decorate([
    Output()
], ItemNotesComponent.prototype, "updateResetValue", void 0);
ItemNotesComponent = __decorate([
    Component({
        selector: 'wkqp-item-notes',
        template: "<div class=\"qp-feature-menu\">\n  <div class=\"notes-menu\">\n    <!--Notes-->\n    <button (click)=\"showNotesDialogBox()\">\n      <span\n        ><img alt=\"Question Notes\" src=\"assets/engine-icons/notes-icon.png\" />\n      </span>\n      <span class=\"pt3\">Notes</span>\n    </button>\n\n    <!--Notes Content-->\n    <div *ngIf=\"canShowNotes && !resetFeature\" class=\"notes-modal\">\n      <div class=\"examTaker-notes\">\n        <div class=\"examTaker-notes-title\">\n          Add Item Notes\n          <a (click)=\"canShowNotes = false\" class=\"examTaker-notes-close\">\n            <img\n              alt=\"Dialog-Close\"\n              (click)=\"canShowNotes = false\"\n              src=\"assets/engine-icons/close-icon.gif\"\n          /></a>\n        </div>\n        <div class=\"examTaker-notes-content\">\n          <textarea\n            id=\"ember1521\"\n            [(ngModel)]=\"currentNotes\"\n            class=\"examTaker-notes-input ember-view ember-text-area\"\n          ></textarea>\n          <div class=\"examTaker-notes-controls\">\n            <button\n              class=\"examTaker-notes-control save\"\n              (click)=\"updateNotesAndClose()\"\n            >\n              Save and Close\n            </button>\n            <button\n              class=\"examTaker-notes-control clear\"\n              (click)=\"deleteNotes()\"\n            >\n              Delete Notes\n            </button>\n          </div>\n        </div>\n      </div>\n    </div>\n  </div>\n</div>\n",
        styles: [".examTaker-header-region-right-inner .examTaker-nav-button._notes{display:inline-block}.examTaker-nav-button-text{white-space:nowrap;color:#fff!important}.examTaker-header-region-right-inner .examTaker-nav-button._text_zoom .examTaker-nav-button-text-zoom{display:flex;margin-bottom:3px}.route-sessionsSessionBlockTake:not(._font-big):not(._font-medium) .examTaker-nav-button-text-zoom-button._big,.route-sessionsSessionBlockTake:not(._font-big):not(._font-medium) .examTaker-nav-button-text-zoom-button._medium,.route-sessionsSessionBlockTake:not(._font-big):not(._font-medium) .examTaker-nav-button-text-zoom-button._small{background-color:#fcfcfc;border-color:#fff!important;color:#000}.examTaker-header-region-right-inner .examTaker-nav-button._text_zoom .examTaker-nav-button-text-zoom .examTaker-nav-button-text-zoom-button._medium{font-size:12pt}.examTaker-header-region-right-inner .examTaker-nav-button._text_zoom .examTaker-nav-button-text-zoom .examTaker-nav-button-text-zoom-button{min-width:22px;max-width:22px;line-height:18pt;text-align:center;padding:0;margin:0;background-color:transparent;vertical-align:middle;border:2px solid;outline:0}.examTaker-header-region-right-inner .examTaker-nav-button._text_zoom .examTaker-nav-button-text-zoom .examTaker-nav-button-text-zoom-button._big{border-left-width:0;border-radius:0 6px 6px 0;font-size:15pt}.examTaker-main .examTaker-header{height:50px}.route-sessionsSessionBlockTake:not(._font-big):not(._font-medium) .examTaker-nav-button-text-zoom-button._small{border-top-left-radius:6px;border-bottom-left-radius:6px}.examTaker-header-region-right-inner .examTaker-nav-button-text-zoom button.examTaker-nav-button-text-zoom-button._big,.examTaker-header-region-right-inner .examTaker-nav-button-text-zoom button.examTaker-nav-button-text-zoom-button._medium,.examTaker-header-region-right-inner .examTaker-nav-button-text-zoom button.examTaker-nav-button-text-zoom-button._small{background-color:#00f;color:#fff}.examTaker-header-region-right-inner .examTaker-nav-button-text-zoom button.examTaker-nav-button-text-zoom-button._medium:hover{background-color:#fff!important;color:#000!important}body>.ember-view:not(.liquid-target-container){min-height:100vh;min-width:768px}button.image-engine-dialog-close{background-color:transparent;border:0;padding:0;border-radius:0;color:#3852a4;font-size:40px;font-weight:700}button.image-engine-dialog-close:focus,button.image-engine-dialog-close:hover{background-color:transparent;color:#3852a4}.notes-modal{position:absolute;top:46px;left:-4px;border:1px solid #97a5d0;background:#fff;z-index:100000}.examTaker-content .examTaker-notes{position:absolute;top:1px;right:1px}.examTaker-notes .examTaker-notes-title{margin-bottom:5px}.examTaker-notes-title{line-height:21px;position:relative;border-bottom:1px solid #000;background-color:var(--primary-color);color:#fff;text-align:center;font-size:13px}.examTaker-notes{padding:2px;width:356px;border:1px solid #000;background-color:#fff}.examTaker-notes-content{padding:3px}.examTaker-notes .examTaker-notes-input{margin-bottom:10px}.examTaker-notes-input{width:100%;height:100px;resize:none}.examTaker-notes-controls{display:flex}.examTaker-notes-control{line-height:12px;font-size:12px;white-space:nowrap;color:#000;border:2px outset #ece9d8;display:block;width:113px;height:32px;background-color:#ccc;margin-right:10px}.examTaker-notes-title .examTaker-notes-close{position:absolute;top:50%;transform:translate(0,-50%);right:3px}.notes-menu button{background-color:transparent;padding:0;color:#474747}.notes-menu button span{display:block;text-align:center;color:#474747;font-size:14px}.pt3{padding-top:3px}.notes-menu{position:relative;background:0 0}.clear,.save{background-color:var(--primary-color)!important;color:#fff!important}.clear:hover,.save:hover{background-color:var(--tertiary-color)!important;color:#000}"]
    })
], ItemNotesComponent);

let LabValuesComponent = class LabValuesComponent {
    constructor() {
        this.labValueEnum = LapValues;
        this.lapValue = this.labValueEnum.blood;
        this.updateResetValue = new EventEmitter();
    }
    ngOnChanges(changes) {
        if (this.resetFeature) {
            this.canShowLabValues = false;
        }
    }
    ngOnInit() { }
    /**
     * to show lab values dialog box
     */
    showLabValueDialogBox() {
        this.updateResetValue.emit();
        this.canShowLabValues = !this.canShowLabValues;
    }
};
__decorate([
    Input()
], LabValuesComponent.prototype, "resetFeature", void 0);
__decorate([
    Output()
], LabValuesComponent.prototype, "updateResetValue", void 0);
LabValuesComponent = __decorate([
    Component({
        selector: 'wkqp-lab-values',
        template: "<div class=\"qp-feature-menu\">\n  <div class=\"labvalues-menu\">\n    <button (click)=\"showLabValueDialogBox()\">\n      <span>\n        <img\n          alt=\"Lab values Details\"\n          class=\"examTaker-nav-button-icon\"\n          src=\"assets/engine-icons/labvalues-icon.png\"\n        />\n      </span>\n      <span class=\"pt3\">Lab Values</span>\n    </button>\n\n    <!-- Lab Value Content-->\n    <div *ngIf=\"canShowLabValues && !resetFeature\" class=\"lap-value-modal\">\n      <div class=\"ember-view examLabValues\">\n        <a\n          tabindex=\"0\"\n          (keypress)=\"canShowLabValues = false\"\n          (click)=\"canShowLabValues = false\"\n          class=\"examLabValues-close\"\n          data-ember-action=\"1550\"\n        >\n          <img alt=\"Dialog-close\" src=\"assets/engine-icons/close-icon.gif\" />\n        </a>\n        <h2 class=\"examLabValues-header\">Lab Values</h2>\n        <div class=\"ember-view\">\n          <div class=\"examLabValues-navigation\">\n            <div\n              tabindex=\"0\"\n              class=\"examLabValues-navigation-link ember-view\"\n              [ngClass]=\"{ active: lapValue == labValueEnum.blood }\"\n              (click)=\"lapValue = labValueEnum.blood\"\n            >\n              <a\n                (click)=\"lapValue = labValueEnum.blood\"\n                (keypress)=\"lapValue = labValueEnum.blood\"\n                data-toggle=\"tab\"\n                >{{ labValueEnum.blood }}</a\n              >\n            </div>\n            <div\n              tabindex=\"0\"\n              class=\"examLabValues-navigation-link ember-view\"\n              [ngClass]=\"{ active: lapValue == labValueEnum.hematologic }\"\n              (click)=\"lapValue = labValueEnum.hematologic\"\n            >\n              <a\n                (click)=\"lapValue = labValueEnum.hematologic\"\n                (keypress)=\"lapValue = labValueEnum.hematologic\"\n                data-toggle=\"tab\"\n                >{{ labValueEnum.hematologic }}</a\n              >\n            </div>\n            <div\n              tabindex=\"0\"\n              class=\"examLabValues-navigation-link ember-view\"\n              [ngClass]=\"{ active: lapValue == labValueEnum.cerebrospinal }\"\n              (click)=\"lapValue = labValueEnum.cerebrospinal\"\n            >\n              <a\n                (click)=\"lapValue = labValueEnum.cerebrospinal\"\n                (keypress)=\"lapValue = labValueEnum.cerebrospinal\"\n                data-toggle=\"tab\"\n                >{{ labValueEnum.cerebrospinal }}</a\n              >\n            </div>\n            <div\n              tabindex=\"0\"\n              class=\"examLabValues-navigation-link ember-view\"\n              [ngClass]=\"{ active: lapValue == labValueEnum.sub }\"\n              (click)=\"lapValue = labValueEnum.sub\"\n            >\n              <a\n                (click)=\"lapValue = labValueEnum.sub\"\n                (keypress)=\"lapValue = labValueEnum.sub\"\n                data-toggle=\"tab\"\n                >Sweet,Urine,BMI</a\n              >\n            </div>\n\n            <!-- Tab panes -->\n            <div class=\"examLabValues-content\">\n              <div\n                *ngIf=\"lapValue == labValueEnum.blood\"\n                class=\"tab-pane active\"\n                id=\"blood\"\n              >\n                <lib-blood-lap-values></lib-blood-lap-values>\n              </div>\n              <div\n                *ngIf=\"lapValue == labValueEnum.hematologic\"\n                class=\"tab-pane active\"\n                id=\"labValueEnum.hematologic\"\n              >\n                <lib-hematologic-lap-values></lib-hematologic-lap-values>\n              </div>\n              <div\n                *ngIf=\"lapValue == labValueEnum.cerebrospinal\"\n                class=\"tab-pane active\"\n                id=\"labValueEnum.cerebrospinal\"\n              >\n                <lib-cerebrospinal-lap-values></lib-cerebrospinal-lap-values>\n              </div>\n              <div\n                *ngIf=\"lapValue == labValueEnum.sub\"\n                class=\"tab-pane active\"\n                id=\"sweet\"\n              >\n                <lib-s-u-b-lap-values></lib-s-u-b-lap-values>\n              </div>\n            </div>\n          </div>\n        </div>\n      </div>\n    </div>\n  </div>\n</div>\n",
        styles: [".examTaker-header-region-right-inner .examTaker-nav-button._calc .examTaker-nav-button-icon,.examTaker-header-region-right-inner .examTaker-nav-button._lab .examTaker-nav-button-icon,.examTaker-header-region-right-inner .examTaker-nav-button._notes .examTaker-nav-button-icon,.examTaker-header-region-right-inner .examTaker-nav-button._reverse .examTaker-nav-button-icon,.examTaker-header-region-right-inner .examTaker-nav-button._text_zoom .examTaker-nav-button-icon{margin-bottom:3px}button.examTaker-nav-button_direction_next:hover span.examTaker-nav-button-text{color:#fff!important}.examTaker-header-region-right-inner .examTaker-nav-button .examTaker-nav-button-text{white-space:nowrap}.examLabValues-header{margin-top:5px;margin-bottom:5px;font-size:15px;text-align:center}.examLabValues-content{overflow-y:auto;overflow-x:hidden;float:left;clear:both;width:100%;padding-right:0;background-color:var(--secondary-color);color:#000}.examLabValues .examLabValues-close{position:absolute;top:0;right:5px}.examLabValues-close{position:absolute;top:0;right:0}.examLabValues-content>.active{max-height:450px;overflow:auto}.examLabValues-content-table{background:#d7dced;width:402px}table{border-collapse:collapse;border-spacing:0}.examTaker{font-family:arial,sans-serif}.examLabValues-content-table td{padding:4px 25px 4px 20px;width:180px;border-bottom:1px solid #aab}.examLabValues-navigation{padding-top:0;padding-left:0;display:inherit;display:inherit;display:inherit;float:left;width:100%}.examLabValues-navigation-link{text-decoration:none;background-color:var(--secondary-color);color:#000;border:1px solid #141548;cursor:pointer;padding:3px 6px;line-height:11px;float:left}.examLabValues-navigation-link a{font-size:12px}.examLabValues-navigation .examLabValues-navigation-link:not(:last-child){margin-right:4px}.examLabValues-navigation-link.active,.examLabValues-navigation-link:hover{background-color:var(--primary-color);color:#fff}body>.ember-view:not(.liquid-target-container){min-height:100vh;min-width:768px}.labvalues-menu{position:relative}.lap-value-modal{position:absolute;background-color:#fff;padding:0;border:1px solid #a3a3b4;z-index:100000;width:380px;top:49px}.labvalues-menu button{background-color:transparent;padding:0;color:#474747;text-align:center}.labvalues-menu button span{color:#474747;text-align:center;display:block;font-size:14px}.pt3{padding-top:3px}"]
    })
], LabValuesComponent);

let TextZoomComponent = class TextZoomComponent {
    constructor(themeService) {
        this.themeService = themeService;
        this.fontSizeEnum = FontSizeEnum;
    }
    ngOnInit() { }
    updateFontSize(fontSizeInPx) {
        this.themeService.setFontSize(fontSizeInPx);
    }
};
TextZoomComponent.ctorParameters = () => [
    { type: ThemeService }
];
__decorate([
    Input()
], TextZoomComponent.prototype, "fontSize", void 0);
TextZoomComponent = __decorate([
    Component({
        selector: 'wkqp-text-zoom',
        template: "<div class=\"qp-feature-menu\">\n  <!--Text Zoom-->\n  <div class=\"examTaker-nav-button _text_zoom textzoom-menu\">\n    <div class=\"examTaker-nav-button-text-zoom\">\n      <button\n        [ngClass]=\"{\n          'font-active': fontSize === fontSizeEnum.SmallFont\n        }\"\n        (click)=\"updateFontSize(fontSizeEnum.SmallFont)\"\n        class=\"examTaker-nav-button-text-zoom-button fontsize-small\"\n      >\n        A\n      </button>\n      <button\n        [ngClass]=\"{\n          'font-active': fontSize === fontSizeEnum.MediumFont\n        }\"\n        (click)=\"updateFontSize(fontSizeEnum.MediumFont)\"\n        class=\"examTaker-nav-button-text-zoom-button fontsize-medium\"\n      >\n        A\n      </button>\n      <button\n        [ngClass]=\"{\n          'font-active': fontSize === fontSizeEnum.LargeFont\n        }\"\n        (click)=\"updateFontSize(fontSizeEnum.LargeFont)\"\n        class=\"examTaker-nav-button-text-zoom-button fontsize-large\"\n      >\n        A\n      </button>\n    </div>\n    <span>Text Zoom</span>\n  </div>\n</div>\n",
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: [".textzoom-menu span{display:block;color:#474747;text-align:center;font-size:14px}.fontsize-small{font-size:10px}.fontsize-medium{font-size:13px}.fontsize-large{font-size:16px}.examTaker-nav-button button.font-active{background-color:var(--primary-color);color:#fff;border:1px solid var(--primary-color)}.route-sessionsSessionBlockTake:not(._font-big):not(._font-medium) .examTaker-nav-button-text-zoom-button._small{background-color:#fcfcfc;border-color:#fff!important;color:#000}.examTaker-header-region-right-inner .examTaker-nav-button._text_zoom .examTaker-nav-button-text-zoom .examTaker-nav-button-text-zoom-button{min-width:22px;max-width:22px;line-height:18pt;text-align:center;padding:0;margin:0;background-color:transparent;vertical-align:middle;border:2px solid;outline:0}.examTaker-header-region-right-inner .examTaker-nav-button._text_zoom .examTaker-nav-button-text-zoom{display:flex;margin-bottom:3px}.examTaker-nav-button._text_zoom{padding:3px 0 0}.examTaker-nav-button button{padding:0 2px;margin-left:3px;border:1px solid #ccc;background-color:var(--secondary-color);color:var(--primary-color);width:18px;height:18px;line-height:normal;vertical-align:bottom}.examTaker-nav-button{display:inline-flex;flex-direction:column;align-items:center;padding:0;text-align:center;text-decoration:none;font-size:14px;color:#fff;border-width:0;background-color:transparent}.examTaker-nav-button:not(._direction){font-size:.7em}.examTaker-header-region-right-inner .examTaker-nav-button:not(:last-child){margin-right:33px}.examTaker-header-region-right-inner .examTaker-nav-button._calc,.examTaker-header-region-right-inner .examTaker-nav-button._lab,.examTaker-header-region-right-inner .examTaker-nav-button._notes,.examTaker-header-region-right-inner .examTaker-nav-button._reverse,.examTaker-header-region-right-inner .examTaker-nav-button._text_zoom{display:inline-block}.examTaker-header-region-right-inner .examTaker-nav-button._calc .examTaker-nav-button-icon,.examTaker-header-region-right-inner .examTaker-nav-button._lab .examTaker-nav-button-icon,.examTaker-header-region-right-inner .examTaker-nav-button._notes .examTaker-nav-button-icon,.examTaker-header-region-right-inner .examTaker-nav-button._reverse .examTaker-nav-button-icon,.examTaker-header-region-right-inner .examTaker-nav-button._text_zoom .examTaker-nav-button-icon{margin-bottom:3px}.examTaker-header-region-right-inner .examTaker-nav-button .examTaker-nav-button-text{white-space:nowrap}.examTaker-header-region._center .examTaker-nav-button._direction._next,.examTaker-header-region._center .examTaker-nav-button._direction._prev{display:inline-block}.examTaker-nav-button[disabled]{pointer-events:none;opacity:.5;cursor:default}.examTaker-nav .examTaker-nav-button:not(:last-child){margin-right:33px}button.examTaker-nav-button_direction_prev:hover span.examTaker-nav-button-text{color:#fff!important}.examTaker-nav-button._finish,.examTaker-nav-button._pause{display:inline-block}.examTaker-nav-button._finish .examTaker-nav-button-icon{margin-bottom:3px}@media only screen and (min-width:992px) and (max-width:1024px){.examTaker-header .examTaker-header-region._center{padding-left:0}.examTaker-header-region-right-inner .examTaker-nav-button:not(:last-child),.examTaker-nav .examTaker-nav-button:not(:last-child){margin-right:10px}}@media only screen and (min-width:768px) and (max-width:991px){.examTaker-header .examTaker-header-region._center{padding-left:0}.examTaker-header-region-right-inner .examTaker-nav-button:not(:last-child),.examTaker-nav .examTaker-nav-button:not(:last-child){margin-right:10px}}@media only screen and (min-width:480px) and (max-width:767px){.examTaker-header .examTaker-header-region._center{padding-left:0}.examTaker-header-region-right-inner .examTaker-nav-button:not(:last-child),.examTaker-nav .examTaker-nav-button:not(:last-child){margin-right:10px}}"]
    })
], TextZoomComponent);

let BloodLapValuesComponent = class BloodLapValuesComponent {
    constructor() { }
    ngOnInit() {
    }
};
BloodLapValuesComponent = __decorate([
    Component({
        selector: 'lib-blood-lap-values',
        template: "<div>\n  <div class=\"title-blood-lap-values\">\n    <sup _ngcontent-hwf-c10=\"\">*</sup> Included in the Biochemical Profile\n    (SMA-12)\n  </div>\n  <table\n    class=\"examLabValues-content-table\"\n    id=\"blood\"\n    cellspacing=\"0\"\n    cellpadding=\"0\"\n    border=\"0\"\n  >\n    <tr valign=\"top\">\n      <td><sup>*</sup> Alanine aminotransferase (ALT at 30EC)</td>\n      <td>8-20 U/L</td>\n      <td>8-20 U/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Amylase, serum</td>\n      <td>25-125 U/L</td>\n      <td>25-125 U/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td><sup>*</sup> Aspartate aminotransferase (AST at 30EC)</td>\n      <td>8-20 U/L</td>\n      <td>8-20 U/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Bilirubin, serum (adult) Total // Direct</td>\n      <td>0.1-1.0 mg/dL // 0.0-0.3 mg/dL</td>\n      <td>2-17 \u03BCmol/L // 0-5 \u03BCmol/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td><sup>*</sup> Calcium, serum (Ca2+)</td>\n      <td>8.4-10.2 mg/dL</td>\n      <td>2.1-2.8 mmol/L</td>\n    </tr>\n\n    <tr valign=\"top\">\n      <td><sup>*</sup> Cholesterol, serum</td>\n      <td>Rec:&lt; 200 mg/dL</td>\n      <td>&lt; 5.2 mmol/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Cortisol, serum</td>\n      <td>\n        0800 h: 5-23 \u03BCg/dL 82-413 nmol/L<br />\n        1600 h: 3-15 \u03BCg/dL 138-635 nmol/L<br />\n        2000 h: &lt; 50% of 0800 h\n      </td>\n      <td>Fraction of 0800 h: &lt; 0.50</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Creatine kinase, serum</td>\n      <td>Male: 25-90 U/L<br />Female: 10-70 U/L</td>\n      <td>25-90 U/L<br />10-70 U/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Creatinine, serum</td>\n      <td>0.6-1.2 mg/dL</td>\n      <td>53-106 \u03BCmol/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td colspan=\"3\">Electrolytes, serum</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;Sodium (Na+)</td>\n      <td>136-145 mEq/L</td>\n      <td>136-145 mmol/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;<sup>*</sup> Potassium (K+)</td>\n      <td>3.5-5.0 mEq/L</td>\n      <td>3.5-5.0 mmol/L</td>\n    </tr>\n\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;Chloride (ClB)</td>\n      <td>95-105 mEq/L</td>\n      <td>95-105 mmol/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;Bicarbonate (HCO3-)</td>\n      <td>22-28 mEq/L</td>\n      <td>22-28 mmol/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;Magnesium (Mg2+)</td>\n      <td>1.5-2.0 mEq/L</td>\n      <td>0.75-1.0 mmol/L</td>\n    </tr>\n\n    <tr valign=\"top\">\n      <td colspan=\"3\">Estriol, total, serum (in pregnancy)</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;24-28 wks // 32-36 wks</td>\n      <td>30-170 ng/mL // 60-280 ng/mL</td>\n      <td>104-590 nmol/L // 208-970 nmol/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;28-32 wks // 36-40 wks</td>\n      <td>40-220 ng/mL // 80-350 ng/mL</td>\n      <td>140-760 nmol/L // 280-1210 nmol/L</td>\n    </tr>\n\n    <tr valign=\"top\">\n      <td>Ferritin, serum</td>\n      <td>Male: 15-200 ng/mL<br />Female: 12-150 ng/mL</td>\n      <td>15-200 \u03BCg/L<br />12-150 \u03BCg/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Follicle-stimulating hormone, serum/plasma</td>\n      <td>Male: 4-25 mIU/mL</td>\n      <td>4-25 U/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;</td>\n      <td>Female: premenopause 4-30 mIU/mL</td>\n      <td>4-30 U/L</td>\n    </tr>\n\n    <tr valign=\"top\">\n      <td>&nbsp;</td>\n      <td>midcycle peak 10-90 mIU/mL</td>\n      <td>10-90 U/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;</td>\n      <td>postmenopause 40-250 mIU/mL</td>\n      <td>40-250 U/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td colspan=\"3\">Gases, arterial blood (room air)</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>pH</td>\n      <td>7.35-7.45</td>\n      <td>[H+] 36-44 nmol/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>PCO2</td>\n      <td>33-45 mm Hg</td>\n      <td>4.4-5.9 kPa</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>PO2</td>\n      <td>75-105 mm Hg</td>\n      <td>10.0-14.0 kPa</td>\n    </tr>\n\n    <tr valign=\"top\">\n      <td><sup>*</sup> Glucose, serum</td>\n      <td>Fasting: 70-110 mg/dL</td>\n      <td>3.8-6.1 mmol/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;</td>\n      <td>2-h postprandial: &lt; 120 mg/dL</td>\n      <td>&lt; 6.6 mmol/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Growth hormone - arginine stimulation</td>\n      <td>Fasting: &lt; 5 ng/mL</td>\n      <td>&lt; 5 \u03BCg/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;</td>\n      <td>provocative stimuli: &gt; 7 ng/mL</td>\n      <td>7 \u03BCg/L</td>\n    </tr>\n\n    <tr valign=\"top\">\n      <td colspan=\"3\">Immunoglobulins, serum</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;IgA</td>\n      <td>76-390 mg/dL</td>\n      <td>0.76-3.90 g/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;IgE</td>\n      <td>0-380 IU/mL</td>\n      <td>0-380 kIU/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;IgG</td>\n      <td>650-1500 mg/dL</td>\n      <td>6.5-15 g/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;IgM</td>\n      <td>40-345 mg/dL</td>\n      <td>0.4-3.45 g/L</td>\n    </tr>\n\n    <tr valign=\"top\">\n      <td>Iron</td>\n      <td>50-170 \u03BCg/dL</td>\n      <td>9-30 \u03BCmol/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Lactate dehydrogenase, serum</td>\n      <td>45-90 U/L</td>\n      <td>45-90 U/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Luteinizing hormone, serum/plasma</td>\n      <td>Male: 6-23 mIU/mL</td>\n      <td>6-23 U/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;</td>\n      <td>Female: follicular phase 5-30 mIU/mL</td>\n      <td>5-30 U/L</td>\n    </tr>\n\n    <tr valign=\"top\">\n      <td>&nbsp;</td>\n      <td>midcycle 75-150 mIU/mL</td>\n      <td>75-150 U/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;</td>\n      <td>postmenopause 30-200 mIU/mL</td>\n      <td>30-200 U/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Osmolality, serum</td>\n      <td>275-295 mOsmol/kg</td>\n      <td>275-295 mOsmol/kg</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Parathyroid hormone, serum, N-terminal</td>\n      <td>230-630 pg/mL</td>\n      <td>230-630 ng/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td><sup>*</sup> Phosphatase (alkaline), serum (p-NPP at 30EC)</td>\n      <td>20-70 U/L</td>\n      <td>20-70 U/L</td>\n    </tr>\n\n    <tr valign=\"top\">\n      <td><sup>*</sup> Phosphorus (inorganic), serum</td>\n      <td>3.0-4.5 mg/dL</td>\n      <td>1.0-1.5 mmol/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Prolactin, serum (hPRL)</td>\n      <td>&lt; 20 ng/mL</td>\n      <td>&lt; 20 \u03BCg/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td colspan=\"3\"><sup>*</sup> Proteins, serum</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;Total (recumbent)</td>\n      <td>6.0-7.8 g/dL</td>\n      <td>60-78 g/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;Albumin</td>\n      <td>3.5-5.5 g/dL</td>\n      <td>35-55 g/L</td>\n    </tr>\n\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;Globulin</td>\n      <td>2.3-3.5 g/dL</td>\n      <td>23-35 g/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Thyroid-stimulating hormone, serum or plasma</td>\n      <td>0.5-5.0 \u03BCU/mL</td>\n      <td>0.5-5.0 mU/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Thyroidal iodine (123I) uptake</td>\n      <td>8%-30% of administered dose/24 h</td>\n      <td>0.08-0.30/24 h</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Thyroxine (T4), serum</td>\n      <td>5-12 \u03BCg/dL</td>\n      <td>64-155 nmol/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Triglycerides, serum</td>\n      <td>35-160 mg/dL</td>\n      <td>0.4-1.81 mmol/L</td>\n    </tr>\n\n    <tr valign=\"top\">\n      <td>Triiodothyronine (T3), serum (RIA)</td>\n      <td>115-190 ng/dL</td>\n      <td>1.8-2.9 nmol/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Triiodothyronine (T3) resin uptake</td>\n      <td>25%-35%</td>\n      <td>0.25-0.35</td>\n    </tr>\n    <tr valign=\"top\">\n      <td><sup>*</sup> Urea nitrogen, serum (BUN)</td>\n      <td>7-18 mg/dL</td>\n      <td>1.2-3.0 mmol urea/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td><sup>*</sup> Uric acid, serum</td>\n      <td>3.0-8.2 mg/dL</td>\n      <td>0.18-0.48 mmol/L</td>\n    </tr>\n  </table>\n</div>\n",
        styles: [".title-blood-lap-values{position:-webkit-sticky;position:sticky;margin-top:-6px;width:363px;text-align:left;padding-top:15px;padding-left:5px;font-size:12px;top:0;background-color:var(--secondary-color);z-index:100}@-moz-document url-prefix(){.title-blood-lap-values{margin-top:-5px!important}}.examLabValues-content-table{width:100%;margin-top:15px}.examLabValues-content-table tr td{font-size:12px;padding:5px;border-top:1px solid #a3a3b4}"]
    })
], BloodLapValuesComponent);

let CerebrospinalLapValuesComponent = class CerebrospinalLapValuesComponent {
    constructor() { }
    ngOnInit() {
    }
};
CerebrospinalLapValuesComponent = __decorate([
    Component({
        selector: 'lib-cerebrospinal-lap-values',
        template: "<div>\n  <table\n    class=\"examLabValues-content-table\"\n    id=\"cerebrospinal\"\n    cellspacing=\"0\"\n    cellpadding=\"0\"\n    border=\"0\"\n  >\n    <tr valign=\"top\">\n      <td>Cell count</td>\n      <td>0-5 cells/mm3</td>\n      <td>0-5 x 106/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Chloride</td>\n      <td>118-132 mEq/L</td>\n      <td>118-132 mmol/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Gamma globulin</td>\n      <td>3-12% total proteins</td>\n      <td>0.03-0.12</td>\n    </tr>\n\n    <tr valign=\"top\">\n      <td>Glucose</td>\n      <td>40-70 mg/dL</td>\n      <td>2.2-3.9 mmol/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Pressure</td>\n      <td>70-180 mm H2O</td>\n      <td>70-180 mm H2O</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Proteins, total</td>\n      <td>&lt; 40 mg/dL</td>\n      <td>&lt; 0.40 g/L</td>\n    </tr>\n  </table>\n</div>\n",
        styles: [".examLabValues-content-table{width:100%}.examLabValues-content-table tr td{font-size:12px;padding:5px;border-top:1px solid #a3a3b4}"]
    })
], CerebrospinalLapValuesComponent);

let HematologicLapValuesComponent = class HematologicLapValuesComponent {
    constructor() { }
    ngOnInit() {
    }
};
HematologicLapValuesComponent = __decorate([
    Component({
        selector: 'lib-hematologic-lap-values',
        template: "<div>\n  <table\n    class=\"examLabValues-content-table\"\n    id=\"hematologic\"\n    cellspacing=\"0\"\n    cellpadding=\"0\"\n    border=\"0\"\n  >\n    <tr valign=\"top\">\n      <td>Bleeding time (template)</td>\n      <td>2-7 minutes</td>\n      <td>2-7 minutes</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Erythrocyte count</td>\n      <td>Male: 4.3-5.9 million/mm3</td>\n      <td>4.3-5.9 x 1012/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;</td>\n      <td>Female: 3.5-5.5 million/mm3</td>\n      <td>3.5-5.5 x 1012/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Erythrocyte sedimentation rate (Westergren)</td>\n      <td>Male: 0-15 mm/h</td>\n      <td>0-15 mm/h</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;</td>\n      <td>Female: 0-20 mm/h</td>\n      <td>0-20 mm/h</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Hematocrit</td>\n      <td>Male: 41%-53%</td>\n      <td>0.41-0.53</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;</td>\n      <td>Female: 36%-46%</td>\n      <td>0.36-0.46</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Hemoglobin A1c</td>\n      <td></td>\n      <td></td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Hemoglobin, blood</td>\n      <td>Male: 13.5-17.5 g/dL</td>\n      <td>2.09-2.71 mmol/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;</td>\n      <td>Female: 12.0-16.0 g/dL</td>\n      <td>1.86-2.48 mmol/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Hemoglobin, plasma</td>\n      <td>1-4 mg/dL</td>\n      <td>0.16-0.62 mmol/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td colspan=\"3\">Leukocyte count and differential</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;Leukocyte count</td>\n      <td>4500-11,000/mm3</td>\n      <td>4.5-11.0 x 109/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;Segmented neutrophils</td>\n      <td>54%-62%</td>\n      <td>0.54-0.62</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;Bands</td>\n      <td>3%-5%</td>\n      <td>0.03-0.05</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;Eosinophils</td>\n      <td>1%-3%</td>\n      <td>0.01-0.03</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;Basophils</td>\n      <td>0%-0.75%</td>\n      <td>0-0.0075</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;Lymphocytes</td>\n      <td>25%-33%</td>\n      <td>0.25-0.33</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;Monocytes</td>\n      <td>3%-7%</td>\n      <td>0.03-0.07</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Mean corpuscular hemoglobin</td>\n      <td>25.4-34.6 pg/cell</td>\n      <td>0.39-0.54 fmol/cell</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Mean corpuscular hemoglobin concentration</td>\n      <td>31%-36% Hb/cell</td>\n      <td>4.81-5.58 mmol Hb/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Mean corpuscular volume</td>\n      <td>80-100 \u03BCm3</td>\n      <td>80-100 fl</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Partial thromboplastin time (activated)</td>\n      <td>25-40 seconds</td>\n      <td>25-40 seconds</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Platelet count</td>\n      <td>150,000-400,000/mm3</td>\n      <td>150-400 x 109/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Prothrombin time</td>\n      <td>11-15 seconds</td>\n      <td>11-15 seconds</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Reticulocyte count</td>\n      <td>0.5%-1.5% of red cells</td>\n      <td>0.005-0.015</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Thrombin time</td>\n      <td>&lt; 2 seconds deviation from control</td>\n      <td>&lt; 2 seconds deviation from control</td>\n    </tr>\n    <tr valign=\"top\">\n      <td colspan=\"3\">Volume</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;Plasma</td>\n      <td>Male: 25-43 mL/kg</td>\n      <td>0.025-0.043 L/kg</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;</td>\n      <td>Female: 28-45 mL/kg</td>\n      <td>0.028-0.045 L/kg</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;Red cell</td>\n      <td>Male: 20-36 mL/kg</td>\n      <td>0.020-0.036 L/kg</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;</td>\n      <td>Female: 19-31 mL/kg</td>\n      <td>0.019-0.031 L/kg</td>\n    </tr>\n  </table>\n</div>\n",
        styles: [".examLabValues-content-table{width:100%}.examLabValues-content-table tr td{font-size:12px;padding:5px;border-top:1px solid #a3a3b4}"]
    })
], HematologicLapValuesComponent);

let SUBLapValuesComponent = class SUBLapValuesComponent {
    constructor() { }
    ngOnInit() {
    }
};
SUBLapValuesComponent = __decorate([
    Component({
        selector: 'lib-s-u-b-lap-values',
        template: "<div>\n  <table\n    class=\"examLabValues-content-table\"\n    id=\"sweat\"\n    cellspacing=\"0\"\n    cellpadding=\"0\"\n    border=\"0\"\n  >\n    <tr valign=\"top\">\n      <td>Calcium</td>\n      <td>100-300 mg/24 h</td>\n      <td>2.5-7.5 mmol/24 h</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Chloride</td>\n      <td>Varies with intake</td>\n      <td>Varies with intake</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Creatinine clearance</td>\n      <td>Male: 97-137 mL/min<br />Female: 88-128 mL/min</td>\n      <td>&nbsp;</td>\n    </tr>\n    <tr valign=\"top\">\n      <td colspan=\"3\">Estriol, total (in pregnancy)</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;30 wks</td>\n      <td>6-18 mg/24 h</td>\n      <td>21-62 \u03BCmol/24 h</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;35 wks</td>\n      <td>9-28 mg/24 h</td>\n      <td>31-97 \u03BCmol/24 h</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;&nbsp;&nbsp;40 wks</td>\n      <td>13-42 mg/24 h</td>\n      <td>45-146 \u03BCmol/24 h</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>17-Hydroxycorticosteroids</td>\n      <td>Male: 3.0-10.0 mg/24 h</td>\n      <td>8.2-27.6 \u03BCmol/24 h</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;</td>\n      <td>Female: 2.0-8.0 mg/24 h</td>\n      <td>5.5-22.0 \u03BCmol/24 h</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>17-Ketosteroids, total</td>\n      <td>Male: 8-20 mg/24 h</td>\n      <td>28-70 \u03BCmol/24 h</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>&nbsp;</td>\n      <td>Female: 6-15 mg/24 h</td>\n      <td>21-52 \u03BCmol/24 h</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Osmolality</td>\n      <td>50-1400 mOsmol/kg</td>\n      <td>&nbsp;</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Oxalate</td>\n      <td>8-40 \u03BCg/mL</td>\n      <td>90-445 \u03BCmol/L</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Potassium</td>\n      <td>Varies with diet</td>\n      <td>Varies with diet</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Proteins, total</td>\n      <td>&lt; 150 mg/24 h</td>\n      <td>&lt;0.15 g/24 h</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Sodium</td>\n      <td>Varies with diet</td>\n      <td>Varies with diet</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Uric acid</td>\n      <td>Varies with diet</td>\n      <td>Varies with diet</td>\n    </tr>\n    <tr valign=\"top\">\n      <td>Body mass index</td>\n      <td>Adult: 19-25 kg/m2</td>\n      <td>&nbsp;</td>\n    </tr>\n  </table>\n</div>\n",
        styles: [".examLabValues-content-table{width:100%}.examLabValues-content-table tr td{font-size:12px;padding:5px;border-top:1px solid #a3a3b4}"]
    })
], SUBLapValuesComponent);

let FontSizeDirective = class FontSizeDirective {
    constructor(elementRef) {
        this.elementRef = elementRef;
    }
    ngOnChanges(changes) {
        if (changes.fontSize && !changes.fontSize.firstChange) {
            this.setFontSize();
        }
    }
    ngOnInit() { }
    setFontSize() {
        this.elementRef.nativeElement.style.setProperty('--font-size', this.fontSize);
    }
};
FontSizeDirective.ctorParameters = () => [
    { type: ElementRef }
];
__decorate([
    Input()
], FontSizeDirective.prototype, "fontSize", void 0);
FontSizeDirective = __decorate([
    Directive({
        selector: '[fontSize]'
    })
], FontSizeDirective);

let ThemeDirective = class ThemeDirective {
    constructor(document) {
        this.document = document;
    }
    ngOnChanges(changes) {
        if (changes.activeTheme &&
            !changes.activeTheme.firstChange &&
            changes.activeTheme.currentValue) {
            this.updateTheme(this.activeTheme);
        }
    }
    ngOnInit() {
        this.updateTheme(this.activeTheme);
    }
    updateTheme(themeId) {
        const theme = appThemesData.find(theme => theme.id === themeId);
        for (const key in theme.properties) {
            this.document.body.style.setProperty(key, theme.properties[key]);
        }
    }
};
ThemeDirective.ctorParameters = () => [
    { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
];
__decorate([
    Input()
], ThemeDirective.prototype, "activeTheme", void 0);
ThemeDirective = __decorate([
    Directive({
        selector: '[appTheme]'
    }),
    __param(0, Inject(DOCUMENT))
], ThemeDirective);

let InverseColorDirective = class InverseColorDirective {
    constructor(renderer, elementRef, themeService) {
        this.renderer = renderer;
        this.elementRef = elementRef;
        this.themeService = themeService;
    }
    ngOnChanges(changes) {
        if (changes.isInvert && !changes.isInvert.firstChange) {
            this.isInvert = changes.isInvert.currentValue;
            this.invertColor();
        }
    }
    ngOnInit() { }
    invertColor() {
        const element = this.elementRef.nativeElement;
        if (this.isInvert) {
            this.renderer.addClass(this.elementRef.nativeElement, 'qp-inverse-color');
            for (const key in invertThemeProperties) {
                element.style.setProperty(key, invertThemeProperties[key]);
            }
        }
        else {
            this.renderer.removeClass(this.elementRef.nativeElement, 'qp-inverse-color');
            for (const key in invertThemeProperties) {
                element.style.removeProperty(key);
            }
            this.themeService.setActiveTheme(this.activeTheme);
        }
    }
};
InverseColorDirective.ctorParameters = () => [
    { type: Renderer2 },
    { type: ElementRef },
    { type: ThemeService }
];
__decorate([
    Input()
], InverseColorDirective.prototype, "isInvert", void 0);
__decorate([
    Input()
], InverseColorDirective.prototype, "activeTheme", void 0);
InverseColorDirective = __decorate([
    Directive({
        selector: '[inverseColor]'
    })
], InverseColorDirective);

let InverseColorComponent = class InverseColorComponent {
    constructor(themeService) {
        this.themeService = themeService;
    }
    ngOnInit() { }
    toggleInverseColor() {
        this.themeService.toggleInverseColor();
    }
};
InverseColorComponent.ctorParameters = () => [
    { type: ThemeService }
];
__decorate([
    Input()
], InverseColorComponent.prototype, "inverseColor", void 0);
InverseColorComponent = __decorate([
    Component({
        selector: 'wkqp-inverse-theme',
        template: "<div class=\"qp-feature-menu\" [ngClass]=\"{ 'menu-selected': inverseColor }\">\n  <div class=\"reverse-menu\">\n    <button (click)=\"toggleInverseColor()\">\n      <span>\n        <img\n          alt=\"Reversing Color\"\n          class=\"examTaker-nav-button-icon\"\n          src=\"assets/engine-icons/theme-color-icon.png\"\n        />\n      </span>\n      <span class=\"pt3\">Reverse Colour</span>\n    </button>\n  </div>\n</div>\n",
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: [".examTaker-header-region-right-inner .examTaker-nav-button._calc .examTaker-nav-button-icon,.examTaker-header-region-right-inner .examTaker-nav-button._lab .examTaker-nav-button-icon,.examTaker-header-region-right-inner .examTaker-nav-button._notes .examTaker-nav-button-icon,.examTaker-header-region-right-inner .examTaker-nav-button._reverse .examTaker-nav-button-icon,.examTaker-header-region-right-inner .examTaker-nav-button._text_zoom .examTaker-nav-button-icon{margin-bottom:3px}.reverse-menu button{background-color:transparent;color:#474747;text-align:center;padding:0}.reverse-menu button span{display:block;color:#474747;text-align:center;font-size:14px}.pt3{padding-top:3px}"]
    })
], InverseColorComponent);

let SharedModule = class SharedModule {
};
SharedModule = __decorate([
    NgModule({
        declarations: [
            UsmleExamCalculatorComponent,
            NclexExamCalculatorComponent,
            TimerComponent,
            TestIndexComponent,
            ItemBookmarkComponent,
            ItemNotesComponent,
            LabValuesComponent,
            TextZoomComponent,
            InverseColorComponent,
            BloodLapValuesComponent,
            CerebrospinalLapValuesComponent,
            HematologicLapValuesComponent,
            SUBLapValuesComponent,
            FontSizeDirective,
            ThemeDirective,
            InverseColorDirective
        ],
        imports: [
            CommonModule,
            FormsModule,
            GoogleChartsModule,
            CarouselModule.forRoot(),
            PaginationModule.forRoot(),
            ItemTypesModule,
            CKEditorModule
        ],
        exports: [
            UsmleExamCalculatorComponent,
            NclexExamCalculatorComponent,
            TimerComponent,
            TestIndexComponent,
            ItemBookmarkComponent,
            ItemNotesComponent,
            LabValuesComponent,
            TextZoomComponent,
            InverseColorComponent,
            TimerComponent,
            FontSizeDirective,
            ThemeDirective,
            InverseColorDirective
        ]
    })
], SharedModule);

let SummaryComponent = class SummaryComponent {
    constructor(quizService) {
        this.quizService = quizService;
        this.currentPage = 1;
        this.pageLoader = false;
        this.SummaryDisplayTypes = SummaryDisplayTypes;
        this.pageChanged = new EventEmitter();
        this.reportContentError = new EventEmitter();
        this.sendReportContentError = new EventEmitter();
    }
    ngOnChanges(changes) {
        this.quizService.isOnline = true;
        if (this.summaryDetails) {
            this.pageLoader = false;
            this.itemResponseDataHeader = this.summaryDetails.details;
            this.preferredTextFormat = this.testData.preferredTextFormat;
            if (this.summaryDetails.details &&
                this.summaryDetails.details.itemResponse &&
                this.summaryDetails.details.itemResponse.questionData) {
                const summaryDataRef = this.summaryDetails.details.itemResponse.questionData;
                // this.itemResponseDataHeader.summaryDisplay = 3;
                summaryDataRef.forEach((element, index, array) => {
                    if (array[index - 1] &&
                        array[index - 1].parentLabelText === 'MEDICAL_CASE' &&
                        element.parentLabelText === 'MEDICAL_CASE') {
                        element.parentLabelText = 'Medical';
                        element.parentDetails = null;
                    }
                });
                this.itemResponseData = summaryDataRef;
                this.itemResponseData.forEach((element, index, array) => {
                    element['questionTime'] = this.itemResponseDataHeader.questionTime;
                    element['preferredTextFormat'] = this.preferredTextFormat;
                    element.modelFeedback[0]['preferredTextFormat'] = this.preferredTextFormat;
                });
            }
        }
    }
    ngOnInit() { }
    paginationChanged(page) {
        this.pageLoader = true;
        this.pageChanged.emit(page);
    }
    reportContentErrorDetails(clientDetails) {
        this.reportContentError.emit(clientDetails);
    }
    sendReportContentErrorDetails(mailContent) {
        this.sendReportContentError.emit(mailContent);
    }
};
SummaryComponent.ctorParameters = () => [
    { type: QuizService }
];
__decorate([
    Output()
], SummaryComponent.prototype, "pageChanged", void 0);
__decorate([
    Output()
], SummaryComponent.prototype, "reportContentError", void 0);
__decorate([
    Output()
], SummaryComponent.prototype, "sendReportContentError", void 0);
__decorate([
    Input('testData')
], SummaryComponent.prototype, "testData", void 0);
__decorate([
    Input('summaryData')
], SummaryComponent.prototype, "summaryDetails", void 0);
__decorate([
    Input()
], SummaryComponent.prototype, "templateData", void 0);
__decorate([
    Input()
], SummaryComponent.prototype, "mailSuccessData", void 0);
SummaryComponent = __decorate([
    Component({
        selector: 'qp-summary',
        template: "<div\n  class=\"qp-summary\"\n  [ngClass]=\"{\n    'qp-summary-pre-defined':\n      itemResponseDataHeader.summaryDisplay ===\n      SummaryDisplayTypes.SummaryPredefined\n  }\"\n>\n  <lib-summary-header-details\n    [summaryData]=\"itemResponseDataHeader\"\n    [templateData]=\"templateData\"\n    [mailSuccessData]=\"mailSuccessData\"\n    (reportContentError)=\"reportContentErrorDetails($event)\"\n    (reportMailContent)=\"sendReportContentErrorDetails($event)\"\n    *ngIf=\"\n      itemResponseDataHeader.summaryDisplay !==\n      SummaryDisplayTypes.SummaryPredefined\n    \"\n  ></lib-summary-header-details>\n  <ng-container\n    *ngIf=\"\n      itemResponseDataHeader.summaryDisplay ===\n        SummaryDisplayTypes.SummaryDefault && !pageLoader\n    \"\n  >\n    <ng-container *ngFor=\"let item of itemResponseData\">\n      <ng-container>\n        <ng-container *ngIf=\"item.parentLabelText === 'MEDICAL_CASE'\"\n          ><lib-medical-case-summary\n            [summaryData]=\"item\"\n          ></lib-medical-case-summary\n        ></ng-container>\n        <ng-container *ngIf=\"item.parentLabelText === 'CLINICAL_SYMPTOMS'\"\n          ><lib-clinical-symptoms-summary\n            [summaryData]=\"item\"\n          ></lib-clinical-symptoms-summary\n        ></ng-container>\n      </ng-container>\n\n      <ng-container [ngSwitch]=\"item.itemType\">\n        <ng-container *ngSwitchCase=\"'1'\"\n          ><lib-multiple-choice-summary\n            [summaryData]=\"item\"\n          ></lib-multiple-choice-summary\n        ></ng-container>\n        <ng-container *ngSwitchCase=\"'2'\">\n          <lib-multiple-response-summary\n            [summaryData]=\"item\"\n          ></lib-multiple-response-summary>\n        </ng-container>\n        <ng-container *ngSwitchCase=\"'3'\">\n          <lib-fill-in-the-blanks-summary\n            [summaryData]=\"item\"\n          ></lib-fill-in-the-blanks-summary>\n        </ng-container>\n        <ng-container *ngSwitchCase=\"'4'\">\n          <lib-true-false-summary [summaryData]=\"item\"></lib-true-false-summary>\n        </ng-container>\n        <ng-container *ngSwitchCase=\"'24'\">\n          <lib-inline-choice-summary\n            [summaryData]=\"item\"\n          ></lib-inline-choice-summary>\n        </ng-container>\n        <ng-container *ngSwitchCase=\"'23'\">\n          <lib-graphic-option-summary\n            [summaryData]=\"item\"\n          ></lib-graphic-option-summary>\n        </ng-container>\n        <ng-container *ngSwitchCase=\"'13'\">\n          <lib-drag-and-drop-summary\n            [summaryData]=\"item\"\n          ></lib-drag-and-drop-summary>\n        </ng-container>\n        <ng-container *ngSwitchCase=\"'12'\">\n          <lib-hot-spot-summary [summaryData]=\"item\"></lib-hot-spot-summary>\n        </ng-container>\n        <ng-container *ngSwitchCase=\"'17'\">\n          <lib-figure-labeling-summary\n            [summaryData]=\"item\"\n          ></lib-figure-labeling-summary>\n        </ng-container>\n      </ng-container>\n    </ng-container>\n  </ng-container>\n  <ng-container\n    *ngIf=\"\n      itemResponseDataHeader.summaryDisplay ===\n        SummaryDisplayTypes.SummaryDefault && itemResponseData.length > 0\n    \"\n  >\n    <lib-summary-pagination\n      [totalquestions]=\"summaryDetails.details.totalQuestions\"\n      [currentPage]=\"currentPage\"\n      (pageChanged)=\"paginationChanged($event)\"\n      [ngStyle]=\"{ visibility: pageLoader ? 'hidden' : 'visible' }\"\n    ></lib-summary-pagination>\n  </ng-container>\n\n  <ng-container>\n    <div\n      *ngIf=\"\n        itemResponseDataHeader.summaryPredefinedText != null &&\n        itemResponseDataHeader.summaryDisplay ===\n          SummaryDisplayTypes.SummaryPredefined\n      \"\n      class=\"summary-pre-defined-text\"\n    >\n      <p>{{ itemResponseDataHeader.summaryPredefinedText }}</p>\n    </div>\n  </ng-container>\n\n  <ng-container *ngIf=\"pageLoader\">\n    <div class=\"loader-container\">\n      <span class=\"wk-icon-spin wk-spin wkqp-spin-center\"></span>\n    </div>\n  </ng-container>\n</div>\n",
        styles: ["body,html{overflow:inherit}.qp-summary{flex:1;display:flex;flex-direction:column;height:100%;width:75rem;margin:0 auto}:host ::ng-deep lib-medical-case-summary.wkqb-question-number{float:left}:host ::ng-deep lib-medical-case-summary.wkqp-badge-danger{top:-4px}:host ::ng-deep lib-medical-case-summary.wrong-checkmark{top:0}:host ::ng-deep lib-medical-case-summary.green-checkmark{top:0}:host ::ng-deep lib-medical-case-summary.wkqp-unattempted{top:-2px}:host ::ng-deep lib-clinical-symptoms-summary.wkqb-question-number{float:left}:host ::ng-deep lib-clinical-symptoms-summary.wkqp-badge-danger{top:-4px}:host ::ng-deep lib-clinical-symptoms-summary.wrong-checkmark{top:0}:host ::ng-deep lib-clinical-symptoms-summary.green-checkmark{top:0}:host ::ng-deep lib-clinical-symptoms-summary.wkqp-unattempted{top:-2px}:host ::ng-deep lib-multiple-choice-summary.wkqb-question-number{float:left}:host ::ng-deep lib-multiple-choice-summary.wkqp-badge-danger{top:-4px}:host ::ng-deep lib-multiple-choice-summary.wrong-checkmark{top:0}:host ::ng-deep lib-multiple-choice-summary.green-checkmark{top:0}:host ::ng-deep lib-multiple-choice-summary.wkqp-unattempted{top:-2px}:host ::ng-deep lib-multiple-response-summary.wkqb-question-number{float:left}:host ::ng-deep lib-multiple-response-summary.wkqp-badge-danger{top:-4px}:host ::ng-deep lib-multiple-response-summary.wrong-checkmark{top:0}:host ::ng-deep lib-multiple-response-summary.green-checkmark{top:0}:host ::ng-deep lib-multiple-response-summary.wkqp-unattempted{top:-2px}:host ::ng-deep lib-fill-in-the-blanks-summary.wkqb-question-number{float:left}:host ::ng-deep lib-fill-in-the-blanks-summary.wkqp-badge-danger{top:-4px}:host ::ng-deep lib-fill-in-the-blanks-summary.wrong-checkmark{top:0}:host ::ng-deep lib-fill-in-the-blanks-summary.green-checkmark{top:0}:host ::ng-deep lib-fill-in-the-blanks-summary.wkqp-unattempted{top:-2px}:host ::ng-deep lib-true-false-summary.wkqb-question-number{float:left}:host ::ng-deep lib-true-false-summary.wkqp-badge-danger{top:-4px}:host ::ng-deep lib-true-false-summary.wrong-checkmark{top:0}:host ::ng-deep lib-true-false-summary.green-checkmark{top:0}:host ::ng-deep lib-true-false-summary.wkqp-unattempted{top:-2px}:host ::ng-deep lib-inline-choice-summary.wkqb-question-number{float:left}:host ::ng-deep lib-inline-choice-summary.wkqp-badge-danger{top:-4px}:host ::ng-deep lib-inline-choice-summary.wrong-checkmark{top:0}:host ::ng-deep lib-inline-choice-summary.green-checkmark{top:0}:host ::ng-deep lib-inline-choice-summary.wkqp-unattempted{top:-2px}:host ::ng-deep lib-graphic-option-summary.wkqb-question-number{float:left}:host ::ng-deep lib-graphic-option-summary.wkqp-badge-danger{top:-4px}:host ::ng-deep lib-graphic-option-summary.wrong-checkmark{top:0}:host ::ng-deep lib-graphic-option-summary.green-checkmark{top:0}:host ::ng-deep lib-graphic-option-summary.wkqp-unattempted{top:-2px}:host ::ng-deep lib-drag-and-drop-summary.wkqb-question-number{float:left}:host ::ng-deep lib-drag-and-drop-summary.wkqp-badge-danger{top:-4px}:host ::ng-deep lib-drag-and-drop-summary.wrong-checkmark{top:0}:host ::ng-deep lib-drag-and-drop-summary.green-checkmark{top:0}:host ::ng-deep lib-drag-and-drop-summary.wkqp-unattempted{top:-2px}:host ::ng-deep lib-hot-spot-summary.wkqb-question-number{float:left}:host ::ng-deep lib-hot-spot-summary.wkqp-badge-danger{top:-4px}:host ::ng-deep lib-hot-spot-summary.wrong-checkmark{top:0}:host ::ng-deep lib-hot-spot-summary.green-checkmark{top:0}:host ::ng-deep lib-hot-spot-summary.wkqp-unattempted{top:-2px}:host ::ng-deep lib-figure-labeling-summary.wkqb-question-number{float:left}:host ::ng-deep lib-figure-labeling-summary.wkqp-badge-danger{top:-4px}:host ::ng-deep lib-figure-labeling-summary.wrong-checkmark{top:0}:host ::ng-deep lib-figure-labeling-summary.green-checkmark{top:0}:host ::ng-deep lib-figure-labeling-summary.wkqp-unattempted{top:-2px}.loader-container{position:absolute;top:425px;left:50%;transform:translate(-50%,0);text-align:center}.loader-container span{font-size:50px;color:var(--primary-color)}.loader-container h2{font-size:24px;text-align:center;width:100%;margin:0;padding:0}.hidden{visibility:hidden}.summary-pre-defined-text{width:500px;padding-top:105px;text-align:center;padding-bottom:105px;position:absolute;top:50%;right:50%;transform:translate(50%,-50%);background-color:#fff;border:1px solid #ccc}.summary-pre-defined-text:hover{background-color:#d4e8b1}.qp-summary-pre-defined{display:flex;width:100%;padding-bottom:20px;max-width:75rem;margin-left:auto;margin-right:auto;background-color:#ededed;height:100vh;max-width:100%}.qp-summary-pre-defined::before{position:absolute;top:0;left:0;width:100%;height:100vh;background-color:#ededed;z-index:-1;content:''}"]
    })
], SummaryComponent);

let QpModule = class QpModule {
};
QpModule = __decorate([
    NgModule({
        declarations: [
            HeaderComponent,
            FooterComponent,
            QPBaseComponent,
            SummaryComponent,
            QpFeaturesComponent
        ],
        imports: [
            FormsModule,
            CommonModule,
            ItemTypesModule,
            PaginationModule.forRoot(),
            GoogleChartsModule,
            SharedModule
        ],
        exports: [QPBaseComponent, SummaryComponent]
    })
], QpModule);

let ErrorComponent = class ErrorComponent {
    constructor(route) {
        this.route = route;
        this.errorCodes = ErrorCodes;
    }
    ngOnInit() { }
};
ErrorComponent.ctorParameters = () => [
    { type: ActivatedRoute }
];
__decorate([
    Input('errorCode')
], ErrorComponent.prototype, "errorCode", void 0);
ErrorComponent = __decorate([
    Component({
        selector: 'quiz-error',
        template: "<ng-container *ngIf=\"errorCode\">\n  <ng-container [ngSwitch]=\"errorCode\">\n    <div class=\"wk-page-content pagenot-found-wrapper\">\n      <div class=\"pagenot-found-inner-wrapper \">\n        <ng-container *ngSwitchCase=\"errorCodes.Unauthorized\">\n          <div class=\"page-not-found-left\">\n            <span class=\"wk-icon-alert-triangle\"></span>\n          </div>\n          <div class=\"page-not-found-right\">\n            <h1 class=\"page-not-found-title\">4<span>0</span>1</h1>\n            <p class=\"page-not-found-des\">\n              You are not authenticated to take this quiz.\n            </p>\n          </div>\n        </ng-container>\n        <ng-container *ngSwitchCase=\"errorCodes.Forbidden\">\n          <div class=\"page-not-found-left\">\n            <span class=\"wk-icon-alert-triangle\"></span>\n          </div>\n          <div class=\"page-not-found-right\">\n            <h1 class=\"page-not-found-title\">4<span>0</span>3</h1>\n            <p class=\"page-not-found-des\">\n              This session is either time-out or you don't have permission to\n              take this quiz.\n            </p>\n          </div>\n        </ng-container>\n        <ng-container *ngSwitchCase=\"errorCodes.NotFound\">\n          <div class=\"page-not-found-left\">\n            <span class=\"wk-icon-alert-triangle\"></span>\n          </div>\n          <div class=\"page-not-found-right\">\n            <h1 class=\"page-not-found-title\">4<span>0</span>4</h1>\n            <p class=\"page-not-found-des\">\n              Quiz not found\n            </p>\n          </div>\n        </ng-container>\n        <ng-container *ngSwitchDefault>\n          <div class=\"page-not-found-left\">\n            <span class=\"wk-icon-alert-triangle\"></span>\n          </div>\n          <div class=\"page-not-found-right\">\n            <h1 class=\"page-not-found-title\">O<span>op</span>s</h1>\n            <p class=\"page-not-found-des mt0\">\n              Please provide proper quiz details.\n            </p>\n          </div>\n        </ng-container>\n      </div>\n    </div>\n  </ng-container>\n</ng-container>\n",
        styles: ["h6.data-not-available{padding-bottom:50px;padding-top:20px;font-weight:400;font-size:16px}.pagenot-found-wrapper{width:100%;height:100%;position:absolute;background-color:#a6d1ea;max-width:100%}.pagenot-found-inner-wrapper{width:800px;height:500px;position:absolute;background-color:#a6d1ea;top:50%;right:50%;transform:translate(50%,-50%)}.page-not-found-left{float:left;width:30%;padding:80px 0 0 40px;text-align:right}.page-not-found-right{float:left;width:60%}.wk-icon-alert-triangle{font-size:200px;color:#007ac3}.wk-icon-alert-triangle:before{margin:0;padding:0}.page-not-found-title{font-size:200px;color:#474747;margin:0;padding:70px 0 0;font-weight:500;line-height:normal;text-align:center}.page-not-found-title span{color:#007ac3;display:inline-block}.page-not-found-des{color:#474747;margin:-25px 0 0;padding:0;font-size:18px;font-weight:600;text-align:center}.mt0{margin-top:0}"]
    })
], ErrorComponent);

let ErrorPageModule = class ErrorPageModule {
};
ErrorPageModule = __decorate([
    NgModule({
        declarations: [ErrorComponent],
        imports: [CommonModule],
        exports: [ErrorComponent]
    })
], ErrorPageModule);

let ExamEngineLibrariesModule = class ExamEngineLibrariesModule {
};
ExamEngineLibrariesModule = __decorate([
    NgModule({
        imports: [
            FormsModule,
            CommonModule,
            TooltipModule.forRoot(),
            QpModule,
            ErrorPageModule
        ],
        declarations: [],
        exports: [QpModule, ErrorPageModule],
        schemas: []
    })
], ExamEngineLibrariesModule);

/*
 * Public API Surface of exam-engine-widget
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AssetPosition, EmailDetails, Engine, ErrorCodes, ErrorComponent, ErrorPageModule, ExamEngineLibrariesModule, ExternalClientCode, FontSizeEnum, LapValues, Navigation, NavigationType, QPBaseComponent, QpModule, RationaleType, RemediaionType, SubmitAnswerPayload, SummaryComponent, SummaryDisplayTypes, SystemConfig, ThemeDirective, ThemesEnum, Timer, UserAnswerTypes, appThemesData, invertThemeProperties, HeaderComponent as ɵa, UtilTimeService as ɵb, FigureLabelComponent as ɵba, CarouselComponent as ɵbb, ItemTextAssetsComponent as ɵbc, MediaControlsComponent as ɵbd, ExhibitModal as ɵbe, MetadataComponent as ɵbf, RationaleComponent as ɵbg, RemediationComponent as ɵbh, SummaryHeaderDetailsComponent as ɵbi, SummaryBase as ɵbj, SharedService as ɵbk, ClinicalSymptomsSummaryComponent as ɵbl, DragAndDropSummaryComponent as ɵbm, FigureLabelingSummaryComponent as ɵbn, FillInTheBlanksSummaryComponent as ɵbo, GraphicOptionSummaryComponent as ɵbp, HotSpotSummaryComponent as ɵbq, InlineChoiceSummaryComponent as ɵbr, MedicalCaseSummaryComponent as ɵbs, MultipleChoiceSummaryComponent as ɵbt, MultipleResponseSummaryComponent as ɵbu, TrueFalseSummaryComponent as ɵbv, SummaryPaginationComponent as ɵbw, GetFormatTextDirective as ɵbx, ImageScalingComponent as ɵby, DownloadTranscriptComponent as ɵbz, QuizService as ɵc, SharedModule as ɵca, UsmleExamCalculatorComponent as ɵcb, NclexExamCalculatorComponent as ɵcc, TimerComponent as ɵcd, ItemBookmarkComponent as ɵce, ItemNotesComponent as ɵcf, LabValuesComponent as ɵcg, TextZoomComponent as ɵch, InverseColorComponent as ɵci, BloodLapValuesComponent as ɵcj, CerebrospinalLapValuesComponent as ɵck, HematologicLapValuesComponent as ɵcl, SUBLapValuesComponent as ɵcm, FontSizeDirective as ɵcn, InverseColorDirective as ɵco, FooterComponent as ɵd, QpFeaturesComponent as ɵe, ThemeService as ɵf, TestIndexComponent as ɵg, ItemService as ɵh, ItemTypesModule as ɵi, MultipleChoiceComponent as ɵj, MultipleResponseComponent as ɵk, ItemTypeWrapperComponent as ɵl, ClinicalMultipleChoiceComponent as ɵm, ClinicalMultipleResponseComponent as ɵn, TrueFalseComponent as ɵo, MedicalMultipleChoiceComponent as ɵp, MedicalMultipleResponseComponent as ɵq, FillInTheBlanksComponent as ɵr, GraphicOptionComponent as ɵs, HotSpotComponent as ɵt, FigureLabelingComponent as ɵu, DragAndDropComponent as ɵv, InlineChoiceComponent as ɵw, HotspotSvgComponent as ɵx, InputTypeConfigurationComponent as ɵy, SelectTypeConfigurationComponent as ɵz };
//# sourceMappingURL=exam-engine-libraries.js.map
